//
//  TwitterSplitViewController.h
//  app_builder
//
//  Created by ivan bejarano on 8/18/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "SilSplitViewController.h"
#import "SA_OAuthTwitterController.h"

@interface TwitterSplitViewController : SilSplitViewController <SA_OAuthTwitterControllerDelegate> {
    NSDictionary * infoData;

	SA_OAuthTwitterEngine *_engine;
	UIView *twitterView;
	UITextView * twitterMessageText;
	NSString * twitterTitle;
	NSString * twitterDescription;
	NSString * twitterLink;
	NSString * useTwitter;
	NSString* kAppId;
	NSString* kOAuthConsumerKey;
	NSString* kOAuthConsumerSecret;

}

@property (nonatomic, retain) NSString* kAppId;
@property (nonatomic, retain) NSString* kOAuthConsumerKey;
@property (nonatomic, retain) NSString* kOAuthConsumerSecret;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
-(void) goTwt;
-(void) createTwitterView;
-(IBAction) sendTwitter: (id) sender;

@end
