//
//  AboutViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 11/11/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "MenuItem.h"
#import <MessageUI/MessageUI.h>
#import <MessageUI/MFMailComposeViewController.h>

@interface AboutViewController : UIViewController <UITableViewDataSource,UITableViewDelegate,MFMailComposeViewControllerDelegate> {
	UIActivityIndicatorView *waitView;
	NSMutableArray *menuItems;
	UITableView * tableView;
	NSString * pattern;
	UIImageView *imageView;
	UILabel *waitLabel;
	
	NSString *supportSubject;
	NSString *supportEmail;
}

@property (nonatomic, retain) NSMutableArray *menuItems;
@property (nonatomic,retain) IBOutlet UITableView * tableView;
@property (nonatomic, retain) NSString * pattern;
@property (nonatomic, retain) IBOutlet UIImageView *imageView;
@property (nonatomic, retain) UILabel *waitLabel;
@property (nonatomic, retain) NSString *supportSubject;
@property (nonatomic, retain) NSString *supportEmail;

-(void)goToMenu:(MenuItem *) menuItem;
- (void) showAnimated:(id)sender;
- (void) initStatusBar:(UIView *)actualView;

@end
