//
//  ConfigViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 12/7/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "CustomScrollView.h"

@interface ConfigViewController : UIViewController <UITableViewDataSource,UITableViewDelegate, UITextFieldDelegate> {
	
	IBOutlet UIScrollView *scrollView;
	NSMutableArray * pageItems;
	NSMutableArray * sortFields;
	NSMutableArray * filterFields;
	NSIndexPath * lastIndexPath;
	NSMutableDictionary *tmpData;

}

@property (nonatomic, retain) NSMutableArray *pageItems;
@property (nonatomic, retain) NSMutableArray *sortFields;
@property (nonatomic, retain) NSMutableArray *filterFields;
@property (nonatomic, retain) NSIndexPath * lastIndexPath;
@property (nonatomic, retain) UIScrollView * scrollView;


- (void) initStatusBar:(UIView *)actualView;
- (IBAction)goBack:(id) sender;
- (BOOL) cellChecked:(UITableView *)tableView cell:(NSIndexPath *)indexPath;
- (NSString *) cellText:(UITableView *)tableView cell:(NSIndexPath *)indexPath;
- (void) removeFile:(NSString *) filename;

@end
