//
//  GraphViewController.h
//  app_builder
//
//  Created by ivan bejarano on 9/13/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import <UIKit/UIKit.h>


@interface GraphViewController : UIViewController {
    NSDictionary * infoData;
	UIActivityIndicatorView *waitView;
	UILabel *waitLabel;
	int currentGraph;
	int totalGraph;
	BOOL addedBars;
}

@property (nonatomic, retain) UILabel *waitLabel;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
- (void) showView;
- (void) showGraphic:(NSString *)graphType;
- (void) paintPieChart:(NSMutableArray *)values andNames:(NSMutableArray *)names;
- (void) paintBarChart:(NSMutableArray *)values andNames:(NSMutableArray *)names;
- (void) paintLineChart:(NSMutableArray *)values;

@end
