//
//  ImageScrollerThumbs.h
//  ImageScrollPOC
//
//  Created by Ihonahan on 2/18/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "UIButtonThumbnail.h"
#import "ImageSliderView.h"
#import "imageInfo.h"
#import "ImageViewController.h"
#import "ShareViewController.h"
#import "Config.h"
#import "TBXML.h"
#import "Functions.h"
#import "NSString+HTML.h"
#import "ImageViewController.h"
#import "SendImageViewController.h"
#import "XmlElementWrapper.h"


@interface ImageScrollerThumbs : UIViewController <UIWebViewDelegate, UIScrollViewDelegate>
{
	UIScrollView *myScroll;

	UIImage *bgImage;
	UIImageView *bgImageView;
	BOOL showImage;

	
	//Temporalmente mientras se verifican los procesos
	int						maxPages;
	NSMutableArray		*	titlesArray;
	NSMutableArray * dataArray;
	NSDictionary * infoData;
	int currentFeedPage;
	int maxSlideNumber;
	UIToolbar *toolbar;
	BOOL hiddenTabBar;
	
	
	
	int curPosX;
	int curPosY;
	
	
	NSMutableArray *imageButtonsArray;
	NSMutableArray *largeImagesUrlsArray;
	NSMutableArray *shareUrlsArray;
	int num_items;
	int numPages;
	int currentPage;
	NSString *feedSource;
	NSString *actualId;
	
	NSString * imageName;
	NSString * titleName;
	NSString * imageIdItem;
	NSString * titleIdType;
	NSString * imageIdType;
	NSString * iconName;
	NSString * urlShareName;

	int picsLoaded;
	BOOL loadingImageLoaded;
	int currentLoadedImage;
	
	int minToLoadPage;
	int maxToLoadPage;
	
	int maxPagesQty;
	
	ImageSliderView *slider;
	ShareViewController *shareView;

	UIActivityIndicatorView *waitView;

	NSString *textTitle;
	NSString *textUrl;

	
	UIWebView *aWebView;
	BOOL isAdVisible;

	int currentUrlIndex;
	int currentLoadedPage;

	NSMutableArray *pagesLoaded;

	/* bh */
	UILabel *waitLabel;
	/* bh */

    /*Ihonahan. 20110328.*/
    float didScrollOffsetY;
    /*Ihonahan. 20110328.*/
}

@property (nonatomic, retain) IBOutlet UIScrollView *myScroll;


@property (nonatomic,retain) NSMutableArray *titlesArray;

@property (nonatomic, retain) NSString *textTitle;
@property (nonatomic, retain) NSString *textUrl;

@property (nonatomic, retain) UILabel *waitLabel;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;

- (void) processInfo;
// - (void) addImageFromName:(NSString*)imagename withFolder:(NSString *)foldername;
- (void) initStatusBar:(UIView *)actualView withType:(int)type;


-(void)getImagesXmlWithData:(NSString *)fileNameDir 
					   data:(NSData *)myXMLData
					  image:(NSString *)imageName2 
					  title:(NSString *)titleName2 
				  imageItem:(NSString *)imageIdItem2 
				   fileName:(NSString *)fileNameNoDir 
				   imageIdT:(NSString *)imageIdType2;



-(void)initLoadImages:(NSString *)fileNameNoDir 
		  dataImgname:(NSString *)image 
				  tag:(int)i 
			 iconFile:(NSString *)iconFile 
		 dataImgTitle:(NSString *)titleImg 
		 shareUrlData:(NSString *)shareUrl;



-(void)prepareImageButtonsArray:(int)nItems;

-(NSData *)getXMLForPage:(int)pageNo;

- (void) hidetabbar;

- (void)				goDetail;
- (void)				goInfo;

-(void) initWaitView;
- (void) showAnimated:(id)sender;
- (void) stopAnimated:(id)sender;

-(void) startLoading;

/*Ihonahan. 20110328.*/
-(void)checkToLoadImages:(float)offsetY inRow:(int)offRow;
// float didScrollOffsetY;
/*Ihonahan. 20110328.*/

@end
