//
//  ImageSliderView.h
//  app_builder
//
//  Created by Ihonahan Buitrago on 2/27/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ShareViewController.h"

@interface ImageSliderView : UIScrollView
{
	UIImageView *detailView;
	UIImage *detailImage;

	NSMutableArray *imagesSliderArray;
	int currentUrlIndex;
	
	int soonUrlIndex;
	
	CGRect curRect;
	
	BOOL hasPrev;
	BOOL hasNext;
	BOOL changeImg;
	
	UIActivityIndicatorView *loadingView;
	
	NSMutableArray *titlesSliderArray;
	NSMutableArray *shareUrlsSliderArray;
	/* bh */
	NSString *actualId;
	int page_items;
	ShareViewController *shareView;
	UIViewController * test;
	UITextView * myTextView;
	/* bh */
}
@property(nonatomic, retain) UIImageView *detailView;
@property(nonatomic, retain) UIImage *detailImage;
@property(nonatomic, retain) NSMutableArray *imagesSliderArray;
@property(nonatomic, retain) NSMutableArray *titlesSliderArray;
@property(nonatomic, retain) NSMutableArray *shareUrlsSliderArray;

/* bh */
@property(nonatomic, retain) UIViewController *test;
@property(nonatomic, retain) UITextView * myTextView;
/* bh */

- (id)initWithFrame:(CGRect)frame Image:(UIImage *)img;



-(void)changeImageDetail:(int)urlIndex;



-(void)slideImageToNew:(int)newIndex;

-(void)animateImageToInitial;

- (void)loadImagefromURL :(NSDictionary *)sliderDic;

/* bh */
- (void) goDetail;
- (void) changeActualId:(NSString *)viewId;
- (void) changeNumItems:(int)items;
- (void) changeView:(UIViewController *)theView;
- (void) scaleToFitRect:(CGRect)rect;
/* bh */



@end
