//
//  ListViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 10/28/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ListViewController.h"
#import "Config.h"
#import "Functions.h"
#import "Element.h"
#import "app_builderAppDelegate.h"
#import "WebServiceHelper.h"
#import "NSString+HTML.h"
#import "TBXML.h"
#import "MenuViewController.h"
#import "URLConnection.h"
#import "TabBarViewController.h"
#import "SplitViewController.h"
#import "SilLoginPrompt.h"
#import "ASIFormDataRequest.h"
#import <QuartzCore/QuartzCore.h>

@implementation ListViewController

@synthesize feeds, elements, searchResults;
@synthesize tableView, feedSource;
@synthesize waitLabel;
@synthesize delegate = _delegate;
@synthesize auth;
@synthesize authUrl;
@synthesize reqName;
@synthesize reqType;
@synthesize reqService;
@synthesize reqFields;
@synthesize parentView;

#define USE_CUSTOM_DRAWING 1
/*
-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
    waitView.layer.shadowColor = [UIColor grayColor].CGColor;
    waitView.layer.shadowRadius = 1;
    waitView.layer.shadowOpacity = 0.5;
    waitView.layer.shadowOffset = CGSizeMake(0, 1);
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	NSLog(@"start");
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	NSLog(@"stop");
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}
* /
- (id)init 
{
    if ( self = [super init] ) 
    {
        self.title = @"Root view";
        self.view = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 460)];
        self.view.backgroundColor = [UIColor blackColor];
    }
    return self;
}*/


- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
 -(void) loadView {
	tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 44, 320, 410)];
	tableView.delegate = self;
	tableView.dataSource = self;
	// [tableView setDataSource:self];
	// [tableView setDelegate:self];
	[self.view addSubview:tableView];
}
*/

-(void) loadData {
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[super viewDidLoad];


	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	[Functions addToolBar:self.view withTitle:@" " actualId:actualId];
	[Functions addStatusBar:self.view withTabBar:[tabbar intValue]];
    [self initStatusBar:self.view];
    [cnf release];

	feedId = 0;
	self.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	self.view.tag = 29876;

	// self.hidesBottomBarWhenPushed=YES;

	/*NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	UIImage *tempImg = [[UIImage alloc] initWithData:imgData];
	UIImageView *imageView = [[UIImageView alloc] initWithImage:tempImg];
	[imageView setImage:tempImg];
	[tempImg release];
	imageView.frame = CGRectMake(0, 0, 320, 410);
	[self.view addSubview:imageView];
	[imageView release];*/

	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
		[self setContentSizeForViewInPopover:CGSizeMake(320.0, 400.0)];
	}
	
	//[self initWaitView];
	//[self showAnimated:nil];
    [Functions initWaitView:self.view];
    [Functions showAnimated:self.view];
	[self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
}

- (void) showView {

	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	// cnf = [[Config alloc] initWithName:@"displayView"];
	// NSString * displayView = cnf.value;
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	// cnf = [[Config alloc] initWithName:@"selectedTabBarItem"];
	// NSString * selectedTabBarItem = cnf.value;

	NSLog(@"tb: %@", tabbar);
	// NSLog(@"sel tb: %@", selectedTabBarItem);
	// NSLog(@"title: %@", self.tabBarItem.title);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
//	if ([actualId isEqualToString:@"0"])
//		actualId = 
	//	actualId = [Functions loadFromTabBar:self.tabBarItem.title];
	// NSLog(@"tbi: %@", [Functions loadFromTabBar:self.tabBarItem.title]);
	// NSLog(@"selected i: %i", self.tabBarController.selectedIndex);
	// NSLog(@"idTab (1): %@", self.idTab);
	// NSLog(@"idTab (2): %@", [infoData valueForKey:@"idTab"]);
	NSLog(@"actualId: %@", actualId);
	//tabbar

	tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 44, 320, 410)];
	tableView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-45);
	tableView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-85);
	//CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	//tableView.frame = CGRectMake(0, 44, CGRectGetWidth(mainViewBounds),CGRectGetHeight(mainViewBounds)-45);
	//tableView.frame = CGRectMake(0, 44, 320, CGRectGetHeight(mainViewBounds)-45);
	tableView.delegate = self;
	tableView.dataSource = self;
	tableView.backgroundColor = [UIColor clearColor];
	// [tableView setDataSource:self];
	// [tableView setDelegate:self];
	// self.tableView.opaque = NO;
	[self.view addSubview:tableView];
	searching = NO;
	letUserSelectRow = YES;
	self.tableView.rowHeight = 80;
	// [self initWaitView];
	// [self showAnimated:nil];
	[Functions showAnimated:self.view];

	NSString * title = @"List";

	NSString * url = @"";
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;

	NSString * pattern = @"";
	NSString * titleName = @"";
	NSString * titleFont = @"Courier";
	NSString * titleSize = @"12";
	NSString * titleColor = @"#cccccc";
	NSString * titleStyle = @"regular";
	NSString * titleLink = @"";
	NSString * subtitleName = @"";
	NSString * descriptionFont = @"Courier";
	NSString * descriptionSize = @"12";
	NSString * descriptionColor = @"#cccccc";
	NSString * descriptionStyle = @"regular";
	NSString * descriptionLink = @"";
	NSString * imageName = @"";
	NSString * imageLink = @"";
	NSString * linkName = @"";
	NSString * linkType = @"";
	NSString * linkUrl = @"";
	NSString * search = @"";
	NSString * listType = @"";

	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;

		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f)
		pattern = [TBXML valueOfAttributeNamed:@"template_id" forElement:feedsXMLElement];
		
		/*
		do {
			if ([[TBXML elementName:child] isEqualToString:@"view"]) {
				NSLog(@" %@ - %@",
					  [TBXML elementName:child],
					  [TBXML valueOfAttributeNamed:@"type" forElement:child]);
				if ([[TBXML valueOfAttributeNamed:@"type" forElement:child] isEqualToString:@"2"]) {
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:value]) {
						f = TRUE;
						feedsXMLElement = child;
					}
				}
			}
		} while ((child = child->nextSibling) && (f == FALSE));
		*/
		
		NSString * perPage = @"true";
		NSString * sortSettings = @"true";
		NSString * filterSettings = @"true";
		NSString * multiModule = @"0";

		if (f) {
			feeds = [[NSMutableArray alloc] init];
			NSMutableArray * multiLists = [[NSMutableArray alloc] init];
			// appXMLElement =  feedsXMLElement; // ->firstChild;
			// do {
			// NSLog(@"feeds...");
			
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"tab_bar"]) {
								}
								if ([attribItem isEqualToString:@"button_search"]) {
									search = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"data_source"]) {
									url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									listType = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"detail_title"]) {
									titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									titleLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									titleFont = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
									if (titleName == nil) titleName = @"";
									if (titleLink == nil) titleLink = @"";
									if (titleFont == nil) titleFont = @"";
								}
								if ([attribItem isEqualToString:@"detail_date"]) {
									subtitleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									descriptionLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									descriptionFont = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
									subtitleName = [subtitleName stringByReplacingOccurrencesOfString:@"_" withString:@":"];
									if (subtitleName == nil) subtitleName = @"";
									if (descriptionLink == nil) descriptionLink = @"";
									if (descriptionFont == nil) descriptionFont = @"";
								}
								if ([attribItem isEqualToString:@"detail_image"]) { // list_item_icon
									imageName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									imageLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									NSLog(@"img: ooooooooooooo %@", imageName);
									NSRange range = [imageName rangeOfString:@"media"];
									if (range.length > 0)
										imageName = [imageName stringByReplacingOccurrencesOfString:@"_" withString:@":"];
									NSLog(@"img: ************* %@", imageName);
									if (imageName == nil) imageName = @"";
									if (imageLink == nil) imageLink = @"";
								}
								if ([attribItem isEqualToString:@"detail_link"]) { // list_item_icon
									// titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									linkName = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									linkType = [TBXML valueOfAttributeNamed:@"link_to_type" forElement:childXMLElement];
                                    if ([linkType isEqualToString:@"link"])
                                        linkUrl = [TBXML valueOfAttributeNamed:@"link_to_from_entity" forElement:childXMLElement];
									linkType = [self reviewLinkType:linkName:linkType];
									if (linkName == nil) linkName = @"";
									if (linkType == nil) linkType = @"";
									if (linkUrl == nil) linkUrl = @"";
									NSLog(@"-------> l: %@:%@:%@:--:%@", title, linkName, linkType, linkUrl);
								}

								if ([attribItem isEqualToString:@"per_page"]) {
									perPage = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"sort_settings"]) {
									sortSettings = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"filter_settings"]) {
									filterSettings = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"multi_module"]) {
									multiModule = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								//Ihonahan. 20110406. Use of indexes								
								if ([attribItem isEqualToString:@"use_indexes"]) 
								{
									useIndexes = YES;
								}
								if ([attribItem isEqualToString:@"authentication"]) {
									self.auth = [TBXML valueOfAttributeNamed:@"sequence" forElement:childXMLElement];
									self.authUrl = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if (![multiModule isEqualToString:@"0"]) {
						if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:multiModule]) {
							TBXMLElement * childXMLElement = appXMLElement->firstChild;;
							do {
								[multiLists addObject:[TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement]];
							} while ((childXMLElement = childXMLElement->nextSibling));
							
						}
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
				
			// linkName = @"";
			// linkType = @"";
			
			if ([filterSettings isEqualToString:@"false"] &&
				[sortSettings isEqualToString:@"false"] &&
				[perPage isEqualToString:@"false"]) {
				[infoData setValue:@"false"
							forKey:@"userConfig"];
			} else {
				[infoData setValue:@"true"
							forKey:@"userConfig"];
			}

			
			// [Functions initToolBar:self.view withTitle:title]; // withTitle:@"" withView:NO];
			// [Functions addToolBar:self.view withTitle:title actualId:actualId];
			UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
			toolbarTitle.text = title;

			NSString * popup = @""; // [TBXML valueOfAttributeNamed:@"show_pop_up" forElement:appXMLElement];
			if ([[infoData valueForKey:@"multiList"] isEqualToString:@"1"])
			{

				for (NSString *findId in multiLists) {
					// NSLog(@"::: %@", findId);
					// NSLog(@"o*o %@", [self loadListInfo:findId]);
					// NSArray * feed = [self loadListInfo:findId];
					NSMutableArray * feed = [[NSMutableArray alloc] initWithArray:[self loadListInfo:findId] copyItems:YES];
					[feeds addObject:feed];
					[feed release];
				}	
				/*
				 TBXML * tbxml = [[TBXML tbxmlWithURL:[NSURL URLWithString:url]] retain];
				if (tbxml.rootXMLElement) {
					TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
					TBXMLElement * childXMLElement = rootXMLElement->firstChild;
					do {
						title = [TBXML textForElement:[TBXML childElementNamed:@"title" parentElement:childXMLElement]];
						url = [TBXML textForElement:[TBXML childElementNamed:@"source" parentElement:childXMLElement]];
						NSArray *list = [NSArray arrayWithObjects:title, url, nil];
						[lists addObject:list];
						// [list release];
					} while ((childXMLElement = childXMLElement->nextSibling));  
				}*/

				// NSLog(@"::: feeds %@", feeds);
				NSString *valueSelectedList = [cnf loadValue:[NSString stringWithFormat:@"selectedList_%@", actualId]];
				if ([valueSelectedList intValue] != 0) {
					feedId = [valueSelectedList intValue];
					// [cnf updateValue:[NSString stringWithFormat:@"selectedList_%@", actualId] value:@"0"];
				}

				[self createMutiListView:feeds];
			}
			else 
			{
				FontItem * font = [Functions loadFont:titleFont]; 
				titleFont = font.nameFont;
				titleSize = font.sizeFont;  
				titleColor = font.colorFont;
				titleStyle = font.styleFont;
				font = [Functions loadFont:descriptionFont]; 
				descriptionFont = font.nameFont;
				descriptionSize = font.sizeFont;  
				descriptionColor = font.colorFont;
				descriptionStyle = font.styleFont;
				NSArray *feed = [NSArray arrayWithObjects: title, url, popup, search, pattern,
								 titleFont, titleSize, titleColor, titleStyle,
								 descriptionFont, descriptionSize, descriptionColor, descriptionStyle,
								 linkName, linkType,
								 titleName, subtitleName, imageName, 
								 titleLink, descriptionLink, imageLink, 
								 listType, linkUrl, actualId,
								 nil];
				NSLog(@"feed: %@", feed);
				[feeds addObject:feed];
			}
			[multiLists release];
			//title = @"";
			//url = @"";

			NSArray *feed = [feeds objectAtIndex:feedId];
			/*
			NSLog(@"Array Count: %d",[feeds count]);
			// NSArray * 
			NSLog(@"Array Count: %d",[feed count]);
			for(NSString * test in feed) {
				NSLog(@"feed: %@", test);
			}
			 */

			title = [feed objectAtIndex:0];
			url = [feed objectAtIndex:1];
			url = [url urlUnescapedString];
			NSLog(@"u: %@", url);
			feedSource = url;
			// NSString * 
			popup = [feed objectAtIndex:2];
			// NSString * 
			search = [feed objectAtIndex:3];
			/*pattern = [feed objectAtIndex:4];
			titleFont = [feed objectAtIndex:5];
			titleSize = [feed objectAtIndex:6];
			titleColor = [feed objectAtIndex:7];
			titleStyle = [feed objectAtIndex:8];
			descriptionFont = [feed objectAtIndex:9];
			descriptionSize = [feed objectAtIndex:10];
			descriptionColor = [feed objectAtIndex:11];
			descriptionStyle = [feed objectAtIndex:12];
			linkName = [feed objectAtIndex:13];
			linkType = [feed objectAtIndex:14];
			titleLink = [feed objectAtIndex:18];
			descriptionLink = [feed objectAtIndex:19];
			imageLink = [feed objectAtIndex:20];
			listType = [feed objectAtIndex:21];*/
			// NSLog(@"l: %@:%@:%@", title, linkName, linkType);
			
			[Functions sendWebtrends: title 
						  eventDescr: title
						   eventType: @"view"
						contentGroup: title
						   mediaName: nil
						   mediaType: nil
						  mediaEvent: nil];
			
			int yT = 44;
			//if ([tabbar isEqualToString:@"1"]) yT = 48;
			//	self.tableView.frame = CGRectMake(0,48,320,380-yT);

			if ([popup isEqualToString:@"1"]) {
				// NSLog(@"go ad...");
				[self performSelector:@selector(showAd) withObject:nil afterDelay:5.0];
			}
			// 44 search
			if ([feeds count] > 1) {
				if ([tabbar isEqualToString:@"1"]) yT += 34;
				// self.tableView.frame = CGRectMake(0,yS+94,320,366-yS-yT);
			}
			if ([search isEqualToString:@"true"]) {
				// int yT = 0;
				// self.tableView.frame = CGRectMake(0,yS+94,320,366-yS-yT);
				searchResults = [[NSMutableArray alloc]init];
				searchBar = [[UISearchBar alloc]initWithFrame:CGRectMake(0,yT,self.view.frame.size.width,44)]; // 50
				searchBar.delegate = self;
				[self.view addSubview:searchBar];
				if ([tabbar isEqualToString:@"1"]) yT += 44;
			}
			if (yT)
			tableView.frame = CGRectMake(0, yT, self.view.frame.size.width, self.view.frame.size.height-yT-40);

			// download info
			NSLog(@"download...");

			NSDate *date = [NSDate date];
			NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
			// NSDateFormatter *dateFormat = [[[NSDateFormatter alloc] init] autorelease];

			// int itemCounter = 0;
			// NSURL *u = [NSURL URLWithString:url];
			// NSData *myXMLData;

			// WebServiceHelper * loadWebService = [[WebServiceHelper alloc] init];
			// NSString * tmpUrl = @"http://mediasuite.multicastmedia.com/rss/vod.php?p=f30jt6g5&thumbs=true";
			// [loadWebService callWebService:tmpUrl delegate:self requestSelector:@selector(test:)];
			// NSString * webService = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/mh_mobile_convert_rss.asmx";
			// NSString * callMethod = @"ConvertRSS";

			// NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug",nil]; // @"numpage",@"pagesize",@"sortby",@"filterby",nil];
			// NSArray *keyvalues = [NSArray arrayWithObjects:url ,@"true", nil];	
			// [loadWebService callWebService:webService methodName:callMethod keys: keys values:keyvalues delegate:self requestSelector:nil];
			
			// cnf = [[Config alloc] initWithName:@"actualId"];
			NSString * displayId = actualId; // cnf.value;
			//tabbar
			NSString * tabbar = [cnf loadValue:@"useTabBar"];
			NSLog(@"tb: %@", tabbar);
			NSLog(@"title: %@", self.tabBarItem.title);
			// NSLog(@"title: %i", self.tabBarController.selectedIndex);
			if ([tabbar isEqualToString:@"1"]) {
				// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
				displayId = [infoData valueForKey:@"idTab"];
			}

			/*
			NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
			NSString *tmpFileName = [NSString stringWithString:dbName];
			// NSLog(@"name 1: %@", tmpFileName);
			 */
			NSString *feedPage = @"";
			if (feedId != 0)
				feedPage = [NSString stringWithFormat:@"_%i", feedId];
			NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			NSString *documentsDir = [documentPaths objectAtIndex:0];
			NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]];

			NSString *displayIdValue = [cnf loadValue:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]];

            // Use moduleId in multiList
            // NSArray * feed = [feeds objectAtIndex:feedId];
            NSString * moduleId = [feed objectAtIndex:23];
            if ([feeds count] > 1)
                displayIdValue = [NSString stringWithFormat:@"tmp_%@_2.xml", moduleId];
            // Use moduleId in multiList
			
			if([displayIdValue isEqualToString:@""] || displayIdValue == nil
			   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
				NSLog(@"down ... ");
				// myXMLData = [NSData dataWithContentsOfURL:u];
				// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
				[dateFormat setDateFormat:@"YYYYMMddHHmm"];
				NSString *dateString = [dateFormat stringFromDate:date];  
				[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] value:dateString];
						[dateFormat release];
		// [loadWebService callWebService:webService methodName:callMethod 
				//						  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
				[self goDownload];
			} else {
				
				// NSTimeInterval dateTime;		
				// NSDateFormatter *
				// dateFormat = [[[NSDateFormatter alloc] init] autorelease];
				[dateFormat setDateFormat:@"yyyyMMddHHmm"];
				NSDate *lastCheck = [dateFormat dateFromString:displayIdValue];
				date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
				
				// dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);
				/*
				 NSLog(@"t: %@ - %@", 
				 [dateFormat stringFromDate:date],
				 [dateFormat stringFromDate:[dateFormat dateFromString:@"201010150300"]]
				 );
				 NSLog(@" date = %@", date);
				 NSLog(@" date = %@", lastCheck);
				 */
				int day1 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:date];
				int day2 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:lastCheck];
				NSLog(@"%i - %i * %@ - %@", day1, day2, [dateFormat stringFromDate:date], [dateFormat stringFromDate:lastCheck]);
				
				// if(dateTime > 1) {
				if(day1 != day2) {
					// if ([date timeIntervalSinceDate:lastCheck] >= 1 ) // today is before launch
					NSLog(@"down (2)... ");
					// myXMLData = [NSData dataWithContentsOfURL:u];
					// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
					[dateFormat setDateFormat:@"YYYYMMddHHmm"];
					NSString *dateString = [dateFormat stringFromDate:date];  
					// [dateFormat release];
					NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_2.xml", displayId],dateString);
					[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] value:dateString];
					[dateFormat release];
					// [loadWebService callWebService:webService methodName:callMethod 
					//						  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
					[self goDownload];
				} else {
					// myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
					// [self processXml:[[NSData alloc] initWithContentsOfFile:fileName]];
					[dateFormat release];
					[self showXML];
				}
			}
			
			// NSLog(@"--> %@ <--", elements);
		} else {
			NSLog(@"err");
			
			// Also issue visual alert
			UIAlertView *alert = [[UIAlertView alloc]
								  initWithTitle:@"Information file doesn't exist."
								  message:nil
								  delegate:nil
								  cancelButtonTitle:nil
								  otherButtonTitles:@"OK", nil];
			[alert show];
			[alert release];
		}
	}
	[cnf release];
	
    if (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad) {
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
	[[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleDefault animated:NO];
	[[UIApplication sharedApplication] setStatusBarHidden:NO withAnimation:UIStatusBarAnimationNone];
	}

#if USE_CUSTOM_DRAWING
	self.tableView.rowHeight = 80;
	self.tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
	self.tableView.backgroundColor = [UIColor clearColor];
#endif

	tableView.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin | UIViewAutoresizingFlexibleRightMargin | UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleTopMargin | UIViewAutoresizingFlexibleWidth);
	self.tableView.autoresizingMask = (UIViewAutoresizingFlexibleRightMargin 
									   |  UIViewAutoresizingFlexibleHeight
									   | UIViewAutoresizingFlexibleTopMargin 
									   | UIViewAutoresizingFlexibleWidth);
	

}

-(void) dataLoaded :(NSMutableData*)content {
	NSLog(@"loaded...");
	
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	NSString * displayId = actualId;

	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"YYYYMMddHHmm"];
	NSString *dateString = [dateFormat stringFromDate:date];  
	// [dateFormat release];
	// NSString *name = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	// [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] withValue:dateString];
	NSString *feedPage = @"";
	if (feedId != 0)
		feedPage = [NSString stringWithFormat:@"_%i", feedId];
	NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage],dateString);
	[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage] value:dateString];

	[cnf release];
	// NSLog(@"%@", [[NSString alloc] initWithData:content encoding:NSASCIIStringEncoding]);
	[self processXml:content];
	
	[dateFormat release];
}

- (void) processXml:(NSMutableData *)myXMLData {
	NSLog(@"process");

	// NSLog(@"%@", [[NSString alloc] initWithData:myXMLData encoding:NSASCIIStringEncoding]);

	Config * cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	//tabbar
	// cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];// cnf.value;
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		displayId = [infoData valueForKey:@"idTab"];
	}

	// NSLog(@"%@", [NSString stringWithFormat:@"tmp_%@_2.xml", displayId]);
	// NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	NSString *feedPage = @"";
	if (feedId != 0)
		feedPage = [NSString stringWithFormat:@"_%i", feedId];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]];

	// Use moduleId in multiList
    if ([feeds count] > 1)
    {
        NSArray * feed = [feeds objectAtIndex:feedId];
        NSString * moduleId = [feed objectAtIndex:23];
        fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2.xml", moduleId]];
    }
	// Use moduleId in multiList

    // cnf = [cnf loadValue:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId]];

	// convertrss
	/* 
	elements = [[NSMutableArray alloc] init];
	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	TBXMLElement * childXMLElement;
	 if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		TBXMLElement * rssXMLElement = [TBXML childElementNamed:@"ConvertRSSResponse" parentElement:childXMLElement];
		rssXMLElement = [TBXML childElementNamed:@"ConvertRSSResult" parentElement:rssXMLElement];
		
		NSString * rssData = [TBXML textForElement:rssXMLElement];
	NSData * XMLData = [rssData dataUsingEncoding:NSUTF8StringEncoding];
		// NSLog(@"--> *** %@", XMLData);
		[XMLData writeToFile:fileName atomically:YES];
		NSLog(@"saved %@...", fileName);
		// NSString *unescaped = [[TBXML textForElement:rssXMLElement] htmlUnescapedString];
		//  escaped = [escaped htmlUnescapedString];

		// [myXMLData writeToFile:fileName atomically:YES];
		/ *
		 NSError *error;
		if (![unescaped writeToFile:fileName atomically:YES encoding:NSASCIIStringEncoding error:&error]) {
			NSLog(@"Error while saving\n%@",
				  ([error localizedDescription] != nil) ? [error localizedDescription] : @"Unknown Error");
		}
		[self showXML];

	// convertrss
	// }
	 */
	
	[cnf release];
	
	[myXMLData writeToFile:fileName atomically:YES];
	[self showXML];

}

- (void)showXML {
	NSLog(@"show");

	int itemCounter = 0;
	NSArray * feed = [feeds objectAtIndex:feedId];

	NSLog(@"-----------------");
	NSLog(@"-----------------");
	NSLog(@"-------xx--------");
	NSLog(@"feed %@", feed);
	NSLog(@"-------xx--------");
	NSLog(@"-----------------");
	NSLog(@"-----------------");

	// NSString * title = [feed objectAtIndex:0];
	// NSString * url = [feed objectAtIndex:1];
	// NSString * popup = [feed objectAtIndex:2];
	// NSString * search = [feed objectAtIndex:3];
	NSString * pattern = [feed objectAtIndex:4];
	NSString * titleFont = [feed objectAtIndex:5];
	NSString * titleSize = [feed objectAtIndex:6];
	NSString * titleColor = [feed objectAtIndex:7];
	NSString * titleStyle = [feed objectAtIndex:8];
	NSString * descriptionFont = [feed objectAtIndex:9];
	NSString * descriptionSize = [feed objectAtIndex:10];
	NSString * descriptionColor = [feed objectAtIndex:11];
	NSString * descriptionStyle = [feed objectAtIndex:12];
	NSString * linkName = [feed objectAtIndex:13];
	NSString * linkType = [feed objectAtIndex:14];
	NSString * linkUrl = [feed objectAtIndex:22];
	NSString * titleName = [feed objectAtIndex:15];
	NSString * subtitleName = [feed objectAtIndex:16];
	NSString * imageName = [feed objectAtIndex:17];
    if ([imageName isEqualToString:@"Select"]) imageName = @"";
	NSString * titleLink = [feed objectAtIndex:18];
	NSString * descriptionLink = [feed objectAtIndex:19];
	// NSString * imageLink = [feed objectAtIndex:20];
	// NSString * listType = [feed objectAtIndex:21];
	NSLog(@"-----------------");
	NSLog(@"-----------------");
    NSLog(@"image name ? %@", imageName);
	NSLog(@"-----------------");
	NSLog(@"-----------------");

	// BOOL auth = YES;
	NSLog(@"auth: %@", auth);
	if (auth != nil)
	if (![auth isEqualToString:@"0"])
	{
		//	[self loadAuth];
		[self loadAuth:FALSE errMsg:@""];
		// [self doAuth:FALSE errMsg:@""];
	}
	else
	{
		[self callAuth:@"Anonymous" withPassword:@""];
		/*
		 NSString *autName = [NSString stringWithFormat:@"tmp_%@_18.log", displayId];
		 NSString * value = [cnf loadValue:autName];
		 if ([value isEqualToString:@"true"]) {
		 [self goDownload];
		 } else {
		 [dateFormat setDateFormat:@"YYYYMMddHHmm"];
		 NSString *dateString = [dateFormat stringFromDate:date];  
		 [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_18.xml", displayId] withValue:dateString];
		 [self doAuth:FALSE];
		 }*/
		
	}
	
	/*int yS = 0;

	if ([feeds count] > 1) {
		yS = 39;
		// self.tableView.frame = CGRectMake(0,yS+44,320,339-yS);
	}*/
	/*if ([search isEqualToString:@"true"]) {
		// int yS = 0;
		if ([feeds count] > 1) yS = 39;
		// self.tableView.frame = CGRectMake(0,yS+94,320,366-yS);
		searchResults = [[NSMutableArray alloc]init];
		searchBar = [[UISearchBar alloc]initWithFrame:CGRectMake(0,yS+44,320,44)]; // 50
		searchBar.delegate = self;
		[self.view addSubview:searchBar];
	}*/

	Config * cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		displayId = [infoData valueForKey:@"idTab"];
		[cnf updateValue:@"displayId" value:displayId];
	}

	// NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	NSString *feedPage = @"";
	if (feedId != 0)
		feedPage = [NSString stringWithFormat:@"_%i", feedId];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]];

    // Use moduleId in multiList
	NSString * moduleId = [feed objectAtIndex:23];
    if ([feeds count] > 1)
        fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2.xml", moduleId]];
	NSLog(@"--> filename %@", fileName);
	// Use moduleId in multiList

	NSData *XMLData = [NSData dataWithContentsOfFile:fileName];  
	NSString *unescaped = [[[NSString alloc] initWithData:XMLData encoding:NSUTF8StringEncoding] autorelease];
	unescaped = [unescaped htmlUnescapedString];
	// NSLog(@"--> %@", unescaped);
	
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	[tbxml release];
	// elements = [[NSMutableArray alloc] initWithCapacity:10];
	// elements = [[NSMutableArray alloc] init];
	TBXMLElement * childXMLElement;
	// elements = [[NSMutableArray alloc] initWithCapacity:10];
	elements = [[NSMutableArray alloc] init];
	// rootXMLElement = tbxml.rootXMLElement;
	// TBXMLElement * childXMLElement;
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
				if (!(childXMLElement->firstChild == nil)) {
				TBXMLElement * dataXMLElement = childXMLElement->firstChild;
				// NSInteger total = 1;
				do {
					Element * element = [[Element alloc] init];
					TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
					// NSLog(@"ch %@ ", [TBXML elementName:itemXMLElement]);
					// NSLog(@"id %@ ", [TBXML valueOfAttributeNamed:@"id" forElement:dataXMLElement]);
					element.idList = [NSString stringWithFormat:@"%i", itemCounter]; // [TBXML valueOfAttributeNamed:@"id" forElement:dataXMLElement];
					itemCounter++;
					element.pattern = pattern;
					element.titleFont = titleFont;
					element.titleSize = titleSize;
					element.titleStyle = titleStyle;
					element.titleColor = titleColor;
					element.descriptionFont = descriptionFont;
					element.descriptionColor = descriptionColor;
					element.descriptionSize = descriptionSize;
					element.descriptionStyle = descriptionStyle;
					element.linkType = linkType;
					element.link = linkName;
					do {
						// NSLog(@"sub %@ ? %@", [TBXML elementName:itemXMLElement], imageName);
						if ([[TBXML elementName:itemXMLElement] isEqualToString:titleName]) {
							// NSLog(@"tt: element.title %@", [TBXML textForElement:itemXMLElement]);
							element.title = [TBXML textForElement:itemXMLElement];
							element.titleLink = titleLink;
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:subtitleName]) {
							// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
							element.description = [TBXML textForElement:itemXMLElement];
							element.descriptionLink = descriptionLink;
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:linkUrl]) {
							// NSLog(@"element.linkUrl: %@", [TBXML textForElement:itemXMLElement]);
							element.linkUrl = [TBXML textForElement:itemXMLElement];
						}
                        if ([[TBXML elementName:itemXMLElement] isEqualToString:imageName]) {
							// NSLog(@"img -> %@", imageName);
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							//if ([element.linkType isEqualToString:@"video"])
							//	element.thumb = [TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement];
							//else
							//	element.thumb = [TBXML textForElement:itemXMLElement];
							if (!element.thumb)
							if ([TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement])
								element.thumb = [TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement];
							else
								element.thumb = [TBXML textForElement:itemXMLElement];
							//NSLog(@"thumb %@ %@", element.linkType, element.thumb);
							//element.thumbLink = imageLink;
						}
						/*
						 if ([[TBXML elementName:itemXMLElement] isEqualToString:linkName]) {
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							if ([element.linkType isEqualToString:@"video"])
								element.link = [TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement];
							else
								element.link = linkName; // [TBXML textForElement:itemXMLElement];
						}*/
					} while ((itemXMLElement = itemXMLElement->nextSibling));
					// total++;
					[elements addObject:element];
					[element release];
				} while ((dataXMLElement = dataXMLElement->nextSibling));
				} else {
					NSLog(@"data null...");
					UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Empty list." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
					[alert show];
					[alert release];	
					[waitView stopAnimating];
					waitView.hidden=YES;
					waitLabel.hidden=YES;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling));

		NSString * displayId = [cnf loadValue:@"actualId"];
		if ([tabbar isEqualToString:@"1"]) {
			displayId = [infoData valueForKey:@"idTab"];
		}
		NSString *feedPage = @"";
		if (feedId != 0)
			feedPage = [NSString stringWithFormat:@"_%i", feedId];
		NSString *newName = [NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage];

        // Use moduleId in multiList
        // NSArray * feed = [feeds objectAtIndex:feedId];
        NSString * moduleId = [feed objectAtIndex:23];
        if ([feeds count] > 1)
            newName = [NSString stringWithFormat:@"tmp_%@_2.xml", moduleId];
        // Use moduleId in multiList

        NSString *newNameValue = [cnf loadValue:newName];
		
		NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:newNameValue];
		
		[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
		[label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:lastCheck]]];
		[dateFormat release];
		
	}

	[self preloadThumbs];

	[self.tableView setContentOffset:CGPointZero animated:YES];
	[self.tableView reloadData];
	self.tableView.scrollEnabled = YES;
	letUserSelectRow = YES;
	// [self stopAnimated:nil];
    [Functions stopAnimated:self.view];
	[cnf release];
	
	NSLog(@"-----------------");
	NSLog(@"-----------------");
	NSLog(@"first element %@", (Element *)[[elements objectAtIndex:0] title]);
	NSLog(@"count element %i", [elements count]);
	NSLog(@"-----------------");
	NSLog(@"-----------------");
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
	{
		if ([parentView isKindOfClass:[SplitViewController class]])
		{
			Element *element = (Element *)[elements objectAtIndex:0];
			[self loadView:element];
			NSLog(@"first...");
		}
	}
	NSLog(@"go?");
	
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return YES; // (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[waitLabel release];
	[popupView release];
	[searchBar release];
	[feeds release];
	[elements release];
	[searchResults release];
	[feedSource release];
	[toolbar release];
	[label release];
	[tableView release];
	[popupView release];
	[searchBar release];
	[elements release];
	[infoData release];
	[auth release];
	[authUrl release];
	[thumbsArray release];
	[reqFields release];
	[reqName release];
	[reqType release];
	[reqService release];
    [super dealloc];
}

- (void) initStatusBar:(UIView *)actualView {
	//tabbar
	Config *cnf = [[Config alloc] init];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	/*int tabSpace = 0;
	if ([tabbar isEqualToString:@"1"])
		tabSpace = 48;*/
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	
	/*
	 toolbar = [UIToolbar new];
	[toolbar sizeToFit];
    toolbar.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	toolbar.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleWidth);

	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
    toolbar.tag = 20009;
	[toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 102.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 102.0, 320, toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, CGRectGetHeight(mainViewBounds)-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	
	/ *toolbar.tintColor = [UIColor blueColor];
	toolbar.barStyle = UIBarStyleBlackTranslucent;
	toolbar.alpha = 0.7;* /
	toolbar.tintColor = [UIColor colorWithRed:.2 green:.5 blue:.7 alpha:.1];
	toolbar.frame = CGRectMake(0, self.view.frame.size.height-toolbarHeight, self.view.frame.size.width, toolbarHeight);
	*/
	// UIToolbar * 
	toolbar = (UIToolbar *)[actualView viewWithTag:11003];
	
	/*//Get the bounds of the parent view 
	CGRect rootViewBounds = self.parentViewController.view.bounds;
	
	//Get the height of the parent view. 
	CGFloat rootViewHeight = CGRectGetHeight(rootViewBounds);
	
	//Get the width of the parent view, 
	CGFloat rootViewWidth = CGRectGetWidth(rootViewBounds);
	
	//Create a rectangle for the toolbar 
	CGRect rectArea = CGRectMake(0, rootViewHeight - toolbarHeight, rootViewWidth, toolbarHeight);
	
	//Reposition and resize the receiver 
	[toolbar setFrame:rectArea];	
	
	
	[actualView addSubview:toolbar];*/

	// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
	[button addTarget:self action:@selector(goRefresh) forControlEvents:UIControlEventTouchUpInside];
	
	// const NSInteger IMAGE_TAG = 1003;
	button.frame = CGRectMake(288, 2, 30, 30);
	[button setFrame:CGRectMake(CGRectGetMaxX(mainViewBounds)-32, 2, 30, 30)];
	[button setFrame:CGRectMake([toolbar frame].size.width -32, 2, 30, 30)];
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	UIImage *btnImage = [UIImage imageNamed:@"tabbutton_refresh.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	button.autoresizingMask = (UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleLeftMargin);
	/*	button.autoresizingMask = UIViewAutoresizingFlexibleRightMargin;

	// button.UIViewContentMode = UIViewContentModeLeft;
	button.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleWidth);*/
	
	[toolbar addSubview:button];
	
	// [button release];
	
	// info
	UIButton *infoButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[infoButton addTarget:self action:@selector(goInfo) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	infoButton.tag = 20004;
	infoButton.frame = CGRectMake(14, 2, 30, 30);
	btnImage = [UIImage imageNamed:@"info_icon.png"];
	// infoButton.tag = IMAGE_TAG;
	infoButton.backgroundColor = [UIColor clearColor];
	[infoButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	[toolbar addSubview:infoButton];
	// [infoButton release];
	// info

	if ([[infoData valueForKey:@"userConfig"] isEqualToString:@"true"]) {

	// config
	UIButton *configButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[configButton addTarget:self action:@selector(goConfig) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	configButton.frame = CGRectMake(56, 2, 30, 30);
	btnImage = [UIImage imageNamed:@"icon_user_settings.png"];
	// infoButton.tag = IMAGE_TAG;
	configButton.backgroundColor = [UIColor clearColor];
	[configButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	// [toolbar addSubview:configButton];
	// [infoButton release];
	// config
	}

	// UILabel *
	label = [[UILabel alloc] initWithFrame:
			 CGRectMake(100,3,185,30)];
    label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	label.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
							   | UIViewAutoresizingFlexibleRightMargin 
							   | UIViewAutoresizingFlexibleLeftMargin 
							   | UIViewAutoresizingFlexibleTopMargin 
							   | UIViewAutoresizingFlexibleWidth);
	[label setFrame:CGRectMake(CGRectGetMaxX(mainViewBounds)-225, 3, 185, 30)];
	[label setFrame:CGRectMake([toolbar frame].size.width-225, 3, 185, 30)];
	[label setFrame:CGRectMake(self.view.frame.size.width-225, 3, 185, 30)];
    /*
	 NSDateFormatter *formatter = [[[NSDateFormatter alloc] init] autorelease];
	 NSDate *date = [NSDate date];
	 [formatter setDateFormat:@"MM/dd/YY HH:mm"];
	 // [label setText:[formatter stringFromDate:date]];
	 [label setText:[NSString stringWithFormat:@"Updated: %@", [formatter stringFromDate:date]]];
	 */
	NSString * displayId = [cnf loadValue:@"actualId"];
	// NSLog(@"tb: %@", tabbar);
	// NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	NSString *feedPage = @"";
	if (feedId != 0)
		feedPage = [NSString stringWithFormat:@"_%i", feedId];
	NSString *newName = [NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage];

    // Use moduleId in multiList
    NSArray * feed = [feeds objectAtIndex:feedId];
    NSString * moduleId = [feed objectAtIndex:23];
    if ([feeds count] > 1)
        newName = [NSString stringWithFormat:@"tmp_%@_2.xml", moduleId];
    // Use moduleId in multiList

    // NSLog(@"name 2: %@", newName);
	NSString *newNameValue = [cnf loadValue:newName];
	
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"yyyyMMddHHmm"];
	NSDate *lastCheck = [dateFormat dateFromString:newNameValue];
	// NSLog(@"date: %@", cnf.value);
	// NSLog(@"date 2: %@", [dateFormat stringFromDate:lastCheck]);
	
	[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
	[label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:lastCheck]]];
	[dateFormat release];

	
    label.backgroundColor = [UIColor clearColor];
    // label.backgroundColor = [UIColor blueColor];
    label.textColor = [UIColor whiteColor];
    label.font = [UIFont boldSystemFontOfSize:11];
    label.textAlignment = UITextAlignmentRight;
	
	[toolbar addSubview:label];
    // [label release];
	
	[cnf release];
}
	
#pragma mark UISearchBarDelegate

- (void) searchBarTextDidBeginEditing:(UISearchBar *)theSearchBar {
	
	searchBar.showsCancelButton = YES;
	
	NSString *searchText = searchBar.text;
	if([searchText isEqualToString:@""] || searchText==nil)
		return;
	
	searching = YES;
	letUserSelectRow = NO;
	searchBar.showsCancelButton = YES;
	searchBar.autocorrectionType = UITextAutocorrectionTypeNo;
	self.tableView.scrollEnabled = NO;
}

- (void)searchBarTextDidEndEditing:(UISearchBar *)theSearchBar
{
	searchBar.showsCancelButton = NO;
}


- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText
{
	[searchResults removeAllObjects];
	
	if([searchText length] > 0) {
		searching = YES;
		letUserSelectRow = YES;
		self.tableView.scrollEnabled = YES;
		[self searchTableView];
	}
	else {
		searching = NO;
		letUserSelectRow = NO;
		self.tableView.scrollEnabled = NO;
	}
	[self.tableView reloadData];
}

- (void) searchTableView {
	NSString *searchText = searchBar.text;
	if([searchText isEqualToString:@""] || searchText==nil)
	{
		[self.tableView reloadData];
		return;
	}
	
	/*
	 NSMutableArray *searchArray = [[NSMutableArray alloc] init];
	 for (NSDictionary *dictionary in elements)
	 {
	 NSArray *array = [dictionary objectForKey:elements];
	 [searchArray addObjectsFromArray:array];
	 }
	 
	 for (NSString *sTemp in searchArray)
	 {
	 NSRange titleResultsRange = [sTemp rangeOfString:searchText options:NSCaseInsensitiveSearch];
	 
	 if (titleResultsRange.length > 0)
	 [searchResults addObject:sTemp];
	 }
	 
	 [searchArray release];
	 searchArray = nil;
	 */
	NSInteger counter = 0;
	// for(NSString *name in elements)
	for(Element *element in elements)
	{
		NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		// NSRange r = [element.title rangeOfString:searchText];
		NSRange r = [element.title rangeOfString:searchText options:NSCaseInsensitiveSearch];
		if(r.location != NSNotFound)
		{
			// if(r.location== 0)//that is we are checking only the start of the names.
			// {
			[searchResults addObject:element];
			// }
		} else {
			if (element.description != nil && ![element.description isEqualToString:@""]) {
				NSRange r = [element.description rangeOfString:searchText options:NSCaseInsensitiveSearch];
				if(r.location != NSNotFound)
				{
					[searchResults addObject:element];
				}
			}
		}
		counter++;
		[pool release];
	}
	
}

- (void)searchBarCancelButtonClicked:(UISearchBar *)theSearchBar
{
	// if a valid search was entered but the user wanted to cancel, bring back the main list content
	// [self.tableView removeAllObjects];
	// [elements addObjectsFromArray:elements];
	NSLog(@"Cancel");
	searching = NO;
	letUserSelectRow = NO;
	letUserSelectRow = YES;
	self.tableView.scrollEnabled = YES;
	@try{
		[self.tableView reloadData];
		[self.tableView setContentOffset:CGPointZero animated:YES];
	}
	@catch(NSException *e){
	}
	[searchBar resignFirstResponder];
	searchBar.text = @"";
}

- (void)searchBarSearchButtonClicked:(UISearchBar *)theSearchBar
{
	NSLog(@"Search");
	[searchBar resignFirstResponder];
	[self searchTableView];
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
//    return 1;
	if (searching || !useIndexes)
		return 1;
	else
		return [elements count];
}

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // return 0;
	if (searching)
		return [searchResults count];
	else
		return elements.count;
}

- (NSIndexPath *)tableView :(UITableView *)theTableView willSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	if(letUserSelectRow)
		return indexPath;
	else
		return nil;
}

- (NSArray *)sectionIndexTitlesForTableView:(UITableView *)atableView 
{
	if(searching || !useIndexes)
		return nil;
	else
	{
		NSMutableArray *result = [[NSMutableArray alloc] init];
		
		//	int i=0;
		//	for(i=0;i<10;i++)
		//	{
		//		[result addObject:[NSString stringWithFormat:@"%d",i]];
		//	}
		
		[result addObject:@"/"];
		[result addObject:@"#"];
		
		char j='A';
		
		for (j='A'; j<='Z'; j++)
		{
			[result addObject:[NSString stringWithFormat:@"%c",j]];
		}
		
		return result;
	}
}

- (NSInteger)tableView:(UITableView *)atableView sectionForSectionIndexTitle:(NSString *)title atIndex:(NSInteger)index 
{
	if(searching || !useIndexes)
		return -1;
	else
	{
		if (index == 0) 
		{
			return 0;
		}
		else if(index == 1)
		{
			return -1;
		}
		else
		{
			int i=0;
			for (i=0; [elements count]; i++)
			{
				Element *item = [elements objectAtIndex:i];
				NSRange rng;
				rng.length=1;
				rng.location=0;
				if([item.title compare:title options:NSCaseInsensitiveSearch range:rng] == NSOrderedSame)
				{
//					return i;
					NSIndexPath *newInxPath = [NSIndexPath indexPathForRow:i inSection:0];
					[atableView scrollToRowAtIndexPath:newInxPath atScrollPosition:UITableViewScrollPositionTop animated:NO];
					return -1;
				}
			}
			return -1;
		}
	}
}

/*- (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath {
	
	//return UITableViewCellAccessoryDetailDisclosureButton;
	//return UITableViewCellAccessoryDisclosureIndicator;
	return UITableViewCellAccessoryNone;
}*/

- (void)tableView:(UITableView *)atableView accessoryButtonTappedForRowWithIndexPath:(NSIndexPath *)indexPath {
	
	[self tableView:atableView didSelectRowAtIndexPath:indexPath];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)aTableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	// NSLog(@"BOOL = %d", (int)searching);
	static NSString *CellIdentifier = @"Cell";
    
	const NSInteger TOP_LABEL_TAG = 1001;
	const NSInteger BOTTOM_LABEL_TAG = 1002;
	const NSInteger IMAGE_TAG = 1003;
	// const NSInteger TEST_LABEL_TAG = 1010;
	UIButton *topLabel;
	
	UIButton *bottomLabel;
//	UIButton *imageCell;
	UIImageView *imageCell;
	// UILabel *testLabel;
	Element *element;
	
	if (searching)
		element = (Element *)[searchResults objectAtIndex:indexPath.row];
	else
		element = (Element *)[elements objectAtIndex:indexPath.row];
	

	BOOL isThumbNull = YES;

	// NSLog(@"id: %@", element.idList);
	NSLog(@"-----------------");
	NSLog(@"-----------------");
	NSLog(@"-----------------");
	NSLog(@"imageth ??? : %@", element.thumb);
	NSLog(@"-----------------");
	NSLog(@"-----------------");
	NSLog(@"-----------------");
	NSLog(@"-----------------");
	
	/*Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	[cnf release];*/
	
    /*
	 UITableV// iewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	 if (cell == nil) {
	 cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
	 }
	 */
    UITableViewCell *cell = [aTableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
		/*
		 UIImage *indicatorImage = [UIImage imageNamed:@"button_right.png"];
		 cell.accessoryView =
		 [[[UIImageView alloc]
		 initWithImage:indicatorImage]
		 autorelease];
		 */
		
		// const CGFloat LABEL_HEIGHT = 20;
		// NSLog(@"pattern %@", element.pattern);
		
		CGRect newTopLabelFrame = CGRectMake(70, 15, 200, 20);
		CGRect newBottomLabelFrame = CGRectMake(70, 45, 200, 20);
		CGRect newThumbnailFrame = CGRectZero;
		newThumbnailFrame = CGRectMake(5, 5, 60, 60);
		
		
		if(useIndexes)
		{
			newTopLabelFrame.size.width -= 30;
			newBottomLabelFrame.size.width -= 30;
		}
		
//		imageCell = [UIButton buttonWithType:UIButtonTypeCustom];
		imageCell = [[[UIImageView alloc] initWithFrame:newThumbnailFrame] autorelease];
		imageCell.tag = IMAGE_TAG;
        [cell.contentView addSubview:imageCell];

		if(element.thumb == nil || [element.thumb isEqualToString:@""])
		{
			newTopLabelFrame.origin.x -= 65;
			newBottomLabelFrame.origin.x -= 65;
			newTopLabelFrame.size.width += 65;
			newBottomLabelFrame.size.width += 65;			
		}
		else
		{

		// cell image
			//		UIImage * btnImage = [[UIImage alloc] init];
			if (![element.pattern isEqualToString:@"1"]) {
				//			imageCell.frame = CGRectMake(5, 10, 60, 60);
				imageCell.frame = newThumbnailFrame;
				// imageCell.frame = CGRectMake(250, 4, 42, 35);
				//			[btnImage release];
				//			btnImage = nil;
				UIImage * btnImage = [UIImage imageNamed:@"unknown.jpg"];
				imageCell.backgroundColor = [UIColor clearColor];
				// btnImage = [Functions resizeImage:btnImage width:40 height:40];
//				[imageCell setImage:btnImage forState:UIControlStateNormal];
				imageCell.image = btnImage;
				imageCell.contentMode = UIViewContentModeScaleAspectFit;
				
				// [btnImage release];
//				[imageCell addTarget:self
//							  action:@selector(loadView:)
//					forControlEvents:UIControlEventTouchUpInside];
			}
		}

		
		if(element.title == nil)
		{
			newBottomLabelFrame.origin.y -= 30;
			newBottomLabelFrame.size.height += 30;
		}
		
		if(element.description == nil)
		{
			newTopLabelFrame.size.height += 30;
		}
		
		//cell accesory
		NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
		NSString *documentsDir = [documentPaths objectAtIndex:0];
		NSString *fileName = @"/indicator.png";
		NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
		NSData *imgData = [NSData dataWithContentsOfFile:filePath];
		UIImage *indicatorImage = [UIImage imageWithData:imgData];
		cell.accessoryView =
		[[[UIImageView alloc]
		  initWithImage:indicatorImage]
		 autorelease];
		
		//
		// Create the label for the top row of text
		//
		topLabel = [UIButton buttonWithType:UIButtonTypeCustom];
//		topLabel.frame = CGRectMake(
//									/*btnImage.size.width*/70/2 + 3.3 * cell.indentationWidth,
//									0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT),
//									aTableView.bounds.size.width -
//									/*btnImage.size.width*/70/2 - 4.0 * cell.indentationWidth
//									- 30,
//									LABEL_HEIGHT);
		topLabel.frame = newTopLabelFrame;
		[cell.contentView addSubview:topLabel];
		topLabel.tag = TOP_LABEL_TAG;
		topLabel.backgroundColor = [UIColor clearColor];
		// topLabel.backgroundColor = [UIColor redColor];
		// topLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize]];
		[topLabel addTarget:self
					 action:@selector(goView:)
		   forControlEvents:UIControlEventTouchUpInside];
		topLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		// [topLabel setTitleColor:[UIColor whiteColor] forState:UIControlStateSelected];
		// [topLabel setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
		// [topLabel setTitleShadowColor:[UIColor colorWithRed:0.25 green:1.0 blue:1.0 alpha:1.0] forState:UIControlStateSelected];
		// [topLabel setContentHorizontalAlignment:UIControlContentHorizontalAlignmentLeft];
		// topLabel.backgroundColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		// UIFont* font = [UIFont fontWithFamilyName:@"Verdana" traits:GSBoldFontMask size:24];
		// theBtn.titleLabel.font = font;
		// [[topLabel titleLabel] setFont:font];
		// [topLabel.titleLabel setFont:[UIFont systemFontOfSize:24]];
		// [topLabel.titleLabel setFont:[UIFont fontWithName:@"American Typewriter" size:24]];
		// [UIFont systemFontOfSize:20]
		
		// element.titleStyle = titleStyle;
		
#ifdef OS_VER_3
#elseif defined OS_VER_2
#endif
		
		//
		// Create the label for the top row of text
		//
		bottomLabel = [UIButton buttonWithType:UIButtonTypeCustom];
//		bottomLabel.frame = CGRectMake(
//									   /*btnImage.size.width*/70/2 + 3.3 * cell.indentationWidth,
//									   0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT) + LABEL_HEIGHT,
//									   aTableView.bounds.size.width -
//									   /*btnImage.size.width*/70/2 - 4.0 * cell.indentationWidth
//									   - 30,
//									   LABEL_HEIGHT);

		bottomLabel.frame = newBottomLabelFrame;
		bottomLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth;

		[cell.contentView addSubview:bottomLabel];
		bottomLabel.tag = BOTTOM_LABEL_TAG;
		bottomLabel.backgroundColor = [UIColor clearColor];
		[bottomLabel addTarget:self
						action:@selector(loadView:)
			  forControlEvents:UIControlEventTouchUpInside];
		// [bottomLabel setTag:indexPath.row];
		[bottomLabel setContentHorizontalAlignment:UIControlContentHorizontalAlignmentLeft];
		// [bottomLabel setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
		
		// testLabel = [[UILabel alloc] initWithFrame:CGRectMake(80, 0, 240, 40)];
		// testLabel.tag = TEST_LABEL_TAG;
		// [cell.contentView addSubview:testLabel];
		
		cell.backgroundView =
		[[[UIImageView alloc] init] autorelease];
		cell.selectedBackgroundView =
		[[[UIImageView alloc] init] autorelease];
		
	}
	else
	{
		topLabel = (UIButton *)[cell viewWithTag:TOP_LABEL_TAG];
		bottomLabel = (UIButton *)[cell viewWithTag:BOTTOM_LABEL_TAG];
//		imageCell = (UIButton *)[cell viewWithTag:IMAGE_TAG];
		imageCell = (UIImageView *)[cell viewWithTag:IMAGE_TAG];
		// testLabel = (UILabel *)[cell viewWithTag:TEST_LABEL_TAG];
	}
	
	// Set up the cell...
	// [cell setText: menuItem.name];
	// cell.textLabel.text = element.title;
	cell.selectionStyle = UITableViewCellSelectionStyleGray;
	
	NSData * imgData;
	if (nil != element.thumb)
    {
/*
			//Ihonahan. 20110406. Else, use it as always.
			NSURL *url = [NSURL URLWithString:element.thumb];
			imgData = [NSData dataWithContentsOfURL:url];
			
			//Ihonahan. 20110406. End.
			
			UIImage *btnImage = [UIImage imageWithData:imgData];
			
			//		btnImage = [Functions resizeImage:btnImage width:60 height:60];
			//		[imageCell setImage:btnImage forState:UIControlStateNormal];
			imageCell.image = btnImage;
			imageCell.contentMode = UIViewContentModeScaleAspectFit;
		// [btnImage release];
			//		[imageCell addTarget:self
			//					  action:@selector(loadView:)
			//			forControlEvents:UIControlEventTouchUpInside];
			//		[imageCell setTitle:element.description forState:UIControlStateNormal];
		imageCell.hidden = NO;
		
		CGRect newTopLabelFrame = CGRectMake(70, 15, 200, 20);
		CGRect newBottomLabelFrame = CGRectMake(70, 45, 200, 20);
		/ *newTopLabelFrame.origin.x -= 65;
		newBottomLabelFrame.origin.x -= 65;
		newTopLabelFrame.size.width += 65;
		newBottomLabelFrame.size.width += 65;* /
		if(element.description == nil)
			newTopLabelFrame.size.height += 30;
		topLabel.frame = newTopLabelFrame;
		bottomLabel.frame = newBottomLabelFrame;
*/
		if (nil != element.thumb && isThumbNull) 
		{
			//		NSData * imgData = [[NSData alloc] init];
			//		NSLog(@"-------->image...  %@", element.thumb);
			//		NSURL *url = [NSURL URLWithString:element.thumb];
			//		imgData = [[NSData alloc] initWithContentsOfURL:url];
			//		UIImage *btnImage = [[UIImage alloc] initWithData:imgData];
			//		//		btnImage = [Functions resizeImage:btnImage width:60 height:60];
			//		[imageCell setImage:btnImage forState:UIControlStateNormal];
			//		// [btnImage release];
			//		[imageCell addTarget:self
			//					  action:@selector(goView:)
			//			forControlEvents:UIControlEventTouchUpInside];
			//		[imageCell setTitle:element.description forState:UIControlStateNormal];
			NSData * imgData = (NSData *)[thumbsArray objectAtIndex:indexPath.row];
			//		UIImage *btnImage = [[[UIImage alloc] initWithData:imgData] autorelease];
			if (imgData) {
				UIImage *btnImage = [UIImage imageWithData:imgData];
				//		btnImage = [Functions resizeImage:btnImage width:60 height:60];
				imageCell.image = btnImage;
				imageCell.contentMode = UIViewContentModeScaleAspectFit;
				imageCell.hidden = NO;
                // [btnImage release]; //// release to review !!!!!!!
				
			}
		}
			
        CGRect tmpFrame = topLabel.frame;
        tmpFrame.origin.x = 70;
		topLabel.frame = tmpFrame;
        tmpFrame = bottomLabel.frame;
        tmpFrame.origin.x = 70;
		bottomLabel.frame = tmpFrame;

	} else {
		imageCell.hidden = YES;

        CGRect tmpFrame = topLabel.frame;
        tmpFrame.origin.x = 5;
		topLabel.frame = tmpFrame;
        tmpFrame = bottomLabel.frame;
        tmpFrame.origin.x = 5;
		bottomLabel.frame = tmpFrame;

		/*CGRect newTopLabelFrame = CGRectMake(70, 15, 200, 20);
		CGRect newBottomLabelFrame = CGRectMake(70, 45, 200, 20);
		newTopLabelFrame.origin.x -= 65;
		newBottomLabelFrame.origin.x -= 65;
		newTopLabelFrame.size.width += 65;
		newBottomLabelFrame.size.width += 65;			
		if(element.description == nil)
			newTopLabelFrame.size.height += 30;
		topLabel.frame = newTopLabelFrame;
		bottomLabel.frame = newBottomLabelFrame;*/
	
	}

	
	/*
	int twoLines = 0;
	if ([element.twoLines isEqualToString:@"true"]) {
		twoLines = 20;
		topLabel.titleLabel.lineBreakMode = UILineBreakModeWordWrap;
		topLabel.titleLabel.numberOfLines = 2;
	}*/

	// NSString *subtitle = [NSString stringWithString: @"All about the color "];
	// subtitle = [subtitle stringByAppendingFormat:colorString];
	
	// cell.detailTextLabel.text = element.description; // subtitle;
	
	// NSString *tmpTitle = element.description;
	// testLabel.text = tmpTitle;
	[topLabel setTitle:element.title forState:UIControlStateNormal];
	// NSLog(@"set title %@", element.title);
	[topLabel setTitle:element.title forState:UIControlStateHighlighted];
	[topLabel setTitle:element.title forState:UIControlStateDisabled];
	[topLabel setTitle:element.title forState:UIControlStateSelected];
	// topLabel.titleLabel.font = [UIFont fontWithName:element.titleFont size:[element.titleSize intValue]];
	NSString * titleFont;
	// NSLog(@"TF: %@ %@", element.titleFont, element.titleSize);
	if (element.titleFont != nil) {
		/*if ([element.titleStyle isEqualToString:@"bold"]) {
			// element.titleFont = [[element.titleFont autorelease] stringByAppendingString:@"-Bold"];
			titleFont = [element.titleFont stringByAppendingString:@"-Bold"];
		} else if ([element.titleStyle isEqualToString:@"italic"]) {
			titleFont = [element.titleFont stringByAppendingString:@"-Oblique"];
		} else if ([element.titleStyle isEqualToString:@"bold-italic"]) {
			titleFont = [element.titleFont stringByAppendingString:@"-BoldOblique"];
		} else {
			titleFont = element.titleFont;
		}*/
		titleFont = [Functions fontName:element.titleFont fontStyle:element.titleStyle];
		[topLabel.titleLabel setFont:[UIFont fontWithName:titleFont size:[element.titleSize intValue]]];
		[topLabel setTitleColor:[Functions colorForHex: element.titleColor] forState:UIControlStateNormal];
	}
	topLabel.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
	
	if (![element.linkType isEqualToString:@"link"] && (
        element.link == nil ||
		[element.link isEqualToString:@"none"] ||
		[element.link isEqualToString:@""]))
		cell.accessoryView = nil;
	else {
		//cell accesory
		NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
		NSString *documentsDir = [documentPaths objectAtIndex:0];
		NSString *fileName = @"/indicator.png";
		NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
		NSData *imgData = [NSData dataWithContentsOfFile:filePath];
		UIImage *indicatorImage = [UIImage imageWithData:imgData];
		/*indicatorImage = [Functions resizeImage:indicatorImage
										  width:30 height:30];*/
		cell.accessoryView =
		[[[UIImageView alloc]
		  initWithImage:indicatorImage]
		 autorelease];
		
	}


//	if (nil == element.thumb) {
		// NSLog(@"image?");
//		const CGFloat LABEL_HEIGHT = 20;
//		topLabel.frame = CGRectMake(
//									2 * cell.indentationWidth,
//									0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT),
//									aTableView.bounds.size.width -
//									4.0 * cell.indentationWidth
//									- 25,
//									LABEL_HEIGHT);
//		bottomLabel.frame = CGRectMake(
//									   2 * cell.indentationWidth,
//									   0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT) + LABEL_HEIGHT,
//									   aTableView.bounds.size.width -
//									   4.0 * cell.indentationWidth
//									   - 20,
//									   LABEL_HEIGHT);
//	}
	
//	if (element.description == nil) {
//		topLabel.titleLabel.lineBreakMode = UILineBreakModeWordWrap;
//		topLabel.titleLabel.numberOfLines = 2;
//		int imageSize = 0;
//		// if (![element.pattern isEqualToString:@"1"]) 
//		if (nil != element.thumb)
//			imageSize = 90;
//		topLabel.frame = CGRectMake(
//									imageSize/2 + 2.5 * cell.indentationWidth,
//									0.5 * (aTableView.rowHeight - 2 * 20),
//									aTableView.bounds.size.width -
//									imageSize/2 - 4.0 * cell.indentationWidth
//									- 25,
//									20*2);
//	}
	
	// NSLog(@"tt: %@", element.title);
	[bottomLabel setTitle:element.description forState:UIControlStateNormal];
	// NSLog(@"DF: %@ %@", element.descriptionFont, element.descriptionSize);
	if (element.descriptionFont != nil) {
		/*if ([element.descriptionStyle isEqualToString:@"bold"]) {
			// element.titleFont = [[element.titleFont autorelease] stringByAppendingString:@"-Bold"];
			titleFont = [element.descriptionFont stringByAppendingString:@"-Bold"];
		} else if ([element.descriptionStyle isEqualToString:@"italic"]) {
			titleFont = [element.descriptionFont stringByAppendingString:@"-Oblique"];
		} else if ([element.descriptionStyle isEqualToString:@"bold-italic"]) {
			titleFont = [element.descriptionFont stringByAppendingString:@"-BoldOblique"];
		} else {
			titleFont = element.descriptionFont;
		}*/
		titleFont = [Functions fontName:element.descriptionFont fontStyle:element.descriptionStyle];
		[bottomLabel.titleLabel setFont:[UIFont fontWithName:titleFont size:[element.descriptionSize intValue]]];
		[bottomLabel setTitleColor:[Functions colorForHex: element.descriptionColor] forState:UIControlStateNormal];
	}

	// UIImage *rowBackground = [UIImage imageNamed:@"bg_cell.png"];
	// ((UIImageView *)cell.backgroundView).image = rowBackground;

	// [cell setBackgroundView: rowBackground];
	// cell.imageView.image = [UIImage imageNamed:@"bg_cell.png"];
	// cell.backgroundImage = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"bg_cell.png"]];

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
		NSString *fileName = @"/bg_cell.png"; // button_right.png";
		NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
		imgData = [NSData dataWithContentsOfFile:filePath];
	// cell.imageView.image = [[UIImage alloc]  initWithData:imgData];
	((UIImageView *)cell.backgroundView).image = [UIImage imageWithData:imgData];
	((UIImageView *)cell.selectedBackgroundView).image = [UIImage imageWithData:imgData];

	// ((UIImageView *)cell.selectedBackgroundView).image = rowBackground;
	
	/*
	 imagen pendiente...
	 testXmlListDetailAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	 NSString * offline = [appDelegate loadOffline];
	 NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	 NSString *documentsDir = [documentPaths objectAtIndex:0];
	 NSData *imgData;
	 UIImage *img;
	 NSString *data = project.thumb;
	 NSLog(@"thumb: %@", data);
	 NSArray *parts = [data componentsSeparatedByString:@"/"];
	 NSString *filename;
	 NSString *imgPath = [documentsDir stringByAppendingPathComponent:@"/thumbs/"];
	 [[NSFileManager defaultManager] createDirectoryAtPath:imgPath attributes:nil];
	 filename = [parts objectAtIndex:[parts count]-2];
	 imgPath = [imgPath stringByAppendingPathComponent:filename];
	 [[NSFileManager defaultManager] createDirectoryAtPath:imgPath attributes:nil];
	 filename = [parts lastObject]; 
	 imgPath = [imgPath stringByAppendingPathComponent:filename];
	 if (offline == @"onl") {
	 NSURL *imgURL = [NSURL URLWithString:data];
	 imgData = [NSData dataWithContentsOfURL:imgURL];
	 [imgData writeToFile:imgPath atomically:YES];
	 } else {
	 // imgData = [[NSData alloc] initWithContentsOfFile:imgPath];
	 // img = [[UIImage alloc] initWithData:imgData];
	 }
	 imgData = [[NSData alloc] initWithContentsOfFile:imgPath];
	 img = [[UIImage alloc] initWithData:imgData];
	 cell.imageView.image = img;
	 */
	
	// cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
	// cell.accessoryType = UITableViewCellAccessoryNone;
	
	[topLabel setEnabled: NO];
	[bottomLabel setEnabled: NO];
	// [imageCell setEnabled: NO];

	if (
		![element.pattern isEqualToString:@"7"] && 
		![element.pattern isEqualToString:@"8"] && 
		![element.pattern isEqualToString:@"9"]
		) {
	// if (![element.titleLink isEqualToString:@"none"])
		[topLabel setEnabled: YES];
	// if (![element.descriptionLink isEqualToString:@"none"])
		[bottomLabel setEnabled: YES];
	// if (![element.thumbLink isEqualToString:@"none"])
//		[imageCell setEnabled: YES];
	}
	[bottomLabel setEnabled: NO];
	[topLabel setEnabled: NO];
	// [imageCell setEnabled: NO];

	return cell;
}

- (void)tableView:(UITableView *)aTableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
	NSLog(@"???");	
	//NSThread *thrAni=[[NSThread alloc] initWithTarget:self
	//										 selector:@selector(showAnimated:) object:self];
	//[thrAni start];
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
	if (![[self parentViewController] isKindOfClass:[SplitViewController class]])
		// [self showAnimated:nil];
	[Functions showAnimated:self.view];

	NSLog(@"parent? %@ %d", [self parentViewController], ([[self parentViewController] isKindOfClass:[TabBarViewController class]]));
	[NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(showAd) object:nil];
	[NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(hideAd) object:nil];
	
	[aTableView deselectRowAtIndexPath:indexPath animated:NO];
	// NSLog(@"p: %d", indexPath);

	Element *element;
	
	if (searching)
		element = (Element *)[searchResults objectAtIndex:indexPath.row];
	else
		element = (Element *)[elements objectAtIndex:indexPath.row];
	
	NSLog(@"e: %@", element.link);
	
	if (![element.linkType isEqualToString:@"link"] && (
        [element.link isEqualToString:@""] ||
		[element.link isEqualToString:@"none"] ||
		element.link == nil)) {
		// [self stopAnimated:nil];
        [Functions stopAnimated:self.view];
		return;
	}
	
	[self loadView:element];
}

- (IBAction)goView:(id)sender {
	
	// titleLink
    NSString *buttonTitle = [(UIButton *)sender currentTitle];
    NSInteger buttonTag = [(UIButton *)sender tag];
	NSLog(@"b: %@ , %i", buttonTitle, buttonTag);
	
	UITableViewCell *cell = (UITableViewCell*)[[sender superview] superview];
    NSIndexPath* indexPath = [[self tableView] indexPathForCell:(UITableViewCell*)cell];
	// NSLog(@"i: %d", index);
	Element *element;
	
	if (searching)
		element = (Element *)[searchResults objectAtIndex:indexPath.row];
	else
		element = (Element *)[elements objectAtIndex:indexPath.row];

	if (buttonTag == 1001)
		element.link = element.titleLink;
	else if (buttonTag == 1002)
		element.link = element.descriptionLink;
	else if (buttonTag == 1003)
		element.link = element.thumbLink;

	// element.link = element.titleLink;

	NSLog(@"must?...");
	if (!element.link) return;
	NSLog(@"loading view...");
	
	[self loadView:element];

}

-(void)loadView:(Element *) element {
	/*
	 Config * cnf;
	 cnf = [[Config alloc] initWithName:@"selectedListItem"];
	 NSString * value = cnf.value;
	 if (value == @"") {
	 int primaryKey = [Config insertValue:@"selectedListItem" value: element.idList];
	 // NSLog("pk %d", primaryKey);
	 } else {
	 [Config updateValue:@"selectedListItem" value: element.idList];
	 }
	 */
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];

	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	NSLog(@"el: %@", element.linkType);	
	NSLog(@"el: %@", element.linkUrl);	
	NSString *feedPage = @"";
	if (feedId != 0)
		feedPage = [NSString stringWithFormat:@"_%i", feedId];

    // Use moduleId in multiList
    if ([feeds count] > 1)
    {
        NSArray * feed = [feeds objectAtIndex:feedId];
        NSString * moduleId = [feed objectAtIndex:23];
        feedPage = @"";
        actualId = moduleId;
    }
    // Use moduleId in multiList

    if ([element.linkType isEqualToString:@"url"]) {
		NSLog(@"??? %@", element.link);
		[cnf updateValue:@"selectedListItem" value:@"0"];
		[cnf updateValue:@"goUrl" value:element.link];
		[cnf updateValue:@"displayId" value:@"0"];
		[cnf updateValue:@"feedSource" value:[NSString stringWithFormat:@"tmp_%@_2%@.xml", actualId, feedPage]];
		[appDelegate displayView:@"5"]; // :[appDelegate detailType]];
	} else if ([element.linkType isEqualToString:@"link"]) {
		[cnf updateValue:@"selectedListItem" value:@"0"];
		[cnf updateValue:@"goUrl" value:element.linkUrl];
		[cnf updateValue:@"displayId" value:@"0"];
		[cnf updateValue:@"feedSource" value:[NSString stringWithFormat:@"tmp_%@_2%@.xml", actualId, feedPage]];
		[appDelegate displayView:@"5"]; // :[appDelegate detailType]];
	} else if ([element.linkType isEqualToString:@"video"]) {
		// detail
		[cnf updateValue:@"selectedListItem" value: element.idList];
		[cnf updateValue:@"displayId" value:element.link];
		[cnf updateValue:@"feedSource" value:[NSString stringWithFormat:@"tmp_%@_2%@.xml", actualId, feedPage]];
		// detail
		
		[cnf updateValue:@"goUrl" value:element.link];
		// [Functions updateConfig:@"displayId" withValue:@"0"];
		[appDelegate displayView:@"6"]; // :[appDelegate detailType]];
	} else {
		NSLog(@"aaa %@", element.link);
		[cnf updateValue:@"selectedListItem" value: element.idList];
		[cnf updateValue:@"goUrl" value:@"---"];
		[cnf updateValue:@"displayId" value:element.link];
		[cnf updateValue:@"feedSource" value:[NSString stringWithFormat:@"tmp_%@_2%@.xml", actualId, feedPage]];

		NSLog(@"self : %@ parent %@ %d", self, self.parentViewController , 
			  [self.parentViewController isKindOfClass:[UISplitViewController class]]);

		if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
			if ([parentView isKindOfClass:[SplitViewController class]])
			{
				[cnf release];
				NSLog(@"go?");
				if (_delegate != nil) {
					NSLog(@"delegate");
					[_delegate ListSelectionChanged];
				}
				// [self stopAnimated:nil];
                [Functions stopAnimated:self.view];
				return;
			}
		TBXMLElement * root = [Functions readConfigXmlFile];
		TBXMLElement * childXMLElement = root->firstChild;
		NSString * newView = @"7";
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"idItem: %@ value : %@ type: %@", idItem, element.link, type);
				if ([element.link isEqualToString:idItem]) {
					NSLog(@"??");
					newView = type;
					break;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
		NSLog(@"nv: %@", newView);
		[appDelegate displayView:newView];
	}

	/*
	 xmlDetailViewController * aXmlDetailViewController = [[xmlDetailViewController alloc] initWithNibName:@"DescriptionView" bundle:nil];
	 
	 aXmlDetailViewController.aProject = [projects objectAtIndex:indexPath.row];
	 NSLog(@"go... %@", aXmlDetailViewController.aProject.title);
	 [self.navigationController pushViewController:aXmlDetailViewController animated:YES];
	 
	 [aXmlDetailViewController release];
	 */
	
	[cnf release];
}

-(NSString *) reviewLinkType: (NSString *)linkName: (NSString *)linkType {
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"linkName : %@ - idItem: %@ ", linkName, idItem);
				if ([linkName isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			/*
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"detail_link"]) {
									
									if ([[TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement] isEqualToString:@"media_content"])
										linkType = @"video";
									
								}
							}
						} while (childXMLElement = childXMLElement->nextSibling);
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			 */
			NSString *attribItem = [TBXML valueOfAttributeNamed:@"type" forElement:feedsXMLElement];
			if ([attribItem isEqualToString:@"6"])
				linkType = @"video";
		}
	}
	return linkType;
}

- (void) goRefresh {
	//NSThread *thrAni=[[NSThread alloc] initWithTarget:self
	//										 selector:@selector(showAnimated:) object:self];
	//[thrAni start];
	// [self showAnimated:nil];
	[Functions showAnimated:self.view];
	searching = NO;
	letUserSelectRow = NO;
	self.tableView.scrollEnabled = NO;
	
	NSLog(@"download...");
	
	[self goDownload];
}

- (void) goDownload {

	BOOL isInternetConnected=[Functions connectedToNetwork];
	
    if (!isInternetConnected){
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"You do not have an internet connection. Please check your settings and try again later." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];
		[self showXML];
		return;
	}else{
		
	}

	NSArray * feed = [feeds objectAtIndex:feedId];
	NSString * url = [feed objectAtIndex:1];
	NSString * listType = [feed objectAtIndex:21];
	NSString * moduleId = [feed objectAtIndex:23];


    NSLog(@"** ** ** ** ** ** ** * l: %@:%@", listType, moduleId);

    
	// download info
	// NSURL *u = [NSURL URLWithString:url];
	// NSData *myXMLData   = [NSData dataWithContentsOfURL:u];

	// NSString * tmpUrl = @"http://mediasuite.multicastmedia.com/rss/vod.php?p=f30jt6g5&thumbs=true";
	// [loadWebService callWebService:tmpUrl delegate:self requestSelector:@selector(test:)];
	// WebServiceHelper * loadWebService = [[WebServiceHelper alloc] init];
	// NSString * webService = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/mh_mobile_convert_rss.asmx";
	// NSString * callMethod = @"ConvertRSS";

	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}

	// if(thumbsArray != nil)
	//	[thumbsArray release];
	// BOOL isInternetConnected=[Functions connectedToNetwork];
    // if (isInternetConnected)
    NSString *feedPage = @"";
    if (feedId != 0)
        feedPage = [NSString stringWithFormat:@"_%i", feedId];
    NSString * fileNameNoDir = [NSString stringWithFormat:@"tmp_%@_2%@", actualId, feedPage];
    if ([feeds count] > 1)
        fileNameNoDir = [NSString stringWithFormat:@"tmp_%@_2", moduleId];

    [Functions deleteAllFilesInPath:fileNameNoDir];

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
		
	NSString * perPage = @"true";
	NSString * sortSettings = @"true";
	NSString * filterSettings = @"true";
	
	// NSMutableArray * pageItems = [[NSMutableArray alloc] init];
	NSMutableArray * sortFields = [[NSMutableArray alloc] init];
	NSMutableArray * filterFields = [[NSMutableArray alloc] init];
	NSMutableDictionary * tmpData = [[NSMutableDictionary alloc] init];
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				//NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		TBXMLElement * appXMLElement;
		NSString * perPageId = @""; // [[NSString alloc] init];
		NSString * sortSettingsId = @""; // [[NSString alloc] init];
		NSString * filterSettingsId = @""; // [[NSString alloc] init];
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"per_page"]) {
									perPageId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									perPage = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"sort_settings"]) {
									sortSettingsId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									sortSettings = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"filter_settings"]) {
									filterSettingsId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									filterSettings = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:sortSettingsId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								[sortFields addObject:attribItem];
								//NSString * fieldName = [NSString stringWithFormat:@"sort_%@_%@", 
								//						actualId, attribItem];
								
								NSString * value = [cnf loadValue:[NSString stringWithFormat:@"sort_%@_%@", actualId, attribItem]];
								[tmpData setObject:value forKey:[NSString stringWithFormat:@"sort_%@_%@", actualId, attribItem]];
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:filterSettingsId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								[filterFields addObject:attribItem];
								//NSString * fieldName = [NSString stringWithFormat:@"filter_", 
								//						actualId, attribItem];
								//cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"filter_%@_%@", actualId, attribItem]];
								
								NSString * value = [cnf loadValue:[NSString stringWithFormat:@"filter_%@_%@", actualId, attribItem]];
								[tmpData setObject:value forKey:[NSString stringWithFormat:@"filter_%@_%@", actualId, attribItem]];
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
        NSLog(@"pp: %@ %@ %@ %@ %@ %@ ", perPageId, perPage, sortSettingsId, sortSettings, filterSettingsId, filterSettings);
	}
		
	NSString * perPageVal = [cnf loadValue:[NSString stringWithFormat:@"perPage_%@", actualId]];
	//if (perPageVal == nil || [perPageVal isEqualToString:@""])
	//	perPageVal = perPage;


	[tmpData setObject:perPageVal
				forKey:[NSString stringWithFormat:@"perPage_%@", actualId]];

	NSLog(@"data: %@", tmpData);
	NSString * filterStr = @"";
	NSString * sortStr = @"";
	NSString * pageSize = @"0";
	
	for (NSString *key in tmpData) {
		NSLog(@"%@ is %@",key, [tmpData objectForKey:key]);
		NSRange textRange;
		textRange =[key rangeOfString:[NSString stringWithFormat:@"sort_%@", actualId]];
		// NSLog(@"range: %@", textRange);
		if(textRange.location != NSNotFound)
		{
			NSLog(@"value: %@", [tmpData objectForKey:key]);
			if ([[tmpData objectForKey:key] isEqualToString:@"1"]) {
				NSString * tmpString = [key stringByReplacingOccurrencesOfString:[NSString stringWithFormat:@"sort_%@_", actualId] withString:@""];
				NSLog(@"tmp %@", tmpString);
				sortStr = [sortStr stringByAppendingString:[NSString stringWithFormat:@"%@,", tmpString]];
				// [tmpString release];
			}
		}
		textRange =[key rangeOfString:[NSString stringWithFormat:@"filter_%@", actualId]];
		if(textRange.location != NSNotFound)
		{
			if (!([[tmpData objectForKey:key] isEqualToString:@""])) {
				NSLog(@"value: %@", [tmpData objectForKey:key]);
				NSString * tmpString = [key stringByReplacingOccurrencesOfString:[NSString stringWithFormat:@"filter_%@_", actualId] withString:@""];
				NSLog(@"tmp %@", tmpString);
				filterStr = [filterStr stringByAppendingString:[NSString stringWithFormat:@"%@='%@',", tmpString, [tmpData objectForKey:key]]];
				// [tmpString release];
			}
		}
		textRange =[key rangeOfString:[NSString stringWithFormat:@"perPage_%@", actualId]];
		if(textRange.location != NSNotFound)
		{
			NSLog(@"value: %@", [tmpData objectForKey:key]);
			switch ([[tmpData objectForKey:key] intValue]) {
				case 1:
					pageSize = @"10";
					break;
				case 2:
					pageSize = @"20";
					break;
				case 3:
					pageSize = @"30";
					break;
			}
		}
	}
	NSLog(@"pageSize: %@", pageSize);
	pageSize = @"8900";

	[sortFields release];
	[filterFields release];
	[tmpData release];

	if ( [sortStr length] > 0 )
		sortStr = [sortStr substringToIndex:[sortStr length] - 1];	
	if ( [filterStr length] > 0 )
		filterStr = [filterStr substringToIndex:[filterStr length] - 1];	

	NSLog(@"sort: %@", sortStr);
	NSLog(@"filter: %@", filterStr);
	
	/*
	 "filter_2028_link" = "";
	 "filter_2028_title" = Test;
	 "perPage_2028" = 1;
	 "sort_2028_title" = 1;
	 */
	NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug",@"strNumpage",@"strPagesize",@"strSortBy",@"strFilterby",nil];
	// NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug", nil]; // ],@"numpage",@"pagesize",@"sortby",@"filterby",nil];
	NSArray *keyvalues = [NSArray arrayWithObjects:url, @"true", @"1", pageSize, sortStr, filterStr,nil];	

	NSLog(@"keys: %@", keys);
	NSLog(@"keyvalues: %@", keyvalues);
	
	// NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug", nil];
	// NSArray *keyvalues = [NSArray arrayWithObjects:url,@"true", nil];	
	// ws?
	//[loadWebService callWebService:webService methodName:callMethod 
	//						  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
	
	// myString = [myString stringByReplacingOccurrencesOfString:@"texttoreplace" withString:@""];

	
	// old
	// URLConnection * urlConnection = [[URLConnection alloc] initWithUrl:url];
	// [urlConnection downloadData:self];
	// old

	NSString *loadUrl = [cnf loadValue:@"servicesUrl"];
	// NSString *  = @"http://184.73.161.149:8040/services/get_rss.aspx";
	if ([listType isEqualToString:@"3"])
		loadUrl = [NSString stringWithFormat:@"%@/get_atom.aspx", loadUrl];
		// loadUrl = @"http://184.73.161.149:8040/services/.aspx";
	else
		loadUrl = [NSString stringWithFormat:@"%@/get_rss.aspx", loadUrl];

	NSString * post = @""; // [[NSString alloc] init];
	for (int i=0;i<[keys count];i++)
	{
		post = [post stringByAppendingString:[keys objectAtIndex:i]];
		post = [post stringByAppendingString:@"="];
		NSString * myString = [keyvalues objectAtIndex:i];
		myString = [myString stringByReplacingOccurrencesOfString:@"'" withString:@""];
		post = [post stringByAppendingString:[myString urlEscapedString]];
		post = [post stringByAppendingString:@"&"];
	}

	// NSLog(@"post : %@", post);
	
	loadUrl = [loadUrl stringByAppendingString:[NSString stringWithFormat:@"?%@", post]];
	// NSLog(@"loadUrl : %@", loadUrl);

	NSURL *u = [NSURL URLWithString:loadUrl];
	NSMutableData *myXMLData = [NSData dataWithContentsOfURL:u];

	// copy from loaded
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"YYYYMMddHHmm"];
	NSString *dateString = [NSString stringWithFormat:@"%@", [dateFormat stringFromDate:date] ];  
	
	[dateFormat release];
	
	// NSString *name = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	// [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] withValue:dateString];
	// NSString *feedPage = @"";
	if (feedId != 0)
		feedPage = [NSString stringWithFormat:@"_%i", feedId];
	NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_2%@.xml", actualId, feedPage],dateString);
	// [cnf updateValue:[NSString stringWithFormat:@"tmp_%@_2%@.xml", actualId, feedPage] value:dateString];
    
    // changed to fileNameNoDir - use moduleId
	[cnf updateValue:fileNameNoDir value:dateString];
	[cnf release];

	// NSLog(@"%@", [[NSString alloc] initWithData:content encoding:NSASCIIStringEncoding]);
	[self processXml:myXMLData];
	
	
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSMutableData*)myXMLData
{
	// NSString *content = [NSString stringWithUTF8String:[data bytes]]; // NSASCIIStringEncoding
	// NSString *content = [[NSString alloc]  initWithBytes:[data bytes]
	//											  length:[data length] 
	//											encoding: NSUTF8StringEncoding];
	// NSLog(@"data: %@", content);
    NSLog(@"didReceiveData");
	NSLog(@"data: %@", [[[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding] autorelease]);
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    NSLog(@"didFinishLoading");
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    NSLog(@"didFailWithError");
}

-(void)internetUrlError:(URLConnection *)urlConnection {
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Error downloading update." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
	[alert show];
	[alert release];	
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.hidden=YES;
}

-(void)internetUrlReady:(URLConnection *)urlConnection {
	NSMutableData *myXMLData   = urlConnection.xmlDownload;

	Config *cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [Functions loadFromTabBar:self.tabBarItem.title];
	}

	NSString *feedPage = @"";
	if (feedId != 0)
		feedPage = [NSString stringWithFormat:@"_%i", feedId];
	NSLog(@"%@", [NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]);
	// NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]];
	// cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]];
	
		[myXMLData writeToFile:fileName atomically:YES];
		NSLog(@"saved %@...", fileName);
		[self showXML];
		
	[cnf release];
}

- (void) goInfo {
	/*NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];
	[thrAni release];*/
	[Functions showAnimated:self.view];
	// [Functions updateConfig:@"goInfo" withValue:@"1"];
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:@"9"];
}

- (void) goConfig {
	NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];
	[thrAni release];
	// [Functions updateConfig:@"goInfo" withValue:@"1"];
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:@"11"];
}

/*
- (BOOL)doesContainSubstring:(NSString *)substring{
	//If self or substring have 0 length they cannot match
	//This can have odd results with NSRange
	if([self length] == 0 || [substring length] == 0)
		return NO;
	NSRange textRange;
	textRange = [[self lowercaseString] rangeOfString:[substring lowercaseString]];
	if(textRange.location != NSNotFound)
	{
		return YES;
	}else{
		return NO;
	}
}
*/

- (IBAction)loadFeed:(id)sender {
    NSString *buttonTitle = [(UIButton *)sender currentTitle];
    NSInteger buttonTag = [(UIButton *)sender tag];
	NSLog(@"b: %@ , %i", buttonTitle, buttonTag);
	
	int 
	i = 0;
	do {
		UIButton * tmpButton = (UIButton *)[self.view viewWithTag:8000+i];
		if (tmpButton == nil)
			break;
		[tmpButton setBackgroundImage:nil forState:UIControlStateNormal];
		i++;

		
	} while (1);
	UIButton * tmpButton = (UIButton *)[self.view viewWithTag:[(UIButton *)sender tag]];
	[tmpButton setBackgroundImage:[UIImage imageNamed:@"button-bg-blck.png"] forState:UIControlStateNormal];

	// [self showAnimated:nil];
	[Functions showAnimated:self.view];
	feedId = buttonTag-8000;
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	[cnf updateValue:[NSString stringWithFormat:@"selectedList_%@", actualId] value:[NSString stringWithFormat:@"%i",  feedId]];
	[cnf release];
	NSLog(@"feedId ... %i", feedId);
	[self performSelector:@selector(useFeed) withObject:nil afterDelay:0.5];
	// [self useFeed];
}

- (void) createMutiListView:(NSArray *)lists
{

	//UIView *listView = [[UIView alloc] initWithFrame:CGRectMake(0, 44, 320, 35)];
	//listView.backgroundColor = [UIColor blueColor];
	UIToolbar * listView = [UIToolbar new];
	[listView sizeToFit];
	[listView setFrame:CGRectMake(0, 44, 320, 20)];

	listView.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleWidth);
	
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	CGFloat toolbarHeight = 30; // [toolbar frame].size.height;
	[listView setFrame:CGRectMake(0, 44, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	
	
	
	
	
	UIImage *tempImg = [UIImage imageNamed:@"arrow_prev.png"];
	UIImageView *imageView = [[UIImageView alloc] initWithImage:tempImg];
	[imageView setImage:tempImg];
	// [tempImg release];
	imageView.frame = CGRectMake(0, 5, 15, 25);
	[listView addSubview:imageView];
	[imageView release];

	// UIImage *
	tempImg = [UIImage imageNamed:@"arrow_next.png"];
	// UIImageView *
	imageView = [[UIImageView alloc] initWithImage:tempImg];
	[imageView setImage:tempImg];
	// [tempImg release];
	imageView.frame = CGRectMake(305, 5, 15, 25);
	imageView.frame = CGRectMake(self.view.frame.size.width-15, 5, 15, 25);
	[listView addSubview:imageView];
	[imageView release];
	
	
	/*
	button.frame = CGRectMake(288, 2, 30, 30);
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	UIImage *btnImage = [UIImage imageNamed:@"tabbutton_refresh.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	
	[toolbar addSubview:button];*/
	
	
	UIScrollView *listScroll = [[UIScrollView alloc] initWithFrame:CGRectMake(15, 5, 290, 25)];
	listScroll.frame = CGRectMake(15, 5, listView.frame.size.width-30, 25);
	// listScroll.backgroundColor = [UIColor redColor];
	int i = 0;
	int x = 0;
	for (NSArray *list in lists) 
	{
		NSString * tmpTitle = [list objectAtIndex:0];
		UIFont * tmpFont = [UIFont boldSystemFontOfSize:12.0];
		CGSize size = [tmpTitle sizeWithFont:tmpFont];
		int w = size.width;
		// NSLog(@"bt s: %i", w);
		// NSLog(@"bt l: %@", list);
		UIButton * tmpButton = [UIButton buttonWithType:UIButtonTypeCustom];
		tmpButton.frame = CGRectMake(x, 0, w+10, 25);
		tmpButton.tag = i+8000;
		// tmpButton.backgroundColor = [UIColor greenColor];
		tmpButton.titleLabel.font = tmpFont;
		// tmpButton.titleLabel.textColor = [UIColor blackColor];
		tmpButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;

		// UIImageView *tmpImage = [UIImageView setImage:[UIImage imageNamed:@"button-bg-blck.png"]];
		// [tmpButton addSubview:tmpImage];
		if (i == feedId)
		[tmpButton setBackgroundImage:[UIImage imageNamed:@"button-bg-blck.png"] forState:UIControlStateNormal];
		[tmpButton setTitle:tmpTitle forState:UIControlStateNormal];
		
		[tmpButton addTarget:self action:@selector(loadFeed:) forControlEvents:UIControlEventTouchUpInside];
		[listScroll addSubview:tmpButton];
		i++;
		x += w+10;
	}
	// x += 10;
	listScroll.alwaysBounceHorizontal = YES; 
	listScroll.directionalLockEnabled = YES;
	[listScroll setContentSize:CGSizeMake(x, 25)];
	[listView addSubview:listScroll];
	[listScroll release];
	[self.view addSubview:listView];
	[listView release];

}

- (void) useFeed {

    if (elements != nil)
    {
        elements = nil;
        [elements release];
        [tableView reloadData];
    }
    

	// [self showAnimated:nil];
    [Functions showAnimated:self.view];

	NSString * title = @"";
	NSString * url = @"";
	NSString * popup = @"";
	/*NSString * pattern = @"";
	// NSString * titleName = @"";
	NSString * titleFont = @"Courier";
	NSString * titleSize = @"12";
	NSString * titleColor = @"#cccccc";
	NSString * titleStyle = @"regular";
	NSString * titleLink = @"";
	// NSString * subtitleName = @"";
	NSString * descriptionFont = @"Courier";
	NSString * descriptionSize = @"12";
	NSString * descriptionColor = @"#cccccc";
	NSString * descriptionStyle = @"regular";
	NSString * descriptionLink = @"";
	// NSString * imageName = @"";
	NSString * imageLink = @"";
	NSString * linkName = @"";
	NSString * linkType = @"";*/
	NSString * search = @"";
	
	NSLog(@"id ... *** %i", feedId);
	
	NSArray *feed = [feeds objectAtIndex:feedId];
	/*
	 NSLog(@"Array Count: %d",[feeds count]);
	 // NSArray * 
	 NSLog(@"Array Count: %d",[feed count]);
	 for(NSString * test in feed) {
	 NSLog(@"feed: %@", test);
	 }
	 */
	
	title = [feed objectAtIndex:0];
	url = [feed objectAtIndex:1];
	url = [url urlUnescapedString];
	NSLog(@"u: %@", url);
	feedSource = url;
	// NSString * 
	popup = [feed objectAtIndex:2];
	// NSString * 
	search = [feed objectAtIndex:3];
	/*pattern = [feed objectAtIndex:4];
	titleFont = [feed objectAtIndex:5];
	titleSize = [feed objectAtIndex:6];
	titleColor = [feed objectAtIndex:7];
	titleStyle = [feed objectAtIndex:8];
	descriptionFont = [feed objectAtIndex:9];
	descriptionSize = [feed objectAtIndex:10];
	descriptionColor = [feed objectAtIndex:11];
	descriptionStyle = [feed objectAtIndex:12];
	linkName = [feed objectAtIndex:13];
	linkType = [feed objectAtIndex:14];
	titleLink = [feed objectAtIndex:18];
	descriptionLink = [feed objectAtIndex:19];
	imageLink = [feed objectAtIndex:20];*/
	// NSLog(@"l: %@:%@:%@", title, linkName, linkType);
	
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * displayId = actualId; // cnf.value;
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}

	[Functions sendWebtrends: title 
				  eventDescr: title
				   eventType: @"view"
				contentGroup: title
				   mediaName: nil
				   mediaType: nil
				  mediaEvent: nil];
	
	/*int yT = 0;
	if ([tabbar isEqualToString:@"1"]) yT = 48;
	self.tableView.frame = CGRectMake(0,48,320,380-yT);
	tableView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-85);
*/
	if ([popup isEqualToString:@"1"]) {
		// NSLog(@"go ad...");
		[self performSelector:@selector(showAd) withObject:nil afterDelay:5.0];
	}
	// 44 search
	if (searchBar != nil)
	{
	[searchBar removeFromSuperview];
		searchBar = nil;
	}
	/*int yT = 83; // 44 + 39
	if ([search isEqualToString:@"true"]) {
		// if ([tabbar isEqualToString:@"1"]) yT = 48+25;
		// self.tableView.frame = CGRectMake(0,yS+94,320,366-yS-yT);
		searchResults = [[NSMutableArray alloc]init];
		searchBar = [[UISearchBar alloc]initWithFrame:CGRectMake(0,yT,self.view.frame.size.width,44)]; // 50
		searchBar.tag = 23001;
		searchBar.delegate = self;
		yT += 44;
		[self.view addSubview:searchBar];
	}
	tableView.frame = CGRectMake(0, yT, self.view.frame.size.width, self.view.frame.size.height-yT-25);
     */	

    // New table view frame code
    int yT = 44;
    //if ([tabbar isEqualToString:@"1"]) yT = 48;
    //	self.tableView.frame = CGRectMake(0,48,320,380-yT);
    
    if ([popup isEqualToString:@"1"]) {
        // NSLog(@"go ad...");
        [self performSelector:@selector(showAd) withObject:nil afterDelay:5.0];
    }
    // 44 search
    if ([feeds count] > 1) {
        if ([tabbar isEqualToString:@"1"]) yT += 34;
        // self.tableView.frame = CGRectMake(0,yS+94,320,366-yS-yT);
    }
    if ([search isEqualToString:@"true"]) {
        // int yT = 0;
        // self.tableView.frame = CGRectMake(0,yS+94,320,366-yS-yT);
        searchResults = [[NSMutableArray alloc]init];
        searchBar = [[UISearchBar alloc]initWithFrame:CGRectMake(0,yT,self.view.frame.size.width,44)]; // 50
        searchBar.delegate = self;
        [self.view addSubview:searchBar];
        if ([tabbar isEqualToString:@"1"]) yT += 44;
    }
    if (yT)
        tableView.frame = CGRectMake(0, yT, self.view.frame.size.width, self.view.frame.size.height-yT-40);

    
    
	// download info
	NSLog(@"download...");
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	// NSDateFormatter *dateFormat = [[[NSDateFormatter alloc] init] autorelease];
	
	// int itemCounter = 0;
	// NSURL *u = [NSURL URLWithString:url];
	// NSData *myXMLData;
	
	// WebServiceHelper * loadWebService = [[WebServiceHelper alloc] init];
	// NSString * tmpUrl = @"http://mediasuite.multicastmedia.com/rss/vod.php?p=f30jt6g5&thumbs=true";
	// [loadWebService callWebService:tmpUrl delegate:self requestSelector:@selector(test:)];
	// NSString * webService = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/mh_mobile_convert_rss.asmx";
	// NSString * callMethod = @"ConvertRSS";
	
	// NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug",nil]; // @"numpage",@"pagesize",@"sortby",@"filterby",nil];
	// NSArray *keyvalues = [NSArray arrayWithObjects:url ,@"true", nil];	
	// [loadWebService callWebService:webService methodName:callMethod keys: keys values:keyvalues delegate:self requestSelector:nil];
	
	// cnf = [[Config alloc] initWithName:@"actualId"];
	
	/*
	 NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	 NSString *tmpFileName = [NSString stringWithString:dbName];
	 // NSLog(@"name 1: %@", tmpFileName);
	 */
	NSString *feedPage = @"";
	if (feedId != 0)
		feedPage = [NSString stringWithFormat:@"_%i", feedId];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]];
	
	NSString *displayIdValue = [cnf loadValue:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage]];
	
	if([displayIdValue isEqualToString:@""] || displayIdValue == nil
	   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		// myXMLData = [NSData dataWithContentsOfURL:u];
		// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];  
		[dateFormat release];
		[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage] value:dateString];
		// [loadWebService callWebService:webService methodName:callMethod 
		//						  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
		[self goDownload];
	} else {
		
		// NSTimeInterval dateTime;		
		// NSDateFormatter *
		// dateFormat = [[[NSDateFormatter alloc] init] autorelease];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:displayIdValue];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		// dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);
		/*
		 NSLog(@"t: %@ - %@", 
		 [dateFormat stringFromDate:date],
		 [dateFormat stringFromDate:[dateFormat dateFromString:@"201010150300"]]
		 );
		 NSLog(@" date = %@", date);
		 NSLog(@" date = %@", lastCheck);
		 */
		int day1 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:date];
		int day2 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:lastCheck];
		NSLog(@"%i - %i * %@ - %@", day1, day2, [dateFormat stringFromDate:date], [dateFormat stringFromDate:lastCheck]);
		
		// if(dateTime > 1) {
		if(day1 != day2) {
			
			// if ([date timeIntervalSinceDate:lastCheck] >= 1 ) // today is before launch
			NSLog(@"down (2)... ");
			// myXMLData = [NSData dataWithContentsOfURL:u];
			// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			// [dateFormat release];
			NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage],dateString);
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_2%@.xml", displayId, feedPage] value:dateString];
			// [loadWebService callWebService:webService methodName:callMethod 
			//						  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
			[self goDownload];
		} else {
			// myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
			// [self processXml:[[NSData alloc] initWithContentsOfFile:fileName]];
			[self showXML];
		}
		[dateFormat release];
	}

	[cnf release];
	
	// NSLog(@"--> %@ <--", elements);
}

- (NSArray *)loadListInfo:(NSString *)moduleId {

	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
		
	NSString * pattern = @"";
	NSString * url = @"";
	NSString * title = @"";
	NSString * popup = @"";
	NSString * titleName = @"";
	NSString * titleFont = @"Courier";
	NSString * titleSize = @"12";
	NSString * titleColor = @"#cccccc";
	NSString * titleStyle = @"regular";
	NSString * titleLink = @"";
	NSString * subtitleName = @"";
	NSString * descriptionFont = @"Courier";
	NSString * descriptionSize = @"12";
	NSString * descriptionColor = @"#cccccc";
	NSString * descriptionStyle = @"regular";
	NSString * descriptionLink = @"";
	NSString * imageName = @"";
	NSString * imageLink = @"";
	NSString * linkName = @"";
	NSString * linkType = @"";
	NSString * linkUrl = @"";
	NSString * search = @"";
	NSString * listType = @"";
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		do {
			// NSLog(@"module? %@ -- %@", [TBXML elementName:childXMLElement], moduleId );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"actualId : %@ | idItem: %@ ", moduleId, idItem);
				if ([moduleId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
	
		/*NSString * perPage = @"true";
		NSString * sortSettings = @"true";
		NSString * filterSettings = @"true";
		 NSString * multiModule = @"0";*/
		
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"tab_bar"]) {
								}
								if ([attribItem isEqualToString:@"button_search"]) {
									search = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"data_source"]) {
									url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									listType = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"detail_title"]) {
									titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									titleLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									titleFont = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
									if (titleName == nil) titleName = @"";
									if (titleLink == nil) titleLink = @"";
									if (titleFont == nil) titleFont = @"";
								}
								if ([attribItem isEqualToString:@"detail_date"]) {
									subtitleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									descriptionLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									descriptionFont = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
									subtitleName = [subtitleName stringByReplacingOccurrencesOfString:@"_" withString:@":"];
									if (subtitleName == nil) subtitleName = @"";
									if (descriptionLink == nil) descriptionLink = @"";
									if (descriptionFont == nil) descriptionFont = @"";
								}
								if ([attribItem isEqualToString:@"detail_image"]) { // list_item_icon
									imageName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									imageLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									NSRange range = [imageName rangeOfString:@"media"];
									if (range.length > 0)
										imageName = [imageName stringByReplacingOccurrencesOfString:@"_" withString:@":"];
									if (imageName == nil) imageName = @"";
									if (imageLink == nil) imageLink = @"";
								}
								if ([attribItem isEqualToString:@"detail_link"]) { // list_item_icon
									// titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									linkName = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									linkType = [TBXML valueOfAttributeNamed:@"link_to_type" forElement:childXMLElement];
									linkType = [self reviewLinkType:linkName:linkType];
                                    if ([linkType isEqualToString:@"link"])
                                        linkUrl = [TBXML valueOfAttributeNamed:@"link_to_from_entity" forElement:childXMLElement];
									if (linkUrl == nil) linkUrl = @"";
                                    if (linkName == nil) linkName = @"";
									if (linkType == nil) linkType = @"";
									// NSLog(@"l: %@:%@:%@", title, linkName, linkType);
								}
								
								/*if ([attribItem isEqualToString:@"per_page"]) {
									perPage = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"sort_settings"]) {
									sortSettings = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"filter_settings"]) {
									filterSettings = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"multi_module"]) {
									multiModule = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}*/
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
		}
	}

	FontItem * font = [Functions loadFont:titleFont]; 
	titleFont = font.nameFont;
	titleSize = font.sizeFont;  
	titleColor = font.colorFont;
	titleStyle = font.styleFont;
	font = [Functions loadFont:descriptionFont]; 
	descriptionFont = font.nameFont;
	descriptionSize = font.sizeFont;  
	descriptionColor = font.colorFont;
	descriptionStyle = font.styleFont;

	NSArray *feed = [NSArray arrayWithObjects: title, url, popup, search, pattern,
					 titleFont, titleSize, titleColor, titleStyle,
					 descriptionFont, descriptionSize, descriptionColor, descriptionStyle,
					 linkName, linkType,
					 titleName, subtitleName, imageName, 
					 titleLink, descriptionLink, imageLink, 
                     listType, linkUrl, moduleId,
					 nil];

	// NSLog(@"feed: %@", feed);
	return feed;
}

# pragma mark Authentication

- (void) loadAuth:(BOOL)showErr errMsg:(NSString *)txtErr 
{
	
	NSString *requestString = authUrl;
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:requestString ] ];
	NSLog(@"sent: %@", requestString);	
	[request startSynchronous];
	
	Config * cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	NSString *autName = [NSString stringWithFormat:@"tmp_%@_2.log", displayId];
	NSString * value = [cnf loadValue:autName];
	if ([value isEqualToString:@"true"])
    {
        [cnf release];
		return;
    }

	NSError *error = [request error];
	self.reqName = @"";
	self.reqType = @"";
	self.reqService = @"";
	// [reqFields release];
	reqFields = [[NSMutableArray alloc] init];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(@"response: %@", response);
		// [self stopAnimated:nil];
        [Functions stopAnimated:self.view];

		TBXML * dataXml = [[TBXML tbxmlWithXMLString:response] retain];
		if (dataXml.rootXMLElement)
		{
			TBXMLElement * childXMLElement = dataXml.rootXMLElement;
			childXMLElement = childXMLElement->firstChild;
			BOOL f = NO;
			do {
				NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"authentication_module"]
					&& [[TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement] isEqualToString:auth]
					) {
					f = YES;
					self.reqName = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
					self.reqType = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					TBXMLElement * serviceXml = [TBXML childElementNamed:@"service" parentElement:childXMLElement];
					if (serviceXml)
						self.reqService = [TBXML textForElement:serviceXml];
					TBXMLElement * fieldsXml = [TBXML childElementNamed:@"fields" parentElement:childXMLElement];
					if (fieldsXml) 
					{
						TBXMLElement * fieldXml = fieldsXml->firstChild;
						
						do
						{
							NSString * formName = [TBXML valueOfAttributeNamed:@"display_name" forElement:fieldXml];
							NSString * formField = [TBXML valueOfAttributeNamed:@"form_name" forElement:fieldXml];
							NSArray *field = [NSArray arrayWithObjects: formName, formField, nil];
							[self.reqFields addObject:field];
							// [field release];
						} while ((fieldXml = fieldXml->nextSibling));
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && !f);
			
		}
        [dataXml release];
	}
	else
	{
		// error
	}
	NSLog(@"f:::: %@ +++ %@ --- %@ *** %@", reqFields, reqName, reqType, reqService);
	
	//NSString *
	autName = [NSString stringWithFormat:@"tmp_%@_2.aut", displayId];
	//NSString * 
	value = [NSString stringWithFormat:@"%@", [cnf loadValue:autName] ];
	[cnf release];

	NSString *errMsg = @"";
	if (showErr) 
		if ([txtErr isEqualToString:@""])
			errMsg = @"Error on data.";
		else
			errMsg = [NSString stringWithFormat:@"%@", txtErr];
	
	NSLog(@"err? %@ ? %d", errMsg, showErr);
	
	SilLoginPrompt *newPrompt = [[SilLoginPrompt alloc] initWithTitle:reqName
															  message:errMsg
															 delegate:self
													cancelButtonTitle:@"cancel"
														okButtonTitle:@"login"
														  fieldNumber: [reqFields count]];
	[newPrompt setUserText:value]; 
	[newPrompt setUserPlaceholder:[[reqFields objectAtIndex:0] objectAtIndex:0]]; 
	[newPrompt show];
	[newPrompt release];
}

- (void) doAuth:(BOOL)showErr errMsg:(NSString *)txtErr
{
	
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	
	NSString *autName = [NSString stringWithFormat:@"tmp_%@_2.aut", displayId];
	NSString * value = [NSString stringWithFormat:@"%@", [cnf loadValue:autName] ];
	
	//	[label setText:@""];
	
	NSString *errMsg = @"";
	if (showErr) 
		if ([txtErr isEqualToString:@""])
			errMsg = @" \nInvalid E-mail";
		else
			errMsg = [NSString stringWithFormat:@"\n%@", txtErr];
	
	NSLog(@"err? %@ ? %d", errMsg, showErr);
	
	UIAlertView *myAlertView = [[UIAlertView alloc] initWithTitle:@"Enter your email to start." message:errMsg delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
	UITextField *myTextField = [[UITextField alloc] initWithFrame:CGRectMake(12.0, 35.0, 260.0, 25.0)];
	[myTextField setBackgroundColor:[UIColor whiteColor]];
	myTextField.tag = 2002;
	
	myTextField.clearButtonMode = UITextFieldViewModeWhileEditing;
	myTextField.keyboardType = UIKeyboardTypeAlphabet;
	myTextField.placeholder = @"E-mail";
	myTextField.text = value;
	// myTextField.keyboardAppearance = UIKeyboardAppearanceAlert;
	// myTextField.autocapitalizationType  = UITextAutocapitalizationTypeWords;
	// myTextField.autocorrectionType = UITextAutocapitalizationTypeNone;
	myTextField.textAlignment = UITextAlignmentCenter;
	
	[myAlertView addSubview:myTextField];
	// CGAffineTransform myTransform = CGAffineTransformMakeTranslation(0.0, 130.0);
	// [myAlertView setTransform:myTransform];
	[myAlertView show];
	[myTextField release];
	[myAlertView release];
	
	[cnf release];
}

- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex {
	
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	
	NSLog(@"sel: %d", buttonIndex);
    if (buttonIndex == 0) {
		[cnf updateValue:@"displayView" value:@"1"];
		[Functions goMenu:nil];
	} else if (buttonIndex == 1) {
        if ([alertView isKindOfClass:[SilLoginPrompt class]]) {
            NSString * userName = [(SilLoginPrompt *)alertView userName];
            NSString * userPassword = [(SilLoginPrompt *)alertView userPassword];
            NSLog(@"Entered information: %@ - %@", userName, userPassword);
			NSString *autName = [NSString stringWithFormat:@"tmp_%@_2.aut", displayId];
			NSLog(@"aut 2: %@", autName);
			NSString * value = [cnf loadValue:autName];
			if ([value isEqualToString:@""] || value == nil) {
				[cnf insertValue:autName value:userName];
			} else {
				[cnf updateValue:autName value:userName];
			}
			[self callAuth:userName withPassword:userPassword];
        } else {
            for (id subview in alertView.subviews) {
                // write to the log what the subview is
                // NSLog(@"Subview is a %@", [subview description]);
                if ([subview isKindOfClass:[UITextField class]]) {
                    NSLog(@"? %@", [(UITextField *)subview text]);
                    
                    NSString *autName = [NSString stringWithFormat:@"tmp_%@_2.aut", displayId];
                    NSLog(@"aut 2: %@", autName);
                    NSString * value = [cnf loadValue:autName];
                    if ([value isEqualToString:@""] || value == nil) {
                        [cnf insertValue:autName value:[(UITextField *)subview text]];
                    } else {
                        [cnf updateValue:autName value:[(UITextField *)subview text]];
                    }
                    
                    // [self loadAuth:[(UITextField *)subview text]];
                    // hide all buttons
                    //if ([subview isKindOfClass:[UIButton class]])
                    //   subview.hidden = YES;
                }
            }
		}
    }
	[cnf release];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
	[textField resignFirstResponder];
	return YES;
}

- (void) callAuth:(NSString *)text withPassword: (NSString *)password
{

	NSString *requestString = [NSString 
							   stringWithFormat:@"%@?", reqService];
	
	int $i = 0;
	NSLog(@"req: %@", reqFields);
	
	for (NSArray *field in reqFields) {
		NSLog(@"req: %@", [field objectAtIndex:1]);
		requestString = [NSString stringWithFormat:@"%@%@=%@&", requestString, [field objectAtIndex:1], ($i == 0) ? text: password];
		$i++;
	}
	
	
	if (![text isEqualToString:@"Anonymous"]) {
		
		ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:requestString ] ];
		NSLog(@"++++++++++++++ req: %@", requestString);
		[request startSynchronous];
		NSError *error = [request error];
		if (!error) {
			NSString *response = [request responseString];
			NSLog(@"response: %@", response);
			// [self stopAnimated:nil];
            [Functions stopAnimated:self.view];
			if ([response isEqualToString:@"true"]) 
			{
				Config * cnf =[[Config alloc] init];
				NSString * displayId = [cnf loadValue:@"actualId"];
				//tabbar
				NSString * tabbar = [cnf loadValue:@"useTabBar"];
				NSLog(@"tb: %@", tabbar);
				NSLog(@"title: %@", self.tabBarItem.title);
				// NSLog(@"title: %i", self.tabBarController.selectedIndex);
				if ([tabbar isEqualToString:@"1"]) {
					displayId = [infoData valueForKey:@"idTab"];
				}
				NSString *autName = [NSString stringWithFormat:@"tmp_%@_2.log", displayId];
				//NSString * value = [cnf loadValue:autName];
				//if ([value isEqualToString:@""] || value == nil) {
				//	[cnf insertValue:autName value:@"true"];
				//} else {
					[cnf updateValue:autName value:@"true"];
				//}
				[cnf release];
			} else {
				[self loadAuth:TRUE errMsg:@""];
				return;
			}
		}
		else 
		{
			// error
			[self loadAuth:TRUE errMsg:[error localizedDescription]];
			return;
		}
	
	}
}

-(void)preloadThumbs
{
	int i=0;
	BOOL isInternetConnected=[Functions connectedToNetwork];
	
    if (!isInternetConnected){
		// return;
	} else {
		
	}
	
	if(thumbsArray != nil)
	{
		[thumbsArray release];
	}
	
	thumbsArray = [[NSMutableArray alloc] init];
	
	
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	[cnf release];
    
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSFileManager* fileManager = [NSFileManager defaultManager];
	// NSString *fileNameNoDir = [NSString stringWithFormat:@"tmp_%@", actualId];
    NSString *feedPage = @"";
    if (feedId != 0)
        feedPage = [NSString stringWithFormat:@"_%i", feedId];
    NSString * fileNameNoDir = [NSString stringWithFormat:@"tmp_%@_2%@", actualId, feedPage];

    // Use moduleId in multiList
	NSArray * feed = [feeds objectAtIndex:feedId];
	NSString * moduleId = [feed objectAtIndex:23];
    if ([feeds count] > 1)
        fileNameNoDir = [NSString stringWithFormat:@"tmp_%@_2", moduleId];
	// Use moduleId in multiList
    
    
	NSString * fileImg = @""; // [documentsDir stringByAppendingPathComponent:fileNameNoDir];
	//if(![fileManager fileExistsAtPath: fileImg]) {
	//	[fileManager createDirectoryAtPath:fileImg withIntermediateDirectories:YES attributes:nil error:nil];
	//}
	
	// NSString *filePath = [[NSBundle mainBundle] pathForResource:@"MyFile" ofType:@"txt"];  
	// NSData *myData = [NSData dataWithContentsOfFile:filePath];  
	
	NSData * imageData; // = [[NSData alloc] init];
	for(i=0; i<[elements count]; i++)
	{
		Element *element = (Element *)[elements objectAtIndex:i];
		if (element.thumb) {
			fileImg = [documentsDir stringByAppendingPathComponent:fileNameNoDir];
            // NSLog(@"fileImg %@", fileImg);
			if(![fileManager fileExistsAtPath: fileImg]) {
				[fileManager createDirectoryAtPath:fileImg withIntermediateDirectories:YES attributes:nil error:nil];
			}
            // NSLog(@"fileImg **  %@ --- %@", fileImg, element.idList);
			fileImg = [NSString stringWithFormat:@"%@/list_%@.png", fileImg, element.idList];
            // NSLog(@"fileImg ++++ %@", fileImg);
			NSURL *url = [NSURL URLWithString:element.thumb];
            element.thumb = fileImg;
			BOOL fileExists = [[NSFileManager defaultManager] fileExistsAtPath:fileImg];
			if (fileExists) {
				// NSLog(@"exists");
				imageData = [NSData dataWithContentsOfFile:fileImg];
			} else {
				// NSLog(@"download");
				// imageData = [[NSData alloc] initWithContentsOfURL:url];
				if (isInternetConnected){
					imageData = [NSData dataWithContentsOfURL:url];
                    [imageData writeToFile:fileImg atomically:YES];
				} else
				{
					NSString *filePath = [[NSBundle mainBundle] pathForResource:@"loadingPhoto" ofType:@"png"];  
					imageData = [NSData dataWithContentsOfFile:filePath];
				}
			}
			fileExists = [[NSFileManager defaultManager] fileExistsAtPath:fileImg];
			if (fileExists)
                [thumbsArray addObject:imageData];
			else
				[thumbsArray addObject:@""];
            
			
		}
	}
}

# pragma mark rotation

- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation   
										 duration:(NSTimeInterval)duration {  
	
	
	UIInterfaceOrientation nowOrientation = self.interfaceOrientation;  
	
	if (nowOrientation == UIInterfaceOrientationPortrait || nowOrientation == UIInterfaceOrientationPortraitUpsideDown) {  
		//moving towards portrait orientation  
	}  
	else {  
		//moving to landscape orientation  
	}  
}  


@end
