//
//  LoginViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 4/18/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "SSTextView.h"
#import "CustomTextField.h"

@interface LoginViewController : UIViewController <UITextViewDelegate> {
	UIActivityIndicatorView *waitView;
	UILabel *waitLabel;
    NSDictionary * infoData;
	IBOutlet SSTextView * txtUsername;
	IBOutlet SSTextView * txtPassword;
	IBOutlet UILabel * txtError;
	
	NSString * reqName;
	NSString * reqType;
	NSString * reqService;
	NSMutableArray * reqFields;

}

@property (nonatomic, retain) UILabel *waitLabel;
@property (nonatomic,retain) IBOutlet SSTextView * txtUsername;
@property (nonatomic,retain) IBOutlet SSTextView * txtPassword;
@property (nonatomic,retain) IBOutlet UILabel * txtError;

@property (nonatomic,retain) NSString * reqName;
@property (nonatomic,retain) NSString * reqType;
@property (nonatomic,retain) NSString * reqService;
@property (nonatomic,retain) NSMutableArray * reqFields;

-(IBAction) goLogin:(id) sender;
- (void) callAuth:(NSString *)text withPassword: (NSString *)password;
- (void) loadAuth:(BOOL)showErr errMsg:(NSString *)txtErr;

@end
