//
//  MapViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 8/20/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MapKit/MapKit.h>
#import <MapKit/MKAnnotation.h>
#import <CoreLocation/CoreLocation.h>

// @interface MainViewController : UIViewController <FlipsideViewControllerDelegate, MKMapViewDelegate, MKReverseGeocoderDelegate, CLLocationManagerDelegate> {
@interface MapViewController : UIViewController <MKMapViewDelegate, CLLocationManagerDelegate, MKReverseGeocoderDelegate, UITextFieldDelegate> {
	IBOutlet MKMapView *mapView;
	MKPlacemark *mPlacemark;
	CLLocationCoordinate2D location;
    NSDictionary * infoData;
	NSString * useGps;
	NSMutableArray * projects;
	// IBOutlet UISlider * slider;
	UITextField *radiusField;
}

@property (nonatomic, retain) IBOutlet MKMapView *mapView;
@property (nonatomic, retain) IBOutlet NSString * useGps;
// @property (nonatomic, retain) IBOutlet UISlider * slider;
@property(nonatomic,retain) IBOutlet UITextField *radiusField;

- (void) loadData;
- (void) initStatusBar:(UIView *)actualView;
- (void) createMap;
- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;

@end
