//
//  MenuViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 10/14/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MenuViewController.h"
#import "TBXML.h"
#import "Functions.h"
#import "Config.h"
#import "app_builderAppDelegate.h"
#import "FontItem.h"
#import "VerticallyAlignedLabel.h"
#import "PopupViewController.h"

#define USE_CUSTOM_DRAWING 1

@implementation MenuViewController

//static MenuViewController *sharedMyManager = nil;

@synthesize menuItems;
@synthesize tableView = _tableView;
@synthesize toolbar = _toolbar;
@synthesize imageView;
@synthesize pattern;



/*-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 150, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];;
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
}

- (void) showAnimated:(id)sender{
	[waitView startAnimating];
	waitView.hidden=NO;
}*/

-(void)toolbarInit{
	// NSString * title = @"Menu Reader";
	
	NSArray *paths = NSSearchPathForDirectoriesInDomains(
														 NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *docDirectory = [paths objectAtIndex:0];
    docDirectory = [docDirectory stringByAppendingPathComponent:@"/logo.png"];
	NSData *imgData = [NSData dataWithContentsOfFile:docDirectory];
	UIImage *img    = [[UIImage alloc] initWithData:imgData];
	CGRect myImageRect = CGRectMake(100, 10, 120, 30);
	UIImageView *logoImage = [[UIImageView alloc] initWithFrame:myImageRect];
	[logoImage setImage:img];
	[self.toolbar addSubview:logoImage];
    [img release];
    [logoImage release];
	
}

-(void)imageInit{
	
	return;
	// NSString *urlText = @"http://www.axul.net/iphone/images";
	// NSString *urlText = @"http://190.147.1.49/builder/skinimages";
	NSString *urlText = @"http://184.73.161.149:8040/iphone/skinimages";
	NSURL *imgURL;
	NSData *imgData;
	NSString *fileURL;
	NSString *skin;
	Config *cnf = [[Config alloc] init];
	skin = [cnf loadValue:@"skin"];
	if([skin isEqualToString:@""] == TRUE) {
		skin = @"skin1";
	}
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
		skin = [NSString stringWithFormat:@"%@/ipad", skin];
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = @"/bottomRow.png";
	NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];

	BOOL fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		// NSLog(@"exists");
	} else {
		// NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@%@", urlText, skin, fileName];
		// NSLog(@"url: %@", fileURL);
		// NSLog(@"path: %@", filePath);
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/middleRow.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		// NSLog(@"exists");
	} else {
		// NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/topAndBottomRow.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		// NSLog(@"exists");
	} else {
		// NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/topRow.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		// NSLog(@"exists");
	} else {
		// NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/gradientBackground.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		// NSLog(@"exists");
	} else {
		// NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/bg_cell.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		// NSLog(@"exists cell bg");
	} else {
		// NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/logo.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		// NSLog(@"exists logo");
	} else {
		// NSLog(@"download logo");
		fileURL = [cnf loadValue:@"logo"]; // = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		NSLog(@"logo %@", fileURL);
		//imgURL = [NSURL URLWithString:fileURL];
		//imgData = [NSData dataWithContentsOfURL:imgURL];
		// [imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/indicator.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		// NSLog(@"exists");
	} else {
		// NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}

	/*
	// icons
	fileName = @"/icoList.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		NSLog(@"exists");
	} else {
		NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/icoMap.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		NSLog(@"exists");
	} else {
		NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	fileName = @"/icoSlide.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	fileExists = [[NSFileManager defaultManager] fileExistsAtPath:filePath];
	if (fileExists) {
		NSLog(@"exists");
	} else {
		NSLog(@"download");
		fileURL = [NSString stringWithFormat:@"%@/%@/%@", urlText, skin, fileName];
		imgURL = [NSURL URLWithString:fileURL];
		imgData = [NSData dataWithContentsOfURL:imgURL];
		[imgData writeToFile:filePath atomically:YES];
	}
	*/
	
	
	[cnf release];
	
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSFileManager* fileManager = [NSFileManager defaultManager];
	NSString *fileNameNoDir = [NSString stringWithFormat:@"menu"];
	NSString * fileName = [documentsDir stringByAppendingPathComponent:fileNameNoDir];
	[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
	
	[Functions initToolBar:self.view withTitle:@" "];
	[Functions initWaitView:self.view];
	[Functions showAnimated:self.view];
	[self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
}

# pragma mark view

// create view
- (void) showView
{
	Config *cnf = [[Config alloc] init];
	[cnf updateValue:@"goUrl" value:@"---"];
	self.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;

	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	// NSLog(@"???? %@", tabbar);
	if ([tabbar isEqualToString:@"1"]) {
		
		[cnf updateValue:@"actualId" value:@"1"];
		[cnf updateValue:@"displayView" value:@"1"];
		[cnf updateValue:@"useTabBar" value:@"0"];
		[cnf updateValue:@"selectedTabBarItem" value:@"0"];
		
//		[Functions goMenu:nil];
	}

	UITableView * tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 44, 320, 410)];
	tableView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-45-103);
	tableView.delegate = self;
	tableView.dataSource = self;
	tableView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;

#if USE_CUSTOM_DRAWING
	//self.
	tableView.rowHeight = 80;
	//self.
	tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
	//self.
	tableView.backgroundColor = [UIColor clearColor];
#endif
	[self.view addSubview:tableView];

	menuItems = [[NSMutableArray alloc] init];
	NSLog(@"start");
	self.title = @"Menu";
	NSString *titleView = @"";
	NSString * idOas = @"";
	NSString * useOas = @"";
	NSString * urlOas = @"";
	NSString * siteOas = @"";
	NSString * posOas = @"";
	NSString * queryOas = @"";

	TBXMLElement * root = [Functions readConfigXmlFile];
	// TBXMLElement * element;
	TBXMLElement * child;
	// NSString *value;
	// NSString * actualId = @"0";
	if (root) {
		NSLog(@"root");
		// if (root->firstChild) 
		//	element = root->firstChild;

		TBXMLElement * menuXMLElement;
		/*
		= [TBXML childElementNamed:@"menu" parentElement:root];

		// template - fontId
		TBXMLElement * patternXMLElement = [TBXML childElementNamed:@"fontid" parentElement:menuXMLElement];
		pattern = [TBXML textForElement:patternXMLElement];
		NSLog(@"p: %@", pattern);
		*/

		BOOL f = FALSE;
		child = root->firstChild;
        NSString * title = @"Menu";
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:child] isEqualToString:@"module"]) {
				NSString *typeItem = [TBXML valueOfAttributeNamed:@"type" forElement:child];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"type: %@ ", typeItem);
				if ([typeItem isEqualToString:@"1"]) {
					f = TRUE;
					menuXMLElement = child;
				}
			}
		} while ((child = child->nextSibling) && (f == FALSE));
		
		// NSString *style = [TBXML valueOfAttributeNamed:@"style_id" forElement:child];
        if (f)
        {
		pattern = [TBXML valueOfAttributeNamed:@"template_id" forElement:menuXMLElement];

		NSLog(@"id::: %@" , [TBXML valueOfAttributeNamed:@"id" forElement:menuXMLElement]);
		// actualId = [TBXML valueOfAttributeNamed:@"id" forElement:menuXMLElement];

		child = menuXMLElement->firstChild;
		f = FALSE;
		NSMutableArray * listMenuItems = [[[NSMutableArray alloc] init] autorelease];
		do {
			// NSLog(@":: %@ .. %@", [TBXML elementName:child], [TBXML valueOfAttributeNamed:@"id" forElement:child]);
			if ([[TBXML elementName:child] isEqualToString:@"field_set"]) {
				if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:@"0"]) {
					f = TRUE;
					TBXMLElement * childXMLElement = child->firstChild;
					do {
						if ([[TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement] isEqualToString:@"text_title"]) {
							titleView = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
						}
						if ([[TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement] isEqualToString:@"ad_OAS"]) {
							useOas = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
							idOas = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
							
						}
						if ([[TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement] isEqualToString:@"menu_item"]) {
							NSArray *menuObject = [NSArray 
												   arrayWithObjects: [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement], 
												   [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement], nil];
							[listMenuItems addObject:menuObject];
						}
						if ([[TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement] isEqualToString:@"tab_bar_menu"]) {
							NSString * menuValue = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
							if ([menuValue isEqualToString:@"true"])
								[cnf updateValue:@"useMenuTabBar" value:@"1"];
							else
								[cnf updateValue:@"useMenuTabBar" value:@"0"];
						}
					} while ((childXMLElement = childXMLElement->nextSibling));
				}
				if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:idOas]) {
					TBXMLElement * childXMLElement = child->firstChild;
					do {
						if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"OAS_url"]) {
							urlOas = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
						}
						if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"OAS_sitepage"]) {
							siteOas = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
						}
						if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"OAS_pos"]) {
							posOas = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
						}
						if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"OAS_query"]) {
							queryOas = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
						}
					} while ((childXMLElement = childXMLElement->nextSibling));
				}
			}
		} while ((child = child->nextSibling)); // && !f);

            if (f)
                title = titleView; // @"Menu";

		for(NSArray * menuObject in listMenuItems) {
			f = FALSE;
			child = menuXMLElement->firstChild;
			do {
				if ([[TBXML elementName:child] isEqualToString:@"field_set"]) {
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:[menuObject objectAtIndex:0]]) {
						f = TRUE;
						TBXMLElement * childXMLElement = child->firstChild;
						// NSString * idItem;
						NSString * icon = @"";
						NSString * titleText = @"";
						NSString * descriptionText = @"";
						NSString * titleStyle = @"";
						NSString * descriptionStyle = @"";
						do {
							NSString * attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
							if ([attribItem isEqualToString:@"menu_title"]) {
								if ([[TBXML valueOfAttributeNamed:@"visible" forElement:childXMLElement] isEqualToString:@"0"]) {
									titleText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									titleStyle = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
								} else {
									titleText = @"";
									titleStyle = @"";
								}
							}
							if ([attribItem isEqualToString:@"menu_desc"]) {
								if ([[TBXML valueOfAttributeNamed:@"visible" forElement:childXMLElement] isEqualToString:@"0"]) {
								descriptionText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								descriptionStyle = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
								} else {
									descriptionText = @"";
									descriptionStyle = @"";
								}
							}
							if ([attribItem isEqualToString:@"menu_image"]) {
								if ([[TBXML valueOfAttributeNamed:@"visible" forElement:childXMLElement] isEqualToString:@"0"]) {
									icon = [TBXML valueOfAttributeNamed:@"resource_url" forElement:childXMLElement];
								} else {
									icon = @"";
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
						MenuItem *menuItem = [[MenuItem alloc] initWithName:titleText];
						menuItem.description = descriptionText;
						menuItem.nameStyle = titleStyle; // [TBXML textForElement:tStyleXMLElement];
						menuItem.descriptionStyle = descriptionStyle; // [TBXML textForElement:dStyleXMLElement];
						menuItem.idItem = [menuObject objectAtIndex:1];
						menuItem.pattern = pattern;
						menuItem.icon = icon;
						[menuItems addObject:menuItem];
						
						[menuItem release];
					}
				}
			} while ((child = child->nextSibling) && !f);

	}
        }
/*
	 MenuItem *menuItem = [[MenuItem alloc] initWithName:@"Poll"];
	menuItem.description = @"";
	menuItem.nameStyle = @"16"; // titleStyle; // [TBXML textForElement:tStyleXMLElement];
	menuItem.descriptionStyle = @"17"; // descriptionStyle; // [TBXML textForElement:dStyleXMLElement];
	menuItem.idItem = @"8";
	menuItem.pattern = pattern;
	menuItem.icon = nil;
	[menuItems addObject:menuItem];
	*/
	
	NSLog(@"menu: %d", [menuItems count]);
	// NSLog(@"menu: %@", menuItems);
	// [self imageInit];
	// [self toolbarInit];
	// self.title = titleView;

		// [Functions addToolBar:self.view withTitle:title actualId:actualId];
		UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
		toolbarTitle.text = title;
	}
	
	// [Functions initToolBar:self.view withTitle:title];
	
	//NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	//NSString *documentsDir = [documentPaths objectAtIndex:0];
	//NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	//NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	//UIImage *imgViewImg = [UIImage imageWithData:imgData];
	//[imageView setImage:imgViewImg];

	[cnf updateValue:@"totalMenuItems" value:[NSString stringWithFormat:@"%i", [menuItems count]]];

	if ([useOas isEqualToString:@"true"])
	{
		[cnf updateValue:@"OASUrl" value:urlOas];
		[cnf updateValue:@"OASSite" value:siteOas];
		[cnf updateValue:@"OASPos" value:posOas];
		[cnf updateValue:@"OASQuery" value:queryOas];
		CGRect frame = self.tableView.frame;
		frame.size.height -= 103;
		self.tableView.frame = frame;
		self.tableView.backgroundColor = [UIColor greenColor];
		PopupViewController * popupViewController = [[PopupViewController alloc] initWithNibName:@"PopupViewController" bundle:nil];
		frame = self.view.frame;
		NSLog(@"?? %f <-- ", frame.size.height);
		popupViewController.view.frame = CGRectMake(0, frame.size.height-100,frame.size.width,100);
		NSLog(@"?? %f <-- ", frame.size.height);
		popupViewController.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleTopMargin;
		popupViewController.view.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
									 | UIViewAutoresizingFlexibleRightMargin 
									 | UIViewAutoresizingFlexibleLeftMargin 
									 | UIViewAutoresizingFlexibleTopMargin 
									 | UIViewAutoresizingFlexibleWidth);
		
		// popupViewController.view.frame = CGRectMake(0,360,320,100);
		[self.view addSubview:popupViewController.view];
		// [popupViewController release];
	}
	else 
	{
		CGRect frame = self.tableView.frame;
		frame.size.height += 103;
		self.tableView.frame = frame;
		tableView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-45);
		tableView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	}
	[tableView release];

	[cnf release];
	
	NSLog(@"off");
	if (1 == [menuItems count]) {
		// [self performSelector:@selector(loadMenuItem) withObject:nil afterDelay:0.0];
	}
	// [self initWaitView];
	[Functions stopAnimated:self.view];
	
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}
/*
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
	return nil; // @"yop";
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
	return nil;
}
*/
#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return menuItems.count;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
#if USE_CUSTOM_DRAWING
	const NSInteger TOP_LABEL_TAG = 1001;
	const NSInteger BOTTOM_LABEL_TAG = 1002;
	const NSInteger IMAGE_TAG = 1003;
	VerticallyAlignedLabel *topLabel;
	UILabel *bottomLabel;
	UIImageView *image;
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	MenuItem *menuItem = (MenuItem *)[menuItems objectAtIndex:indexPath.row];
#endif
    
    static NSString *CellIdentifier = @"Cell";
 	BOOL isThumbNull = YES;
   
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        // cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
		
#if USE_CUSTOM_DRAWING
		FontItem * font;
		NSString *fileName = @"/indicator.png"; // button_right.png";
		NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
		NSData *imgData = [NSData dataWithContentsOfFile:filePath];
		UIImage *indicatorImage = [UIImage imageWithData:imgData];
		
		// UIImage *indicatorImage = [UIImage imageNamed:@"button_right.png"];
		cell.accessoryView =
		[[[UIImageView alloc]
		  initWithImage:indicatorImage]
		 autorelease];
		
		const CGFloat LABEL_HEIGHT = 20;
		NSInteger leftMargin = 0;
		if ([menuItem.pattern isEqualToString:@"1"])
			leftMargin = 50;
		
		// image
		image = [[[UIImageView alloc] initWithFrame:CGRectMake(15, 15, 50, 50)] autorelease];
        image.tag = IMAGE_TAG;
		// NSLog(@"pattern %@", menuItem.pattern);
		if ([menuItem.pattern isEqualToString:@"2"]) {
			image.frame = CGRectMake(230, 15, 50, 50);
			// NSLog(@"template");
		}
        // image.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleHeight;
        [cell.contentView addSubview:image];
		
		//
		// Create the label for the top row of text
		//
		topLabel =
		[[[VerticallyAlignedLabel alloc]
		  initWithFrame:
		  CGRectMake(
					 /*64 + 50*/leftMargin + 2.0 * cell.indentationWidth,
					 0.5 * (tableView.rowHeight - 2 * LABEL_HEIGHT),
					 tableView.bounds.size.width -
					 /*image.size.width 64 -  50*/leftMargin - 4.0 * cell.indentationWidth
					 - 20,
					 LABEL_HEIGHT)]
		 autorelease];
		[cell.contentView addSubview:topLabel];
		
		//
		// Configure the properties for the text that are the same on every row
		//
		topLabel.tag = TOP_LABEL_TAG;
		topLabel.backgroundColor = [UIColor clearColor];
		topLabel.textColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		topLabel.highlightedTextColor = [UIColor colorWithRed:1.0 green:1.0 blue:0.9 alpha:1.0];
		topLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize]];
		font = [Functions loadFont:menuItem.nameStyle]; 
		
		[topLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
		topLabel.textColor = [Functions colorForHex:font.colorFont];
		topLabel.highlightedTextColor = [Functions colorForHex:font.colorFont];
				
		//
		// Create the label for the top row of text
		//
		bottomLabel =
		[[[UILabel alloc]
		  initWithFrame:
		  CGRectMake(
					 /*image.size.width + */ leftMargin + 2.0 * cell.indentationWidth,
					 0.5 * (tableView.rowHeight - 2 * LABEL_HEIGHT) + LABEL_HEIGHT,
					 tableView.bounds.size.width -
					 /*image.size.width - */ leftMargin - 4.0 * cell.indentationWidth
					 - 20,
					 LABEL_HEIGHT)]
		 autorelease];
		[cell.contentView addSubview:bottomLabel];
		
		//
		// Configure the properties for the text that are the same on every row
		//
		bottomLabel.tag = BOTTOM_LABEL_TAG;
		bottomLabel.backgroundColor = [UIColor clearColor];
		bottomLabel.textColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		bottomLabel.highlightedTextColor = [UIColor colorWithRed:1.0 green:1.0 blue:0.9 alpha:1.0];
		bottomLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize] - 2];
		
		font = [Functions loadFont:menuItem.descriptionStyle]; 

		[bottomLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
		bottomLabel.textColor = [Functions colorForHex:font.colorFont];
		bottomLabel.highlightedTextColor = [Functions colorForHex:font.colorFont];
		
		//
		// Create a background image view.
		//
		cell.backgroundView =
		[[[UIImageView alloc] init] autorelease];
		cell.selectedBackgroundView =
		[[[UIImageView alloc] init] autorelease];
#endif
    }
#if USE_CUSTOM_DRAWING
	else
	{
		topLabel = (VerticallyAlignedLabel *)[cell viewWithTag:TOP_LABEL_TAG];
		bottomLabel = (UILabel *)[cell viewWithTag:BOTTOM_LABEL_TAG];
        image = (UIImageView *)[cell.contentView viewWithTag:IMAGE_TAG];
	}
	
	// NSLog(@"m: %@", menuItem.name);
	FontItem *font;
	
	topLabel.text = menuItem.name;
	font = [Functions loadFont:menuItem.nameStyle]; 
	
	[topLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
	topLabel.textColor = [Functions colorForHex:font.colorFont];

	bottomLabel.text = menuItem.description;
	font = [Functions loadFont:menuItem.descriptionStyle]; 
	[bottomLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
	bottomLabel.textColor = [Functions colorForHex:font.colorFont];

	if (menuItem.description == nil ||
		[menuItem.description isEqualToString:@""]) {
		// topLabel.titleLabel.lineBreakMode = UILineBreakModeWordWrap;
		// topLabel.titleLabel.numberOfLines = 2;
		int imageSize = 0;
		// if (![element.pattern isEqualToString:@"1"]) 
		if ([menuItem.pattern isEqualToString:@"1"])
			imageSize = 50;
		topLabel.frame = CGRectMake(
									/*64 + 50*/imageSize + 2.0 * cell.indentationWidth,
									0.5 * (tableView.rowHeight - 2 * 20),
									tableView.bounds.size.width -
									/*image.size.width 64 -  50*/imageSize - 4.0 * cell.indentationWidth
									- 20,
									20*2);
		// topLabel.backgroundColor = [UIColor blackColor];
	}
	
	//
	// Set the background and selected background images for the text.
	// Since we will round the corners at the top and bottom of sections, we
	// need to conditionally choose the images based on the row index and the
	// number of rows in the section.
	//
	UIImage *rowBackground;
	NSString * fileName;
	// UIImage *selectionBackground;
	NSInteger sectionRows = [tableView numberOfRowsInSection:[indexPath section]];
	NSInteger row = [indexPath row];
	if (row == 0 && row == sectionRows - 1)
	{
		fileName = @"/topAndBottomRow.png";
		// rowBackground = [UIImage imageNamed:@"topAndBottomRow.png"];
		// selectionBackground = [UIImage imageNamed:@"topAndBottomRowSelected.png"];
	}
	else if (row == 0)
	{
		fileName = @"/topRow.png";
		// rowBackground = [UIImage imageNamed:@"topRow.png"];
		// selectionBackground = [UIImage imageNamed:@"topRowSelected.png"];
	}
	else if (row == sectionRows - 1)
	{
		fileName = @"/bottomRow.png";
		// rowBackground = [UIImage imageNamed:@"bottomRow.png"];
		// selectionBackground = [UIImage imageNamed:@"bottomRowSelected.png"];
	}
	else
	{
		fileName = @"/middleRow.png";
		// rowBackground = [UIImage imageNamed:@"middleRow.png"];
		// selectionBackground = [UIImage imageNamed:@"middleRowSelected.png"];
	}
	NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
	// NSLog(@"show %@", filePath);
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	rowBackground = [UIImage imageWithData:imgData];
	((UIImageView *)cell.backgroundView).image = rowBackground;
	((UIImageView *)cell.selectedBackgroundView).image = rowBackground;
	// ((UIImageView *)cell.selectedBackgroundView).image = selectionBackground;
	
	//
	// Here I set an image based on the row. This is just to have something
	// colorful to show on each row.
	//
	// NSLog(@"icon: %@", menuItem.icon);
	// NSLog(@"pattern: %@", menuItem.pattern);

	NSString *fileNameNoDir = [NSString stringWithFormat:@"menu"];
	NSString * fileMenu = [documentsDir stringByAppendingPathComponent:fileNameNoDir];
	fileMenu = [NSString stringWithFormat:@"%@/menu_%@.png", fileMenu, menuItem.idItem];
	
	NSLog(@"icon: %@", menuItem.icon);
	NSLog(@"fileMenu: %@", fileMenu);
	if(isThumbNull)
	{

	if ([menuItem.pattern isEqualToString:@"1"] ||
		[menuItem.pattern isEqualToString:@"2"]) {
		fileName = menuItem.icon;
		if([fileName isEqualToString:@""] == FALSE) {
			BOOL fileExists = [[NSFileManager defaultManager] fileExistsAtPath:fileMenu];
			if (fileExists) {
				NSLog(@"exists");
				imgData = [NSData dataWithContentsOfFile:fileMenu];
			} else {
				NSLog(@"download");
				/*NSURL *imgURL     = [NSURL URLWithString:fileName];
				imgData   = [NSData dataWithContentsOfURL:imgURL];
				[imgData writeToFile:fileMenu atomically:YES];*/
                // deleted for change of plans...
				// cell.image = [[UIImage alloc] initWithData:imgData];
				// cell.imageView.image = [[UIImage alloc] initWithData:imgData];
			}				
			
/*			filePath = [documentsDir stringByAppendingPathComponent:fileName];

	// imgData = [[NSData alloc] initWithContentsOfFile:filePath];
			NSURL *imgURL     = [NSURL URLWithString:fileName];
			imgData   = [NSData dataWithContentsOfURL:imgURL];
			// cell.image = [[UIImage alloc] initWithData:imgData];
			// cell.imageView.image = [[UIImage alloc] initWithData:imgData];*/
			UIImage *img    = [[UIImage alloc] initWithData:imgData];
			image.image = img;
		}
	}
	}//End if(isThumbNull)
    
#else
    // Set up the cell...
	MenuItem *menuItem = (MenuItem *)[menuItems objectAtIndex:indexPath.row];
	NSLog(@"m: %@", menuItem.name);
	// [cell setText: menuItem.name];
	cell.textLabel.text = menuItem.name;
	
	// NSString *subtitle = [NSString stringWithString: @"All about the color "];
	// subtitle = [subtitle stringByAppendingFormat:colorString];
	
	cell.detailTextLabel.text = menuItem.description; // subtitle;
#endif
    
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];

	// NSLog(@"sel row: %d", indexPath.row);
	Config *cnf = [[Config alloc] init];
	NSString * useMenuTabBar = [cnf loadValue:@"useMenuTabBar"];
	if ([useMenuTabBar isEqualToString:@"1"]) {
		// NSLog(@"sel row: %d", indexPath.row);
		[cnf updateValue:@"selectedTabBarItem" value:[NSString stringWithFormat: @"%d", indexPath.row]];
	} else {
		[cnf updateValue:@"selectedTabBarItem" value:@"0"];
	}


	MenuItem *menuItem = (MenuItem *)[menuItems objectAtIndex:indexPath.row];
	NSLog(@"**-> %@", menuItem.idItem);
	/*NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];
	[thrAni release];*/
	[Functions showAnimated:self.view];
	// actual view
	
	[cnf updateValue:@"actualId" value:menuItem.idItem];
	
	[cnf updateValue:@"displayView" value:@"1"];
	[cnf updateValue:@"useTabBar" value:@"0"];
	
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:menuItem.idItem];
	
	[cnf release];
	
	[waitView stopAnimating];
}

-(void)goToMenu:(MenuItem *) menuItem {
	// Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
	NSLog(@"jump -> %@", menuItem.idItem);
	/*NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];*/
	// actual view
	Config *cnf = [[Config alloc] init];
	[cnf updateValue:@"actualId" value:menuItem.idItem];
	
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:menuItem.idItem];
	
	[cnf release];
	
	// [waitView stopAnimating];
}

-(void)loadMenuItem {
	MenuItem *menuItem = (MenuItem *)[menuItems objectAtIndex:0];
	[self goToMenu:menuItem];
}

// ads
-(void)showAd {
	NSLog(@"show ad");
    // [self performSelector:@selector(hideAd) withObject:nil afterDelay:5];
	// return;
	Config *cnf = [[Config alloc] init];
	/*
     NSString * tabbar = [cnf loadValue:@"useTabBar"];
	int tabSpace = 0;
	if ([tabbar isEqualToString:@"1"])
		tabSpace += 48;*/
	NSString * viewAd = [cnf loadValue:@"viewAd"];
	
	if (![viewAd isEqualToString:@"1"])
	{
		[cnf release];
		return;
	}
	/*
    [NSObject cancelPreviousPerformRequestsWithTarget: self];
	// [popupViewController.view removeFromSuperview];
	popupViewController = [[PopupViewController alloc] initWithNibName:@"PopupViewController" bundle:nil];
	[self.view addSubview:popupViewController.view];
	// popupView.view.frame = CGRectMake(0, self.view.frame.size.height,320,100);
	popupViewController.view.frame = CGRectMake(0,460-tabSpace,320,200);
    // [popupView setFrame:CGRectOffset([popupView frame], 0, popupView.frame.size.height)]; // Move it up top and off screen
	 [UIView beginAnimations:@"animateImageOn" context:NULL]; // Begin animation
	[popupViewController.view setFrame:CGRectOffset([popupViewController.view frame], 0, -popupViewController.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
	// Config *cnf;
	NSString *value;
	cnf = [[Config alloc] initWithName:@"adTime"];
	value = cnf.value;
	NSLog(@"show %@", value);
	int adTime = [value intValue];
    [self performSelector:@selector(hideAd) withObject:nil afterDelay:adTime];
	 */
	[cnf release];
}

-(void)hideAd {
	NSLog(@"hide ad");
	// [self performSelector:@selector(showAd) withObject:nil afterDelay:5];
	// return;
	/*
	 Config *cnf;
	cnf = [[Config alloc] initWithName:@"viewAd"];
	NSString * viewAd = cnf.value;
	if (![viewAd isEqualToString:@"1"])
		return;
    [NSObject cancelPreviousPerformRequestsWithTarget: self];
	[UIView beginAnimations:@"animateImageOff" context:NULL]; // Begin animation
	[popupViewController.view setFrame:CGRectOffset([popupViewController.view frame], 0, popupViewController.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
	// [popupView.view removeFromSuperview];
	NSString *value;
	cnf = [[Config alloc] initWithName:@"adFrequency"];
	value = cnf.value;
	NSLog(@"hide %@", value);
	int adFrequency = [value intValue];
	[self performSelector:@selector(showAd) withObject:nil afterDelay:adFrequency];
	[popupViewController.view removeFromSuperview];
	
	cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * displayId = cnf.value;
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	if ([tabbar isEqualToString:@"1"])
		displayId = [infoData valueForKey:@"idTab"];
	[Functions useAd:displayId];*/
}

- (void) cancelAd {
	NSLog(@"cancel");
    [NSObject cancelPreviousPerformRequestsWithTarget: self];
	// [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(showAd) object:nil];
	// [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(hideAd) object:nil];
}

#pragma mark Singleton Methods
//+ (id)sharedManager {
//	@synchronized(self) {
//		if(sharedMyManager == nil)
//			sharedMyManager = [[super allocWithZone:NULL] init];
//	}
//	return sharedMyManager;
//}
//+ (id)allocWithZone:(NSZone *)zone {
//	return [[self sharedManager] retain];
//}

//- (id)copyWithZone:(NSZone *)zone {
//	return self;
//}
//- (id)retain {
//	return self;
//}
//- (unsigned)retainCount {
//	return UINT_MAX; //denotes an object that cannot be released
//}
//- (void)release {
//	// never release
//}
//- (id)autorelease {
//	return self;
//}
//- (id)init {
//	return self;
//}



@end
