//
//  PollResultsViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 12/12/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PollResultsViewController.h"
#import "BarGraph.h"
#import "TBXML.h"
#import "Functions.h"
#import "Config.h"
#import "PollViewController.h"
#import "NSString+HTML.h"
#import "NWPickerField.h"

@implementation PollResultsViewController

@synthesize pollList, XMLData;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        infoData = data;
    }
    return self;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	XMLData =[[NSMutableData alloc] init];
    useDefault = false;

	// NSString * displayId = @"8";
	// NSString *url = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/deleted/poll.xml";
	self.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	
	pollList = [[NSMutableArray alloc] init];

	[Functions initToolBar:self.view withTitle:@"Poll"]; // withTitle:@"" withView:NO];
	// ***	[self initStatusBar:self.view];

	self.view.backgroundColor = [UIColor redColor];
	[self goDownload];
//	[self showXML];

	// pollSelect = [[NWPickerField alloc] initWithFrame:CGRectMake(30, 370, 260, 30)];
	// pollSelect.delegate = self;
	// pollSelect.backgroundColor = [UIColor grayColor];
	// [self.view addSubview:pollSelect];
	// pollSelect.hidden = YES;
	// [pollSelect release];


}

-(void) oldLoad {

	Config *cnf;
	cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}

	NSData *myXMLData;

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_8.xml", displayId]];
	
	// NSString *displayIdValue = [cnf loadValue:[NSString stringWithFormat:@"tmp_%@_8.xml", displayId]];
	
	myXMLData = [NSData dataWithContentsOfFile:fileName];

	NSString *name = ((PollViewController *)self.parentViewController).idPoll;
	NSLog(@"?? %@", name);
	NSLog(@"?? %@", self.parentViewController);

	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	NSString *lastPoolIdValue = [cnf loadValue:[NSString stringWithFormat:@"lastPollId_%@", displayId]];
	NSString * showPollId = lastPoolIdValue;
	NSString * question = @"";
	NSMutableArray *optionsId = [[NSMutableArray alloc] init];
	NSMutableArray *optionsText = [[NSMutableArray alloc] init];
	NSMutableArray *optionsResult = [[NSMutableArray alloc] init];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
    [tbxml release];
	TBXMLElement * childXMLElement;
	// BOOL f = FALSE;
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"poll"]) {
				NSString * pollId = [TBXML valueOfAttributeNamed:@"poll_id" forElement:childXMLElement];

				if ([[cnf loadValue:[NSString stringWithFormat:@"poll_%@_%@", pollId, displayId]] isEqualToString:@"1"]) {
					NSLog(@"add it %@", pollId);
				// cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"poll_%@", pollId]];
				question = [TBXML valueOfAttributeNamed:@"question" forElement:childXMLElement];
				[pollList addObject:question];
				if ([pollId isEqualToString:showPollId]) {
					// if (![cnf.value isEqualToString:@"1"]) {
					// showPollId = pollId;
					// f = TRUE;
					TBXMLElement * itemXMLElement = childXMLElement->firstChild;
					do {
						// NSLog(@"opt? %@", [TBXML elementName:itemXMLElement]);
						if ([[TBXML elementName:itemXMLElement] isEqualToString:@"option"]) {
							NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:itemXMLElement];
							NSString * optionText = [TBXML valueOfAttributeNamed:@"text" forElement:itemXMLElement];
							// NSLog(@"opt-> %@", optionText);
							NSLog(@"val: %@ - %@", optionId, optionText);
							[optionsId addObject:optionId];
							[optionsText addObject:optionText];
							// NSArray * element = [NSArray arrayWithObjects:optionId, optionText, nil];
							// [elements addObject:element];
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:@"stats"]) {
							TBXMLElement * statXMLElement = itemXMLElement->firstChild;
							do {
								if ([[TBXML elementName:statXMLElement] isEqualToString:@"option"]) {
									// NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:statXMLElement];
									NSString * optionText = [TBXML valueOfAttributeNamed:@"value" forElement:statXMLElement];
									NSLog(@"val: %@", optionText);
									// [optionsId addObject:optionId];
									[optionsResult addObject:optionText];
									// [optionText release];
								}
							} while ((statXMLElement = statXMLElement->nextSibling));
						}
					} while ((itemXMLElement = itemXMLElement->nextSibling));
				}
				} // end if poll results...
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
		// } while ((childXMLElement = childXMLElement->nextSibling) && !f);
	}

	// UILabel * 
	questLabel = [[UILabel alloc] initWithFrame:CGRectMake(30, 50, 260, 60)];
	questLabel.text = question;
	questLabel.backgroundColor = [UIColor clearColor];
	[questLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:16]];
	questLabel.textColor = [Functions colorForHex:@"#000000"];
	questLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	questLabel.lineBreakMode = UILineBreakModeWordWrap;
	questLabel.numberOfLines = 0;
	questLabel.shadowColor = [UIColor grayColor];
	questLabel.shadowOffset = CGSizeMake(1,1);
	questLabel.backgroundColor = [UIColor blueColor];
	questLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[self.view addSubview:questLabel];

	graph = [[BarGraph alloc] initWithFrame:CGRectMake(0, 44, 320, 300)];
	// graph.autoresizesSubviews = YES;
	graph.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth
							| UIViewAutoresizingFlexibleLeftMargin  | UIViewAutoresizingFlexibleTopMargin);
	[graph setBackgroundColor:[UIColor whiteColor]];

	// setuo the graph title and axis names
	graph.verticalAxisName		= @""; // @"Vertical Axis";
	graph.horizontalAxisName	= @""; // question; // @"Horazontal Axis";
	
	NSArray * barColors = [NSArray 
						   arrayWithObjects:
						   @"#cc33dd",@"#aa5577",
						   @"#ccaa33",@"#11cc22",
						   @"#2233ee",@"#22eeaa",
						   nil];

	int j = 0;
	for (int i=0;i<optionsId.count;i++) {
		NSString * name = [optionsText objectAtIndex:i];
		//if (name.length > 6) {
		//	name = [name substringWithRange:NSMakeRange(0, 6)];
		//	[name stringByAppendingString:@"..."];
		//}
		[graph addBarWithName:name // [optionsId objectAtIndex:i] 
					WithColor:[Functions colorForHex:[barColors objectAtIndex:j]]
					 AndValue:[[optionsResult objectAtIndex:i] intValue]];
		// NSLog(@"name: %@ %@", name, [barColors objectAtIndex:j]);
		j++;
		if (j >= barColors.count) j = 0;
	}
	// add a new line 
	// [graph addBarWithName:@"Bar One" WithColor:[UIColor redColor] AndValue:25];
	// [graph addBarWithName:@"Bar Two" WithColor:[UIColor greenColor] AndValue:50];

	// [self.view addSubview:graph];
    [optionsResult release];
    [optionsId release];
    [optionsText release];

	UILabel * testLabel = [[UILabel alloc] initWithFrame:CGRectMake(30, 370, 260, 30)];
	testLabel.backgroundColor = [UIColor blackColor];
	[self.view addSubview:testLabel];
    [testLabel release];
	
	// if (![[infoData valueForKey:@"showPoll"] isEqualToString:@"1"]);
	//	graph.frame = CGRectMake(0, 110, 320, 310);
	
	[cnf release];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[XMLData release];
	// [pollSelect release];
	[pollList release];
	[graph release];
	[infoData release];
    [super dealloc];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSMutableData*)myXMLData
{
	// NSString *content = [NSString stringWithUTF8String:[data bytes]]; // NSASCIIStringEncoding
	// NSString *content = [[NSString alloc]  initWithBytes:[data bytes]
	//											  length:[data length] 
	//											encoding: NSUTF8StringEncoding];
	// NSLog(@"data: %@", content);
    NSLog(@"didReceiveData Results");
	[XMLData appendData:myXMLData];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    NSLog(@"didFinishLoading Results");
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
		// [cnf updateValue:@"displayId" value:actualId];	
	}
	NSString * displayId = actualId;
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"YYYYMMddHHmm"];
	NSString *dateString = [dateFormat stringFromDate:date];  
	[dateFormat release];
	// NSString *name = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	// [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] withValue:dateString];
	NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_8.xml", displayId],dateString);
	[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_8.xml", displayId] value:dateString];
	
	// NSLog(@"%@", [[NSString alloc] initWithData:content encoding:NSASCIIStringEncoding]);
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId]];
	
	[XMLData writeToFile:fileName atomically:YES];
	NSLog(@"saved %@...", fileName);
	
	[cnf release];
	
	[self showXML];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    NSLog(@"didFailWithError Results");
}

-(void) goDownload {
	
	Config * cnf = [[Config alloc] init];
	NSString *url = [cnf loadValue:@"servicesUrl"]; // @"http://184.73.161.149:8040/services/get_application_polls.aspx";
	url = [NSString stringWithFormat:@"%@/get_application_polls.aspx", url];

	NSString * email = @"cberzolla@isg-marketing.com";
	NSString * pass = @"soccer";
	NSString * app = [cnf loadValue:@"app_id"]; //@"1";
	// self.idApp = app;
	
	NSString * post = [NSString stringWithFormat:@"&email=%@&password=%@&application_id=%@", 
					   email,
					   pass,
					   app];
	NSData * postData = [post dataUsingEncoding:NSUTF8StringEncoding allowLossyConversion:NO];
	NSString * postLength = [NSString stringWithFormat:@"%d",[postData length]];
	NSMutableURLRequest * request = [[[NSMutableURLRequest alloc] init] autorelease];
	[request setURL:[NSURL URLWithString:url]]; 
	[request setHTTPMethod:@"POST"];
	[request setValue:postLength forHTTPHeaderField:@"Content-Length"];
	[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
	[request setHTTPBody:postData];
	NSLog(@"url %@", url);
	NSLog(@"var %@", post);
	// NSMutableURLRequest *request = [ [ NSMutableURLRequest alloc ] initWithURL: [ NSURL URLWithString:url ] ];
	// [ request setHTTPMethod: @"POST" ];
	// [ request setHTTPBody: postData ];
	
	NSURLConnection * conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	if (conn) NSLog(@"Connection Successful");
	else NSLog(@"Failed to submit request");
    [conn release];
	
	[cnf release];
}

- (void) showXML {
	
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		actualId = [infoData valueForKey:@"idTab"];
		[cnf updateValue:@"displayId" value:actualId];	
	}
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId]];
	
	NSData *Data = [NSData dataWithContentsOfFile:fileName];  
	NSString *unescaped = [[[NSString alloc] initWithData:Data encoding:NSUTF8StringEncoding] autorelease];
	unescaped = [unescaped htmlUnescapedString];
	// NSLog(@"xml <>? %@", unescaped);
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];

	current = 0;
    total = 0;
	NSString * showPollId = [cnf loadValue:[NSString stringWithFormat:@"lastPollId_%@", actualId]];
	NSLog(@"id: %@ %@", [NSString stringWithFormat:@"lastPollId_%@", actualId], showPollId);
	NSString * question = @"";
	NSMutableArray *optionsId = [[NSMutableArray alloc] init];
	NSMutableArray *optionsText = [[NSMutableArray alloc] init];
	NSMutableArray *optionsResult = [[NSMutableArray alloc] init];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
    [tbxml release];
	TBXMLElement * childXMLElement;
	BOOL f = FALSE;
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"poll"]) {
				NSString * pollId = [TBXML valueOfAttributeNamed:@"poll_id" forElement:childXMLElement];
				NSString * pollDefault = [TBXML valueOfAttributeNamed:@"default" forElement:childXMLElement];
//				if ([[cnf loadValue:[NSString stringWithFormat:@"poll_%@_%@", pollId, actualId]] isEqualToString:@"1"]) {
                if ([pollDefault isEqualToString:@"1"])
                    useDefault = true;

					// cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"poll_%@", pollId]];
					if (![pollId isEqualToString:showPollId]) {
						NSString * tmpQuestion = [TBXML valueOfAttributeNamed:@"question" forElement:childXMLElement];
						[pollList addObject:tmpQuestion];
					}
                    total++;
                    if (!f)
                        current++;
					if ([pollId isEqualToString:showPollId] || [showPollId isEqualToString:@""]) {
						// if (![cnf.value isEqualToString:@"1"]) {
                        if ([showPollId isEqualToString:@""])
                        {
						showPollId = pollId;
                            total--;
                            // [cnf updateValue:[NSString stringWithFormat:@"lastPollId_%@", actualId] value:showPollId];
                        }
						question = [TBXML valueOfAttributeNamed:@"question" forElement:childXMLElement];
						f = TRUE;
						TBXMLElement * itemXMLElement = childXMLElement->firstChild;
						do {
							// NSLog(@"opt? %@", [TBXML elementName:itemXMLElement]);
							if ([[TBXML elementName:itemXMLElement] isEqualToString:@"option"]) {
								NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:itemXMLElement];
								NSString * optionText = [TBXML valueOfAttributeNamed:@"text" forElement:itemXMLElement];
								// NSLog(@"opt-> %@", optionText);
								NSLog(@"val: %@ - %@", optionId, optionText);
								[optionsId addObject:optionId];
								[optionsText addObject:optionText];
								// NSArray * element = [NSArray arrayWithObjects:optionId, optionText, nil];
								// [elements addObject:element];
							}
							if ([[TBXML elementName:itemXMLElement] isEqualToString:@"stats"]) {
								TBXMLElement * statXMLElement = itemXMLElement->firstChild;
								do {
									if ([[TBXML elementName:statXMLElement] isEqualToString:@"option"]) {
										// NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:statXMLElement];
										NSString * optionText = [TBXML valueOfAttributeNamed:@"value" forElement:statXMLElement];
										NSLog(@"val: %@", optionText);
										// [optionsId addObject:optionId];
										[optionsResult addObject:optionText];
										// [optionText release];
									}
								} while ((statXMLElement = statXMLElement->nextSibling));
							}
						} while ((itemXMLElement = itemXMLElement->nextSibling));
					}
//				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
		// } while ((childXMLElement = childXMLElement->nextSibling) && !f);
	}
	
	current--;
	NSLog(@"tot: %i", total);
	NSLog(@"cur: %i", current);
	NSLog(@"qst: %@", question);
	NSLog(@"opt: %@", optionsText);
	// UILabel * 
	questLabel = [[UILabel alloc] initWithFrame:CGRectMake(30, 50, self.view.frame.size.width-60, 60)];
	questLabel.text = question;
	questLabel.backgroundColor = [UIColor clearColor];
	[questLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:16]];
	questLabel.textColor = [Functions colorForHex:@"#000000"];
	questLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	questLabel.lineBreakMode = UILineBreakModeWordWrap;
	questLabel.numberOfLines = 0;
	questLabel.shadowColor = [UIColor grayColor];
	questLabel.shadowOffset = CGSizeMake(1,1);
	// questLabel.textColor = [UIColor blueColor];
	questLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[self.view addSubview:questLabel];
	
	// graph = [[BarGraph alloc] initWithFrame:CGRectMake(0, 110, self.view.frame.size.width, self.view.frame.size.height-100)];
	graph = [[BarGraph alloc] initWithFrame:CGRectMake(0, 110, 320, 190)];
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
		graph.frame = CGRectMake(50, 110, self.view.frame.size.width-100, 500);
	// graph.autoresizesSubviews = YES;
	graph.autoresizingMask=(
							
							UIViewAutoresizingFlexibleBottomMargin
							| UIViewAutoresizingFlexibleLeftMargin
							| UIViewAutoresizingFlexibleRightMargin
							
							);
	
	
	// [graph setBackgroundColor:[UIColor whiteColor]];
	[graph setBackgroundColor:[UIColor clearColor]];
	graph.drawBarHighlight = FALSE;
	
	graph.drawLabels = FALSE;
	// setuo the graph title and axis names
	graph.verticalAxisName		= @""; // @"Vertical Axis";
	graph.horizontalAxisName	= @""; // question; // @"Horazontal Axis";
	// graph.fillColor =[UIColor whiteColor];

	// new
	graph.showValueInside = FALSE;
	graph.showPercengages = TRUE;
	graph.drawBarNames = FALSE;
	graph.drawScale = FALSE;
	graph.fillColor = [Functions colorForHex:@"#eeeeee"];
	graph.gridLineColor = [Functions colorForHex:@"#dddddd"];
	graph.barOutlineColor = [Functions colorForHex:@"#cccccc"]; // bar outline
	graph.barHighlightColor = [Functions colorForHex:@"#3534ae"];
	graph.fontColor = [Functions colorForHex:@"#444444"];
	graph.barShadowColor = [Functions colorForHex:@"#657687"]; // shadow
	graph.lineColor = [Functions colorForHex:@"#dddddd"];
	
	NSArray * barColors = [NSArray 
						   arrayWithObjects:
						   @"#3e70a2",@"#ad132e",
						   @"#f6c521",@"#e86608",
						   @"#6109b8",@"#999999",
						   @"#006699",@"#cc3333",
						   @"#666666",@"#3399cc",
						   @"#cc6666",@"#999999",
						   @"#cc33dd",@"#aa5577",
						   @"#ccaa33",@"#11cc22",
						   @"#2233ee",@"#22eeaa",
						   nil];

	NSArray * imgColors = [NSArray 
						   arrayWithObjects:
						   @"chart_blue",@"chart_red01",
						   @"chart_yellow",@"chart_orange",
						   @"chart_purple",@"chart_green",
						   nil];
	
	int j = 0;
	NSString * myHtml = @"<html>"
	"<head> \n"
	"<style type=\"text/css\"> \n"
	"* { \n"
	"margin: 0;\n"
	"padding: 0;\n"
	"font-family:Arial; \n"
	"font-size: 11px;\n"
	"font-color: #000000; \n"
	"font-weight: normal; \n"
	"}\n"
	"table\n"
	"{\n"
	"border-style: none;"
	"}"
	"td\n"
	"{\n" 
	"border-style: none;"
	"vertical-align: top;\n"
	"}\n"
	"</style> \n"
	"</head> \n"
	"<body><table>\n";
	for (int i=0;i<optionsId.count;i++) {
		// NSString * name = [optionsText objectAtIndex:i];
		NSString * name = @" "; // [NSString stringWithFormat:@"%i", i+1]; // [optionsText objectAtIndex:i];
		// myHtml = [NSString stringWithFormat:@"%@<tr><td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td></tr>", myHtml, [barColors objectAtIndex:i], [optionsText objectAtIndex:i]];
		if (i%2)
			myHtml = [NSString stringWithFormat:@"%@<td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td></tr>", myHtml, [barColors objectAtIndex:j], [optionsText objectAtIndex:i]];
		else
			myHtml = [NSString stringWithFormat:@"%@<tr><td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td>", myHtml, [barColors objectAtIndex:j], [optionsText objectAtIndex:i]];
		//if (name.length > 6) {
		//	name = [name substringWithRange:NSMakeRange(0, 6)];
		//	[name stringByAppendingString:@"..."];
		//}
		if (name.length > 12) {
			name = [[name substringWithRange:NSMakeRange(0, 12)] stringByAppendingString:@"..."];
			// graph.useTwoLines = TRUE;
		}
		[graph addBarWithName:name // [optionsId objectAtIndex:i] 
					WithColor:[Functions colorForHex:[barColors objectAtIndex:j]]
				 WithImgColor:[imgColors objectAtIndex:j]
					 AndValue:[[optionsResult objectAtIndex:i] intValue]];
		NSLog(@"name: %@ %@", name, [barColors objectAtIndex:j]);
		j++;
		if (j >= barColors.count) j = 0;
	}
	if (optionsId.count%2)
		myHtml = [NSString stringWithFormat:@"%@<td style=\"width: 10px;\"><span>&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>&nbsp;</td></tr>", myHtml];
	if (optionsId.count < 5) {
		for (int i=optionsId.count;i<5;i++) {
			[graph addBarWithName:@" " 
						WithColor:[Functions colorForHex:[barColors objectAtIndex:j]]
						 AndValue:0];
			// NSLog(@"name: %@ %@", name, [barColors objectAtIndex:j]);
			j++;
			if (j >= barColors.count) j = 0;
		}
	}
    [optionsText release];
    [optionsResult release];
    [optionsId release];
	myHtml = [NSString stringWithFormat:@"%@</table></body></html>", myHtml];
	// add a new line 
	// [graph addBarWithName:@"Bar One" WithColor:[UIColor redColor] AndValue:25];
	// [graph addBarWithName:@"Bar Two" WithColor:[UIColor greenColor] AndValue:50];
	
	[self.view addSubview:graph];
	NSLog(@"graph: %@ %i", graph, graph.count);

	// UILabel * testLabel = [[UILabel alloc] initWithFrame:CGRectMake(30, 370, 260, 30)];
	// testLabel.backgroundColor = [UIColor blackColor];
	// [self.view addSubview:testLabel];

	[pollList insertObject:question atIndex:0];
	// current = 0;
	// pollSelect.delegate = self;
	// [pollSelect reloadAllComponents];
	// NSLog(@"pl: %@", pollList);
	/*
	 // [pollSelect release];
	NWPickerField *pollSelect = [[NWPickerField alloc] initWithFrame:CGRectMake(30, 370, 260, 30)];
	[self.view addSubview:pollSelect];
	pollSelect.backgroundColor = [UIColor grayColor];
	pollSelect.delegate = self;
	[pollSelect reloadInfoData];
	// [pollSelect selectRow:1 inComponent:0 animated:NO];
	
	[pollSelect release];
	*/
	
	// NSString * myHtml = @"asasas";
	UIWebView * webView = [[UIWebView alloc] initWithFrame:CGRectMake(13, 320, 217, 70)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
	webView.frame = CGRectMake(13, graph.frame.size.height+50+80, 217, 70);
	webView.tag = 5005;
	webView.autoresizesSubviews = YES;
	webView.backgroundColor = [UIColor whiteColor];
	webView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth
							  | UIViewAutoresizingFlexibleTopMargin
							  | UIViewAutoresizingFlexibleLeftMargin
							  | UIViewAutoresizingFlexibleRightMargin
							  );
	webView.opaque = FALSE;
	webView.backgroundColor = [UIColor clearColor];

	/*[[webView layer] setCornerRadius:10];
	[webView setClipsToBounds:YES];
	[[webView layer] setBorderColor:
	 [[UIColor colorWithRed:0.52 green:0.09 blue:0.07 alpha:1] CGColor]];
	[[webView layer] setBorderWidth:2.75];*/
 
	[self.view addSubview:webView];
	// [webView setDelegate:self];
	// NSLog(@"html: %@", myHtml);
	[webView loadHTMLString:myHtml baseURL:nil];
	[webView release];

	if (total > 1) {
	// if ([pollList count] > 1) {

		UIButton * prevButt = [UIButton buttonWithType:UIButtonTypeCustom];
		prevButt.tag = 2001;
		prevButt.frame = CGRectMake(240, 350, 30, 30);
		if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
			prevButt.frame = CGRectMake(440, 650, 30, 30);
		UIImage * btnImage = [UIImage imageNamed:@"prev.png"];
		prevButt.backgroundColor = [UIColor clearColor];
		btnImage = [Functions resizeImage:btnImage width:30 height:30];
		[prevButt setImage:btnImage forState:UIControlStateNormal];
		[prevButt addTarget:self
					 action:@selector(prevPoll)
		   forControlEvents:UIControlEventTouchUpInside];
		if (current > 0) prevButt.hidden = FALSE;
		else prevButt.hidden = TRUE;
		// prevButt.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin  | UIViewAutoresizingFlexibleTopMargin;
		[self.view addSubview:prevButt];
		
	UIButton * nextButt = [UIButton buttonWithType:UIButtonTypeCustom];
		nextButt.tag = 2002;
	nextButt.frame = CGRectMake(280, 350, 30, 30);
		if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
			nextButt.frame = CGRectMake(480, 650, 30, 30);
		//nextButt.autoresizingMask = UIViewAutoresizingFlexibleTopMargin | UIViewAutoresizingFlexibleLeftMargin;
	btnImage = [UIImage imageNamed:@"next.png"];
	btnImage = [Functions resizeImage:btnImage width:30 height:30];
	nextButt.backgroundColor = [UIColor clearColor];
	[nextButt setImage:btnImage forState:UIControlStateNormal];
	[nextButt addTarget:self
				 action:@selector(nextPoll)
	   forControlEvents:UIControlEventTouchUpInside];
		if (current < [pollList count]-1) nextButt.hidden = FALSE;
		else nextButt.hidden = TRUE;
	[self.view addSubview:nextButt];
	}

	[cnf release];
}	

-(void) nextPoll {
	NSLog(@"-> cur: %i", current);
	if (current >= /*[pollList count]*/total-1) return;
	current++;
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2002];
	if (current == /*[pollList count]*/total-1) tmpBt.hidden = TRUE;
	else tmpBt.hidden = FALSE;
	tmpBt = (UIButton *)[self.view viewWithTag:2001];
	if (current > 0) tmpBt.hidden = FALSE;
	else tmpBt.hidden = TRUE;
	[self showPoll];
}

-(void) prevPoll {
	if (current <= 0) return;
	current--;
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2001];
	if (current > 0) tmpBt.hidden = FALSE;
	else tmpBt.hidden = TRUE;
	tmpBt = (UIButton *)[self.view viewWithTag:2002];
	if (current <= /*[pollList count]*/total-1) tmpBt.hidden = FALSE;
	else tmpBt.hidden = TRUE;
	[self showPoll];
}

- (void) showPoll{
	// questLabel.text = @"aeiou";
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		actualId = [infoData valueForKey:@"idTab"];
		[cnf updateValue:@"displayId" value:actualId];	
	}
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId]];
	
	NSData *Data = [NSData dataWithContentsOfFile:fileName];  
	NSString *unescaped = [[[NSString alloc] initWithData:Data encoding:NSUTF8StringEncoding] autorelease];
	unescaped = [unescaped htmlUnescapedString];
	// NSLog(@"xml? %@ ", unescaped);	
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
	
	NSString * question = @"";
	NSMutableArray *optionsId = [[NSMutableArray alloc] init];
	NSMutableArray *optionsText = [[NSMutableArray alloc] init];
	NSMutableArray *optionsResult = [[NSMutableArray alloc] init];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
    [tbxml release];
	TBXMLElement * childXMLElement;
	BOOL f = FALSE;
	int count = 1;
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"poll"]) {
				// NSString * pollId = [TBXML valueOfAttributeNamed:@"poll_id" forElement:childXMLElement];
				NSString * pollDefault = [TBXML valueOfAttributeNamed:@"default" forElement:childXMLElement];
				// cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"poll_%@", pollId]];
                int tmpC = 0;
                if (!useDefault) tmpC = 1;
				if ((count == current+tmpC && pollDefault == nil) 
					|| (current == 0 && [pollDefault isEqualToString:@"1"])) {
					// if (![cnf.value isEqualToString:@"1"]) {
					// showPollId = pollId;
					question = [TBXML valueOfAttributeNamed:@"question" forElement:childXMLElement];
					f = TRUE;
					TBXMLElement * itemXMLElement = childXMLElement->firstChild;
					do {
						// NSLog(@"opt? %@", [TBXML elementName:itemXMLElement]);
						if ([[TBXML elementName:itemXMLElement] isEqualToString:@"option"]) {
							NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:itemXMLElement];
							NSString * optionText = [TBXML valueOfAttributeNamed:@"text" forElement:itemXMLElement];
							// NSLog(@"opt-> %@", optionText);
							NSLog(@"val: %@ - %@", optionId, optionText);
							[optionsId addObject:optionId];
							[optionsText addObject:optionText];
							// NSArray * element = [NSArray arrayWithObjects:optionId, optionText, nil];
							// [elements addObject:element];
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:@"stats"]) {
							TBXMLElement * statXMLElement = itemXMLElement->firstChild;
							do {
								if ([[TBXML elementName:statXMLElement] isEqualToString:@"option"]) {
									// NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:statXMLElement];
									NSString * optionText = [TBXML valueOfAttributeNamed:@"value" forElement:statXMLElement];
									NSLog(@"val: %@", optionText);
									// [optionsId addObject:optionId];
									[optionsResult addObject:optionText];
									// [optionText release];
								}
							} while ((statXMLElement = statXMLElement->nextSibling));
						}
					} while ((itemXMLElement = itemXMLElement->nextSibling));
				}
				NSLog(@"def: %@ %i %i", pollDefault, current, count);
				if (![pollDefault isEqualToString:@"1"]) count++;
			}
		// } while ((childXMLElement = childXMLElement->nextSibling));
		} while ((childXMLElement = childXMLElement->nextSibling) && !f);
	}
	
	NSLog(@"qst: %@", question);
	NSLog(@"opt: %@", optionsText);
	// UILabel * 
	questLabel.text = question;
    [graph removeFromSuperview];
	graph = nil;
	[graph release];
	graph = [[BarGraph alloc] initWithFrame:CGRectMake(0, 110, 320, 190)];
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
		graph.frame = CGRectMake(50, 110, self.view.frame.size.width-100, 500);
//		graph.frame = CGRectMake(50, 110, self.view.frame.size.width-100, self.view.frame.size.height-400);
	// graph.autoresizesSubviews = YES;
	graph.autoresizingMask=(
							
							 UIViewAutoresizingFlexibleBottomMargin
							| UIViewAutoresizingFlexibleLeftMargin
							| UIViewAutoresizingFlexibleRightMargin
							
							);
	// [graph setBackgroundColor:[UIColor whiteColor]];
	[graph setBackgroundColor:[UIColor clearColor]];
	// [graph removeAllBars];
	graph.drawBarHighlight = FALSE;
	
	// setuo the graph title and axis names
	graph.verticalAxisName		= @""; // @"Vertical Axis";
	graph.horizontalAxisName	= @""; // question; // @"Horazontal Axis";
	graph.fillColor = [UIColor whiteColor];
	
	// new
	graph.showValueInside = FALSE;
	graph.showPercengages = TRUE;
	graph.drawBarNames = TRUE;
	graph.drawScale = FALSE;
	graph.fillColor = [Functions colorForHex:@"#eeeeee"];
	graph.gridLineColor = [Functions colorForHex:@"#dddddd"];
	graph.barOutlineColor = [Functions colorForHex:@"#cccccc"]; // bar outline
	graph.barHighlightColor = [Functions colorForHex:@"#3534ae"];
	graph.fontColor = [Functions colorForHex:@"#444444"];
	graph.barShadowColor = [Functions colorForHex:@"#657687"]; // shadow
	graph.lineColor = [Functions colorForHex:@"#dddddd"];
	
	graph.drawLabels = FALSE;
	graph.drawBarNames = FALSE;

	NSArray * barColors = [NSArray 
						   arrayWithObjects:
						   @"#3e70a2",@"#ad132e",
						   @"#f6c521",@"#e86608",
						   @"#6109b8",@"#999999",
						   @"#006699",@"#cc3333",
						   @"#666666",@"#3399cc",
						   @"#cc6666",@"#999999",
						   @"#cc33dd",@"#aa5577",
						   @"#ccaa33",@"#11cc22",
						   @"#2233ee",@"#22eeaa",
						   nil];
	
	NSArray * imgColors = [NSArray 
						   arrayWithObjects:
						   @"chart_blue",@"chart_red01",
						   @"chart_yellow",@"chart_orange",
						   @"chart_purple",@"chart_green",
						   nil];
	int j = 0;
	NSString * myHtml = @"<html>"
	"<head> \n"
	"<style type=\"text/css\"> \n"
	"* { \n"
	"margin: 0;\n"
	"padding: 0;\n"
	"font-family:Arial; \n"
	"font-size: 11px;\n"
	"font-color: #000000; \n"
	"font-weight: normal; \n"
	"}\n"   
	"td\n"
	"{\n" 
	"vertical-align: top;\n"
	"}\n"
	"</style> \n"
	"</head> \n"
	"<body><table>\n";
	for (int i=0;i<optionsId.count;i++) {
		NSString * name = @" "; // [NSString stringWithFormat:@"%i", i+1]; // [optionsText objectAtIndex:i];
		// myHtml = [NSString stringWithFormat:@"%@<tr><td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td></tr>", myHtml, [barColors objectAtIndex:i], [optionsText objectAtIndex:i]];
		if (i%2)
			myHtml = [NSString stringWithFormat:@"%@<td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td></tr>", myHtml, [barColors objectAtIndex:j], [optionsText objectAtIndex:i]];
		else
			myHtml = [NSString stringWithFormat:@"%@<tr><td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td>", myHtml, [barColors objectAtIndex:j], [optionsText objectAtIndex:i]];
		//if (name.length > 6) {
		//	name = [name substringWithRange:NSMakeRange(0, 6)];
		//	[name stringByAppendingString:@"..."];
		//}
		[graph addBarWithName:name // [optionsId objectAtIndex:i] 
					WithColor:[Functions colorForHex:[barColors objectAtIndex:j]]
				 WithImgColor:[imgColors objectAtIndex:j]
					 AndValue:[[optionsResult objectAtIndex:i] intValue]];
		// NSLog(@"name: %@ %@", name, [barColors objectAtIndex:j]);
		j++;
		if (j >= barColors.count) j = 0;
	}
	if (optionsId.count%2)
		myHtml = [NSString stringWithFormat:@"%@<td style=\"width: 10px;\"><span>&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>&nbsp;</td></tr>", myHtml];
	if (optionsId.count < 5) {
		for (int i=optionsId.count;i<5;i++) {
			[graph addBarWithName:@" " 
						WithColor:[Functions colorForHex:[barColors objectAtIndex:j]]
					 WithImgColor:[imgColors objectAtIndex:i]
						 AndValue:0];
			// NSLog(@"name: %@ %@", name, [barColors objectAtIndex:j]);
			j++;
			if (j >= barColors.count) j = 0;
		}
	}
	[optionsId release];
    [optionsResult release];
    [optionsText release];
	[self.view addSubview:graph];
	myHtml = [NSString stringWithFormat:@"%@</table></body></html>", myHtml];
	NSLog(@"html: %@", myHtml);
	UIWebView * webView = (UIWebView *)[self.view viewWithTag:5005];
	[webView loadHTMLString:myHtml baseURL:nil];

	[cnf release];
}

#pragma mark -
#pragma mark NWPickerField
#pragma mark -

-(NSInteger) numberOfComponentsInPickerField:(NWPickerField*)pickerField {
	NSLog(@"nc: 1");
	return 1;
}

-(NSInteger) pickerField:(NWPickerField*)pickerField numberOfRowsInComponent:(NSInteger)component{
	NSLog(@"c: %d", [pollList count]);
	return [pollList count];
}

-(NSString *) pickerField:(NWPickerField *)pickerField titleForRow:(NSInteger)row forComponent:(NSInteger)component{
	if ([pollList count] == 0) return @"";
	NSLog(@"l: %@", [pollList objectAtIndex:row]);
	return [pollList objectAtIndex:row];
}

- (void) pickerField:(NWPickerField *)pickerField didSelectRow:(NSInteger)row inComponent:(NSInteger)component {
	if ([pollList count] == 0) return;
	NSLog(@"1 Selected Color: %@. Index of selected color: %i", [pollList objectAtIndex:row], row);
	[pickerField resignFirstResponder];
}

@end
