//
//  PollViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 10/29/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PollViewController.h"
#import <QuartzCore/QuartzCore.h>
#import "Functions.h"
#import "MIRadioButtonGroup.h"
#import "TBXML.h"
#import "Config.h"
#import "PollResultsViewController.h"
#import "NSString+HTML.h"

@implementation PollViewController

@synthesize idPoll, idApp, XMLData;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	// NSString *url = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/deleted/poll.xml";
	// NSString *url = @"http://184.73.161.149:8040/services/get_application_polls.aspx";
	NSString * title = @"Poll";
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	self.idApp = @""; // [[[NSString alloc] init] retain];
	self.idPoll = @""; // [[[NSString alloc] init] retain];

	// [Functions initToolBar:self.view withTitle:@"Poll"]; // withTitle:@"" withView:NO];
	[Functions addToolBar:self.view withTitle:title actualId:actualId];
// ***	[self initStatusBar:self.view];
	
	// NSLog(@"u: %@", url);
	// NSURL *u = [NSURL URLWithString:url];

	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];

	// cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"tmp_%@_8.xml", displayId]];
	NSString * value = [cnf loadValue:@"useTabBar"];

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId]];
	XMLData =[[NSMutableData alloc] init];
	// if([cnf.value isEqualToString:@""] || cnf.value == nil
	if([value isEqualToString:@""] || value == nil
	   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];  
		// [dateFormat release];
		[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId] value:dateString];
		// myXMLData = [NSData dataWithContentsOfURL:u];
		[self goDownload];
	} else {
		NSTimeInterval dateTime;		
		// NSDateFormatter *
		// dateFormat = [[[NSDateFormatter alloc] init] autorelease];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		// NSDate *lastCheck = [dateFormat dateFromString:cnf.value];
		NSDate *lastCheck = [dateFormat dateFromString:value];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);
		
		if(dateTime > 1) {
			NSLog(@"down (2)... ");
			// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			// [dateFormat release];
			NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_8.xml", actualId],dateString);
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId] value:dateString];
			// myXMLData = [NSData dataWithContentsOfURL:u];
			[self goDownload];
		} else {
			// myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
			// [self processXml:[[NSData alloc] initWithContentsOfFile:fileName]];
			NSLog(@"down (3)... ");
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_8.xml", actualId],dateString);
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId] value:dateString];
			[self goDownload];
			// always download
			// [self showXML];
		}
	}
	
	[dateFormat release];

	[cnf release];
}

- (IBAction)goSubmit:(id)sender {
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}

	if ([group getSelected] == -1) {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" 
														message:@"One answer must be selected." 
													   delegate:nil
											  cancelButtonTitle:@"OK"
											  otherButtonTitles:nil];
		[alert show];
		[alert release];
		[cnf release];
		return;
	}

	if (![idPoll isEqualToString:@""] &&
		!(idPoll == nil)) { 
		NSLog(@"...");
		NSLog(@"sel: %i %@", [group getSelected], idPoll);
		NSLog(@"***");
		// [Functions updateConfig:[NSString stringWithFormat:@"lastPollId_%@", actualId] withValue:idPoll];
		// [Functions updateConfig:[NSString stringWithFormat:@"poll_%@_%@", idPoll, actualId] withValue:@"1"];
		// [Config updateValue:[NSString stringWithFormat:@"lastPollId_%@", actualId] value:idPoll];
		// [Config updateValue:[NSString stringWithFormat:@"poll_%@_%@", idPoll, actualId] value:@"1"];

		NSString * format = @"lastPollId_%@";
		//NSString * value = [cnf loadValue:[NSString stringWithFormat:format, actualId]];
		//if([value isEqualToString:@""] == TRUE)
		//	[cnf insertValue:[NSString stringWithFormat:format, actualId] value:idPoll];
		//else
			[cnf updateValue:[NSString stringWithFormat:format, actualId] value:idPoll];

		format = @"poll_%@_%@";
		//value = [cnf loadValue:[NSString stringWithFormat:format, idPoll, actualId]];
		//if([value isEqualToString:@""] == TRUE)
		//	[cnf insertValue:[NSString stringWithFormat:format, idPoll, actualId] value:@"1"];
		//else
			[cnf updateValue:[NSString stringWithFormat:format, idPoll, actualId] value:@"1"];
		
		// [format release];
		// [value release];
	
	}
	// return;
	// NSMutableDictionary * myData;
	// [myData setObject:@"1" forKey:@"showPoll"];
	// PollResultsViewController *pollResultsViewController = [[PollResultsViewController alloc] 
	//														initWithData:myData
	//														nibName:@"PollResultsViewController" bundle:[NSBundle mainBundle]];

	
	// NSString * url = @"http://184.73.161.149:8040/services/add_poll_vote.aspx";

	NSString *url = [cnf loadValue:@"servicesUrl"];
	url = [NSString stringWithFormat:@"%@/add_poll_vote.aspx", url];
	
	NSString * email = @"cberzolla@isg-marketing.com";
	NSString * pass = @"soccer";
	NSString * app = [cnf loadValue:@"app_id"]; //@"1";
	// NSString * app = idApp; // @"1";
	NSString * pollId = idPoll;
	NSString * answerId = [NSString stringWithFormat:@"%i", [group getSelected]+1];

	NSString *post =[NSString stringWithFormat:@"email=%@&password=%@&application_id=%@&poll_id=%@&answer=%@",
					 email, pass, app, pollId, answerId];
	
	NSData *postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
	
	NSString *postLength = [NSString stringWithFormat:@"%d", [postData length]];
	
	NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
	[request setURL:[NSURL URLWithString:url]];
	[request setHTTPMethod:@"POST"];
	[request setValue:postLength forHTTPHeaderField:@"Content-Length"];
	[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
	[request setHTTPBody:postData];
	[cnf release];
	
	NSError *error;
	NSURLResponse *response;
	NSData *urlData=[NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];
	NSString *data=[[NSString alloc] initWithData:urlData encoding:NSUTF8StringEncoding];
	NSLog(@"%@", post);	
	NSLog(@"%@", data);	
	[data release];

	if ([tabbar isEqualToString:@"1"]) {
		NSMutableDictionary *myData = [[ NSMutableDictionary alloc]
									   init];
		[myData setObject:[infoData valueForKey:@"idTab"] forKey:@"idTab"];
		PollResultsViewController *pollResultsViewController = [[PollResultsViewController alloc] 
																initWithData:myData
																nibName:@"PollResultsViewController" bundle:[NSBundle mainBundle]];
		// pollViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
		// pollViewController.tabBarItem.image = image;
        pollResultsViewController.view.frame = self.view.frame;
        pollResultsViewController.view.autoresizingMask = (UIViewAutoresizingFlexibleWidth
                                                           | UIViewAutoresizingFlexibleHeight);
		[self.view addSubview:pollResultsViewController.view];
		// self.tabBarController.selectedViewController = pollResultsViewController;
		// [pollResultsViewController release];
	} else {		
		PollResultsViewController *pollResultsViewController = [[PollResultsViewController alloc] 
																initWithNibName:@"PollResultsViewController" bundle:[NSBundle mainBundle]];
        pollResultsViewController.view.frame = self.view.frame;
        pollResultsViewController.view.autoresizingMask = (UIViewAutoresizingFlexibleWidth
                                                           | UIViewAutoresizingFlexibleHeight);
		[self.view addSubview:pollResultsViewController.view];
		// [pollResultsViewController release];
	}			

	//PollResultsViewController *pollResultsViewController = [[PollResultsViewController alloc] 
	//														initWithNibName:@"PollResultsViewController" bundle:[NSBundle mainBundle]];
	// self.tabBarController.selectedViewController = pollResultsViewController;
	//[self.view addSubview:pollResultsViewController.view];
	
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[XMLData release];
	[idApp release];
	[idPoll release];
	[infoData release];
    [super dealloc];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSMutableData*)myXMLData
{
	// NSString *content = [NSString stringWithUTF8String:[data bytes]]; // NSASCIIStringEncoding
	// NSString *content = [[NSString alloc]  initWithBytes:[data bytes]
	//											  length:[data length] 
	//											encoding: NSUTF8StringEncoding];
	// NSLog(@"data: %@", content);
    NSLog(@"didReceiveData");

	[XMLData appendData:myXMLData];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    NSLog(@"didFinishLoading");
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
		[cnf updateValue:@"displayId"  value:actualId];	
	}
	NSString * displayId = actualId;
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"YYYYMMddHHmm"];
	NSString *dateString = [dateFormat stringFromDate:date];  
	[dateFormat release];
	// NSString *name = [NSString stringWithFormat:@"tmp_%@_8.xml", displayId];
	// [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_8.xml", displayId] withValue:dateString];
	NSLog(@"finish d: %@ %@", [NSString stringWithFormat:@"tmp_%@_8.xml", displayId],dateString);
	[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_8.xml", displayId] value:dateString];
	
	// NSLog(@"%@", [[NSString alloc] initWithData:myXMLData encoding:NSASCIIStringEncoding]);

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId]];

	[XMLData writeToFile:fileName atomically:YES];
	NSLog(@"saved %@...", fileName);

	[cnf release];
	
	[self showXML];

}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    NSLog(@"didFailWithError");
}

-(void) goDownload {
	
	// NSString * url = @"http://184.73.161.149:8040/services/get_application_polls.aspx";

	Config * cnf = [[Config alloc] init];
	NSString *url = [cnf loadValue:@"servicesUrl"];
	url = [NSString stringWithFormat:@"%@/get_application_polls.aspx", url];

	NSString * email = @"cberzolla@isg-marketing.com";
	NSString * pass = @"soccer";
	NSString * app = [cnf loadValue:@"app_id"]; //@"1";
	self.idApp = app;
	[cnf release];

	NSString * post = [NSString stringWithFormat:@"&email=%@&password=%@&application_id=%@", 
					   email,
					   pass,
					   app];
	NSData * postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:NO];
	NSString * postLength = [NSString stringWithFormat:@"%d",[postData length]];
	NSMutableURLRequest * request = [[[NSMutableURLRequest alloc] init] autorelease];
	[request setURL:[NSURL URLWithString:url]]; 
	[request setHTTPMethod:@"POST"];
	[request setValue:postLength forHTTPHeaderField:@"Content-Length"];
	[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
	[request setHTTPBody:postData];
	NSLog(@"url %@", url);
	NSLog(@"post %@", post);
	// NSMutableURLRequest *request = [ [ NSMutableURLRequest alloc ] initWithURL: [ NSURL URLWithString:url ] ];
	// [ request setHTTPMethod: @"POST" ];
	// [ request setHTTPBody: postData ];
	
	NSURLConnection * conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	if (conn) NSLog(@"Connection Successful");
	else NSLog(@"Failed to submit request");
	[conn release];
	// [post release];
	
}

- (void) showXML {

	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		actualId = [infoData valueForKey:@"idTab"];
		[cnf updateValue:@"displayId" value:actualId];	
	}

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_8.xml", actualId]];
	
	NSData *Data = [NSData dataWithContentsOfFile:fileName];  
	NSString *unescaped = [[[NSString alloc] initWithData:Data encoding:NSASCIIStringEncoding] autorelease];
	unescaped = [unescaped htmlUnescapedString];
	NSLog(@"ooo? %@", unescaped);

	
	// TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	//BOOL pollTmp = NO;
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
	NSString * showPollId = @"";
	NSString * question = @"";
	NSString * bgImage = @"";
	//NSMutableArray *optionsId = [[NSMutableArray alloc] init];
	NSMutableArray *optionsText = [[NSMutableArray alloc] init];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	[tbxml release];
	TBXMLElement * childXMLElement;
	BOOL f = FALSE;
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"poll"]) {
				NSString * pollId = [TBXML valueOfAttributeNamed:@"poll_id" forElement:childXMLElement];
				NSString * pollDefault = [TBXML valueOfAttributeNamed:@"default" forElement:childXMLElement];
				// cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"poll_%@", pollId]];
				NSString * value = [cnf loadValue:[NSString stringWithFormat:@"poll_%@_%@", pollId, actualId]];
				NSLog(@"val? %@ def: %@ --> %@", value, pollDefault, [NSString stringWithFormat:@"poll_%@_%@", pollId, actualId]);
				if (![value isEqualToString:@"1"] && [pollDefault isEqualToString:@"1"]) {
//				if (![value isEqualToString:@"1"] && 
//					([pollDefault isEqualToString:@"1"] || pollTmp == NO)) {
					// pollTmp = YES;
					showPollId = pollId;
					question = [TBXML valueOfAttributeNamed:@"question" forElement:childXMLElement];
					bgImage = [TBXML valueOfAttributeNamed:@"background_image" forElement:childXMLElement];
					f = TRUE;
					TBXMLElement * itemXMLElement = childXMLElement->firstChild;
					do {
						// NSLog(@"opt? %@", [TBXML elementName:itemXMLElement]);
						if ([[TBXML elementName:itemXMLElement] isEqualToString:@"option"]) {
							// NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:itemXMLElement];
							NSString * optionText = [TBXML valueOfAttributeNamed:@"text" forElement:itemXMLElement];
							// NSLog(@"opt-> %@", optionText);
							//[optionsId addObject:optionId];
							[optionsText addObject:optionText];
							// NSArray * element = [NSArray arrayWithObjects:optionId, optionText, nil];
							// [elements addObject:element];
						}
					} while ((itemXMLElement = itemXMLElement->nextSibling));
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && !f);
	}
	
	// NSLog(@"--> %@ <--", optionsText);
	
	/*
	 // NSLog(@"--> %@ <--", elements);
	 } else {
	 NSLog(@"err");
	 
	 // Also issue visual alert
	 UIAlertView *alert = [[UIAlertView alloc]
	 initWithTitle:@"Information file doesn't exists."
	 message:nil
	 delegate:nil
	 cancelButtonTitle:nil
	 otherButtonTitles:@"OK", nil];
	 [alert show];
	 }
	 
	 */
	
	
	
	/*
	 UIImageView * backImage = [[[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 320, 480)] autorelease];
	 NSString * url = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/poll/pollimages/bg_archrecord.png";
	 NSURL *imgURL     = [NSURL URLWithString:url];
	 NSData *imgData   = [NSData dataWithContentsOfURL:imgURL];
	 UIImage *img    = [[UIImage alloc] initWithData:imgData];
	 [backImage	setImage:img];
	 [self.view addSubview:backImage];
	 */
	
	self.idPoll = @""; // showPollId;
	self.idPoll = showPollId;
	NSLog(@"poll: %@", idPoll);
	if ([idPoll isEqualToString:@""] ||
		(idPoll == nil)) { 

		/*NSMutableDictionary * myData;
		 [myData setObject:@"0" forKey:@"showPoll"];
		 PollResultsViewController *pollResultsViewController = [[PollResultsViewController alloc] 
		 initWithData:myData
		 nibName:@"PollResultsViewController" bundle:[NSBundle mainBundle]];
		 [self.view addSubview:pollResultsViewController.view];*/
		
		if ([tabbar isEqualToString:@"1"]) {
			NSMutableDictionary *myData = [[ NSMutableDictionary alloc]
										   init];
			[myData setObject:[infoData valueForKey:@"idTab"] forKey:@"idTab"];
			PollResultsViewController *pollResultsViewController = [[PollResultsViewController alloc] 
																	initWithData:myData
																	nibName:@"PollResultsViewController" bundle:[NSBundle mainBundle]];
			// pollViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
			// pollViewController.tabBarItem.image = image;
			pollResultsViewController.view.frame = self.view.frame;
			[self.view addSubview:pollResultsViewController.view];
			pollResultsViewController.view.autoresizingMask = UIViewAutoresizingFlexibleWidth
			| UIViewAutoresizingFlexibleHeight;
			// self.tabBarController.selectedViewController = pollResultsViewController;
			// [pollResultsViewController release];
			// [myData release];
		} else {		
			PollResultsViewController *pollResultsViewController = [[PollResultsViewController alloc] 
																	initWithNibName:@"PollResultsViewController" 
																	bundle:[NSBundle mainBundle]];
			pollResultsViewController.view.frame = self.view.frame;
			pollResultsViewController.view.autoresizingMask = (UIViewAutoresizingFlexibleWidth
															   | UIViewAutoresizingFlexibleHeight);
			[self.view addSubview:pollResultsViewController.view];
			// [pollResultsViewController release];
		}
		
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Poll" message:@"You already voted on this poll, click to see results." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];
		
		/*cnf = [[Config alloc] initWithName:@"useTabBar"];
		 NSString * tabbar = cnf.value;
		 
		 NSLog(@"tb: %@", tabbar);
		 if ([tabbar isEqualToString:@"1"]) {
		 actualId = [infoData valueForKey:@"idTab"];
		 }*/
	} else {

		if ((bgImage != nil) && !([bgImage isEqualToString:@""])) {
		NSURL *url = [NSURL URLWithString:bgImage];
		NSData * imgData = [[NSData alloc] initWithContentsOfURL:url];
			UIImage *img = [[UIImage alloc] initWithData:imgData];
			UIImageView * imgView = [[UIImageView alloc] initWithImage:img];
			[self.view addSubview:imgView];
			[imgView release];
			[img release];
			[imgData release];
			NSLog(@"image %@", bgImage);
		}		
		
		UILabel * questLabel = [[UILabel alloc] initWithFrame:CGRectMake(30, 50, 260, 60)];
        questLabel.frame = CGRectMake(30, 50, self.view.frame.size.width-60, 60);
		questLabel.text = question;
		questLabel.backgroundColor = [UIColor clearColor];
		[questLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:16]];
		questLabel.textColor = [Functions colorForHex:@"#000000"];
		questLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
		questLabel.lineBreakMode = UILineBreakModeWordWrap;
		questLabel.numberOfLines = 0;
		questLabel.shadowColor = [UIColor grayColor];
		questLabel.shadowOffset = CGSizeMake(1,1);
		// questLabel.textColor = [UIColor blueColor];
		questLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		[self.view addSubview:questLabel];
		[questLabel release];

		/*
		 UIView *background = [[UIView alloc] initWithFrame:CGRectMake(50, 120, 220, 220)];
		 background.backgroundColor = [UIColor whiteColor];
		 background.alpha = 0.7;
		 background.layer.cornerRadius = 8;
		 background.layer.masksToBounds = YES;
		 background.layer.borderColor = [[UIColor blueColor] CGColor];
		 background.layer.borderColor = [[Functions colorForHex:@"#555555"] CGColor];
		 background.layer.borderWidth = 2;
		 [self.view addSubview:background];
		 
		 UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		 [button setFrame:CGRectMake(210,350,75,26)];
		 [button setTitle:@"Go" forState:UIControlStateNormal];
		 [button addTarget:self action:@selector(goSubmit:) forControlEvents:UIControlEventTouchUpInside];
		 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
		 [self.view addSubview:button];
		 // [button release];
		 */
		
		/*
		 UISegmentedControl *codeButton = [[UISegmentedControl alloc] initWithItems:[NSArray arrayWithObject:@"      Go      "]];
		 codeButton.segmentedControlStyle = UISegmentedControlStyleBar;
		 codeButton.momentary = YES;
		 codeButton.tintColor = [Functions colorForHex:@"#4478e2"];
		 // [UIColor blueColor]; //]darkGrayColor];
		 codeButton.center = CGPointMake(160,400);
		 [codeButton addTarget:self action:@selector(goSubmit:) forControlEvents:UIControlEventValueChanged];
		 [self.view addSubview:codeButton];
		 */
		
		UIButton *cancelButton = [UIButton buttonWithType:UIButtonTypeCustom];
		[cancelButton setFrame:CGRectMake(110,350,120,44)];
		if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
            [cancelButton setFrame:CGRectMake((self.view.frame.size.width-120)/2,self.view.frame.origin.y + 450,120,44)];
		[cancelButton setTitle:@"Go" forState:UIControlStateNormal];
		[cancelButton addTarget:self action:@selector(goSubmit:) forControlEvents:UIControlEventTouchUpInside];
		cancelButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin | UIViewAutoresizingFlexibleBottomMargin;
		cancelButton.backgroundColor = [UIColor clearColor]; // [Functions colorForHex:@"#cccccc"];
		[cancelButton setBackgroundImage:[[UIImage imageNamed:@"button-bg-blck.png"] stretchableImageWithLeftCapWidth:10.0 topCapHeight:0.0] forState:UIControlStateNormal];
		[self.view addSubview:cancelButton];
		// [cancelButton release];
		
		/*NSArray *options =[[NSArray alloc]initWithObjects:
		 @"1. My First Test",
		 @"2. Another test. Another test.",
		 @"3. New test...",
		 @"1. My First Test. My First Test.",
		 @"2. Another test.",
		 @"3. New test... New test... New test...",
		 nil];*/
		
		NSArray *options = [[NSArray alloc] initWithArray:optionsText];

		group =[[MIRadioButtonGroup alloc] initWithFrame:CGRectMake(0, 100, 320, 200) andOptions:nil andColumns:1];
		CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
		if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
			[group setFrame:CGRectMake(CGRectGetMinX(mainViewBounds)+100, questLabel.frame.origin.y + questLabel.frame.size.height + 50.0, CGRectGetWidth(mainViewBounds)-200, 270)];
		group.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin  | UIViewAutoresizingFlexibleTopMargin
        | UIViewAutoresizingFlexibleBottomMargin | UIViewAutoresizingFlexibleRightMargin;
        // group.backgroundColor = [UIColor blueColor];
		[group removeAll];
		if ([options count])
			[group createButtons:options withColumns:1];
		[self.view addSubview:group];
		[options release];
		// NSLog(@"sel? %i %@", [group getSelected], idPoll);
	}
	
    [optionsText release];
	[cnf release];

}

@end
