//
//  ShareViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 11/5/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ShareViewController.h"
#import "app_builderAppDelegate.h"
#import "FBConnect.h"
#import "SA_OAuthTwitterEngine.h"
#import "Functions.h"

@implementation ShareViewController

/*
 static NSString* kAppId = @"4871258982";

#define kOAuthConsumerKey				@"42PyqwqpvNtsucn49QEAw"		//REPLACE ME
#define kOAuthConsumerSecret			@"tbA4NQrBwBNAq9HW0Lj9NgpcxoPLIhH0FodyDuPx40"		//REPLACE ME
*/

static ShareViewController *sharedMyManager = nil;

@synthesize mailSubject, mailText;
@synthesize textTitle, textUrl, textDescription;
@synthesize kAppId, kOAuthConsumerKey, kOAuthConsumerSecret;

@synthesize facebookTitle, facebookDescription, facebookLink;
@synthesize twitterTitle, twitterDescription, twitterLink;
@synthesize useMail, useTwitter, useFacebook;

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
		permissions =  [[NSArray arrayWithObjects: 
						 @"read_stream", @"offline_access",@"publish_stream",nil] retain];
    }
    return self;
}

-(void) changeUISegmentFont:(UIView*) aView {
	NSString*className = [NSString stringWithFormat:@"%@", [aView class]];
	// NSLog(@"object type = %@", className); // [[aView class] className]);
	// NSString* typeName = [[aView class] className];
	if ([className compare:@"UISegmentLabel" options:NSLiteralSearch] == NSOrderedSame) {
		UILabel* label = (UILabel*)aView;
		[label setTextAlignment:UITextAlignmentCenter];
		[label setFont:[UIFont boldSystemFontOfSize:18]];
		[label sizeToFit];
	}
	NSArray* subs = [aView subviews];
	NSEnumerator* iter = [subs objectEnumerator];
	UIView* subView;
	while ((subView = [iter nextObject])) {
		[self changeUISegmentFont:subView];
	}
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	// Config *cnf = [[Config alloc] init];
	// kAppId = [cnf loadValue:@"facebook_app_id"];
	// kOAuthConsumerKey = [NSString stringWithFormat:@"%@", [cnf loadValue:@"twitter_consumer_key"]];
	// kOAuthConsumerSecret = [NSString stringWithFormat:@"%@", [cnf loadValue:@"twitter_consumer_secret"]];
	
	// NSLog(@"tt:  %@ %@", kOAuthConsumerKey, kOAuthConsumerSecret);
	
	facebook = [[Facebook alloc] init];
	
	[self.view setBackgroundColor:[Functions colorForHex:@"#444444"]];
	[self.view setAlpha:0.9];

	/*
	UIButton *closeButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[closeButton setFrame:CGRectMake(270,230,20,20)];
	UIImage * btnImage = [UIImage imageNamed:@"close.png"];
	[closeButton setImage:btnImage forState:UIControlStateNormal];	
	[closeButton addTarget:self action:@selector(hideShare:) forControlEvents:UIControlEventTouchUpInside];
	closeButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[self.view addSubview:closeButton];
	// [closeButton release];
	*/

	int topButton = 240;
/*
	if ([useTwitter isEqualToString:@"true"]) {
	UISegmentedControl *twitterButton = [[UISegmentedControl alloc] initWithItems:[NSArray arrayWithObject:@"Twitter"]];
	twitterButton.segmentedControlStyle = UISegmentedControlStyleBar;
	twitterButton.momentary = YES;
	twitterButton.backgroundColor=[UIColor clearColor];
// codeButton.tintColor = [Functions colorForHex:@"#777777"];
	twitterButton.tintColor = [Functions colorForHex:@"#cccccc"];
	// [UIColor blueColor]; //]darkGrayColor];
	twitterButton.center = CGPointMake(160,400);
	[twitterButton setFrame:CGRectMake(20,topButton,280,37)];
	[twitterButton addTarget:self action:@selector(twButtonClick:) forControlEvents:UIControlEventValueChanged];
	[self.view addSubview:twitterButton];
	[self changeUISegmentFont:twitterButton];
		topButton += 40;
	}

	if ([useFacebook isEqualToString:@"true"]) {
	UISegmentedControl *facebookButton = [[UISegmentedControl alloc] initWithItems:[NSArray arrayWithObject:@"Facebook"]];
	facebookButton.segmentedControlStyle = UISegmentedControlStyleBar;
	// facebookButton.segmentedControlStyle = UISegmentedControlStylePlain;
	facebookButton.momentary = YES;
	// codeButton.tintColor = [Functions colorForHex:@"#777777"];
	facebookButton.tintColor = [Functions colorForHex:@"#cccccc"];
	// [UIColor blueColor]; //]darkGrayColor];
	facebookButton.center = CGPointMake(160,400);
	[facebookButton setFrame:CGRectMake(20,topButton,280,37)];
	[facebookButton addTarget:self action:@selector(fbButtonClick:) forControlEvents:UIControlEventValueChanged];
	[self.view addSubview:facebookButton];
	[self changeUISegmentFont:facebookButton];
		topButton += 40;
	}

	if ([useMail isEqualToString:@"true"]) {
	UISegmentedControl *mailButton = [[UISegmentedControl alloc] initWithItems:[NSArray arrayWithObject:@"Send by E-mail"]];
	mailButton.segmentedControlStyle = UISegmentedControlStyleBar;
	mailButton.momentary = YES;
	// codeButton.tintColor = [Functions colorForHex:@"#777777"];
	mailButton.tintColor = [Functions colorForHex:@"#cccccc"];
	// [UIColor blueColor]; //]darkGrayColor];
	mailButton.center = CGPointMake(160,400);
	[mailButton setFrame:CGRectMake(20,topButton,280,37)];
	[mailButton addTarget:self action:@selector(sendMail:) forControlEvents:UIControlEventValueChanged];
	[self.view addSubview:mailButton];
	[self changeUISegmentFont:mailButton];
	}
	
	UISegmentedControl *cancelButton = [[UISegmentedControl alloc] initWithItems:[NSArray arrayWithObject:@"Cancel"]];
	cancelButton.segmentedControlStyle = UISegmentedControlStyleBar;
	cancelButton.momentary = YES;
	cancelButton.tintColor = [Functions colorForHex:@"#777777"];
	// [UIColor blueColor]; //]darkGrayColor];
	cancelButton.center = CGPointMake(160,400);
	[cancelButton setFrame:CGRectMake(20,390,280,37)];
	[cancelButton addTarget:self action:@selector(hideShare:) forControlEvents:UIControlEventValueChanged];
	[self.view addSubview:cancelButton];
	[self changeUISegmentFont:cancelButton];
*/	

	if ([useTwitter isEqualToString:@"true"]) {
		UIButton *twitterButton = [UIButton buttonWithType:UIButtonTypeCustom];
		[twitterButton setFrame:CGRectMake(20,topButton,280,44)];
		// twitterButton.center = CGPointMake(160,400);
		[twitterButton setTitle:@"Twitter" forState:UIControlStateNormal];
		// twitterButton.titleLabel.font = [UIFont fontWithName:@"Georgia" size:20];
		[twitterButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
		// [twitterButton setFont:[UIFont boldSystemFontOfSize:20]];
		[twitterButton addTarget:self action:@selector(twButtonClick:) forControlEvents:UIControlEventTouchUpInside];
		twitterButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin;
		twitterButton.backgroundColor = [UIColor clearColor]; // [Functions colorForHex:@"#cccccc"];
		[twitterButton setBackgroundImage:[[UIImage imageNamed:@"button-bg-gray.png"] stretchableImageWithLeftCapWidth:10.0 topCapHeight:0.0] forState:UIControlStateNormal];
		[self.view addSubview:twitterButton];
		// [twitterButton release];
		topButton += 46;
	}
	
	if ([useFacebook isEqualToString:@"true"]) {
		UIButton *facebookButton = [UIButton buttonWithType:UIButtonTypeCustom];
		[facebookButton setFrame:CGRectMake(20,topButton,280,44)];
		[facebookButton setTitle:@"Facebook" forState:UIControlStateNormal];
		[facebookButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
		[facebookButton addTarget:self action:@selector(fbButtonClick:) forControlEvents:UIControlEventTouchUpInside];
		facebookButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin;
		facebookButton.backgroundColor = [UIColor clearColor]; // [Functions colorForHex:@"#cccccc"];
		[facebookButton setBackgroundImage:[[UIImage imageNamed:@"button-bg-gray.png"] stretchableImageWithLeftCapWidth:10.0 topCapHeight:0.0] forState:UIControlStateNormal];
		[self.view addSubview:facebookButton];
		// [facebookButton release];
		topButton += 46;
	}
	
	if ([useMail isEqualToString:@"true"]) {
		UIButton *mailButton = [UIButton buttonWithType:UIButtonTypeCustom];
		[mailButton setFrame:CGRectMake(20,topButton,280,44)];
		[mailButton setTitle:@"Send by E-mail" forState:UIControlStateNormal];
		[mailButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
		[mailButton addTarget:self action:@selector(sendMail:) forControlEvents:UIControlEventTouchUpInside];
		mailButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin;
		mailButton.backgroundColor = [UIColor clearColor]; // [Functions colorForHex:@"#cccccc"];
		[mailButton setBackgroundImage:[[UIImage imageNamed:@"button-bg-gray.png"] stretchableImageWithLeftCapWidth:10.0 topCapHeight:0.0] forState:UIControlStateNormal];
		[self.view addSubview:mailButton];
		// [mailButton release];
	}
	
	UIButton *cancelButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[cancelButton setFrame:CGRectMake(20,390,280,44)];
	[cancelButton setTitle:@"Cancel" forState:UIControlStateNormal];
	[cancelButton addTarget:self action:@selector(hideShare:) forControlEvents:UIControlEventTouchUpInside];
	cancelButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin;
	cancelButton.backgroundColor = [UIColor clearColor]; // [Functions colorForHex:@"#cccccc"];
	[cancelButton setBackgroundImage:[[UIImage imageNamed:@"button-bg-blck.png"] stretchableImageWithLeftCapWidth:10.0 topCapHeight:0.0] forState:UIControlStateNormal];
	[self.view addSubview:cancelButton];
	
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[facebookTitle release];
	[facebookDescription release];
	[facebookLink release];
	[twitterTitle release];
	[twitterDescription release];
	[twitterLink release];
	[twitterView release];
	[facebook release];
	[permissions release];
    [super dealloc];
}
- (IBAction) hideShare:(id)sender {
	// app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	// [appDelegate hideShare];
	[self.view removeFromSuperview];
}

- (IBAction)sendMail:(id)sender {
	MFMailComposeViewController *picker = [[MFMailComposeViewController alloc] init];
	picker.mailComposeDelegate = self;
	
	// [picker setSubject:@"I have a pencil for you"];
	[picker setSubject:mailSubject];
	
	//UIImage *roboPic = [UIImage imageNamed:@"RobotWithPencil.jpg"];
	//NSData *imageData = UIImageJPEGRepresentation(roboPic, 1);
	//[picker addAttachmentData:imageData mimeType:@"image/jpg" fileName:@"RobotWithPencil.jpg"];
	
	// NSString *emailBody = @"This is a cool image of a robot I found.  Check it out!";
	// [picker setMessageBody:emailBody isHTML:YES];
	[picker setMessageBody:mailText isHTML:YES];
	
	[self presentModalViewController:picker animated:YES];
	[picker release];
}

-(void)mailComposeController:(MFMailComposeViewController*)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error {
	NSLog(@"end mail");
	[self dismissModalViewControllerAnimated:YES];
}

/**
 * Example of facebook login and permission request
 */
- (void) login {
	[facebook authorize:kAppId permissions:permissions delegate:self];
}

- (IBAction) fbButtonClick: (id) sender {

	Config *cnf = [[Config alloc] init];
	kAppId = [cnf loadValue:@"facebook_app_id"];
	[cnf release];

	facebook = [[Facebook alloc] init];
	[self changeUISegmentFont:sender];
	
	Facebook *_facebook = [[Facebook alloc] init];
	SBJSON *jsonWriter = [[SBJSON new] autorelease];
	
	NSDictionary* actionLinks = [NSArray arrayWithObjects:[NSDictionary dictionaryWithObjectsAndKeys: 
														   @"Always Running",@"text",@"http://itsti.me/",@"href", nil], nil];
	

	NSString *actionLinksStr = [jsonWriter stringWithObject:actionLinks];

	// NSString *media = [NSString stringWithFormat:@"[{\"type\": \"image\", \"src\": \"http://www.feedmeit.com/smallgreen.png\", \"href\": \"http://www.feedmeit.com/\"}]"];
	// NSLog(@"m: %@", media);
	NSDictionary* attachment = [NSDictionary dictionaryWithObjectsAndKeys:
								facebookTitle, @"name",
								@" ", @"caption",
								facebookDescription, @"description",
								facebookLink, @"href", 
		//						media, @"media",
								nil];
	NSString *attachmentStr = [jsonWriter stringWithObject:attachment];
	NSLog(@"att: %@", attachmentStr);
	NSMutableDictionary* params = [NSMutableDictionary dictionaryWithObjectsAndKeys:
								   kAppId, @"api_key",
								   @"Share on Facebook",  @"user_message_prompt",
								   actionLinksStr, @"action_links",
								   attachmentStr, @"attachment",
								   nil];
    [_facebook dialog:@"stream.publish"
			andParams:params
		  andDelegate:self];

	
/*
 var attachment = { "description":Your description here, 
	"name":Your title here ,
	"media":[{
		"caption":"test caption",
		"description":"test description",
		"name":"test name",
		"type":"image",
		"href":"http://www.google.com",
		"src":"http://www.google.com/logos/comic-con09.gif"}
			 ]}
	*/
	
	// [self login];
}

/**
 * Example of facebook logout
 */
- (void) logout {
	NSLog(@"logout");
	[facebook logout:self]; 
}

- (void) sendFacebook:(id) sender {
	
	NSLog(@"sending...");
	
	SBJSON *jsonWriter = [[SBJSON new] autorelease];
	
	NSDictionary* actionLinks = [NSArray arrayWithObjects:[NSDictionary dictionaryWithObjectsAndKeys: 
														   @"Always Running",@"text",@"http://itsti.me/",@"href", nil], nil];
	
	NSString *actionLinksStr = [jsonWriter stringWithObject:actionLinks];
	NSDictionary* attachment = [NSDictionary dictionaryWithObjectsAndKeys:
								textTitle, @"name",
								@" ", @"caption",
								textDescription, @"description",
								textUrl, @"href", nil];
	NSString *attachmentStr = [jsonWriter stringWithObject:attachment];
	NSMutableDictionary* params = [NSMutableDictionary dictionaryWithObjectsAndKeys:
								   kAppId, @"api_key",
								   @"Share on Facebook",  @"user_message_prompt",
								   actionLinksStr, @"action_links",
								   attachmentStr, @"attachment",
								   nil];
	
	[facebook dialog: @"stream.publish"
		   andParams: params
		 andDelegate:self];
}

/**
 * Callback for facebook login
 */ 
-(void) fbDidLogin {
	NSLog(@"logged");
	[self sendFacebook:nil];
	
	NSString *theURL = 
	[ [NSString stringWithFormat: 
	   @"https://graph.facebook.com/me?access_token=%@", facebook.accessToken
	   ]stringByAddingPercentEscapesUsingEncoding: NSUTF8StringEncoding
	 ];
	
	NSLog(@"%@", theURL);
	// [facebook requestWithGraphPath: theURL andDelegate: self];
	[facebook requestWithGraphPath: @"me" andDelegate: self];
	
}

/**
 * Callback for facebook did not login
 */
- (void)fbDidNotLogin:(BOOL)cancelled {
	NSLog(@"did not login");
}

/**
 * Callback for facebook logout
 */ 
-(void) fbDidLogout {
	NSLog(@"logout");
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// FBRequestDelegate

/**
 * Callback when a request receives Response
 */ 
- (void)request:(FBRequest*)request didReceiveResponse:(NSURLResponse*)response{
	NSLog(@"received response");
};

/**
 * Called when an error prevents the request from completing successfully.
 */
- (void)request:(FBRequest*)request didFailWithError:(NSError*)error{
	NSLog(@"err: %@", [error localizedDescription]);
};

/**
 * Called when a request returns and its response has been parsed into an object.
 * The resulting object may be a dictionary, an array, a string, or a number, depending
 * on thee format of the API response.
 */
- (void)request:(FBRequest*)request didLoad:(id)result {
	if ([result isKindOfClass:[NSArray class]]) {
		result = [result objectAtIndex:0]; 
	}
	// if ([result objectForKey:@"owner"]) {
	//	[self.label setText:@"Photo upload Success"];
	// } else {
	//	[self.label setText:[result objectForKey:@"name"]];
	// }
	NSLog(@"res: %@", [result objectForKey:@"name"]);
};

- (void)request:(FBRequest*)request didLoadRawResponse:(NSData*)data
{
	NSString *response = [[NSString alloc] initWithData: data encoding: NSUTF8StringEncoding];
	NSLog(@"%@", response);
	[response release];
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// FBDialogDelegate

/** 
 * Called when a UIServer Dialog successfully return
 */
- (void)dialogDidComplete:(FBDialog*)dialog{
	NSLog(@"publish successfully");
	UIAlertView *alert = [[UIAlertView alloc]
						  initWithTitle:@"Information sent."
						  message:nil
						  delegate:nil
						  cancelButtonTitle:nil
						  otherButtonTitles:@"OK", nil];
	[alert show];
    [alert release];

}

// twitter
-(IBAction) twButtonClick: (id) sender {

	Config *cnf = [[Config alloc] init];
	// kOAuthConsumerKey = [NSString stringWithFormat:@"%@", [cnf loadValue:@"twitter_consumer_key"]];
	// kOAuthConsumerSecret = [NSString stringWithFormat:@"%@", [cnf loadValue:@"twitter_consumer_secret"]];
	kOAuthConsumerKey = [cnf loadValue:@"twitter_consumer_key"];
	kOAuthConsumerSecret = [cnf loadValue:@"twitter_consumer_secret"];
	[cnf release];

	NSLog(@"t2:  %@ %@", kOAuthConsumerKey, kOAuthConsumerSecret);

	// if (_engine) return;
	_engine = [[SA_OAuthTwitterEngine alloc] initOAuthWithDelegate: self];
	_engine.consumerKey = kOAuthConsumerKey;
	_engine.consumerSecret = kOAuthConsumerSecret;
	
	UIViewController			*controller = [SA_OAuthTwitterController controllerToEnterCredentialsWithTwitterEngine: _engine delegate: self];
	
	if (controller) 
		[self presentModalViewController: controller animated: YES];
	else {
		// snd update
		[self createTwitterView];
	}
}

-(void) closeTwitter {
	if (twitterView != nil) {
		[twitterView removeFromSuperview];
		twitterView = nil;
	} 
}

-(IBAction) sendTwitter: (id) sender {
	NSString *message = [NSString stringWithFormat:@"%@", twitterMessageText.text];
	
	
	NSLog(@"send %@", message);
	[_engine sendUpdate: message];
}

-(void) createTwitterView {
	twitterView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 50, 320, 370)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
	twitterView.autoresizesSubviews = YES;
	twitterView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
	// [twitterView setBackgroundColor:[Functions colorForHex:@"#9AE4E8"]];
	
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	[button addTarget:self action:@selector(closeTwitter) forControlEvents:UIControlEventTouchUpInside];
	// UIImage * btnImage = [UIImage alloc];
	button.frame = CGRectMake(300, 5, 20, 20);
	UIImage * btnImage = [UIImage imageNamed:@"close.png"];
	button.backgroundColor = [UIColor clearColor];
	[button setImage:btnImage forState:UIControlStateNormal];
	[twitterView addSubview:button];
	
	twitterMessageText = [[UITextView alloc] initWithFrame:CGRectMake(10,30,300,80)];
	// twitterMessageText.delegate = self;
	twitterMessageText.text = [NSString stringWithFormat:@"%@ : %@ - %@", 
							   twitterDescription, twitterTitle, twitterLink];

	UIButton   * updateButton;
	updateButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[updateButton setFrame:CGRectMake(10,130,60,30)];
	[updateButton setTitle:@"Update" forState:UIControlStateNormal];
	updateButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[updateButton addTarget:self action:@selector(sendTwitter:) forControlEvents:UIControlEventTouchUpInside];
	
	[twitterView addSubview:twitterMessageText];
	[twitterView addSubview:updateButton];
	
	[self.view addSubview:twitterView];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range 
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        [textView resignFirstResponder];
		
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

//=============================================================================================================================
#pragma mark SA_OAuthTwitterEngineDelegate
- (void) storeCachedTwitterOAuthData: (NSString *) data forUsername: (NSString *) username {
	NSUserDefaults			*defaults = [NSUserDefaults standardUserDefaults];
	
	[defaults setObject: data forKey: @"authData"];
	[defaults synchronize];
}

- (NSString *) cachedTwitterOAuthDataForUsername: (NSString *) username {
	return [[NSUserDefaults standardUserDefaults] objectForKey: @"authData"];
}

//=============================================================================================================================
#pragma mark SA_OAuthTwitterControllerDelegate
- (void) OAuthTwitterController: (SA_OAuthTwitterController *) controller authenticatedWithUsername: (NSString *) username {
	NSLog(@"Authenicated for %@", username);
}

- (void) OAuthTwitterControllerFailed: (SA_OAuthTwitterController *) controller {
	NSLog(@"Authentication Failed!");
}

- (void) OAuthTwitterControllerCanceled: (SA_OAuthTwitterController *) controller {
	NSLog(@"Authentication Canceled.");
}

//=============================================================================================================================
#pragma mark TwitterEngineDelegate
- (void) requestSucceeded: (NSString *) requestIdentifier {
	NSLog(@"Request %@ succeeded", requestIdentifier);
	UIAlertView *alert = [[UIAlertView alloc]
						  initWithTitle:@"Information sent."
						  message:nil
						  delegate:nil
						  cancelButtonTitle:nil
						  otherButtonTitles:@"OK", nil];
	[alert show];
    [alert release];
	[self closeTwitter];
}

- (void) requestFailed: (NSString *) requestIdentifier withError: (NSError *) error {
	NSLog(@"Request %@ failed with error: %@", requestIdentifier, error);
	UIAlertView *alert = [[UIAlertView alloc]
						  initWithTitle:@"Error sending."
						  message:nil
						  delegate:nil
						  cancelButtonTitle:nil
						  otherButtonTitles:@"OK", nil];
	[alert show];
    [alert release];
}

 #pragma mark Singleton Methods
+ (id)sharedManager {
	@synchronized(self) {
		if(sharedMyManager == nil)
			sharedMyManager = [[super allocWithZone:NULL] init];
	}
	return sharedMyManager;
}
+ (id)allocWithZone:(NSZone *)zone {
	return [[self sharedManager] retain];
}
- (id)copyWithZone:(NSZone *)zone {
	return self;
}
- (id)retain {
	return self;
}
- (unsigned)retainCount {
	return UINT_MAX; //denotes an object that cannot be released
}

- (oneway void)release {
	// never release
}
- (id)autorelease {
	return self;
}
- (id)init {
	return self;
}

@end
