//
//  SurveyViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 6/7/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "MIRadioButtonGroup.h"
#import "SSTextView.h"

@interface SurveyViewController : UIViewController <UITextViewDelegate, UITextFieldDelegate> {
	UIActivityIndicatorView *waitView;
	UILabel *waitLabel;
	MIRadioButtonGroup *group;
	NSString *idResponse;
	NSString *idQuestion;
	NSString *idSurvey;
	NSString *idModule;
	NSString *auth;
	NSString *authUrl;
    NSDictionary * infoData;
	NSMutableData* XMLData;

	NSString * reqName;
	NSString * reqType;
	NSString * reqService;
	NSMutableArray * reqFields;

	BOOL textBox;
	CGFloat animatedDistance;

}

@property (nonatomic,retain) NSString *idResponse;
@property (nonatomic,retain) NSString *idQuestion;
@property (nonatomic,retain) NSString *idSurvey;
@property (nonatomic,retain) NSString *idModule;
@property (nonatomic,retain) NSString *auth;
@property (nonatomic,retain) NSString *authUrl;
@property (nonatomic,retain) NSMutableData* XMLData;

@property (nonatomic,retain) NSString * reqName;
@property (nonatomic,retain) NSString * reqType;
@property (nonatomic,retain) NSString * reqService;
@property (nonatomic,retain) NSMutableArray * reqFields;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
- (void) goDownload;
- (void) showXML:(int)isHome;
- (void) showHome;
- (void) callAuth:(NSString *)text withPassword: (NSString *)password;
- (void) loadAuth:(BOOL)showErr errMsg:(NSString *)txtErr;

@end
