//
//  TabBarViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 11/4/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "TabBarViewController.h"
#import "app_builderAppDelegate.h"
#import "Functions.h"
#import "ListViewController.h"
#import "GalleryViewController.h"
#import "PollViewController.h"
#import "PollResultsViewController.h"
#import "MenuViewController.h"
#import "WebViewController.h"
#import "MapViewController.h"
#import "ImageScrollerThumbs.h"
#import "SurveyViewController.h"
#import "TwitterViewController.h"
#import "SplitViewController.h"
#import "TwitterSplitViewController.h"
#import "SubmenuViewController.h"
#import "SendImageViewController.h"
#import "GraphViewController.h"

@implementation TabBarViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSFileManager* fileManager = [NSFileManager defaultManager];
	NSString *fileNameNoDir = [NSString stringWithFormat:@"tab"];
	NSString * fileName = [documentsDir stringByAppendingPathComponent:fileNameNoDir];
	[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];

	Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];

    
	//CGRect frame = CGRectMake(0, 0, 320, 460); // Replacing with your dimensions
    //self.view.frame = frame; // CGRectMake(0, 0, 320, 460);

    /*
http://www.raywenderlich.com/1111/how-to-port-an-iphone-application-to-the-ipad
     //}

//- (void)loadView {

	[self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
}

- (void) showView {
	
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	self.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;


	CGRect frame = CGRectMake(0, 0, 320, 460); // Replacing with your dimensions
    frame = CGRectMake(0, 0, CGRectGetWidth(mainViewBounds), CGRectGetHeight(mainViewBounds));
    frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    frame = CGRectMake(0, 0, 768, 1024);
    NSLog(@"-> %f %f %f %f <-", CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds), CGRectGetWidth(mainViewBounds), CGRectGetHeight(mainViewBounds));
    NSLog(@"-> %f %f %f %f <-", self.view.frame.size.width, self.view.frame.size.height, 
          self.view.frame.origin.x, self.view.frame.origin.y);
    
	/ *UIView *contentView = [[UIView alloc] initWithFrame:frame];
	contentView.backgroundColor = [UIColor whiteColor];
	self.view = contentView;
	contentView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	[contentView release];* /

	self.view.autoresizingMask = (UIViewAutoresizingFlexibleRightMargin 
                                              |  UIViewAutoresizingFlexibleHeight
                                              | UIViewAutoresizingFlexibleTopMargin 
                                  | UIViewAutoresizingFlexibleWidth
                                  | UIViewAutoresizingFlexibleBottomMargin
                                  | UIViewAutoresizingFlexibleRightMargin
                                  
                                  );

 
 UITabBarController *tabBarController = [[UITabBarController alloc] init];
 tabBarController.view.frame = frame; // CGRectMake(0, 0, 320, 460);
 // [tabBarController.view setFrame:CGRectMake(0, 0, CGRectGetWidth(mainViewBounds), CGRectGetHeight(mainViewBounds))];
 tabBarController.delegate = self;
 // [self initWaitView:tabBarController];
 / *	tabBarController.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
 tabBarController.view.autoresizingMask = (UIViewAutoresizingFlexibleRightMargin 
 |  UIViewAutoresizingFlexibleHeight
 | UIViewAutoresizingFlexibleTopMargin 
 | UIViewAutoresizingFlexibleWidth);
 tabBarController.view.autoresizingMask = (UIViewAutoresizingFlexibleRightMargin 
 |  UIViewAutoresizingFlexibleHeight
 | UIViewAutoresizingFlexibleTopMargin 
 | UIViewAutoresizingFlexibleWidth
 | UIViewAutoresizingFlexibleBottomMargin
 | UIViewAutoresizingFlexibleRightMargin
 
 );*/

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement = nil;
	TBXMLElement * appXMLElement;
	NSString *idFieldSet;
	UITabBarController *tabBarController = self; // [[UITabBarController alloc] init];
//	UITabBarController *tabBarController = [[UITabBarController alloc] init];
	tabBarController.delegate = self;
/*    tabBarController.view.autoresizingMask = (UIViewAutoresizingFlexibleRightMargin 
                                              |  UIViewAutoresizingFlexibleHeight
                                              | UIViewAutoresizingFlexibleTopMargin 
                                              | UIViewAutoresizingFlexibleWidth
                                              | UIViewAutoresizingFlexibleBottomMargin
                                              | UIViewAutoresizingFlexibleRightMargin
                                              );*/
	// tabBarController.customizableViewControllers = [NSArray arrayWithObjects:nil];
	tabBarController.customizableViewControllers = nil;
	// - (void)viewWillAppear:(BOOL)animated { self.customizableViewControllers = nil; }

	
	// UIViewController *moreViewController = tabBarController.moreNavigationController.topViewController;
	// moreViewController.view.delegate = self;
	// [moreViewController.view setDelegate:self];

	// UINavigationController * moreNav = tabBarController.moreNavigationController;
	// http://stackoverflow.com/questions/438381/customizing-the-more-menu-on-a-tab-bar
	// Customizing the More menu on a Tab bar

	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		// NSString* type;

		NSString * useMenuTabBar = [cnf loadValue:@"useMenuTabBar"];
		
		if ([useMenuTabBar isEqualToString:@"1"]) {
			TBXMLElement * menuXMLElement;
			do {
				// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
					NSString *typeItem = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					// NSLog(@"type: %@ ", typeItem);
					if ([typeItem isEqualToString:@"1"]) {
						f = TRUE;
						menuXMLElement = childXMLElement;
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));

			TBXMLElement *child = menuXMLElement->firstChild;
			f = FALSE;
			NSString * idTabBar;
			do {
				// NSLog(@":: %@ .. %@", [TBXML elementName:child], [TBXML valueOfAttributeNamed:@"id" forElement:child]);
				if ([[TBXML elementName:child] isEqualToString:@"field_set"]) {
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = child->firstChild;
						do {
							if ([[TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement] isEqualToString:@"tab_bar_menu"]) {
								idTabBar = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:idTabBar]) {
						f = TRUE;
						feedsXMLElement = child;
					}
				}
			} while ((child = child->nextSibling) && !f);

		} else {
			do {
				// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
					NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
					// NSString *
					// type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					// NSLog(@"idItem: %@ / %@ ", actualId, idItem);
					if ([actualId isEqualToString:idItem]) {
						f = TRUE;
						feedsXMLElement = childXMLElement;
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));

			if (f) {
				appXMLElement = feedsXMLElement->firstChild;
				do {
					if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
						if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
							// BOOL f = FALSE;
							// NSString * titleTab;
							childXMLElement = appXMLElement->firstChild;
							do {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"tab_bar"]) {
									// f = TRUE;
									idFieldSet = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"text_title"]) {
									// titleTab = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								// } while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
								
							} while ((childXMLElement = childXMLElement->nextSibling));
							
							// tab abr self
							/*
							 UIImage *image;
							 NSMutableDictionary *myData = [[ NSMutableDictionary alloc]
							 init];
							 image = [UIImage imageNamed:@"icons_tab_bar_menu.png"];
							 
							 if ([type isEqualToString:@"2"]) {
							 NSLog(@"list");
							 // ListViewController *listViewController = [[ListViewController alloc] 
							 // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
							 [myData setObject:actualId forKey:@"idTab"];
							 ListViewController *listViewController = [[ListViewController alloc] 
							 initWithData:myData
							 nibName:@"ListViewController" bundle:[NSBundle mainBundle]];
							 // listViewController.tag = attribId;
							 listViewController.title = titleTab;
							 listViewController.tabBarItem.image = image;
							 // listViewController.idTab = attribId;
							 [views addObject:listViewController];
							 [listViewController release];
							 }
							 if ([type isEqualToString:@"4"]) {
							 NSLog(@"img");
							 // ListViewController *listViewController = [[ListViewController alloc] 
							 // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
							 [myData setObject:actualId forKey:@"idTab"];
							 GalleryViewController *galleryViewController = [[GalleryViewController alloc] 
							 initWithData:myData
							 nibName:@"GalleryViewController" bundle:[NSBundle mainBundle]];
							 // listViewController.tag = attribId;
							 galleryViewController.title = titleTab;
							 galleryViewController.tabBarItem.image = image;
							 // galleryViewController.idTab = attribId;
							 [views addObject:galleryViewController];
							 [galleryViewController release];
							 }
							 if ([type isEqualToString:@"5"]) {
							 NSLog(@"web");
							 // ListViewController *listViewController = [[ListViewController alloc] 
							 // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
							 [myData setObject:actualId forKey:@"idTab"];
							 WebViewController *webViewController = [[WebViewController alloc] 
							 initWithData:myData
							 nibName:@"WebViewController" bundle:[NSBundle mainBundle]];
							 // listViewController.tag = attribId;
							 webViewController.title = titleTab;
							 webViewController.tabBarItem.image = image;
							 // listViewController.idTab = attribId;
							 [views addObject:webViewController];
							 [webViewController release];
							 }
							 if ([type isEqualToString:@"8"]) {
							 NSLog(@"poll");
							 PollViewController *pollViewController = [[PollViewController alloc] 
							 initWithNibName:@"PollViewController" bundle:[NSBundle mainBundle]];
							 pollViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
							 pollViewController.tabBarItem.image = image;
							 [views addObject:pollViewController];
							 [pollViewController release];
							 }
							 */
							// tab abr self
							
							
						}
						if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:idFieldSet]) {
							// childXMLElement = appXMLElement->firstChild;
							feedsXMLElement = appXMLElement;
						}
					}
				} while ((appXMLElement = appXMLElement->nextSibling));
			}

		}			

	}

	NSMutableArray * views = [[NSMutableArray alloc] init];
    if (feedsXMLElement)
    {
        childXMLElement = feedsXMLElement ->firstChild;
        do {
            NSString *attribId = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
            NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
            NSString *attribType = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
            
            if ([attribType isEqualToString:@"tab_bar_item"]
                ||
                [attribType isEqualToString:@"tab_bar_menu_item"]) {
                TBXMLElement * loopXMLElement = [Functions readConfigXmlFile];
                loopXMLElement = loopXMLElement->firstChild;
                
                BOOL f = FALSE;
                BOOL split = NO;
                do {
                    if ([[TBXML elementName:loopXMLElement] isEqualToString:@"module"]) {
                        NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:loopXMLElement];
                        if ([attribId isEqualToString:idItem]) {
                            f = TRUE;
                            attribType = [TBXML valueOfAttributeNamed:@"type" forElement:loopXMLElement];
                            if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
                            {
                                if ([attribType isEqualToString:@"2"])
                                {
                                    appXMLElement = loopXMLElement->firstChild;
                                    do {
                                        if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"])
                                        {
                                            if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
                                                TBXMLElement * dataXMLElement = appXMLElement->firstChild;;
                                                do {
                                                    if ([[TBXML elementName:dataXMLElement] isEqualToString:@"field"]) {
                                                        NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:dataXMLElement];
                                                        // NSLog(@"att : %@", attribItem);
                                                        if ([attribItem isEqualToString:@"split_list"])
                                                        {
                                                            if ([[TBXML valueOfAttributeNamed:@"value" forElement:dataXMLElement] isEqualToString:@"true"])
                                                            {
                                                                split = YES;
                                                                break;
                                                            }
                                                        }
                                                    }
                                                } while ((dataXMLElement = dataXMLElement->nextSibling) && !split);
                                                
                                            }
                                        }
                                    } while ((appXMLElement = appXMLElement->nextSibling) && !split);
                                }
                            }
                        }
                    }
                } while ((loopXMLElement = loopXMLElement->nextSibling) && (f == FALSE));
                
                NSString * fileMenu = [documentsDir stringByAppendingPathComponent:fileNameNoDir];
                fileMenu = [NSString stringWithFormat:@"%@/menu_%@.png", fileMenu, attribId];
                NSLog(@"tabbar fileMenu %@", fileMenu);

                UIImage *image;
                NSString * icon = [TBXML valueOfAttributeNamed:@"resource_url" forElement:childXMLElement];
                NSMutableDictionary *myData = [[ NSMutableDictionary alloc]
                                               init];
                if (icon != nil) {
                    BOOL fileExists = [[NSFileManager defaultManager] fileExistsAtPath:fileMenu];
                    NSData *imgData; // = [[NSData alloc] init];
                    if (fileExists) {
                        NSLog(@"exists");
                        imgData = [NSData dataWithContentsOfFile:fileMenu];
                        image = [UIImage imageWithData:imgData];
                    } else {
                        NSLog(@"download");
						image = [UIImage imageNamed:@"icons_tab_bar_menu.png"];
                        // NSURL *url = [NSURL URLWithString:icon];
                        // imgData = [[NSData alloc] initWithContentsOfURL:url];
                        // [imgData writeToFile:fileMenu atomically:YES];
                    }
                } else {
                    icon = @"";
                    image = [UIImage imageNamed:@"icons_tab_bar_menu.png"];
                }
                NSLog(@"icon: %@", icon);
                if ([attribType isEqualToString:@"2"] && !split)
                {
                    NSLog(@"list");
                    // ListViewController *listViewController = [[ListViewController alloc] 
                    // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    ListViewController *listViewController = [[ListViewController alloc] 
                                                              initWithData:myData
                                                              nibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    // listViewController.tag = attribId;
                    listViewController.title = attribItem;
                    listViewController.tabBarItem.image = image;
                    // listViewController.idTab = attribId;
                    [views addObject:listViewController];
                    [listViewController release];
                }
                if ([attribType isEqualToString:@"2"] && split)
                {
				// if ([attribType isEqualToString:@"21"]) {
				NSLog(@"splitIpad");
				[myData setObject:attribId forKey:@"idTab"];
				SplitViewController *splitViewController = [[SplitViewController alloc] 
															initWithData:myData
															nibName:@"SplitViewController" bundle:[NSBundle mainBundle]];
                    splitViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
                    splitViewController.tabBarItem.image = image;
                    [views addObject:splitViewController];
                    [splitViewController release];
                }
                if ([attribType isEqualToString:@"12"]) {
                    NSLog(@"multilist");
                    // ListViewController *listViewController = [[ListViewController alloc] 
                    // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    [myData setObject:@"1" forKey:@"multiList"];
                    [myData setObject:attribId forKey:@"idTab"];
                    ListViewController *listViewController = [[ListViewController alloc] 
                                                              initWithData:myData
                                                              nibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    // listViewController.tag = attribId;
                    listViewController.title = attribItem;
                    listViewController.tabBarItem.image = image;
                    // listViewController.idTab = attribId;
                    [views addObject:listViewController];
                    [listViewController release];
                }
                if ([attribType isEqualToString:@"3"]) {
                    NSLog(@"list");
                    // ListViewController *listViewController = [[ListViewController alloc] 
                    // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    MapViewController *mapViewController = [[MapViewController alloc] 
                                                            initWithData:myData
                                                            nibName:@"MapViewController" bundle:[NSBundle mainBundle]];
                    // listViewController.tag = attribId;
                    mapViewController.title = attribItem;
                    mapViewController.tabBarItem.image = image;
                    // listViewController.idTab = attribId;
                    [views addObject:mapViewController];
                    [mapViewController release];
                }
                
                if ([attribType isEqualToString:@"4"]) {
                    NSLog(@"img");
                    // ListViewController *listViewController = [[ListViewController alloc] 
                    // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    GalleryViewController *galleryViewController = [[GalleryViewController alloc] 
                                                                    initWithData:myData
                                                                    nibName:@"GalleryViewController" bundle:[NSBundle mainBundle]];
                    // listViewController.tag = attribId;
                    galleryViewController.title = attribItem;
                    galleryViewController.tabBarItem.image = image;
                    // galleryViewController.idTab = attribId;
                    [views addObject:galleryViewController];
                    [galleryViewController release];
                }
                
                
                if ([attribType isEqualToString:@"5"]) {
                    NSLog(@"web");
                    // ListViewController *listViewController = [[ListViewController alloc] 
                    // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    WebViewController *webViewController = [[WebViewController alloc] 
                                                            initWithData:myData
                                                            nibName:@"WebViewController" bundle:[NSBundle mainBundle]];
                    // listViewController.tag = attribId;
                    webViewController.title = attribItem;
                    webViewController.tabBarItem.image = image;
                    // listViewController.idTab = attribId;
                    [views addObject:webViewController];
                    [webViewController release];
                }
                if ([attribType isEqualToString:@"17"]) {
                    NSLog(@"eloqua - web");
                    // ListViewController *listViewController = [[ListViewController alloc] 
                    // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    WebViewController *webViewController = [[WebViewController alloc] 
                                                            initWithData:myData
                                                            nibName:@"WebViewController" bundle:[NSBundle mainBundle]];
                    // listViewController.tag = attribId;
                    webViewController.title = attribItem;
                    webViewController.tabBarItem.image = image;
                    // listViewController.idTab = attribId;
                    [views addObject:webViewController];
                    [webViewController release];
                }
                if ([attribType isEqualToString:@"8"]) {
                    NSLog(@"poll");
                    // PollViewController *pollViewController = [[PollViewController alloc] 
                    //										  initWithNibName:@"PollViewController" 
                    //												 bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    PollViewController *pollViewController = [[PollViewController alloc] 
                                                              initWithData:myData
                                                              nibName:@"PollViewController" bundle:[NSBundle mainBundle]];
                    pollViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
                    pollViewController.tabBarItem.image = image;
                    [views addObject:pollViewController];
                    [pollViewController release];
                }
                if ([attribType isEqualToString:@"14"]) {
                    NSLog(@"thumbs");
                    // ListViewController *listViewController = [[ListViewController alloc] 
                    // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    //				ThumbnailViewController *thumbnailViewController = [[ThumbnailViewController alloc] 
                    //																initWithData:myData
                    //																nibName:@"ThumbnailViewController" bundle:[NSBundle mainBundle]];
                    
                    ImageScrollerThumbs *thumbnailViewController = [[ImageScrollerThumbs alloc] 
                                                                    initWithData:myData
                                                                    nibName:@"ImageScrollerThumbs" bundle:[NSBundle mainBundle]];
                    
                    // listViewController.tag = attribId;
                    thumbnailViewController.title = attribItem;
                    thumbnailViewController.tabBarItem.image = image;
                    // thumbnailViewController.idTab = attribId;
                    [views addObject:thumbnailViewController];
                    [thumbnailViewController release];
                }
				if ([attribType isEqualToString:@"15"]) {
					NSLog(@"take pic");
					// SendImageViewController *sendImageViewController = [[SendImageViewController alloc] 
					//										  initWithNibName:@"SendImageViewController" bundle:[NSBundle mainBundle]];
					[myData setObject:attribId forKey:@"idTab"];
					SendImageViewController *sendImageViewController = [[SendImageViewController alloc] 
																		initWithData:myData
																		nibName:@"SendImageViewController" bundle:[NSBundle mainBundle]];
					//ImageScrollerThumbs *thumbnailViewController = [[ImageScrollerThumbs alloc] 
					//												initWithData:myData
					//												nibName:@"ImageScrollerThumbs" bundle:[NSBundle mainBundle]];
					// listViewController.tag = attribId;
					sendImageViewController.title = attribItem;
					sendImageViewController.tabBarItem.image = image;
					// sendImageViewController.idTab = attribId;
					[views addObject:sendImageViewController];
					[sendImageViewController release];
				}
                if ([attribType isEqualToString:@"18"]) {
                    NSLog(@"survey");
                    // ListViewController *listViewController = [[ListViewController alloc] 
                    // 										  initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    NSLog(@"qwe %@", myData);
                    SurveyViewController *surveyViewController = [[SurveyViewController alloc] 
                                                                  initWithData:myData
                                                                  nibName:@"SurveyViewController" bundle:[NSBundle mainBundle]];
                    
                    // listViewController.tag = attribId;
                    surveyViewController.title = attribItem;
                    surveyViewController.tabBarItem.image = image;
                    // thumbnailViewController.idTab = attribId;
                    [views addObject:surveyViewController];
                    [surveyViewController release];
                }
                if ([attribType isEqualToString:@"33"]) {
                    NSLog(@"survey");
                    // PollViewController *pollViewController = [[PollViewController alloc] 
                    //										  initWithNibName:@"PollViewController" 
                    //												 bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    NSLog(@"qwe %@", myData);
                    SurveyViewController * surveyViewController = [[SurveyViewController alloc] 
                                                                   initWithData:myData
                                                                   nibName:@"SurveyViewController" bundle:[NSBundle mainBundle]];
                    
                    NSLog(@"asd %@", myData);
                    surveyViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
                    surveyViewController.tabBarItem.image = image;
                    [views addObject:surveyViewController];
                    [surveyViewController release];
                }
                if ([attribType isEqualToString:@"24"]) {
                    NSLog(@"submenu");
                    // PollViewController *pollViewController = [[PollViewController alloc] 
                    //										  initWithNibName:@"PollViewController" 
                    //												 bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    NSLog(@"qwe %@", myData);
                    SubmenuViewController * submenuViewController = [[SubmenuViewController alloc] 
                                                                   initWithData:myData
                                                                   nibName:@"SubmenuViewController" bundle:[NSBundle mainBundle]];
                    
                    NSLog(@"asd %@", myData);
                    submenuViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
                    submenuViewController.tabBarItem.image = image;
                    [views addObject:submenuViewController];
                    [submenuViewController release];
                }
                if ([attribType isEqualToString:@"19"]
                    && (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad)
                    
                    ) {
                    NSLog(@"twitter");
                    // PollViewController *pollViewController = [[PollViewController alloc] 
                    //										  initWithNibName:@"PollViewController" 
                    //												 bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    TwitterViewController *twitterViewController = [[TwitterViewController alloc] 
                                                                    initWithData:myData
                                                                    nibName:@"TwitterViewController" bundle:[NSBundle mainBundle]];
                    twitterViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
                    twitterViewController.tabBarItem.image = image;
                    [views addObject:twitterViewController];
                    [twitterViewController release];
                }
                if ([attribType isEqualToString:@"19"]
                    && (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
                    
                    ) {
                    NSLog(@"twitter split");
                    // PollViewController *pollViewController = [[PollViewController alloc] 
                    //										  initWithNibName:@"PollViewController" 
                    //												 bundle:[NSBundle mainBundle]];
                    [myData setObject:attribId forKey:@"idTab"];
                    
                    TwitterSplitViewController *twitterViewController = [[TwitterSplitViewController alloc] 
                                                                         initWithData:myData
                                                                         nibName:@"TwitterSplitViewController" bundle:[NSBundle mainBundle]];
                    twitterViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
                    twitterViewController.tabBarItem.image = image;
                    [views addObject:twitterViewController];
                    [twitterViewController release];
                }
				if ([attribType isEqualToString:@"23"]) {
					NSLog(@"graph");
					// PollViewController *pollViewController = [[PollViewController alloc] 
					//										  initWithNibName:@"PollViewController" 
					//												 bundle:[NSBundle mainBundle]];
					[myData setObject:attribId forKey:@"idTab"];
					GraphViewController *graphViewController = [[GraphViewController alloc] 
																initWithData:myData
																nibName:@"GraphViewController" bundle:[NSBundle mainBundle]];
					graphViewController.title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
					graphViewController.tabBarItem.image = image;
					[views addObject:graphViewController];
					[graphViewController release];
				}
                // [myData release];
            }
        } while ((childXMLElement = childXMLElement->nextSibling));
	}
    
	/*
	PollViewController *pollViewController = [[PollViewController alloc] 
											  initWithNibName:@"PollViewController" bundle:[NSBundle mainBundle]];
	pollViewController.title = @"Poll";
	// pollViewController.tabBarItem.image = image;
	[views addObject:pollViewController];
	[pollViewController release];
	 */
	
	//[views release];
	//views = [[NSMutableArray alloc] init];
	MenuViewController *menuViewController = [[MenuViewController alloc]
											  initWithNibName:@"MenuViewController" bundle:[NSBundle mainBundle]];
	menuViewController.title = @"Menu";
	menuViewController.tabBarItem.image = [UIImage imageNamed:@"icons_tab_bar_menu.png"];
	[views addObject:menuViewController];
	[menuViewController release];
	
	NSLog(@"---->>>>> views: %@", views);
	[tabBarController setViewControllers:views];
	// [self setViewControllers:views];
    [views release];
	NSString * tabItem = [cnf loadValue:@"selectedTabBarItem"];
	NSLog(@"sel: %@", tabItem);
	// [Functions updateConfig:@"selectedTabBarItem" withValue:@"0"];
	if(!([tabItem isEqualToString:@"0"]) && !(tabItem == nil) && [tabItem intValue]) {
		// [tabBarController setSelectedIndex:2];
		tabBarController.selectedIndex = [tabItem intValue];
	}

    // tabBarController.moreNavigationController.navigationBar.barStyle = UIBarStyleBlackOpaque;
    tabBarController.moreNavigationController.delegate = self;
    // tabBarController.delegate = self;
	tabBarController.moreNavigationController.topViewController.view.backgroundColor = [UIColor clearColor];

	/*
	UIImageView *backView = [[UIImageView alloc] init];;
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [[NSData alloc] initWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	[backView setImage:[[UIImage alloc] initWithData:imgData]];
	backView.frame = CGRectMake(0, 0, 320, 420);
	[tabBarController.moreNavigationController.topViewController.view addSubview:backView];
	[backView release];
	*/
	/* pending ... tabbar icon value
	int indexICareAbout = 2;
	NSString *badgeValue = @"10";
	[[[[tabBarController viewControllers] objectAtIndex: indexICareAbout] tabBarItem] setBadgeValue:badgeValue];
	*/

	// [self.view addSubview:[tabBarController view]];  
	
	[cnf release];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
    
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

- (void)tabBarController:(UITabBarController *)tabBarController
 didSelectViewController:(UIViewController *)viewController
{

	Config *cnf = [[Config alloc] init];
	
	if( viewController.navigationController == tabBarController.moreNavigationController ){
		NSLog(@"pop to more list");
		[tabBarController.moreNavigationController popToRootViewControllerAnimated:NO];
	}

	// NSLog(@"-didSelectViewController:%@", viewController);
	NSLog(@"selected: %d", tabBarController.selectedIndex);
	[cnf updateValue:@"selectedTabBarItem" value:[NSString stringWithFormat: @"%d", tabBarController.selectedIndex]];
	if ([viewController isKindOfClass:[MenuViewController class]]) {
		NSLog(@"menu...");
		[cnf updateValue:@"displayView" value:@"1"];
		[Functions goMenu:nil];
	}
    tabBarController.moreNavigationController.navigationBar.topItem.rightBarButtonItem = nil;   
	
	[cnf release];
}

-(BOOL) tabBarController:(UITabBarController *)tabBarController shouldSelectViewController:(UIViewController *)viewController{

	NSLog(@"did app...");
	Config *cnf = [[Config alloc] init];
	NSString * tmpValue = [cnf loadValue:@"detailTitle"];
	if ([tmpValue isEqualToString:@""] || 
		tmpValue == nil)
		[cnf insertValue:@"detailTitle" value:@"---"];
	else
		[cnf updateValue:@"detailTitle" value:@"---"];
	
	NSLog(@"should select: %d", tabBarController.selectedIndex);
    UIViewController *selected = [tabBarController selectedViewController];
	NSLog(@"v: %@", selected);
	NSLog(@"vc: %@", viewController);
    if ([viewController isEqual:[tabBarController moreNavigationController]]) {
		NSLog(@"more sel...");
		[cnf updateValue:@"displayView" value:@"1"];
        [cnf release];

		app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
		[appDelegate displayView:@"1"];
		
		
		return NO;
	}
	
	[cnf release];

	// NSLog(@"selected: %d", tabBarController.selectedIndex);
	// [Functions updateConfig:@"selectedTabBarItem" withValue:[NSString stringWithFormat: @"%d", tabBarController.selectedIndex]];
	// NSLog(@"lkjsdhfahsdfljhasdlkjfhajksdhfkjlahsdjkfhajlsdhfkjahsdlfhas");
	UIViewController *currentVC = [tabBarController selectedViewController];
	if (currentVC == viewController) {
		NSLog(@"same???");
		return NO;
	}
	if ([currentVC isKindOfClass:[WebViewController class]]) { // && currentVC != viewController) {
		NSLog(@"web...");
		// [(WebViewController *)currentVC cancelAd];
	}
	return YES;	
	if (tabBarController.selectedIndex == 1 && [tabBarController.viewControllers objectAtIndex:tabBarController.selectedIndex] == viewController){
        // If we're on the second item, and the user is trying to click it.
		return NO;
	}
}
- (void)navigationController:(UINavigationController *)navigationController
	  willShowViewController:(UIViewController *)viewController
					animated:(BOOL)animated {
	/*NSLog(@"more...");
    UINavigationBar *morenavbar = navigationController.navigationBar;
    UINavigationItem *morenavitem = morenavbar.topItem;
    / * We don't need Edit button in More screen. * /
    morenavitem.rightBarButtonItem = nil;*/
	
	if ([viewController isKindOfClass:[MenuViewController class]]) {
		Config *cnf = [[Config alloc] init];
		
		NSLog(@"menu...");
		[cnf updateValue:@"displayView" value:@"1"];
		[Functions goMenu:nil];
		
		[cnf release];
		
		return;
		
	}

	if ([viewController isEqual:[navigationController.viewControllers objectAtIndex:0]]) {
        // tab bar icon touched while some view controller from "more" is active
        // [[self moreNavigationController] setNavigationBarHidden:NO animated:NO];
        [navigationController setNavigationBarHidden:NO animated:NO];
		
        NSLog(@"Unhiding navigation bar");
    } else {
        // [[self moreNavigationController] setNavigationBarHidden:YES animated:NO];
        [navigationController setNavigationBarHidden:YES animated:NO];
        NSLog(@"Hiding navigation bar");
    }
}


- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation   
										 duration:(NSTimeInterval)duration {  
	

	NSLog(@"rotate rotate rotate rotate rotate rotate rotate rotate rotate rotate rotate ");
	UIInterfaceOrientation nowOrientation = self.interfaceOrientation;  
	
	if (nowOrientation == UIInterfaceOrientationPortrait || nowOrientation == UIInterfaceOrientationPortraitUpsideDown) {  
		//moving towards portrait orientation  
	}  
	else {  
		//moving to landscape orientation  
	}  
    UIViewController *selected = [self selectedViewController];
	[selected willAnimateRotationToInterfaceOrientation:interfaceOrientation   
											   duration:duration];
}  

@end
