//
//  ThumbnailViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 2/1/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "imageInfo.h"
#import "ImageViewController.h"
#import "ShareViewController.h"

@interface ThumbnailViewController : UIViewController {
	NSDictionary * infoData;
	int						pageIndex;
	int						maxPages;
	NSMutableArray		*	imagesArray;
	NSMutableArray		*	titlesArray;
	NSMutableArray * dataArray;
	int currentFeedPage;
	int maxSlideNumber;
	ImageViewController * imgCont;
	BOOL showImage;
	UIToolbar *toolbar;
	BOOL hiddenTabBar;
	// UITabBarController *tabBarController;
	ShareViewController *shareView;
	NSString *textTitle;
	NSString *textUrl;
}

@property (nonatomic,retain) NSMutableArray *imagesArray;
@property (nonatomic,retain) NSMutableArray *titlesArray;

@property (nonatomic, retain) NSString *textTitle;
@property (nonatomic, retain) NSString *textUrl;

// - (void)				initStatusBar:(UIView *)actualView;
- (void)				goRefresh;
- (void)				goDetail;
- (void)				processInfo;
- (imageInfo*)			getCurrentImage;
- (void)				addImageFromName:(NSString*)imagename withFolder:(NSString *)foldername;
- (void) initStatusBar:(UIView *)actualView withType:(int)type;

- (void) goBack;
-(IBAction)goShare:(id) sender;
-(IBAction)goSubmit:(id) sender;
- (void) hidetabbar;

@end
