//
//  TwitterDetailViewController.h
//  app_builder
//
//  Created by ivan bejarano on 7/28/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ShareViewController.h"
#import "ListSelectionDelegate.h"
#import "TwitterViewController.h"

@interface TwitterDetailViewController : UIViewController <UIWebViewDelegate, UISplitViewControllerDelegate, ListSelectionDelegate>
{
    NSDictionary * infoData;
	ShareViewController *shareView;
	UIViewController * parentView;
    id _popover;
    BOOL created;
	TwitterViewController * twitterViewController;
}

@property (nonatomic, retain) id popover;
@property (nonatomic, retain) TwitterViewController *twitterViewController;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
- (void) initStatusBar:(UIView *)actualView withType:(int)type;
- (IBAction)goShare:(id) sender;
- (void)hideShare;
- (void)setParent: (UIViewController *)viewController;
- (void) showView;

@end
