//
//  VideoViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 11/10/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MediaPlayer/MediaPlayer.h>

@interface VideoViewController : UIViewController <UIScrollViewDelegate, UIWebViewDelegate>{
	MPMoviePlayerController  *moviePlayer;
	NSURL  *movieURL;
	UILabel *waitLabel;
	UIViewController *shareView;
	UIActivityIndicatorView *waitView;
}

@property (nonatomic, retain) UILabel *waitLabel;

- (void)goMenu:(id)sender;
- (void) initStatusBar:(UIView *)actualView;
// -(IBAction) goShare:(id) sender;
// -(void)hideShare;
- (void)deviceInterfaceOrientationChanged:(UIInterfaceOrientation)interfaceOrientation;
- (void) moviePlayerLoadStateChanged:(NSNotification*)notification;
- (void) showAnimated:(id)sender;
-(void) initWaitView;

@end
