//
//  WebViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 11/10/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <UIKit/UIWebView.h>
#import "ShareViewController.h"

@interface WebViewController : UIViewController <UIAccelerometerDelegate, UIWebViewDelegate> {
	IBOutlet UIWebView *webView;
	NSURL * openLink;
    NSDictionary * infoData;
	ShareViewController *shareView;
	NSString *textTitle;
	NSString *textUrl;
}

@property (nonatomic, retain) NSURL * openLink;
@property (nonatomic, retain) NSString *textTitle;
@property (nonatomic, retain) NSString *textUrl;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
- (void) initStatusBar:(UIView *)actualView;
- (IBAction)goShare:(id) sender;
- (void)hideShare;
- (void) initStatusBar:(UIView *)actualView useShare:(BOOL) share;

@end
