//
//  Project.h
//  app_builder
//
//  Created by IVAN BEJARANO on 12/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@interface Project : NSObject {
	
	NSInteger bookID;
	NSString *title;	//Same name as the Entity Name.
	NSString *city;	//Same name as the Entity Name.
	NSString *state;	//Same name as the Entity Name.	
	NSString *report_num;
	NSString *report_type;
	NSString *publish_date;
	NSString *bid_date;
	NSString *publisher;
	NSString *report_url;
	NSString *county;
	NSString *currency_type;
	NSString *low_est;
	NSString *high_est;
	NSString *project_type;
	NSString *work_type;
	NSString *desc;
	NSString *plan_available;
	NSString *stage;
	NSString *ownership;
	NSString *latitude;
	NSString *longitude;
	
}

@property (nonatomic, readwrite) NSInteger bookID;
@property (nonatomic, retain) NSString *title;
@property (nonatomic, retain) NSString *city;
@property (nonatomic, retain) NSString *state;
@property (nonatomic, retain) NSString *report_num;
@property (nonatomic, retain) NSString *report_type;
@property (nonatomic, retain) NSString *publish_date;
@property (nonatomic, retain) NSString *bid_date;
@property (nonatomic, retain) NSString *publisher;
@property (nonatomic, retain) NSString *report_url;
@property (nonatomic, retain) NSString *county;
@property (nonatomic, retain) NSString *currency_type;
@property (nonatomic, retain) NSString *low_est;
@property (nonatomic, retain) NSString *high_est;
@property (nonatomic, retain) NSString *project_type;
@property (nonatomic, retain) NSString *work_type;
@property (nonatomic, retain) NSString *desc;
@property (nonatomic, retain) NSString *plan_available;
@property (nonatomic, retain) NSString *stage;
@property (nonatomic, retain) NSString *ownership;
@property (nonatomic, retain) NSString *latitude;
@property (nonatomic, retain) NSString *longitude;

@end
