
#import <UIKit/UIKit.h>

@interface URLConnection : NSObject {
@private NSMutableData *xmlData;
@private id m_Delegate;
@private NSURLConnection *xmlConnection;
@public NSString* xmlUrl;
@public NSMutableData* xmlDownload;
	bool workInProgress;
}


@property (nonatomic, retain) NSString* xmlUrl;
@property (nonatomic, retain) NSMutableData* xmlDownload;
@property (nonatomic, assign) bool workInProgress;

-(void)setDelegate:(id)new_delegate;
-(id)initWithUrl:(NSString*)urlData;
-(void)downloadData:(id)delegate;
-(void)abortDownload;

@end


@interface NSObject (InternetURLDelegate)
- (void)internetUrlReady:(URLConnection*)urlConnection;
- (void)internetUrlError:(URLConnection*)urlConnection;
@end
