//
//  VerticallyAlignedLabel.h
//
// http://discussions.apple.com/message.jspa?messageID=10270072#10270072
 
#import <Foundation/Foundation.h>
 
 
typedef enum VerticalAlignment {
    VerticalAlignmentTop,
    VerticalAlignmentMiddle,
    VerticalAlignmentBottom,
} VerticalAlignment;
 
@interface VerticallyAlignedLabel : UILabel {
@private
    VerticalAlignment verticalAlignment_;
}
 
@property (nonatomic, assign) VerticalAlignment verticalAlignment;
 
@end
