//
//  WebServiceHelper.h
//  app_builder
//
//  Created by IVAN BEJARANO on 9/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface WebServiceHelper : NSObject {
	NSMutableData *webData;
	NSMutableURLRequest	*request;
	NSURLConnection	*theConnection;
	id	delegate;
	SEL	callback;
	SEL	errorCallback;
	NSString	*requestBody;
}

@property(nonatomic, retain) NSMutableData *webData;
@property(nonatomic, retain) id	delegate;
@property(nonatomic) SEL	callback;
@property(nonatomic) SEL	errorCallback;

// +(void) callWebService:(NSString *)url: (NSArray *)keys: (NSArray *) values;
// +(NSString *)callWebService:(NSString *)url: (NSString *) methodName: (NSArray *)keys: (NSArray *) values;

// -(void)request:(NSURL *) url: (NSString *) methodName: (NSArray *)keys: (NSArray *) values;
// -(void)callWebService:(NSString *)url methodName:(NSString *)methodName keys:(NSArray *)keys values:(NSArray *)values delegate:(id)requestDelegate requestSelector:(SEL)requestSelector;
// -(void)callWebService:(NSString *)url delegate:(id)requestDelegate requestSelector:(SEL)requestSelector;
-(void)callWebService:(NSString *)url methodName:(NSString *)methodName keys:(NSArray *)keys values:(NSArray *)values delegate:(id)requestDelegate requestSelector:(SEL)requestSelector;
-(void)request:(NSURL *) url: (NSString *) xmlRequest: (NSString *) methodName;

@end
