//
//  SilLoginPrompt.h
//  Alert login window
//
//  Created by Byron Herrera on 4/20/11.
//  Copyright 2011 Silencesoft. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface SilLoginPrompt : UIAlertView
{
	UITextField * textUser;
	UITextField * textPassword;
}

@property (nonatomic, retain) UITextField * textUser;
@property (nonatomic, retain) UITextField * textPassword;
@property (readonly) NSString * userName;
@property (readonly) NSString * userPassword;

- (id) initWithTitle:(NSString *)title message:(NSString *)message delegate:(id)delegate cancelButtonTitle:(NSString *)cancelButtonTitle okButtonTitle:(NSString *)okButtonTitle fieldNumber:(int)fields;
- (void) setUserText: (NSString *)userText;
-(void) setUserPlaceholder: (NSString *)placeholder;
-(void) setPassPlaceholder: (NSString *)placeholder;

@end
