//
//  SilSplitViewController.h
//  Custom Split View
//
//  Created by Byron Herrera on 11/23/11.
//  Copyright 2011 Silencesoft. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface SilSplitViewController : UIViewController

{
	UIViewController *leftController;
	UIViewController *rightController;
}

@property (nonatomic, retain) UIViewController *leftController;
@property (nonatomic, retain) UIViewController *rightController;

- (void)layoutViews:(UIInterfaceOrientation)orientation initialVerticalOffset:(float)offset;

- (SilSplitViewController *) initwithLeftVC:(UIViewController*)leftvc rightVC:(UIViewController*)rightvc;

@end
