//
//  SplitViewController.m
//  app_builder
//
//  Created by ivan bejarano on 11/28/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import "SplitViewController.h"
#import "ListViewController.h"
#import "DetailViewController.h"
// #import "IntelligentSplitViewController.h"
#import "SilSplitViewController.h"

@implementation SplitViewController

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;

    	ListViewController *root = [[[ListViewController alloc] 
									 initWithData:infoData
									 nibName:@"ListViewController" bundle:[NSBundle mainBundle]] autorelease];
		// root.view.tag = 17001;
		ListViewController *pop = [[[ListViewController alloc] 
									initWithData:infoData
									nibName:@"ListViewController" bundle:[NSBundle mainBundle]] autorelease];
		DetailViewController *detail = [[[DetailViewController alloc] init] autorelease]; 
		// detail.view.tag = 17002;
		
		
		SilSplitViewController * splitViewController = self; // [[SilSplitViewController alloc] initwithLeftVC:root rightVC:detail];
		splitViewController.leftController = root;
		splitViewController.rightController = detail;
		root.delegate = detail;
		pop.delegate = detail;
		detail.listViewController = pop;
		detail.parentView = splitViewController;
		root.parentView = splitViewController;
		
	}
    return self;
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
    SilSplitViewController * splitViewController = self; // [[SilSplitViewController alloc] initwithLeftVC:root rightVC:detail];
    [splitViewController viewWillAppear:YES];
    
	//self.viewControllers = [NSArray arrayWithObjects:root, detail, nil];
	//self.delegate = detail;
	/*ListViewController *root = (ListViewController *)splitViewController.leftController;
    //[root viewWillAppear:YES];
    //[root viewDidAppear:YES];
	
	DetailViewController *detail = (DetailViewController *)splitViewController.rightController;
    [detail viewWillAppear:YES];
    [detail viewDidAppear:YES];*/
	
    [splitViewController viewDidAppear:YES];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
