//
//  AddressViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 12/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "AddressViewController.h"
#import "Functions.h"
#import "Config.h"

@implementation AddressViewController

@synthesize addressField, cityField, stateField, zipField;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	// address, city, state, zip
	[self addressField];
	[self cityField];
	[self stateField];
	[self zipField];
	[self.view addSubview:addressField];
	[self.view addSubview:cityField];
	[self.view addSubview:stateField];
	[self.view addSubview:zipField];

	UILabel * addressLbl = [[UILabel alloc] initWithFrame:CGRectMake(20,40,280,32)];
	addressLbl.backgroundColor = [UIColor clearColor];
	[self.view addSubview:addressLbl];
	addressLbl.text = @"Address";
	[addressLbl release];

	UILabel * cityLbl = [[UILabel alloc] initWithFrame:CGRectMake(20,110,280,32)];
	cityLbl.backgroundColor = [UIColor clearColor];
	[self.view addSubview:cityLbl];
	cityLbl.text = @"City";
	[cityLbl release];

	UILabel * stateLbl = [[UILabel alloc] initWithFrame:CGRectMake(20,180,280,32)];
	stateLbl.backgroundColor = [UIColor clearColor];
	[self.view addSubview:stateLbl];
	stateLbl.text = @"State";
	[stateLbl release];

	UILabel * zipLbl = [[UILabel alloc] initWithFrame:CGRectMake(20,250,280,32)];
	zipLbl.backgroundColor = [UIColor clearColor];
	[self.view addSubview:zipLbl];
	zipLbl.text = @"Zip";
	[zipLbl release];

	/*
	Config * cnf;
	cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * actualId = cnf.value;
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [cnf loadValue:@"displayId"];
	}

	NSString * address = [cnf loadValue:[NSString stringWithFormat:@"Address_%@", actualId]];
	NSString * zip = [cnf loadValue:[NSString stringWithFormat:@"Zip_%@", actualId]];
	NSString * state = [cnf loadValue:[NSString stringWithFormat:@"State_%@", actualId]];
	NSString * city = [cnf loadValue:[NSString stringWithFormat:@"City_%@", actualId]];

	addressField.text = address;
	cityField.text = city;
	stateField.text = state;
	zipField.text = zip;
	*/
	[self initStatusBar:self.view];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

- (BOOL) textFieldShouldReturn:(UITextField *)textField {
	[textField resignFirstResponder];
	return YES;
}

- (UITextField *) addressField {
	if(addressField == nil) {
		CGRect frame = CGRectMake(20,70,280,30);
		addressField = [[UITextField alloc] initWithFrame:frame];
		
		addressField.borderStyle = UITextBorderStyleRoundedRect;
		addressField.textColor = [UIColor blackColor];
		addressField.font = [UIFont systemFontOfSize:17.0];
		addressField.placeholder = @"Address";
		// addressField.autocorrectionType = UITextAutoCorrectionTypeNo;
		
		addressField.keyboardType = UIKeyboardTypeDefault;
		addressField.returnKeyType = UIReturnKeyDone;
		
		addressField.clearButtonMode = UITextFieldViewModeWhileEditing;
		
		addressField.delegate = self;
	}
	return addressField;
}

- (UITextField *) cityField {
	if(cityField == nil) {
		CGRect frame = CGRectMake(20,140,280,30);
		cityField = [[UITextField alloc] initWithFrame:frame];
		
		cityField.borderStyle = UITextBorderStyleRoundedRect;
		cityField.textColor = [UIColor blackColor];
		cityField.font = [UIFont systemFontOfSize:17.0];
		cityField.placeholder = @"City";
		// cityField.autocorrectionType = UITextAutoCorrectionTypeNo;
		
		cityField.keyboardType = UIKeyboardTypeDefault;
		cityField.returnKeyType = UIReturnKeyDone;
		
		cityField.clearButtonMode = UITextFieldViewModeWhileEditing;
		
		cityField.delegate = self;
	}
	return cityField;
}

- (UITextField *) stateField {
	if(stateField == nil) {
		CGRect frame = CGRectMake(20,210,280,30);
		stateField = [[UITextField alloc] initWithFrame:frame];
		
		stateField.borderStyle = UITextBorderStyleRoundedRect;
		stateField.textColor = [UIColor blackColor];
		stateField.font = [UIFont systemFontOfSize:17.0];
		stateField.placeholder = @"State";
		// stateField.autocorrectionType = UITextAutoCorrectionTypeNo;
		
		stateField.keyboardType = UIKeyboardTypeDefault;
		stateField.returnKeyType = UIReturnKeyDone;
		
		stateField.clearButtonMode = UITextFieldViewModeWhileEditing;
		
		stateField.delegate = self;
	}
	return stateField;
}

- (UITextField *) zipField {
	if(zipField == nil) {
		CGRect frame = CGRectMake(20,280,280,30);
		zipField = [[UITextField alloc] initWithFrame:frame];
		
		zipField.borderStyle = UITextBorderStyleRoundedRect;
		zipField.textColor = [UIColor blackColor];
		zipField.font = [UIFont systemFontOfSize:17.0];
		zipField.placeholder = @"Zip";
		// zipField.autocorrectionType = UITextAutoCorrectionTypeNo;
		
		zipField.keyboardType = UIKeyboardTypeDefault;
		zipField.returnKeyType = UIReturnKeyDone;
		
		zipField.clearButtonMode = UITextFieldViewModeWhileEditing;
		
		zipField.delegate = self;
	}
	return zipField;
}

- (void) initStatusBar:(UIView *)actualView {
	// NSString *title =@"Video";
	UIToolbar *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 420, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	toolbar.alpha = 0.7;
	[actualView addSubview:toolbar];

	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[backButton setFrame:CGRectMake(260,7,50,26)];
	[backButton setTitle:@"Back" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(goBack:) forControlEvents:UIControlEventTouchUpInside];
	backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[toolbar addSubview:backButton];
	// [backButton release];
	[toolbar release];
	
}

- (IBAction)goBack:(id) sender{

	Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [cnf loadValue:@"displayId"];
	}

	[cnf updateValue:[NSString stringWithFormat:@"Address_%@", actualId] value:addressField.text];
	[cnf updateValue:[NSString stringWithFormat:@"Zip_%@", actualId] value:zipField.text];
	[cnf updateValue:[NSString stringWithFormat:@"State_%@", actualId] value:stateField.text];
	[cnf updateValue:[NSString stringWithFormat:@"City_%@", actualId] value:cityField.text];
	

	NSString *url = @"http://widgets.isg-marketing.com/mcgrawhill/construction/network/geocode_address.aspx";
	NSString *address = addressField.text;
	address = [address stringByReplacingOccurrencesOfString:@" " withString:@"+"];
	NSString *zip = zipField.text;
	zip = [zip stringByReplacingOccurrencesOfString:@" " withString:@"+"];
	NSString *state = stateField.text;
	state = [state stringByReplacingOccurrencesOfString:@" " withString:@"+"];
	NSString *city = cityField.text;
	city = [city stringByReplacingOccurrencesOfString:@" " withString:@"+"];
	NSString *radius = @"16";
	url = [NSString stringWithFormat:@"%@?rad=%@&l_add=%@&l_city=%@&l_state=%@&l_zip=%@",url,radius,address,city,state,zip];
	NSLog(@"url: %@", url);

	NSURL *u = [NSURL URLWithString:url];
	NSData *myXMLData = [NSData dataWithContentsOfURL:u];
	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
    [tbxml release];
	NSString * longitude = @""; // [[NSString alloc] init];
	NSString * latitude = @""; // [[NSString alloc] init];
	if (rootXMLElement) {
		TBXMLElement * childXMLElement = rootXMLElement->firstChild;
		do {
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"position"]) {
				TBXMLElement * dataXMLElement = childXMLElement->firstChild;
				do {
					if ([[TBXML elementName:dataXMLElement] isEqualToString:@"latitude"]) {
						latitude = [TBXML textForElement:dataXMLElement];
					}
					if ([[TBXML elementName:dataXMLElement] isEqualToString:@"longitude"]) {
						longitude = [TBXML textForElement:dataXMLElement];
					}
				} while ((dataXMLElement = dataXMLElement->nextSibling));
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
	}
	
	NSLog(@"lt: %@ ln: %@", latitude, longitude);
	if ([latitude isEqualToString:@"0"] &&
		[longitude isEqualToString:@"0"])
		[cnf updateValue:[NSString stringWithFormat:@"useGps_%@", actualId] value:@"1"];
	else
		[cnf updateValue:[NSString stringWithFormat:@"useGps_%@", actualId] value:@"0"];

		
	[cnf updateValue:[NSString stringWithFormat:@"latitude_%@", actualId] 
				  value:latitude];
	[cnf updateValue:[NSString stringWithFormat:@"longitude_%@", actualId]
				  value:longitude];


	[cnf release];
	
	[Functions goMenu:nil];
}

@end
