//
//  DetailViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 11/5/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ShareViewController.h"
#import "ListSelectionDelegate.h"
#import "ListViewController.h"

@interface DetailViewController : UIViewController <UIWebViewDelegate, UISplitViewControllerDelegate, ListSelectionDelegate>
{
	ShareViewController *shareView;
	NSString *textTitle;
	NSString *textUrl;
	NSString *linkRef;
	NSString *linkType;
    BOOL created;
    id _popover;
	ListViewController * listViewController;
	UIViewController * parentView;
}

@property (nonatomic, retain) NSString *textTitle;
@property (nonatomic, retain) NSString *textUrl;
@property (nonatomic, retain) NSString *linkRef;
@property (nonatomic, retain) NSString *linkType;
@property (nonatomic, retain) id popover;
@property (nonatomic, retain) ListViewController * listViewController;
@property (nonatomic,retain) UIViewController *parentView;

- (void) initStatusBar:(UIView *)actualView useShare:(BOOL) share;
-(IBAction)goShare:(id) sender;
-(void)hideShare;
- (void) showView;


@end
