//
//  DetailViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 11/5/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "DetailViewController.h"
#import "Functions.h"
#import "TBXML.h"
#import "Config.h"
#import "NSString+HTML.h"
#import "ShareViewController.h"
#import "app_builderAppDelegate.h"
#import "SplitViewController.h"

@implementation DetailViewController

@synthesize textUrl, textTitle, linkRef, linkType;
@synthesize popover = _popover;
@synthesize listViewController;
@synthesize parentView;

/*// Implement standard init when creating a view hierachy programatically, without using a nib.
- (id)init 
{
    if ( self = [super init] ) 
    {
        self.view = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 460)];
        self.view.backgroundColor = [UIColor grayColor];
        
        // self.toolbar = [[UIToolbar alloc] initWithFrame:CGRectMake(0, 0, 768, 44)];
        // [self.view addSubview:self.toolbar];
    }
    return self;
}*/

- (id)initWithData:(NSMutableDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // infoData = data;
    }
    return self;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
 // Custom initialization
 }
 return self;
 }
 */

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[super viewDidLoad];	
	
    created = NO;
	
	// UIScreen *screen = [UIScreen mainScreen];
    // [self.view setFrame:[screen applicationFrame]];
	////////////// self.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	[Functions initToolBar:self.view withTitle:@" "];
	[Functions addStatusBar:self.view withTabBar:YES];

	[self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
}

- (void) showView
{
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"displayId"];
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	NSString * title = @"Detail";
	
	/*NSString * titleName = @"";
	NSString * titleType = @"";
	NSString * titleFont = @"Courier";
	NSString * titleSize = @"12";
	NSString * titleColor = @"#cccccc";
	NSString * titleStyle = @"regular";
	NSString * descriptionName = @"";
	NSString * descriptionType = @"";
	NSString * descriptionFont = @"Courier";
	NSString * descriptionSize = @"12";
	NSString * descriptionColor = @"#cccccc";
	NSString * descriptionStyle = @"regular";
	NSString * imageName = @"";
	// NSString * linkName = @"";
	// NSString * linkType = @"";*/
	// NSString *siteUrl;
	// siteUrl = @"";  // [[NSString alloc] initWithString:@""];
	NSMutableArray * detailFields = [[[NSMutableArray alloc] init] autorelease];
	NSMutableArray * detailData = [[[NSMutableArray alloc] init] autorelease];
	NSString *twitter = @"";
	NSString *facebook = @"";
	NSString *email = @"";
	BOOL useShare = NO;

	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"idItem: %@ : %@ ", displayId, idItem);
				if ([displayId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			// int i = 0;
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								if (![[TBXML valueOfAttributeNamed:@"sequence" forElement:childXMLElement] isEqualToString:@"0"]) {
									if ([[TBXML valueOfAttributeNamed:@"visible" forElement:childXMLElement] isEqualToString:@"0"]) {
										// sequence detail fields
										NSArray * fieldObject = [NSArray 
															   arrayWithObjects: 
																 [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement], 
																 [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement], 
																 [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement], 
																 [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement], 
																 nil];
										[detailFields addObject:fieldObject];
									}
								}
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"detail_title"]) {
									// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
									self.linkRef= [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									self.linkType= [TBXML valueOfAttributeNamed:@"link_to_type" forElement:childXMLElement];
								}
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"twitter"]) {
									twitter = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"facebook"]) {
									facebook = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"email"]) {
									email = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								/*
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"detail_title"]) {
									if ([[TBXML valueOfAttributeNamed:@"visible" forElement:childXMLElement] isEqualToString:@"0"]) {
										titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
										titleType = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
										titleFont = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
									} else {
										titleName = @"";
										titleType = @"";
										titleFont = @"";
									}
								}
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"detail_desc"]) {
									if ([[TBXML valueOfAttributeNamed:@"visible" forElement:childXMLElement] isEqualToString:@"0"]) {
										descriptionName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
										descriptionType = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
										descriptionFont = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
									} else {
										descriptionName = @"";
										descriptionType = @"";
										descriptionFont = @"";
									}
								}
								 */
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}				
				}
			} while ((appXMLElement = appXMLElement->nextSibling));

			if ([twitter isEqualToString:@"true"]
				||
				[facebook isEqualToString:@"true"]
				||
				[email isEqualToString:@"true"]) {
				useShare = YES;

			}
			/*
			 FontItem * font;
			font = [Functions loadFont:titleFont]; 
			titleFont = font.nameFont;
			titleSize = font.sizeFont;  
			titleColor = font.colorFont;
			titleStyle = font.styleFont;
			font = [Functions loadFont:descriptionFont]; 
			descriptionFont = font.nameFont;
			descriptionSize = font.sizeFont;  
			descriptionColor = font.colorFont;
			descriptionStyle = font.styleFont;
			[font release];
			 */

			// NSString *titleLabel = [[NSString alloc] init];
			// NSString *descriptionLabel = [[NSString alloc] init];
			// NSString *imageLabel = [[NSString alloc] init];
			// NSLog(@" ... %@ %@ %@ %@", descriptionName,descriptionFont,titleName,titleFont);
			
			NSString * selectedListItem = [cnf loadValue:@"selectedListItem"];
			NSString * feedSource = [cnf loadValue:@"feedSource"];
			// NSURL *u = [NSURL URLWithString:feedSource];
			
			NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			NSString *documentsDir = [documentPaths objectAtIndex:0];
			NSString *fileName = [documentsDir stringByAppendingPathComponent:feedSource];
			NSData *myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
			NSString *unescaped = [[[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding] autorelease];
			unescaped = [unescaped htmlUnescapedString];
			TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
			// NSLog(@"--> %@", unescaped);
            [myXMLData release];

			// NSData *myXMLData   = [NSData dataWithContentsOfURL:u];
			// [myXMLData writeToFile:databasePath atomically:YES];
			// TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
			// elements = [[NSMutableArray alloc] initWithCapacity:10];
			TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
            [tbxml release];
			// detailData = [NSMutableArray arrayWithCapacity:[detailFields count]+1]; 
			// [[NSMutableArray alloc]initWithArray:detailFields copyItems:YES];
			for(int i=0;i<[detailFields count];i++) {
				[detailData addObject:[[detailFields objectAtIndex:i] objectAtIndex:2]];
			}
			// NSLog(@"data: %@", detailData);
			if (rootXMLElement) {
				childXMLElement = rootXMLElement->firstChild;
				do {

					// if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
					if (
						!([[TBXML elementName:childXMLElement] isEqualToString:@"error"]) &&
						!([[TBXML elementName:childXMLElement] isEqualToString:@"debug"])
						) {
						TBXMLElement * dataXMLElement = childXMLElement->firstChild;
						// NSInteger total = 1;
						int counter = 0;
						do {
							// NSLog(@"... ??? %@ --- %i", selectedListItem, counter);
							if ([selectedListItem isEqualToString:[NSString stringWithFormat:@"%i", counter]]) {
								TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
								// NSLog(@"ch %@ ", [TBXML elementName:itemXMLElement]);
								// NSLog(@"id %@ ", [TBXML valueOfAttributeNamed:@"id" forElement:dataXMLElement]);
								
								// CGSize titleTextSize;
								// CGSize descriptionTextSize;
								// int imgHeight = 0;
								do {
									for(int i=0;i<[detailFields count];i++) {
										NSString * field = [[detailFields objectAtIndex:i] objectAtIndex:1];
										// field = [field stringByReplacingOccurrencesOfString:@"_" withString:@":"];
										// NSLog(@"f: %@ == %@ arr: %@", [TBXML elementName:itemXMLElement], field, detailData);
										if ([[TBXML elementName:itemXMLElement] isEqualToString:field]) {
											if ([[[detailFields objectAtIndex:i] objectAtIndex:2] isEqualToString:@"image_entity"]) {
												// [detailData insertObject:[TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement] atIndex:i];
												if ([TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement])
                                                    [detailData replaceObjectAtIndex:i withObject:[TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement]];
												else
													[detailData replaceObjectAtIndex:i withObject:[TBXML textForElement:itemXMLElement]];
											} else {
												// [detailData insertObject:[TBXML textForElement:itemXMLElement] atIndex:i];
												[detailData replaceObjectAtIndex:i withObject:[TBXML textForElement:itemXMLElement]];
											}
											break;
										}
									}
									/*
									 if ([[TBXML elementName:itemXMLElement] isEqualToString:titleName]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										titleLabel = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:descriptionName]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										descriptionLabel = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:imageName]) {
										// NSLog(@"img: %@", [TBXML textForElement:itemXMLElement]);
										NSString *imageUrl = [TBXML textForElement:itemXMLElement];
										imageLabel = imageUrl;
										/ *
										 NSURL *imgURL = [NSURL URLWithString:imageUrl];
										 NSData *imgData = [NSData dataWithContentsOfURL:imgURL];
										 imageView.image = [[UIImage alloc] initWithData:imgData];
										 CGRect imageFrame = CGRectMake(10, titleTextSize.height+60, 160, 200);
										 imageView.frame = imageFrame;
										 imgHeight = 200;
										 * /
									}
									/ *
									 if ([[TBXML elementName:itemXMLElement] isEqualToString:linkName]) {
									 // NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
									 siteUrl = [TBXML textForElement:itemXMLElement];
									 } */
								} while ((itemXMLElement = itemXMLElement->nextSibling));
								// CGRect descriptionLabelFrame = CGRectMake(10, titleTextSize.height+imgHeight+60, 300, descriptionTextSize.height);
								// descriptionLabel.frame = descriptionLabelFrame;
								// total++;
								// self.view.frame = CGRectMake(0, 0, 320,titleTextSize.height+imgHeight+descriptionTextSize.height);
							}
							counter++;
						} while ((dataXMLElement = dataXMLElement->nextSibling));
					}
				} while ((childXMLElement = childXMLElement->nextSibling));
			}
			
			/*
			 if ([titleType isEqualToString:@"label"])
				titleLabel = descriptionName;
			if ([descriptionType isEqualToString:@"label"])
				descriptionLabel = descriptionName;
			// NSLog(@"??? %@", titleLabel);
			// NSLog(@"??? %@", descriptionLabel);
			 */
			
			// NSLog(@"d: %@", detailData);
			// Web View

            UIWebView * aWebView = (UIWebView *)[self.view viewWithTag:50007];
            if (aWebView == nil) {

                //UIWebView * 
                aWebView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 50, 320, 370)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
                aWebView.frame = CGRectMake(0, 50, self.view.frame.size.width, self.view.frame.size.height-90);
                aWebView.tag = 50007;
                aWebView.autoresizesSubviews = YES;
                aWebView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
                aWebView.delegate = self;
            }
			
			NSMutableString * head = [[NSMutableString alloc] init];
			NSMutableString * body = [[NSMutableString alloc] init];
			for(int i=0;i<[detailFields count];i++) {
				// NSLog(@"%i --> %@", i, [detailFields objectAtIndex:i]);
				// NSString * field = [[detailFields objectAtIndex:i] objectAtIndex:0];
				FontItem * font;
				if ([[[detailFields objectAtIndex:i] objectAtIndex:2] isEqualToString:@"image_entity"]) {
					[body appendString:[NSString stringWithFormat:@"<img src='%@' />", [detailData objectAtIndex:i]]];
				} else if ([[[detailFields objectAtIndex:i] objectAtIndex:2] isEqualToString:@"label"]) {
					NSString * aHref = @"";
					if ([[[detailFields objectAtIndex:i] objectAtIndex:0] isEqualToString:@"detail_title"])
						aHref = @"a";
					[body appendString:[NSString stringWithFormat:@"<p id='%@'>%@</p>", [[detailFields objectAtIndex:i] objectAtIndex:0], [[detailFields objectAtIndex:i] objectAtIndex:1]]];
					font = [Functions loadFont:[[detailFields objectAtIndex:i] objectAtIndex:3]]; 
					[head appendString:[NSString stringWithFormat:@"#%@ %@ { \n"
										"font-family:%@; \n"
										"font-size:%@px;\n"
										"color:%@; \n"
										"font-weight: %@; \n"
										"}\n",
										[[detailFields objectAtIndex:i] objectAtIndex:0],
										aHref,
										font.nameFont,
										font.sizeFont,
										font.colorFont,
										font.styleFont]];
				} else {
					NSString * aCss = @"";
					NSString * aHref = @"";
					NSString * aHrefEnd = @"";
					if ([@"detail_title" isEqualToString:[[detailFields objectAtIndex:i] objectAtIndex:0]]) {
						aHref = @"<a href=\"javascript:void(0)\" onMouseDown=\"titleClicked()\">";
						aHrefEnd = @"</a>";
						aCss = @"a";
					}
					[body appendString:[NSString stringWithFormat:@"<p id='%@'>%@%@%@</p>", [[detailFields objectAtIndex:i] objectAtIndex:0], aHref, [detailData objectAtIndex:i], aHrefEnd]];
					font = [Functions loadFont:[[detailFields objectAtIndex:i] objectAtIndex:3]]; 
					[head appendString:[NSString stringWithFormat:@"#%@ %@ { \n"
					 "font-family:%@; \n"
					 "font-size:%@px;\n"
					 "color:%@; \n"
					 "font-weight: %@; \n"
					 "}\n",
										[[detailFields objectAtIndex:i] objectAtIndex:0],
										aCss,
										font.nameFont,
										font.sizeFont,
										font.colorFont,
										font.styleFont]];
				}
			}
			// NSLog(@"b: %@", body);
            [aWebView setOpaque:NO];
            [aWebView setBackgroundColor:[UIColor clearColor]];
			
			NSString *myHtml = [NSString stringWithFormat:@"<html> \n"
								"<head> \n"
								"<meta name=\"viewport\" content=\"width=320\" />\n"
								"<script>\n"
								"function titleClicked(){\n"
								"	var clicked=true;\n"
								"	window.location=\"/\"+clicked;\n"
								"}\n"
								"</script>\n"
								"<style type=\"text/css\"> \n"
								"* {\n"
								"margin-top: 0em;\n"
								"margin-bottom: 0em;\n"
								"}\n"
								"body{background-color:transparent;}\n"
								"p {\n"
								"margin-top: 0em;\n"
								"margin-bottom: 0em;\n"
								"}\n"
								"%@"
								"</style> \n"
								"</head> \n"
								"<body>%@</body> \n"
								"</html>",
								head,
								body];
								
			// NSLog(@"h: %@", myHtml);

			//set the web view delegates for the web view to be itself
			// [aWebView setDelegate:self];
			
			//Set the URL to go to for your UIWebView
			// NSString *urlAddress = @"http://www.google.com";//Go to Google.com for my UIWebView
			//Create a URL object.
			// NSURL *url = [NSURL URLWithString:urlAddress];
			//URL Requst Object
			// NSURLRequest *requestObj = [NSURLRequest requestWithURL:url];
			//load the URL into the web view.
			// [aWebView loadRequest:requestObj];
			
			/*
			 NSString *myHtml = [NSString stringWithFormat:@"<html> \n"
								"<head> \n"
								"<style type=\"text/css\"> \n"
								"h1 { \n"
								"font-family:%@; \n"
								"font-size:%@px;\n"
								"font-color:%@; \n"
								"font-weight: %@; \n"
								"}\n"   
								".textData { \n"
								"font-family:%@; \n"
								"font-size:%@px;\n"
								"font-color:%@; \n"
								"font-weight: %@; \n"
								"}\n"   
								"</style> \n"
								"</head> \n"
								"<body><h1>%@<h1><div class=\"textData\">%@</div></body> \n"
								"</html>", 
								titleFont, titleSize, titleColor, titleStyle,
								descriptionFont, descriptionSize, descriptionColor, descriptionStyle,
								titleLabel, descriptionLabel];
			// NSLog(@"html: %@", myHtml);
			 */
			// [self.view addSubview:aWebView];
			[aWebView setDelegate:self];
			[aWebView loadHTMLString:myHtml baseURL:nil];
            [head release];
            [body release];
			// self.textTitle = titleLabel;
			// self.textUrl = siteUrl;
            if (!created) {
                created = YES;

				// [Functions initToolBar:self.view withTitle:title];

				UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
				toolbarTitle.text = title;
				
				[self initStatusBar:self.view useShare:useShare];
				if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
					if ([[self parentViewController] isKindOfClass:[UISplitViewController class]])
					{
						UIToolbar * toolbar = (UIToolbar *)[self.view viewWithTag:10001];
						UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
						[backButton setFrame:CGRectMake(10,7,75,26)];
						[backButton setTitle:@"List" forState:UIControlStateNormal];
						[backButton addTarget:self action:@selector(showList:) forControlEvents:UIControlEventTouchUpInside];
						// backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
						[toolbar addSubview:backButton];
					}
				}
				[self.view addSubview:aWebView];
            }
			
			//add the web view to the content view
			// Web View
			
		}
	}
	[cnf release];
	
    if (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad) {
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
	}
	
	[self performSelector:@selector(showStatusBar) withObject:nil afterDelay:0.1];
	
	
}


-(void)showStatusBar{
	
	[[UIApplication sharedApplication] setStatusBarHidden:NO withAnimation:UIStatusBarAnimationNone];
	[[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleDefault animated:NO];
}

 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
     return YES;
 //    return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc 
{
    [shareView release];
	[textTitle release];
	[textUrl release];
	[linkRef release];
	[linkType release];
    [super dealloc];
}

-(IBAction)goShare:(id) sender {
	
	Config *cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"displayId"];

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * twitter = @""; // [[NSString alloc] init];
	NSString * email = @""; // [[NSString alloc] init];
	NSString * twitterId = @""; // [[NSString alloc] init];
	NSString * emailId = @""; // [[NSString alloc] init];

	NSString * facebook = @""; // [[NSString alloc] init];
	NSString * facebookId = @""; // [[NSString alloc] init];
	NSString * facebookLink = @""; // [[NSString alloc] init];
	NSString * facebookTitle = @""; // [[NSString alloc] init];
	NSString * facebookComment = @""; // [[NSString alloc] init];

	NSString * twitterLink = @""; // [[NSString alloc] init];
	NSString * twitterTitle = @""; // [[NSString alloc] init];
	NSString * twitterComment = @""; // [[NSString alloc] init];

	NSString * emailSubject = @""; // [[NSString alloc] init];
	NSString * emailSubjectTitle = @""; // [[NSString alloc] init];
	NSString * emailBodyText = @""; // [[NSString alloc] init];
	NSString * emailBodyTitle = @""; // [[NSString alloc] init];
	NSString * emailBodyLink = @""; // [[NSString alloc] init];
	
	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"idItem: %@ : %@ ", displayId, idItem);
				if ([displayId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		

		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"twitter"]) {
									twitter = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"facebook"]) {
									facebook = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"email"]) {
									email = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// facebook
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:facebookId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"facebook_subject_entity"]) {
									facebookTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookTitle = [facebookTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"facebook_link"]) {
									facebookLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookLink = [facebookLink urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"facebook_comment"]) {
									facebookComment = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookComment = [facebookComment urlUnescapedString];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// twitter
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:twitterId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"twitter_title"]) {
									twitterTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterTitle = [twitterTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"twitter_link"]) {
									twitterLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterLink = [twitterLink urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"twitter_twitt"]) {
									twitterComment = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterComment = [twitterComment urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// e-mail
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:emailId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"email_subject"]) {
									emailSubject = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailSubject = [emailSubject urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_subject_entity"]) {
									emailSubjectTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailSubjectTitle = [emailSubjectTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_body"]) {
									emailBodyText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyText = [emailBodyText urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_body_entity"]) {
									emailBodyTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyTitle = [emailBodyTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_link"]) {
									emailBodyLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyLink = [emailBodyLink urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					
								
								
				}
			} while ((appXMLElement = appXMLElement->nextSibling));

			NSString * selectedListItem = [cnf loadValue:@"selectedListItem"];
			NSString * feedSource = [cnf loadValue:@"feedSource"];
			// NSURL *u = [NSURL URLWithString:feedSource];
			
			NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			NSString *documentsDir = [documentPaths objectAtIndex:0];
			NSString *fileName = [documentsDir stringByAppendingPathComponent:feedSource];
			NSData *myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
			NSString *unescaped = [[[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding] autorelease];
			unescaped = [unescaped htmlUnescapedString];
            [myXMLData release];
			
			TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
			
			TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
            [tbxml release];
			if (rootXMLElement) {
				childXMLElement = rootXMLElement->firstChild;
				do {
					if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
						TBXMLElement * dataXMLElement = childXMLElement->firstChild;
						// NSInteger total = 1;
						int counter = 0;
						do {
							if ([selectedListItem isEqualToString:[NSString stringWithFormat:@"%i", counter]]) {
								TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
								do {
									if ([[TBXML elementName:itemXMLElement] isEqualToString:facebookTitle]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										facebookTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:facebookLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										facebookLink = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:twitterTitle]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										twitterTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:twitterLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										twitterLink = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailSubjectTitle]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailSubjectTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailBodyTitle]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailBodyTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailBodyLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailBodyLink = titleText;
									}
								} while ((itemXMLElement = itemXMLElement->nextSibling));
								// CGRect descriptionLabelFrame = CGRectMake(10, titleTextSize.height+imgHeight+60, 300, descriptionTextSize.height);
								// descriptionLabel.frame = descriptionLabelFrame;
								// total++;
								// self.view.frame = CGRectMake(0, 0, 320,titleTextSize.height+imgHeight+descriptionTextSize.height);
							}
							counter++;
						} while ((dataXMLElement = dataXMLElement->nextSibling));
					}
				} while ((childXMLElement = childXMLElement->nextSibling));
			}

		}

	}
	
	NSLog(@"tw: %@", twitter);
	

	[shareView.view removeFromSuperview];
	shareView = [ShareViewController sharedManager];
	
	[shareView setMailSubject:[NSString stringWithFormat:@"%@ : %@", emailSubject, emailSubjectTitle]];
	NSString * message = [NSString stringWithFormat:@"<p>%@\n"
						  "<br /><br /> \n"
						  "<a href=\"%@\">%@</a> \n"
						  "<br />%@<br /><br /> \n"
						  "</p>\n",
						  emailBodyText, emailBodyLink, emailBodyTitle, emailBodyLink];
	
	[shareView setMailText:message];
	
	[shareView setTextTitle:textTitle];
	[shareView setTextDescription:textUrl];
	[shareView setTextUrl:textUrl];

	[shareView setUseMail:email];
	[shareView setUseFacebook:facebook];
	[shareView setUseTwitter:twitter];

	[shareView setFacebookTitle:facebookTitle];
	[shareView setFacebookDescription:facebookComment];
	[shareView setFacebookLink:facebookLink];

	[shareView setTwitterTitle:twitterTitle];
	[shareView setTwitterDescription:twitterComment];
	[shareView setTwitterLink:twitterLink];

	[self.view addSubview:shareView.view];
	// popupView.view.frame = CGRectMake(0, self.view.frame.size.height,320,100);
	shareView.view.frame = CGRectMake(0,460,320,460);
	shareView.view.frame = CGRectMake(0,self.view.frame.size.height,self.view.frame.size.width,self.view.frame.size.height);
    // [popupView setFrame:CGRectOffset([popupView frame], 0, popupView.frame.size.height)]; // Move it up top and off screen
	[UIView beginAnimations:@"animateImageOn" context:NULL]; // Begin animation
	[shareView.view setFrame:CGRectOffset([shareView.view frame], 0, -shareView.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
	
	[cnf release];
}

-(void)hideShare {
    [NSObject cancelPreviousPerformRequestsWithTarget: self];
	[UIView beginAnimations:@"animateImageOff" context:NULL]; // Begin animation
	// [shareView.view setFrame:CGRectOffset([shareView.view frame], 0, shareView.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
}

- (void) showList:(id)sender
{
    if (listViewController == nil) {
        // self.listViewController = [[[ListViewController alloc] initWithStyle:UITableViewStylePlain] autorelease];
        self.listViewController = [[[ListViewController alloc] init] autorelease];
    }
    // _ratingController.game = _game;
    
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        UIButton *button = (UIButton *)sender;
        if (self.popover == nil) {
            Class classPopoverController = NSClassFromString(@"UIPopoverController");
            if (classPopoverController) {
                self.popover = [[[classPopoverController alloc] initWithContentViewController:listViewController] autorelease];
            }
        }
        [self.popover presentPopoverFromRect:button.frame inView:self.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];        
    }
}

- (void) initStatusBar:(UIView *)actualView useShare:(BOOL) share
{
	// NSString *title =@"Video";
	/*UIToolbar *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 420, CGRectGetWidth(mainViewBounds), toolbarHeight)];
    toolbar.frame = CGRectMake(0, self.view.frame.size.height-60, self.view.frame.size.width, 40);

	[toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 102.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
    toolbar.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	toolbar.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleWidth);
	toolbar.frame = CGRectMake(0, self.view.frame.size.height-toolbarHeight, self.view.frame.size.width, toolbarHeight);

	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	toolbar.alpha = 0.7;
	
	[actualView addSubview:toolbar];*/
	UIToolbar *toolbar = (UIToolbar *)[actualView viewWithTag:11003];

	// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
	[button addTarget:self action:@selector(goShare:) forControlEvents:UIControlEventTouchUpInside];
	
	// const NSInteger IMAGE_TAG = 1003;
	UIImage * btnImage = [UIImage imageNamed:@"tabbutton_share.png"];
	button.frame = CGRectMake(2, 2, 30, 30);
	[button setFrame:CGRectMake(57, 2, 30, 30)];
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	if (share)
		[toolbar addSubview:button];
	
	// [button release];

	/*
	 UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	 [button setFrame:CGRectMake(260,10,50,26)];
	 [button setTitle:@"View" forState:UIControlStateNormal];
	 [button addTarget:self action:@selector(goView:) forControlEvents:UIControlEventTouchUpInside];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 [toolbar addSubview:button];
	 // [button release];
	 */
	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	// [backButton setFrame:CGRectMake(self.view.frame.size.width-60 /*260*/,7,50,26)];
	[backButton setFrame:CGRectMake(toolbar.frame.size.width-60 /*260*/,7,50,26)];
	[backButton setFrame:CGRectMake(5,4,50,26)];
	[backButton setTitle:@"Back" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(goBack:) forControlEvents:UIControlEventTouchUpInside];
	backButton.autoresizingMask = UIViewAutoresizingFlexibleRightMargin;
	backButton.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin );
	// if (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad)
	if (![parentView isKindOfClass:[SplitViewController class]])
		[toolbar addSubview:backButton];
	// [backButton release];
	
    // [toolbar release];
}

- (IBAction)goBack:(id) sender
{
	[Functions goMenu:nil];
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType {
    if ( [request.mainDocumentURL.relativePath isEqualToString:@"/false"] ) {    
        NSLog( @"not clicked" );
        return false;
    }
    
    if ( [request.mainDocumentURL.relativePath isEqualToString:@"/true"] ) {        //the image is clicked, variable click is true
        NSLog(@"clicked" );
		
		Config *cnf = [[Config alloc] init];

		app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
		if ([linkType isEqualToString:@"url"]) {
			NSLog(@"??? %@", linkRef);
			[cnf updateValue:@"selectedListItem" value:@"0"];
			[cnf updateValue:@"goUrl" value:linkRef];
			[cnf updateValue:@"displayId" value:@"0"];
			
			// [Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
			[appDelegate displayView:@"5"]; // :[appDelegate detailType]];
		} else if ([linkType isEqualToString:@"video"]) {
			// detail
			// [Functions updateConfig:@"selectedListItem" withValue: element.idList];
			// [Functions updateConfig:@"displayId" withValue:linkRef];
			// [Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
			// detail
			
			[cnf updateValue:@"goUrl" value:linkRef];
			// [Functions updateConfig:@"displayId" withValue:@"0"];
			[appDelegate displayView:@"6"]; // :[appDelegate detailType]];
		} else {
			NSLog(@"aaa %@", linkRef);
			// [Functions updateConfig:@"selectedListItem" withValue: element.idList];
			[cnf updateValue:@"goUrl" value:@"---"];
			[cnf updateValue:@"displayId" value:linkRef];
			// [Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
			[appDelegate displayView:@"5"];
		}
		
		[cnf release];
		
        /*
		 UIAlertView* alert=[[UIAlertView alloc]initWithTitle:@"JavaScript called" 
													 message:@"You've called iPhone provided control from javascript!!" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:nil];
        [alert show];
        [alert release];
		*/
        return false;
    }
    
	NSLog(@"true...");
    // Determine if we want the system to handle it.
    NSURL *url = request.URL;
    if (![url.scheme isEqual:@"http"] && ![url.scheme isEqual:@"https"]
		&& ![url.scheme isEqual:@"tel"]) {
        if ([[UIApplication sharedApplication]canOpenURL:url]) {
            [[UIApplication sharedApplication]openURL:url];
            return NO;
        }
    }
	return YES;    
}

- (void)webViewDidStartLoad:(UIWebView *)webView {
	// [activityIndicator startAnimating];
}

- (void)webViewDidFinishLoad:(UIWebView *)aWebView {
	// [activityIndicator stopAnimating];
}

- (void)webView:(UIWebView *)wv didFailLoadWithError:(NSError *)error {
    NSLog (@"webView:didFailLoadWithError");
    // [activityIndicator stopAnimating];
	NSURL *url = [NSURL URLWithString:[error.userInfo objectForKey:@"NSErrorFailingURLStringKey"]];
    if ([error.domain isEqual:@"WebKitErrorDomain"]
        && error.code == 101
        && [[UIApplication sharedApplication]canOpenURL:url])
    {
        [[UIApplication sharedApplication]openURL:url];
        return;
    }
    /*
	 if (error != NULL) {
	 UIAlertView *errorAlert = [[UIAlertView alloc]
	 initWithTitle: [error localizedDescription]
	 message: [error localizedFailureReason]
	 delegate:nil
	 cancelButtonTitle:@"OK" 
	 otherButtonTitles:nil];
	 [errorAlert show];
	 [errorAlert release];
	 }
	 */
}

#pragma mark Split View Delegate

- (void)splitViewController: (UISplitViewController*)svc willHideViewController:(UIViewController *)aViewController withBarButtonItem:(UIBarButtonItem*)barButtonItem forPopoverController: (UIPopoverController*)pc {
    barButtonItem.title = @"Sidebar";    
    
	NSLog(@"gogo");
	// UINavigationItem *navItem = [self navigationItem];
	// [navItem setLeftBarButtonItem:barButtonItem animated:YES];

    self.popover = pc;
}

- (void)splitViewController: (UISplitViewController*)svc willShowViewController:(UIViewController *)aViewController invalidatingBarButtonItem:(UIBarButtonItem *)barButtonItem {    
    
	NSLog(@"tete");
    UINavigationItem *navItem = [self navigationItem];
    [navItem setLeftBarButtonItem:nil animated:YES];
    
    self.popover = nil;
    
}

#pragma mark List Selection

-(void) ListSelectionChanged
{
	NSLog(@"changed...");
	[self showView];
    if (_popover != nil) {
        [_popover dismissPopoverAnimated:YES];
    }
}
	
@end
