//
//  ImageScrollerThumbs.m
//  ImageScrollPOC
//
//  Created by Ihonahan on 2/18/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ImageScrollerThumbs.h"
#import "SendImageViewController.h"
#import "app_builderAppDelegate.h"

@implementation ImageScrollerThumbs

//const int _pageCount = 50;
#define _pageCount  50

@synthesize myScroll;

@synthesize titlesArray;

@synthesize textUrl, textTitle;
@synthesize waitLabel;

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 150, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];;
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#666666"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
//	NSLog(@"st an..");
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil 
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) 
	{
        // Custom initialization.
    }
    return self;
}


- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) 
	{
        infoData = data;
    }
    return self;
}




// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
    [super viewDidLoad];
	
	// [self initWaitView];
	// [self showAnimated:nil];
    [Functions initWaitView:self.view];
    [Functions showAnimated:self.view];
    [Functions initToolBar:self.view withTitle:@""]; // withTitle:@"Gallery" withView:NO];
	[Functions addStatusBar:self.view withTabBar:NO];

	[self performSelector:@selector(startLoading) withObject:nil afterDelay:0.2];
}

-(void) startLoading {
	[myScroll setDelegate:self];
	
	// [myScroll setFrame:CGRectMake(0, 0, 320, 380)];

	
	// [self.view setFrame:CGRectMake(0, 0, 75, 75)];
	aWebView = [[UIWebView alloc] initWithFrame:CGRectMake(5, 50, 75, 75)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
	aWebView.autoresizesSubviews = YES;
	aWebView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
	aWebView.delegate = self;
	// aWebView.backgroundColor = [UIColor clearColor];
	// [aWebView setOpaque:NO];
	NSString *myHtml = [NSString stringWithFormat:@"<html> \n"
						"<head> \n"
						"<meta name=\"viewport\" content=\"width=320\" />\n"
						"<style type=\"text/css\"> \n"
						"* {\n"
						"margin: 0em;\n"
						"padding: 0em;\n"
						"}\n"
						"</style> \n"
						"</head> \n"
						"<body>"
						// "<!-- OAS JX Tag Begins -->\n"
						"<script language=\"JavaScript\" type=\"text/javascript\">\n"
						"<!--\n"
						"var OAS_url = 'http://oascentral.construction.com'; // // Your OAS cname - Required\n"
						"var OAS_sitepage = 'www.construction.com/iphoneApp/eventCFT'; // Target site/page - Required\n"
						"var OAS_pos = 'Position4'; // Target Position - Required\n"
						"var OAS_query = ''; // Search Terms/Keywords - Optional\n"
						"\n"
						"var OAS_RN = new String (Math.random());\n"
						"var OAS_RNS = OAS_RN.substring (2,11);\n"
						"\n"
						"document.write('<scr' + 'ipt language=\"javascript\" type=\"text/javascript\" src=\"'\n"
						"+ OAS_url + '/RealMedia/ads/adstream_jx.ads/' + OAS_sitepage + '/1' + OAS_RNS\n"
						"+ '@' + OAS_pos + '?' + OAS_query + '\"></scr' + 'ipt>');\n"
						"// -->\n"
						"</script>\n"
						// "<!-- OAS JX Tag Ends -->"
						"</body> \n"
						"</html>"];
	
	// myHtml = @"<html><body>123M</body></html>";
	// NSLog(@"html: %@", myHtml);
	// [aWebView setDelegate:self];
	[aWebView loadHTMLString:myHtml baseURL:nil];
	[self.view addSubview:aWebView];
	
	isAdVisible = YES;
	
	//Inital data
	/*NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [[NSData alloc] initWithContentsOfFile:filePath];
	bgImage = [UIImage imageWithData:imgData];
	bgImageView = [[UIImageView alloc] initWithImage:bgImage];*/
	[myScroll setOpaque:NO];
	[myScroll setBackgroundColor:[UIColor clearColor]];
	// [myScroll setBackgroundColor:[UIColor redColor]];
	// [self.view insertSubview:bgImageView atIndex:0];

	/*CGRect progressFrame = CGRectMake(135, 150, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];;
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	
	[waitView startAnimating];*/
	
	showImage = FALSE;
	[self processInfo];
	
}



- (void)processInfo 
{
	maxPages = 0;
	// bh	
//	imagesArray = [[NSMutableArray alloc] init];
	// NSMutableArray * aImages; // = [[NSMutableArray init] alloc];
	// NSMutableArray * aTitles; // = [[NSMutableArray init] alloc];

	// UILabel *counter;
	
	Config *cnf = [[Config alloc] init];
	actualId = [cnf loadValue:@"actualId"]; 
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	
	// NSLog@(@"oooooooooooooo o o o oooooo %@", actualId);
	//tabbar
	NSString * currentFeed = [cnf loadValue:@"currentFeedPage"];
	currentFeedPage=1;
	if ([currentFeed intValue] != currentFeedPage)
		currentFeedPage = [currentFeed intValue];
	if (currentFeedPage == 0) currentFeedPage = 1;
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * feedsXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * title = @"Gallery";
	NSString * url = @"";
	//NSString * titleIdItem = @"";
	imageIdType = @"";
	imageName = @"";
	titleName = @"";
	imageIdItem = @"";
	titleIdType = @"";
	NSLog(@"root");
	if (root) {
		BOOL f = FALSE;
		
		childXMLElement = root->firstChild;

		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						if (childXMLElement)
							do {
								if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
									NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
									
									if ([attribItem isEqualToString:@"tab_bar"]) {
									}
									else if ([attribItem isEqualToString:@"data_source"]) {
										url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									}
									else if ([attribItem isEqualToString:@"text_title"]) {
										title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									else if ([attribItem isEqualToString:@"slide_title"]) {
										titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									else if ([attribItem isEqualToString:@"slide_image"]) {
										imageName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									else if ([attribItem isEqualToString:@"slide_thumbnail"]) {
										iconName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									//HACK: Nuevamente, para obtener el elemento de link
									if(YES)
									{
//										urlShareName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
										urlShareName = @"link";
									}
									
								}
							} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
								// NSLog(@"url? %@", url);
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
			
			imageIdItem = @"";
			imageIdType = @"";
			//titleIdItem = @"";
			titleIdType = @"";
			
		}
		
	}
	
	// [Functions initToolBar:self.view withTitle:@"Gallery" withView:YES];
//	[Functions initToolBar:self.view withTitle:title]; // withTitle:@"Gallery" withView:NO];
    UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
    toolbarTitle.text = title;

	NSString *detailTitleValue = [cnf loadValue:@"detailTitle"];
	if ([detailTitleValue isEqualToString:@""] || 
		detailTitleValue == nil)
		[cnf insertValue:@"detailTitle" value:title];
	else
		[cnf updateValue:@"detailTitle" value:title];
	
	UIWebView * webView = (UIWebView *)[self.view viewWithTag:20000];
	webView.delegate = self;

	feedSource = [NSString stringWithFormat:@"%@",url];
	

	
//	NSLog(@"0.imageName: %@",imageName);
	
	// aImages = [[NSMutableArray alloc] init];
	// aTitles = [[NSMutableArray alloc] init];

	curPosX = 5;
	curPosY = 50; // 10
	loadingImageLoaded = NO;
	currentLoadedImage = 0;
	imageButtonsArray = [[NSMutableArray alloc] init];
	largeImagesUrlsArray = [[NSMutableArray alloc] init];
	titlesArray = [[NSMutableArray alloc] init];
	shareUrlsArray = [[NSMutableArray alloc] init];
	pagesLoaded = [[NSMutableArray alloc] init];
	
	minToLoadPage = 1;
	maxToLoadPage = 1; //3
	
	
	NSData *myXMLData = [self getXMLForPage:currentFeedPage];

	NSString *fileNameNoDir = [NSString stringWithFormat:@"tmp_%@_4_%i", actualId, currentFeedPage];

	[self getImagesXmlWithData:@"" 
						  data:myXMLData 
						 image:imageName 
						 title:titleName 
					 imageItem:imageIdItem 
					  fileName:fileNameNoDir 
					  imageIdT:imageIdType];


//	[self initStatusBar:self.view withType:1];
//
	[cnf release];
}

-(void) cleanDir {

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSFileManager *fileManager = [NSFileManager defaultManager];
	
	// [fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
	
	NSError *error = nil;
	// BOOL isDir;
	
	// remove lists files
	for (NSString *file in [fileManager contentsOfDirectoryAtPath:documentsDir error:&error]) {
		if ([file hasPrefix:[NSString stringWithFormat:@"tmp_%@_4", actualId]]) {
			NSLog(@"list: %@", file);
			// if ([fileManager fileExistsAtPath:fontPath isDirectory:&isDir] && isDir) {
				NSLog(@"dele: %@", [NSString stringWithFormat:@"%@/%@", documentsDir, file]);
				BOOL success = [fileManager removeItemAtPath:[NSString stringWithFormat:@"%@/%@", documentsDir, file] error:&error];
				if (!success || error) {
					// it failed.
					// NSLog(@"err: %@%@", fileName, file);
				} else {
					// NSLog(@"del: %@%@", fileName, file);
				}
			//}
		}
	}
}
	
-(void)goRefresh {

	[self cleanDir];
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"YYYYMMddHHmm"];
	NSString *dateString = [dateFormat stringFromDate:date];  
	[dateFormat release];
	// NSString *name = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	// [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] withValue:dateString];
	NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_4_1.xml", actualId],dateString);
	Config *cnf = [[Config alloc] init];
	[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_4_1.xml", actualId] value:dateString];
	[cnf release];

	currentLoadedImage = 0;
	[imageButtonsArray release];
	imageButtonsArray = [[NSMutableArray alloc] init];
	[largeImagesUrlsArray release];
	largeImagesUrlsArray = [[NSMutableArray alloc] init];
	[titlesArray release];
	titlesArray = [[NSMutableArray alloc] init];
	[shareUrlsArray release];
	shareUrlsArray = [[NSMutableArray alloc] init];
	[pagesLoaded release];
	pagesLoaded = [[NSMutableArray alloc] init];
	
	// [self initWaitView];
	// [self showAnimated:nil];
    [Functions showAnimated:self.view];
	[self processInfo];
}

-(NSData *)getXMLForPage:(int)pageNo
{
//	NSLog(@"1. log into getXMLForPage: ");
	
	NSLog(@"feedS :::::: %@", feedSource);
	NSString * url = [NSString stringWithFormat:@"%@",feedSource];

//	NSLog(@"2. log into getXMLForPage: ");
	
	//NSURL *u = [NSURL URLWithString:url];
	url=[url stringByReplacingOccurrencesOfString:@"page_num=1"
									   withString:@"page_num=%i"];
	// NSLog(@"URL - FINAL %@", [NSString stringWithFormat:url, pageNo]);
	
	NSURL *u = [NSURL URLWithString:[NSString stringWithFormat:url, pageNo]];

	NSData *myXMLData; 
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	NSString *databaseName = [NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, pageNo];
	Config *cnf = [[Config alloc] init];
	NSString *feedSourceValue = [cnf loadValue:@"feedSource"];
	if ([feedSourceValue isEqualToString:@""] || 
		feedSourceValue == nil)
		[cnf insertValue:@"feedSource" value:databaseName];
	else
		[cnf updateValue:@"feedSource" value:databaseName];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, pageNo]];
	// NSLog(@"fil: %@", fileName);
	NSLog(@"fsr: %@", [cnf loadValue:databaseName]);
	NSString * tmpValue = [cnf loadValue:databaseName];
	if([tmpValue isEqualToString:@""] || tmpValue == nil
	   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		myXMLData = [NSData dataWithContentsOfURL:u];
		[myXMLData writeToFile:fileName atomically:YES];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];
		[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_4_1.xml", actualId] value:dateString];
		// [dateFormat release];
	} else {
		NSLog(@"use ... ");
		// NSTimeInterval dateTime;		
		// NSDateFormatter *
		// dateFormat = [[NSDateFormatter alloc] init];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:tmpValue];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		
		// NSTimeInterval dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);  
		// Comparing two NSDates and ignoring the time component
		// http://stackoverflow.com/questions/1854890/comparing-two-nsdates-and-ignoring-the-time-component
		int day1 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:date];
		int day2 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:lastCheck];
		NSLog(@"%i - %i * %@ - %@", day1, day2, [dateFormat stringFromDate:date], [dateFormat stringFromDate:lastCheck]);

		// if(dateTime > 1) {
		if(day1 != day2) {
			NSLog(@"down (2)... ");
			
			[self cleanDir];

			myXMLData = [NSData dataWithContentsOfURL:u];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_4_1.xml", actualId] value:dateString];
			
			
			[myXMLData writeToFile:fileName atomically:YES];
			
			/*// NSFileManager* fileManager = [NSFileManager defaultManager];
			// fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId, pageNo]];
			// [fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
			
			NSError *error = nil;
			for (NSString *file in [fileManager contentsOfDirectoryAtPath:fileName error:&error]) {
				BOOL success = [fileManager removeItemAtPath:[NSString stringWithFormat:@"%@/%@", fileName, file] error:&error];
				if (!success || error) {
					// it failed.
					// NSLog(@"err: %@%@", fileName, file);
				} else {
					// NSLog(@"del: %@%@", fileName, file);
				}
			}*/
		} else {
			myXMLData = [NSData dataWithContentsOfFile:fileName];
		}
	}
    [dateFormat release];
	// NSLog(@"bk: %@", fileName);

	// fill images
	dataArray = [[NSMutableArray alloc] init];
	// [self addImageFromName:@"1.png"];
	// [self addImageFromName:@"2.png"];
	// [self addImageFromName:@"3.png"];
	// [self addImageFromName:@"4.png"];
	// [self addImageFromName:@"5.png"];
	
	// NSFileManager* fileManager = [NSFileManager defaultManager];
	
	
	// NSString *fileNameNoDir = [NSString stringWithFormat:@"tmp_%@_4_%i", actualId, pageNo];
	
	
	// fileName = [documentsDir stringByAppendingPathComponent:fileNameNoDir];
	// [fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
	
	[cnf release];
	
	return myXMLData;
}


-(void)getImagesXmlWithData:(NSString *)fileNameDir 
					   data:(NSData *)myXMLData
					  image:(NSString *)imageName2 
					  title:(NSString *)titleName2 
				  imageItem:(NSString *)imageIdItem2 
				   fileName:(NSString *)fileNameNoDir 
				   imageIdT:(NSString *)imageIdType2
{

	TBXML *tbxmlDoc = [TBXML tbxmlWithXMLData:myXMLData];
	TBXMLElement *root = tbxmlDoc.rootXMLElement;
	TBXMLElement *childXMLElement;
	NSString *image = @"";
	NSString *imageTitle = @"";
	NSString *icon = @"";
	NSString *shareUrlStr = @"";
	
	int val = 0;
	int i = currentLoadedImage;
	
	NSLog(@"currentLoadedImage: %d",currentLoadedImage);

	picsLoaded = 0;
	
	if(root != nil)
	{
		childXMLElement = [TBXML childElementNamed:@"data" parentElement:root];
		while(childXMLElement != nil)
		{
			num_items = [[TBXML valueOfAttributeNamed:@"num_items" forElement:childXMLElement] intValue];
			
			maxPagesQty = num_items / _pageCount; //10
			if ((num_items % _pageCount) != 0) maxPagesQty++; //10
			
//			NSLog(@"maxPagesQty: %d", maxPagesQty);
			
			//TODO: for debug only, load just 5 pages
//			maxPagesQty = 5;
			
			if(!loadingImageLoaded)
				[self prepareImageButtonsArray:num_items];
			
			XmlElementWrapper *myWrapper = [[XmlElementWrapper alloc] init];
			myWrapper.val = val;
			myWrapper.innerElement = childXMLElement;
            [myWrapper release];
			
			
			TBXMLElement *dataXmlElement = childXMLElement->firstChild;
			while(dataXmlElement != nil)
			{
				TBXMLElement *itemXMLElement = [TBXML childElementNamed:imageName parentElement:dataXmlElement];
				if(itemXMLElement != nil)
				{
					image = [TBXML textForElement:itemXMLElement];
				}
				
				TBXMLElement *itemTitleXMLElement = [TBXML childElementNamed:titleName parentElement:dataXmlElement];
				if(itemTitleXMLElement != nil)
				{
					imageTitle = [TBXML textForElement:itemTitleXMLElement];
				}
				
				TBXMLElement *itemIconXMLElement = [TBXML childElementNamed:iconName parentElement:dataXmlElement];
				if(itemIconXMLElement != nil)
				{
					icon = [TBXML textForElement:itemIconXMLElement];
				}

				TBXMLElement *itemShareXMLElement = [TBXML childElementNamed:urlShareName parentElement:dataXmlElement];
				if(itemShareXMLElement != nil)
				{
					shareUrlStr = [TBXML textForElement:itemShareXMLElement];
				}
				
				maxPages++;

				[self initLoadImages:fileNameNoDir 
						 dataImgname:image 
								 tag:i 
							iconFile:icon 
						dataImgTitle:imageTitle 
						shareUrlData:shareUrlStr ];

				i++;
				
				currentLoadedImage = i;

				dataXmlElement = dataXmlElement->nextSibling;
			}
			
			childXMLElement = [TBXML nextSiblingNamed:@"data" searchFromElement:root];
		}
	}
}



-(void)initLoadImages:(NSString *)fileNameNoDir 
		  dataImgname:(NSString *)image 
				  tag:(int)i 
			 iconFile:(NSString *)iconFile 
		 dataImgTitle:(NSString *)titleImg 
		 shareUrlData:(NSString *)shareUrl
{
	NSNumber *myTag = [NSNumber numberWithInt:i];
	NSString *curFeedPg = [NSString stringWithFormat:@"%d",currentFeedPage];
	NSString *curLoadImg = [NSString stringWithFormat:@"%d", currentLoadedImage];
	NSString *maxPagQ = [NSString stringWithFormat:@"%d", maxPagesQty];
	NSArray *valsArray = [[[NSArray alloc] initWithObjects:
						   fileNameNoDir, 
						   image, 
						   myTag, 
						   imageName, 
						   curFeedPg, 
						   titleName, 
						   curLoadImg,
						   feedSource,
						   iconFile,
						   iconName,
						   maxPagQ,
						   largeImagesUrlsArray,
						   
						   titlesArray,
						   shareUrlsArray,
						   urlShareName,
						   titleImg,
						   shareUrl,
						   pagesLoaded,
						   nil] autorelease];

	NSArray *keysArray = [[[NSArray alloc] initWithObjects:
						   @"fileNameNoDir", 
						   @"image", 
						   @"myTag", 
						   @"imageName", 
						   @"currentFeedPage", 
						   @"titleName", 
						   @"currentLoadedImage",
						   @"feedSource",
						   @"iconfile",
						   @"iconname",
						   @"maxpagesqty",
						   @"largeImagesUrlsArray",
						   
						   @"titlesArray",
						   @"shareUrlsArray",
						   @"urlShareName",
						   @"titleImg",
						   @"shareUrl",
						   @"pagesLoaded",
						   nil] autorelease] ;
	// NSDictionary *myDic = [NSDictionary dictionaryWithObjects:valsArray forKeys:keysArray];
	NSDictionary *myDic = [[NSDictionary alloc] initWithObjects:valsArray forKeys:keysArray];

    //	NSLog(@"loading %d image", currentLoadedImage);
	
	[NSThread detachNewThreadSelector:@selector(loadImages:) toTarget:self withObject:myDic];
    // [valsArray release];
    // [keysArray release];
    
}


-(void)loadXMLComplete:(NSDictionary *)theDic
{
	picsLoaded++;

	imageName = [theDic valueForKey:@"imageName"];
	currentFeedPage = [[theDic valueForKey:@"currentFeedPage"] intValue];
	titleName = [theDic valueForKey:@"titleName"];
	currentLoadedImage = [[theDic valueForKey:@"currentLoadedImage"] intValue];
	// currentLoadedImage = ((currentFeedPage-1) * 10) + (currentLoadedImage%10 ? currentLoadedImage%10 : 10);
	currentLoadedImage++;
	feedSource = [theDic valueForKey:@"feedSource"];
	iconName = [theDic valueForKey:@"iconname"];
	maxPagesQty = [[theDic valueForKey:@"maxpagesqty"] intValue]; 
	largeImagesUrlsArray = [theDic valueForKey:@"largeImagesUrlsArray"];
	titlesArray = [theDic valueForKey:@"titlesArray"];
	shareUrlsArray = [theDic valueForKey:@"shareUrlsArray"];
	urlShareName = [theDic valueForKey:@"urlShareName"];
	pagesLoaded = [theDic valueForKey:@"pagesLoaded"];

	// [waitView stopAnimating];
	// [self stopAnimated:nil];
    [Functions stopAnimated:self.view];
	
	// NSLog(@"curPage: %d | minPage: %d | maxPage: %d cI: %d", currentFeedPage, minToLoadPage, maxToLoadPage, currentLoadedImage);

	int i=0;
	
	NSLog(@"pagesLoaded count: %d", [pagesLoaded count]);
	
	if([pagesLoaded count] <= 0)
	{
		NSNumber *pageLoaded = [NSNumber numberWithInt:currentFeedPage];
		[pagesLoaded addObject:pageLoaded];
	}
	else 
	{
		BOOL isEqual = NO;
		for(i=0; i<[pagesLoaded count]; i++)
		{
			NSNumber *cmpPage = (NSNumber *)[pagesLoaded objectAtIndex:i];
			
			if([cmpPage intValue] == currentFeedPage)
			{
				isEqual = YES;
				break;
			}
		}
		
		if(!isEqual)
		{
			NSNumber *pageLoaded = [NSNumber numberWithInt:currentFeedPage];
			[pagesLoaded addObject:pageLoaded];
			
			NSLog(@"-->pagesLoaded.count: %d -->added : %d", [pagesLoaded count], currentFeedPage);
		}
	}
	
//	if(currentFeedPage < maxPagesQty)
	if( (currentFeedPage < maxToLoadPage) && (currentFeedPage > minToLoadPage) )
	{
		//	if(picsLoaded >= 10)
		if( (currentLoadedImage % _pageCount) == 0) //10
		{
			currentFeedPage++;
			
			//		NSLog(@"Entering getXMLForPage:");
			NSData *myXMLData = [self getXMLForPage:currentFeedPage];
			//		NSLog(@"Finished getXMLForPage:");
			
			NSString *fileNameNoDir = [NSString stringWithFormat:@"tmp_%@_4_%i", actualId, currentFeedPage];
			
			[self getImagesXmlWithData:@"" 
								  data:myXMLData 
								 image:imageName 
								 title:titleName 
							 imageItem:imageIdItem 
							  fileName:fileNameNoDir 
							  imageIdT:imageIdType];
		}
	}
}


-(void)prepareImageButtonsArray:(int)nItems
{
	int i;
	
	if(isAdVisible)
	{
		// CGRect btnRect = CGRectMake(curPosX, curPosY, 75, 75);
		// [aWebView setFrame:btnRect];
		[myScroll addSubview:aWebView];
		curPosX += 79;		
	}

	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	
	for(i=0; i<nItems; i++)
	{
		// if( curPosX >= 320 )
		if( curPosX >= CGRectGetWidth(mainViewBounds) )
		{
			curPosX = 5;
			curPosY += 79;
		}
		
		UIImage *loadingImg = [UIImage imageNamed:@"loadingPhoto.png"];
		UIImageView *loadingImgView = [[UIImageView alloc] initWithImage:loadingImg];
		
		CGRect btnRect = CGRectMake(curPosX, curPosY, 75, 75);
		
		UIButtonThumbnail *imgBtn = [[UIButtonThumbnail alloc] initWithFrame:btnRect];
		[imgBtn addSubview:loadingImgView];
		
		[imageButtonsArray addObject:imgBtn];
		
		[myScroll addSubview:imgBtn];
		
		[imgBtn release];
		// [loadingImg release];
		[loadingImgView release];
		
		[largeImagesUrlsArray addObject:@" "];
		
		[shareUrlsArray addObject:@" "];
		
		[titlesArray addObject:@" "];

		curPosX += 79;
	}
	
	
	[myScroll setContentSize:CGSizeMake(320, curPosY+79)];

//	NSLog(@"imageButtonsArray size: %d", [imageButtonsArray count]);
	
	curPosX = 5;
	curPosY = 50; // 10

	loadingImageLoaded = YES;

	[self initStatusBar:self.view withType:1];

}




-(void)getTap:(id)sender
{
	// [waitView startAnimating];
	
	UIButtonThumbnail *tapped = (UIButtonThumbnail *)sender;
//	NSLog(@"tapped: %d",[tapped val1]);
//	NSLog(@"tapped %@", tapped);
	
	// CGRect imgVal2Rect = CGRectMake(0, 0, tapped.val2.size.width, tapped.val2.size.height);
	CGRect imgVal2Rect = self.view.frame;
	NSLog(@"fr? %@", NSStringFromCGRect(imgVal2Rect));
	
	// UIImage *bigImage = [tapped val2];

	UIViewController * tmpView = [[UIViewController alloc] init];
	tmpView.view.tag = 14010;
	tmpView.view.frame = imgVal2Rect;
	[self.view addSubview:tmpView.view];

	 if(slider == nil)
	{
		// slider = [[ImageSliderView alloc] initWithFrame:imgVal2Rect Image:bigImage];
		UIImage * tmpImage = [UIImage imageNamed:@"loading.png"];
		slider = [[ImageSliderView alloc] initWithFrame:imgVal2Rect Image:tmpImage];
		slider.imagesSliderArray = largeImagesUrlsArray;
		
		slider.titlesSliderArray = titlesArray;
		slider.shareUrlsSliderArray = shareUrlsArray;
		CGRect frame = self.view.frame;
		frame.size.height -= 150;
		//[slider scaleToFitRect:frame];
		slider.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight
		| UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin
		| UIViewAutoresizingFlexibleBottomMargin | UIViewAutoresizingFlexibleTopMargin;
		// [self.view addSubview:slider];
        //[Functions addStatusBar:slider withTabBar:YES];
		//[self initStatusBar:slider withType:2];

		[tmpView.view addSubview:slider];
        [Functions addStatusBar:tmpView.view withTabBar:YES];
		[self initStatusBar:tmpView.view withType:2];

	}

	// [self initWaitView];
	// [self showAnimated:nil];
    [Functions showAnimated:self.view];
	[slider changeView:self];
	[slider changeImageDetail:[tapped val1]];
	[slider changeActualId:actualId];
	[slider changeNumItems:_pageCount]; //10
	currentUrlIndex = [tapped val1];

	// [self hidetabbar];

    [Functions stopAnimated:self.view];
    //UIToolbar * sldToolbar = (UIToolbar *)[slider viewWithTag:11003];
    //[slider bringSubviewToFront:sldToolbar];
	[tmpView release];
}


-(void)loadImages:(NSDictionary *)myDic
{
	/*You need this for all threads you create or you will leak! */
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	
	
	[NSThread sleepForTimeInterval:0.1];
	@synchronized(myDic)
	{
//		NSLog(@"Entering Sync");
		//Load Image section
		
//		NSString *foldername = [myDic objectForKey:@"fileNameNoDir"];
		NSString *imagename = [myDic objectForKey:@"image"];
		NSNumber *myTag = [myDic objectForKey:@"myTag"];
		NSString *iconfile = [myDic objectForKey:@"iconfile"];
		
		NSString *titleStr = [myDic objectForKey:@"titleImg"];
		NSString *shareUrlStr = [myDic objectForKey:@"shareUrl"];
							  
		int i = [myTag intValue];
		
		if( curPosX >= 320 )
		{
			curPosX = 5;
			curPosY += 79;
		}
		
//		if(foldername == nil) foldername = @" ";
		
//		NSLog(@"VALUES->filename: %@ | foldername: %@",imagename, foldername);
		
//		NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
//		NSString *docDirectory = [paths objectAtIndex:0];
//		docDirectory = [docDirectory stringByAppendingPathComponent:foldername];
//		NSArray * myArray = [imagename componentsSeparatedByString: @"/"];
//		NSString* fileName = (NSString*)[myArray lastObject];
//		docDirectory = [docDirectory stringByAppendingPathComponent:fileName];
//		NSURL *imgURL     = [NSURL URLWithString:imagename];
//		NSData * imgData = [[NSData alloc] initWithContentsOfURL:imgURL];
//		UIImage * tmpImage = [[UIImage alloc] initWithData:imgData];
		NSURL *imgURL     = [NSURL URLWithString:imagename];
		NSURL *icoURL     = [NSURL URLWithString:iconfile];
		NSData * icoData = [NSData dataWithContentsOfURL:icoURL];
		UIImage * tmpImage = [[UIImage alloc] initWithData:icoData];
		
		if(largeImagesUrlsArray != nil)
			[largeImagesUrlsArray replaceObjectAtIndex:i withObject:imgURL];
		
		if(shareUrlsArray != nil)
			[shareUrlsArray replaceObjectAtIndex:i withObject:shareUrlStr];
		
		if(titlesArray != nil)
			[titlesArray replaceObjectAtIndex:i withObject:titleStr];

		//Init
		UIImageView *imgView = [[UIImageView alloc] initWithImage:tmpImage];
		imgView.frame = CGRectMake(0, 0, 75, 75);
		
		UIButtonThumbnail *imgBtn = [imageButtonsArray objectAtIndex:i];
		[imgBtn addSubview:imgView];
		[imgBtn setVal1:i];
		[imgBtn setVal2:tmpImage];
		[imgBtn addTarget:self action:@selector(getTap:) forControlEvents:UIControlEventTouchUpInside];
		
		[tmpImage release];
		[imgView release];
		//End
	}
	[self performSelectorOnMainThread:@selector(loadXMLComplete:)
						   withObject:myDic waitUntilDone:NO];
	
	//remove our pool and free the memory collected by it
	[pool release];	
}


- (void)scrollViewDidScroll:(UIScrollView *)scrollView 
{
	// CGPoint offset = [myScroll contentOffset];
	
	// NSLog(@"go: %f", offset.y);
	
	if(!scrollView.decelerating)
	{
		// [self showAnimated:nil];
        [Functions showAnimated:self.view];

		
		CGPoint offset = [myScroll contentOffset];
		
		float dist = fabs(offset.y - didScrollOffsetY);
		
		if(dist > 320)
		{
//			NSLog(@"checking from DidScroll");
			
			didScrollOffsetY = offset.y;
			
			[self checkToLoadImages:offset.y inRow:0];
			
			[self checkToLoadImages:offset.y inRow:5];
		}
	}
}

- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView
{
	CGPoint offset = [myScroll contentOffset];

	NSLog(@"checking from DidEndDecelerating");
	
	[self checkToLoadImages:offset.y inRow:0];
	
	[self checkToLoadImages:offset.y inRow:6];
	
//	[self stopAnimated:nil];
}

-(void)checkToLoadImages:(float)offsetY inRow:(int)offRow
{
	// [self showAnimated:nil];
    [Functions showAnimated:self.view];
	
	// NSLog(@"y: %f", offset.y);
	int visibleButtonRow = offsetY / 79; //79
	
	visibleButtonRow += offRow;
	
	int visibleButton = visibleButtonRow * 4;
	
	// int visiblePage = visibleButton / 4;
//	int visiblePage = offset.y / (79*(_pageCount/4)); //(790/4);
	int visiblePage = (visibleButton / _pageCount) + 1; 
	
//	NSLog(@"y: %i pg: %i",maxToLoadPage, visiblePage);
	
	NSLog(@"visibleButtonRow: %d | visiblePage: %d ",visibleButtonRow,visiblePage);

	int i=0;
	for(i=0; i<[pagesLoaded count]; i++)
	{
		NSNumber *pageLoaded = (NSNumber *)[pagesLoaded objectAtIndex:i];
		
		NSLog(@"pageLoaded: %d", [pageLoaded intValue]);
		
		if(visiblePage == [pageLoaded intValue])
		{
			// [self stopAnimated:nil];
            [Functions stopAnimated:self.view];
			return;
		}
	}
	
	currentFeedPage = visiblePage;

//	NSLog(@"currentFeedPage: %d | visibleButton: %d",currentFeedPage, visibleButton);
	
	minToLoadPage = currentFeedPage;
	maxToLoadPage = currentFeedPage; // minToLoadPage; // + 1; //+ 3;

	currentLoadedImage = (minToLoadPage-1) * _pageCount;

	NSLog(@"vb: %i vp: %i: min: %i max: %i",
		  visibleButton, visiblePage, minToLoadPage, maxToLoadPage
		  );
	
	NSData *myXMLData = [self getXMLForPage:currentFeedPage];
	
	NSString *fileNameNoDir = [NSString stringWithFormat:@"tmp_%@_4_%i", actualId, currentFeedPage];

	NSLog(@"scroll Ended: actualId: %@ | currentFeedPage: %d",actualId, currentFeedPage);
	
	[self getImagesXmlWithData:@"" 
						  data:myXMLData 
						 image:imageName 
						 title:titleName 
					 imageItem:imageIdItem 
					  fileName:fileNameNoDir 
					  imageIdT:imageIdType];
	currentFeedPage++;
	
	
	NSLog(@"got view %d", currentFeedPage);
	
}


- (void) initStatusBar:(UIView *)actualView withType:(int)type 
{
	NSLog(@"status...");
	Config *cnf = [[Config alloc] init];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	/*int tabSpace = 0;
	if ([tabbar isEqualToString:@"1"] && type != 2)
		tabSpace = 48;*/
	
	// NSString *title =@"Video";
	// UIToolbar *
	/*toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 34; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	[toolbar setFrame:CGRectMake(0, 425-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, CGRectGetHeight(mainViewBounds)-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];

	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	// toolbar.alpha = 0.7;

	
	UIView *testView = [[UIView alloc] initWithFrame:toolbar.frame];
	testView.backgroundColor = [[UIColor alloc] initWithRed:0.6 green:0.6 blue:0.65 alpha:0.7];
	testView.opaque = NO;
	CGRect toolRect = CGRectMake(0, 0, toolbar.frame.size.width, toolbar.frame.size.height);
	[toolbar setFrame:toolRect];
	[testView addSubview:toolbar];
	
//	[self.view addSubview:testView];
	[actualView addSubview:testView];*/
	
    toolbar = (UIToolbar *)[actualView viewWithTag:11003];

//	[actualView addSubview:toolbar];
	
	if (type == 1) {
		// info
		UIButton *infoButton = [UIButton buttonWithType:UIButtonTypeCustom];
		[infoButton addTarget:self action:@selector(goInfo) forControlEvents:UIControlEventTouchUpInside];
		// const NSInteger IMAGE_TAG = 1003;
		// UIImage * btnImage = [UIImage alloc];
		infoButton.frame = CGRectMake(14, 2, 30, 30);
		UIImage * btnImage = [UIImage imageNamed:@"info_icon.png"];
		// infoButton.tag = IMAGE_TAG;
		infoButton.backgroundColor = [UIColor clearColor];
		[infoButton setImage:btnImage forState:UIControlStateNormal];
		// [btnImage release];
		// [testView addSubview:infoButton];
		[toolbar addSubview:infoButton];
		// [infoButton release];
		// info

		// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
		/*
		 [button setFrame:CGRectMake(5,10,20,20)];
		 [button setTitle:@"->" forState:UIControlStateNormal];
		 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
		 */
		[button addTarget:self action:@selector(goSubmit:) forControlEvents:UIControlEventTouchUpInside];
		
		// NSString *url = @"http://72.3.226.28/clients/development/mcgrawhill/construction/construction_app_events/buttons/tab_bar_icon_photos.png";
		// NSURL *imgURL     = [NSURL URLWithString:url];
		// NSData * imgData = [NSData dataWithContentsOfURL:imgURL];
		
		// const NSInteger IMAGE_TAG = 1003;
		// UIImage * btnImage = [UIImage alloc];
		// UIImage * 
		// btnImage = [UIImage imageWithData:imgData] ; 
		btnImage = [UIImage imageNamed:@"tab_bar_icon_photos.png"];

		button.frame = CGRectMake(280, 7, 30, 30);
		// imageCell.frame = CGRectMake(250, 4, 42, 35);
		// btnImage = [UIImage imageNamed:@"tabbutton_share.png"];
		// button.tag = IMAGE_TAG;
		button.backgroundColor = [UIColor clearColor];
		// btnImage = [Functions resizeImage:btnImage width:32 height:32];
		[button setImage:btnImage forState:UIControlStateNormal];
		// [btnImage release];


		UILabel *
		label = [[UILabel alloc] initWithFrame:
				 CGRectMake(100,3,185,30)];
		label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		/*
		 NSDateFormatter *formatter = [[[NSDateFormatter alloc] init] autorelease];
		 NSDate *date = [NSDate date];
		 [formatter setDateFormat:@"MM/dd/YY HH:mm"];
		 // [label setText:[formatter stringFromDate:date]];
		 [label setText:[NSString stringWithFormat:@"Updated: %@", [formatter stringFromDate:date]]];
		 */
		NSString * displayId = [cnf loadValue:@"actualId"];
		// NSLog(@"tb: %@", tabbar);
		// NSLog(@"title: %@", self.tabBarItem.title);
		// NSLog(@"title: %i", self.tabBarController.selectedIndex);
		if ([tabbar isEqualToString:@"1"]) {
			displayId = [infoData valueForKey:@"idTab"];
		}
		NSString *newName = [NSString stringWithFormat:@"tmp_%@_4_1.xml", displayId];

		// NSLog(@"name 2: %@", newName);
		NSString *newNameValue = [cnf loadValue:newName];
		
		NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:newNameValue];
		// NSLog(@"date: %@", cnf.value);
		// NSLog(@"date 2: %@", [dateFormat stringFromDate:lastCheck]);
		
		[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
		[label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:lastCheck]]];
        [dateFormat release];
		
		label.backgroundColor = [UIColor clearColor];
		// label.backgroundColor = [UIColor blueColor];
		label.textColor = [UIColor whiteColor];
		label.font = [UIFont boldSystemFontOfSize:11];
		label.textAlignment = UITextAlignmentRight;
		
		[toolbar addSubview:label];
		[label release];
		
		UIButton *refreshButton = [UIButton buttonWithType:UIButtonTypeCustom];
		/*
		 [button setFrame:CGRectMake(5,10,20,20)];
		 [button setTitle:@"->" forState:UIControlStateNormal];
		 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
		 */
		[refreshButton addTarget:self action:@selector(goRefresh) forControlEvents:UIControlEventTouchUpInside];
		
		// const NSInteger IMAGE_TAG = 1003;
		// btnImage = [UIImage alloc];
		refreshButton.frame = CGRectMake(288, 2, 30, 30);
		// imageCell.frame = CGRectMake(250, 4, 42, 35);
		btnImage = [UIImage imageNamed:@"tabbutton_refresh.png"];
		// button.tag = IMAGE_TAG;
		refreshButton.backgroundColor = [UIColor clearColor];
		// btnImage = [Functions resizeImage:btnImage width:32 height:32];
		[refreshButton setImage:btnImage forState:UIControlStateNormal];
		// [btnImage release];
		
		[toolbar addSubview:refreshButton];
		
		// [button release];
		
		// [toolbar removeFromSuperview];
		toolbar = (UIToolbar *)[self.view viewWithTag:10001];
		[toolbar addSubview:button];


		UIWebView * webView = (UIWebView *)[self.view viewWithTag:20000];
		webView.delegate = self;

	} else if (type == 2) {
		
		//[self hidetabbar];
		hiddenTabBar = [Functions hidetabbar:hiddenTabBar
						  withViewController:self];
		
		UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
		[button addTarget:self action:@selector(goShare:) forControlEvents:UIControlEventTouchUpInside];
		// UIImage * btnImage = [UIImage alloc];
		button.frame = CGRectMake(2, 2, 30, 30);
		[button setFrame:CGRectMake(65, 2, 30, 30)];
		UIImage * btnImage = [UIImage imageNamed:@"tabbutton_share.png"];
		button.backgroundColor = [UIColor clearColor];
		[button setImage:btnImage forState:UIControlStateNormal];
		[toolbar addSubview:button];

		// detail
		UIButton *detailButton = [UIButton buttonWithType:UIButtonTypeCustom];
		[detailButton addTarget:self action:@selector(goDetail) forControlEvents:UIControlEventTouchUpInside];
		// const NSInteger IMAGE_TAG = 1003;
		// UIImage * btnImage = [UIImage alloc];
		detailButton.frame = CGRectMake(45, 2, 30, 30);
		[detailButton setFrame:CGRectMake(100, 2, 30, 30)];
		btnImage = [UIImage imageNamed:@"icon_detailview.png"];
		// detailButton.tag = IMAGE_TAG;
		detailButton.backgroundColor = [UIColor clearColor];
		[detailButton setImage:btnImage forState:UIControlStateNormal];
		// [btnImage release];
		[toolbar addSubview:detailButton];
		// [detailButton release];
		// detail
		
		
		UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		[backButton setFrame:CGRectMake(260,4,50,26)];
		[backButton setFrame:CGRectMake(5,4,50,26)];
		[backButton setTitle:@"Back" forState:UIControlStateNormal];
		[backButton addTarget:self action:@selector(goBack) forControlEvents:UIControlEventTouchUpInside];
		backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
		[toolbar addSubview:backButton];
		// [backButton release];
	}
	
	[cnf release];
	
}

- (void) goInfo {
	//NSThread *thrAni=[[NSThread alloc] initWithTarget:self
	//										 selector:@selector(showAnimated:) object:self];
	//[thrAni start];
	// [Functions updateConfig:@"goInfo" withValue:@"1"];
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:@"9"];
}

- (void) goBack {
	NSLog(@"back...");
	if(slider != nil) {
		hiddenTabBar = [Functions hidetabbar:hiddenTabBar
						  withViewController:self];
		// [self hidetabbar];
		// [toolbar removeFromSuperview];
		[slider removeFromSuperview];
		slider = nil;
		[slider release];
		showImage = FALSE;
		// [self stopAnimated:nil];
        [Functions stopAnimated:self.view];
		UIView * tmpView = (UIView *)[self.view viewWithTag:14010];
		[tmpView removeFromSuperview];
		tmpView = nil;
	}
}

-(BOOL) webView:(UIWebView *)inWeb shouldStartLoadWithRequest:(NSURLRequest *)inRequest navigationType:(UIWebViewNavigationType)inType {
	if (inType == UIWebViewNavigationTypeLinkClicked) {
		[[UIApplication sharedApplication] openURL:[inRequest URL]];
		return NO;
	}
    return YES;
}


- (void) hidetabbar {
	
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.5];
	
	for(UIView *view in self.tabBarController.view.subviews)
	{
		// NSLog(@"%@", view);
		
		if([view isKindOfClass:[UITabBar class]])
		{
			
			if (hiddenTabBar) {
				[view setFrame:CGRectMake(view.frame.origin.x, 411, view.frame.size.width, view.frame.size.height)];
			} else {
				[view setFrame:CGRectMake(view.frame.origin.x, 480, view.frame.size.width, view.frame.size.height)];
			}
		} else {
			if (hiddenTabBar) {
				[view setFrame:CGRectMake(view.frame.origin.x, view.frame.origin.y, view.frame.size.width, 411)];
			} else {
				[view setFrame:CGRectMake(view.frame.origin.x, view.frame.origin.y, view.frame.size.width, 480)];
			}
		}
	}
	
	[UIView commitAnimations];
	
	hiddenTabBar = !hiddenTabBar;
}

- (void) goSubmit:(id) sender {
	// int tabSpace = 0;
	[self hidetabbar];
	SendImageViewController * sendImg = [[SendImageViewController alloc] 
										 initWithNibName:@"SendImageViewController" bundle:[NSBundle mainBundle]];
	//									 initWithFrame:CGRectMake(0, 0, 320, 460-44-tabSpace)];
	// sendImg.frame = CGRectMake(0.0f, 0.0f, 320.0f, 460.0f);
	// sendImg.view.frame = CGRectMake(0, 0, 200, 200);
	[sendImg setParent:self];
	[self.view addSubview:sendImg.view];
//	[sendImg release];
}

- (void)didReceiveMemoryWarning 
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload 
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc 
{
    [super dealloc];
}

-(IBAction)goShare:(id) sender {
	
//	Config *cnf = [[Config alloc] initWithName:@"actualId"];
	// NSString * displayId = cnf.value;
	// if ([tabbar isEqualToString:@"1"])
	//	actualId = [infoData valueForKey:@"idTab"];
	NSString * displayId = actualId;

	NSLog(@"curr %i, pp %i, aID %@", currentUrlIndex, _pageCount, actualId);
	// return;
	
	int actImg = currentUrlIndex+1;
	int pageNo = actImg / _pageCount;
	if ((actImg % _pageCount) != 0) pageNo++;
	actImg = actImg - ((pageNo-1)*_pageCount);
	NSLog(@"actImg %i, pN %i, aID %@", actImg, pageNo, actualId);

	NSString * feedInfo = [NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, pageNo];
	/*cnf = [[Config alloc] initWithName:@"feedInfo"];
	if ([[cnf value] isEqualToString:@""] || 
		[cnf value] == nil)
		[Config insertValue:@"feedInfo" value:feedInfo];
	else
		[Config updateValue:@"feedInfo" value:feedInfo];*/
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * twitter = @""; // [[NSString alloc] init];
	NSString * email = @""; // [[NSString alloc] init];
	NSString * twitterId = @""; // [[NSString alloc] init];
	NSString * emailId = @""; // [[NSString alloc] init];
	
	NSString * facebook = @""; // [[NSString alloc] init];
	NSString * facebookId = @""; // [[NSString alloc] init];
	NSString * facebookLink = @""; // [[NSString alloc] init];
	NSString * facebookTitle = @""; // [[NSString alloc] init];
	NSString * facebookComment = @""; // [[NSString alloc] init];
	
	NSString * twitterLink = @""; // [[NSString alloc] init];
	NSString * twitterTitle = @""; // [[NSString alloc] init];
	NSString * twitterComment = @""; // [[NSString alloc] init];
	
	NSString * emailSubject = @""; // [[NSString alloc] init];
	NSString * emailSubjectTitle = @""; // [[NSString alloc] init];
	NSString * emailBodyText = @""; // [[NSString alloc] init];
	NSString * emailBodyTitle = @""; // [[NSString alloc] init];
	NSString * emailBodyLink = @""; // [[NSString alloc] init];
	
	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"idItem: %@ : %@ ", displayId, idItem);
				if ([displayId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		NSLog(@"f? %i", f);
		
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"twitter"]) {
									twitter = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"facebook"]) {
									facebook = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"email"]) {
									email = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// facebook
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:facebookId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"facebook_subject_entity"]) {
									facebookTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookTitle = [facebookTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"facebook_link"]) {
									facebookLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookLink = [facebookLink urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"facebook_comment"]) {
									facebookComment = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookComment = [facebookComment urlUnescapedString];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// twitter
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:twitterId]) {
						NSLog(@"twot..");
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"twitter_title"]) {
									twitterTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterTitle = [twitterTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"twitter_link"]) {
									twitterLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterLink = [twitterLink urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"twitter_twitt"]) {
									twitterComment = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterComment = [twitterComment urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// e-mail
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:emailId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"email_subject"]) {
									emailSubject = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailSubject = [emailSubject urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_subject_entity"]) {
									emailSubjectTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailSubjectTitle = [emailSubjectTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_body"]) {
									emailBodyText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyText = [emailBodyText urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_body_entity"]) {
									emailBodyTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyTitle = [emailBodyTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_link"]) {
									emailBodyLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyLink = [emailBodyLink urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					
					
					
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
			
			
			NSLog(@"testing ? %@ %@", urlShareName, titleName);

			// cnf = [[Config alloc] initWithName:@"selectedListItem"];
			// NSString * selectedListItem = cnf.value;
			NSString * selectedListItem = [NSString stringWithFormat:@"%i", actImg]; // cnf.value;
			selectedListItem = [NSString stringWithFormat:@"%i", [selectedListItem intValue]-1];
			// NSString * selectedListItem = [cnf loadValue:@"selectedListItem"];
			// cnf = [[Config alloc] initWithName:@"feedInfo"];
			// NSString * feedInfo = [cnf loadValue:@"feedInfo"];
			// NSURL *u = [NSURL URLWithString:feedInfo];
			NSLog(@"fil: %@", feedInfo); 
			NSLog(@"sel: %@", selectedListItem); 

			NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			NSString *documentsDir = [documentPaths objectAtIndex:0];
			NSString *fileName = [documentsDir stringByAppendingPathComponent:feedInfo];
			NSLog(@"fil: %@", fileName); 
			NSData *myXMLData = [NSData dataWithContentsOfFile:fileName];
			NSString *unescaped = [[[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding] autorelease];
			unescaped = [unescaped htmlUnescapedString];
			// selectedListItem = [NSString stringWithFormat:@"%i", [selectedListItem intValue]-1];
			
			TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
			TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
            [tbxml release];
			if (rootXMLElement) {
				childXMLElement = rootXMLElement->firstChild;
				do {
					NSLog(@"tt: %@", [TBXML elementName:childXMLElement]);
					if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
						TBXMLElement * dataXMLElement = childXMLElement->firstChild;
						// NSInteger total = 1;
						int counter = 0;
						do {
							NSLog(@"dd: %@ - %@", [TBXML elementName:dataXMLElement], selectedListItem);
							// NSLog(@"ct: %i", counter);
							if ([selectedListItem isEqualToString:[NSString stringWithFormat:@"%i", counter]]) {
								TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
								do {
									NSLog(@"ii: %@", [TBXML elementName:itemXMLElement]);
									if ([[TBXML elementName:itemXMLElement] isEqualToString:facebookTitle]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										facebookTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:facebookLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										facebookLink = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:twitterTitle]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										twitterTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:twitterLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										twitterLink = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailSubjectTitle]) {
										NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailSubjectTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailBodyTitle]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailBodyTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailBodyLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailBodyLink = titleText;
									}
								} while ((itemXMLElement = itemXMLElement->nextSibling));
								// CGRect descriptionLabelFrame = CGRectMake(10, titleTextSize.height+imgHeight+60, 300, descriptionTextSize.height);
								// descriptionLabel.frame = descriptionLabelFrame;
								// total++;
								// self.view.frame = CGRectMake(0, 0, 320,titleTextSize.height+imgHeight+descriptionTextSize.height);
							}
							counter++;
						} while ((dataXMLElement = dataXMLElement->nextSibling));
					}
				} while ((childXMLElement = childXMLElement->nextSibling));
			}
			
		}
		
	}
	
	NSLog(@"tw: %@", twitter);

	[shareView.view removeFromSuperview];
	shareView = [ShareViewController sharedManager];
	
	[shareView setMailSubject:[NSString stringWithFormat:@"%@ : %@", emailSubject, emailSubjectTitle]];
	NSString * message = [NSString stringWithFormat:@"<p>%@\n"
						  "<br /><br /> \n"
						  "<a href=\"%@\">%@</a> \n"
						  "<br />%@<br /><br /> \n"
						  "</p>\n",
						  emailBodyText, emailBodyLink, emailBodyTitle, emailBodyLink];
	
	[shareView setMailText:message];
	
	[shareView setTextTitle:textTitle];
	[shareView setTextDescription:textUrl];
	[shareView setTextUrl:textUrl];
	
	[shareView setUseMail:email];
	[shareView setUseFacebook:facebook];
	[shareView setUseTwitter:twitter];
	
	[shareView setFacebookTitle:facebookTitle];
	[shareView setFacebookDescription:facebookComment];
	[shareView setFacebookLink:facebookLink];
	
	[shareView setTwitterTitle:twitterTitle];
	[shareView setTwitterDescription:twitterComment];
	[shareView setTwitterLink:twitterLink];
	
	[self.view addSubview:shareView.view];
	// popupView.view.frame = CGRectMake(0, self.view.frame.size.height,320,100);
	shareView.view.frame = CGRectMake(0,460,320,460);
	shareView.view.frame = CGRectMake(0,self.view.frame.size.height,self.view.frame.size.width,self.view.frame.size.height);
    // [popupView setFrame:CGRectOffset([popupView frame], 0, popupView.frame.size.height)]; // Move it up top and off screen
	[UIView beginAnimations:@"animateImageOn" context:NULL]; // Begin animation
	[shareView.view setFrame:CGRectOffset([shareView.view frame], 0, -shareView.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
}

-(void)hideShare {
    [NSObject cancelPreviousPerformRequestsWithTarget: self];
	[UIView beginAnimations:@"animateImageOff" context:NULL]; // Begin animation
	// [shareView.view setFrame:CGRectOffset([shareView.view frame], 0, shareView.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
}

- (void) goDetail {
	[slider goDetail];
	return;
	
	// [self showAnimated:nil];
	maxPages = 0;
	Config *cnf = [[Config alloc] init];
	// NSString * 
	actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	
	
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * feedsXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * detailId = @"0";
	
	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"slide_detail"]) {
									detailId = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
		}		
	}
	
	NSLog(@"detail %@", detailId);
	
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	// [Functions updateConfig:@"selectedListItem" withValue:[NSString stringWithFormat:@"%i", (int)pageControl.currentPage]];
	[cnf updateValue:@"goUrl" value:@"---"];
	[cnf updateValue:@"displayId" value:detailId];
	// [Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, currentFeedPage]];
	[cnf updateValue:@"currentFeedPage" value:[NSString stringWithFormat:@"%i", currentFeedPage]];
	
	[cnf release];
	
	[appDelegate displayView:@"7"];
}


#pragma mark TapDetectingImageViewDelegate methods  

- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event 
{
	UITouch *aTouch = [touches anyObject];
    if (aTouch.tapCount == 2) {
		[NSObject cancelPreviousPerformRequestsWithTarget:self];
	}	
}

- (void) touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event 
{
	UITouch *theTouch = [touches anyObject];
	//CGPoint currentTouchPosition = [theTouch locationInView:self.view];
	NSDictionary *touchLoc = [NSDictionary dictionaryWithObject:
							  [NSValue valueWithCGPoint:[theTouch locationInView:self.view]] forKey:@"location"];
	
    /*if (theTouch.tapCount == 1) {
		[self performSelector:@selector(handleSingleTap:) withObject:touchLoc afterDelay:0.3];
	} 
	else*/ 
	if (theTouch.tapCount == 2) {
		[self performSelector:@selector(handleDoubleTap:) withObject:touchLoc afterDelay:0.01];
	}	
}

- (void)handleDoubleTap:(UIGestureRecognizer *)gestureRecognizer 
{  
	// single tap does nothing for now  
	NSLog(@"double tap ist");
    [Functions stopAnimated:self.view];
	[slider goDetail];
}  

@end
