//
//  ListViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 10/28/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Element.h"


@interface ListViewController : UIViewController <UITableViewDataSource, UITableViewDelegate, UISearchBarDelegate> {

	NSMutableArray * feeds;
	NSMutableArray * elements;
	NSMutableArray * searchResults;
	UITableView * tableView;
	UIViewController *popupView;
	UISearchBar *searchBar;
	BOOL searching;
	BOOL letUserSelectRow;
	NSString *feedSource;
	UIToolbar *toolbar;
	UILabel * label;
	UIActivityIndicatorView *waitView;
	UILabel *waitLabel;
    NSDictionary * infoData;
}

@property (nonatomic, retain) NSMutableArray * feeds;
@property (nonatomic, retain) NSMutableArray * elements;
@property (nonatomic, retain) NSMutableArray * searchResults;
@property (nonatomic,retain) IBOutlet UITableView * tableView;
@property (nonatomic,retain) NSString *feedSource;
@property (nonatomic, retain) UILabel *waitLabel;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
-(void) searchTableView;
- (void) processXml:(NSMutableData *)myXMLData;
- (void)showXML;
-(void)loadView:(Element *) element;
-(NSString *) reviewLinkType: (NSString *)linkName: (NSString *)linkType;
- (void) initStatusBar:(UIView *)actualView;
+ (id)sharedManager;

@end
