//
//  ShareViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 11/5/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MessageUI/MessageUI.h>
#import <MessageUI/MFMailComposeViewController.h>
#import "FBConnect.h"
#import "SA_OAuthTwitterController.h"

@class SA_OAuthTwitterEngine;

@interface ShareViewController : UIViewController <MFMailComposeViewControllerDelegate, FBRequestDelegate,
FBDialogDelegate, FBSessionDelegate, SA_OAuthTwitterControllerDelegate> {
	NSString * mailSubject;
	NSString * mailText;
	
	NSString * textTitle;
	NSString * textDescription;
	NSString * textUrl;
	NSString * useMail;
	
	Facebook *facebook;
	NSString * facebookTitle;
	NSString * facebookDescription;
	NSString * facebookLink;
	NSString * useFacebook;

	NSArray* permissions;
	
	SA_OAuthTwitterEngine				*_engine;
	UIView *twitterView;
	UITextView * twitterMessageText;
	NSString * twitterTitle;
	NSString * twitterDescription;
	NSString * twitterLink;
	NSString * useTwitter;
	
	NSString* kAppId;
	NSString* kOAuthConsumerKey;
	NSString* kOAuthConsumerSecret;
	
}

@property (nonatomic, retain) NSString *mailSubject;
@property (nonatomic, retain) NSString *mailText;
@property (nonatomic, retain) NSString * textTitle;
@property (nonatomic, retain) NSString * textDescription;
@property (nonatomic, retain) NSString * textUrl;

@property (nonatomic, retain) NSString * facebookTitle;
@property (nonatomic, retain) NSString * facebookDescription;
@property (nonatomic, retain) NSString * facebookLink;
@property (nonatomic, retain) NSString * twitterTitle;
@property (nonatomic, retain) NSString * twitterDescription;
@property (nonatomic, retain) NSString * twitterLink;

@property (nonatomic, retain) NSString * useMail;
@property (nonatomic, retain) NSString * useTwitter;
@property (nonatomic, retain) NSString * useFacebook;

@property (nonatomic, retain) NSString* kAppId;
@property (nonatomic, retain) NSString* kOAuthConsumerKey;
@property (nonatomic, retain) NSString* kOAuthConsumerSecret;

- (IBAction) hideShare:(id)sender;
- (IBAction) sendMail:(id)sender;
- (void) sendFacebook:(id) sender;
-(IBAction) fbButtonClick: (id) sender;
-(IBAction) twButtonClick: (id) sender;
-(void) createTwitterView;
-(IBAction) sendTwitter: (id) sender;
+ (id)sharedManager;

@end
