//
//  ThumbnailViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 2/1/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ThumbnailViewController.h"
#import "Config.h"
#import "TBXML.h"
#import "Functions.h"
#import "NSString+HTML.h"
#import "ImageViewController.h"
#import "SendImageViewController.h"

@implementation ThumbnailViewController

@synthesize imagesArray;
@synthesize titlesArray;
@synthesize textUrl, textTitle; //, linkRef, linkType;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	UIImageView *backView = [[UIImageView alloc] init];;
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	[backView setImage:[UIImage imageWithData:imgData]];
	backView.frame = CGRectMake(0, 0, 320, 420);
	[self.view addSubview:backView];
	[backView release];
	
	showImage = FALSE;
	[self processInfo];
}

-(void) viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	NSLog(@"oeoeo");
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

- (void)processInfo {
	maxPages = 0;
	// bh	
	self.imagesArray = [NSMutableArray array];
	NSMutableArray * aImages; // = [[NSMutableArray init] alloc];
	NSMutableArray * aTitles; // = [[NSMutableArray init] alloc];
	// NSString *feedSource; // = [[NSString init] alloc];
	// UILabel *counter;
	
	Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	
	// NSLog@(@"oooooooooooooo o o o oooooo %@", actualId);
	//tabbar
	NSString * currentFeed = [cnf loadValue:@"currentFeedPage"];
	currentFeedPage=1;
	if ([currentFeed intValue] != currentFeedPage)
		currentFeedPage = [currentFeed intValue];
	if (currentFeedPage == 0) currentFeedPage = 1;
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * feedsXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * title = @"Gallery";
	NSString * url = @"";
	NSString * imageName = @"";
	NSString * titleName = @"";
	NSString * imageIdItem = @"";
	// NSString * titleIdItem = @"";
	NSString * imageIdType = @"";
	// NSString * titleIdType = @"";
	NSLog(@"root");
	if (root) {
		BOOL f = FALSE;
		
		childXMLElement = root->firstChild;
		
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						if (childXMLElement)
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"tab_bar"]) {
								}
								if ([attribItem isEqualToString:@"data_source"]) {
									url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"slide_title"]) {
									titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"slide_image"]) {
									imageName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
								// NSLog(@"url? %@", url);
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
			
			imageIdItem = @"";
			imageIdType = @"";
			// titleIdItem = @"";
			// titleIdType = @"";
			
		}
		
	}
	
	// [Functions initToolBar:self.view withTitle:@"Gallery" withView:YES];
	[Functions initToolBar:self.view withTitle:title]; // withTitle:@"Gallery" withView:NO];
	
	aImages = [[NSMutableArray alloc] init];
	aTitles = [[NSMutableArray alloc] init];
	
	// feedSource = url;
	//NSURL *u = [NSURL URLWithString:url];
	url=[url stringByReplacingOccurrencesOfString:@"page_num=1"
									   withString:@"page_num=%i"];
	NSLog(@"URL - FINAL %@", [NSString stringWithFormat:url, currentFeedPage]);
	
	NSURL *u = [NSURL URLWithString:[NSString stringWithFormat:url, currentFeedPage]];
	// NSString *xmlFile = [NSString stringWithContentsOfURL:u];
	NSData *myXMLData; //   = [NSData dataWithContentsOfURL:u];
	// [myXMLData writeToFile:databasePath atomically:YES];
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	NSString *databaseName = [NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, currentFeedPage];
	// cnf = [[Config alloc] initWithName:databaseName];
	[cnf updateValue:@"feedSource" value:databaseName];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage]];
	
	NSString *feedSourceValue = [cnf loadValue:@"feedSource"];
	
	NSLog(@"fil: %@", fileName);
	NSLog(@"fsr: %@", feedSourceValue);
	if([feedSourceValue isEqualToString:@""] || feedSourceValue == nil
	   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		myXMLData = [NSData dataWithContentsOfURL:u];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];  
		[cnf updateValue:databaseName value:dateString];
	} else {
		
		NSLog(@"use ... ");
		NSTimeInterval dateTime;		
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:feedSourceValue];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);  
		if(dateTime > 1) {
			NSLog(@"down (2)... ");
			myXMLData = [NSData dataWithContentsOfURL:u];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			// [dateFormat release];
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage] value:dateString];
			
			NSFileManager* fileManager = [NSFileManager defaultManager];
			fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage]];
			[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
			
			NSError *error = nil;
			for (NSString *file in [fileManager contentsOfDirectoryAtPath:fileName error:&error]) {
				BOOL success = [fileManager removeItemAtPath:[NSString stringWithFormat:@"%@/%@", fileName, file] error:&error];
				if (!success || error) {
					// it failed.
					// NSLog(@"err: %@%@", fileName, file);
				} else {
					// NSLog(@"del: %@%@", fileName, file);
				}
			}
		} else {
			myXMLData = [NSData dataWithContentsOfFile:fileName];
		}
	}
    [dateFormat release];
	// NSLog(@"bk: %@", fileName);
	[myXMLData writeToFile:fileName atomically:YES];
	// fill images
	imagesArray = [[NSMutableArray alloc] init];
	dataArray = [[NSMutableArray alloc] init];
	// [self addImageFromName:@"1.png"];
	// [self addImageFromName:@"2.png"];
	// [self addImageFromName:@"3.png"];
	// [self addImageFromName:@"4.png"];
	// [self addImageFromName:@"5.png"];
	
	NSFileManager* fileManager = [NSFileManager defaultManager];
	fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage]];
	[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
	
	/*
	 NSFileManager* fileManager = [NSFileManager defaultManager];
	 NSString* documentsDir = [filePath stringByDeletingLastPathComponent];
	 NSString *tmpPath = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage]];
	 [fileManager createDirectoryAtPath:tmpPath attributes:nil];
	 */
	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	root = tbxml.rootXMLElement;
    [tbxml release];
	if (root) {
		childXMLElement = root->firstChild;
		do {
			NSLog(@"st: %@ - %@", imageName, [TBXML elementName:childXMLElement]);
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
				TBXMLElement * dataXMLElement = childXMLElement->firstChild;
				NSString * num_items = [TBXML valueOfAttributeNamed:@"num_items" forElement:childXMLElement];
				maxSlideNumber=[num_items intValue];
				do {
				TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
					NSString * image = @"";
					NSString * imgTitle = @"";
					// BOOL tmpImage = FALSE;
					// if(itemXMLElement)
					do {
						NSLog(@"im: %@ - %@", imageName, [TBXML elementName:itemXMLElement]);
						
						if ([[TBXML elementName:itemXMLElement] isEqualToString:imageName]) {
							NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							// element.image = [TBXML textForElement:itemXMLElement];
							image = [TBXML textForElement:itemXMLElement];
							[self addImageFromName:image 
							 			withFolder:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage]
							 ];
							// tmpImage = TRUE;
							// NSLog(@"u: %@", image);
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:titleName]) {
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							// element.image = [TBXML textForElement:itemXMLElement];
							imgTitle = [TBXML textForElement:itemXMLElement];
							// NSLog(@"t: %@", title);
						}
					} while ((itemXMLElement = itemXMLElement->nextSibling));
					// [self.aImages addObject: image];
					// tmpImage = FALSE;
					NSMutableArray *imageData = [NSArray arrayWithObjects: image, imageIdItem, imageIdType, nil];
					// NSLog(@"img: %@ ** %@ ** %@ ** ...", image, imageIdItem, imageIdType);
					[aImages addObject: imageData];
					[dataArray addObject: imageData];
					// NSMutableArray *titleData = [NSArray arrayWithObjects: title, titleIdItem, titleIdType, nil];
					// [aTitles addObject: titleData];
					[aTitles addObject: imgTitle];
					// [image release];
					// [images addObject:[TBXML valueOfAttributeNamed:@"url" forElement:childXMLElement]];
					maxPages++;
					// NSString *str = [[NSString alloc] initWithString:@"blah"]; 
					// [array addObject: str];
					// [str release];
				} while ((dataXMLElement = dataXMLElement->nextSibling));
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
	}
	//	NSLog(@" im: %@", aImages);
    [aImages release];

	int a = 5;
	int b = 50; // 10
	// self.imagesArray = [NSMutableArray array];
	
	titlesArray = [[NSMutableArray alloc] init];
	[self.titlesArray addObjectsFromArray:aTitles];
    [aTitles release];
	
	int counter = [imagesArray count];
	if (counter > 20) counter = 20;
	for( int i=1; i<=counter; i++ )
	{
		// [self.xArray addObject:[UIImage imageNamed:[NSString stringWithFormat:@"%dth.png",i]]];		
		// NSURL *imgURL     = [NSURL URLWithString:[[aImages objectAtIndex:i] objectAtIndex:0]];
		// NSLog(@"img: %@", imgURL);
		// NSData * imgData = [NSData dataWithContentsOfURL:imgURL];
		// [self.imagesArray addObject:[UIImage imageWithData:imgData]];

		
		if( a >= 320 )
		{
			a = 4;
			b += 79;
		}
		/*imageInfo * thumb = [imagesArray objectAtIndex:i-1];
		[thumb scaleToFitRect:CGRectMake(0,0,100,100)];
		[thumb setOffset:a:b];
		[thumb resizeImage:60:60];
		[self.view addSubview:thumb];*/

		
		NSString * foldername = [NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage];
		NSString * imagename = [[dataArray objectAtIndex:i-1] objectAtIndex:0];
		NSArray *paths = NSSearchPathForDirectoriesInDomains(
															 NSDocumentDirectory, NSUserDomainMask, YES);
		NSString *docDirectory = [paths objectAtIndex:0];
		docDirectory = [docDirectory stringByAppendingPathComponent:foldername];
		NSArray * myArray = [imagename componentsSeparatedByString: @"/"];
		NSString* fileName = (NSString*)[myArray lastObject];
		docDirectory = [docDirectory stringByAppendingPathComponent:fileName];
		// NSLog(@"fil: %@", docDirectory);
		NSData * imgData = [NSData dataWithContentsOfFile:docDirectory];
		UIImage * tmpImage = [UIImage imageWithData:imgData];
		UIImageView *any = [[UIImageView alloc] initWithFrame:CGRectMake(a,b,75,75)];
		any.image = [Functions resizeImage:tmpImage width:75 height:75];
		any.tag = i;
		[self.view addSubview:any];
		[any release];
		a += 79;
	}
	
	[cnf release];
	
	[self initStatusBar:self.view withType:1];
}

- (void) goRefresh {
}

- (void) goDetail {
}

- (void) goBack {
	NSLog(@"back...");
	if (imgCont != nil) {
		[self hidetabbar];
		[toolbar removeFromSuperview];
		[imgCont.view removeFromSuperview];
		imgCont = nil;
		[imgCont release];
		showImage = FALSE;
	}
}

- (void) goSubmit:(id) sender {
	// int tabSpace = 0;
	[self hidetabbar];
	SendImageViewController * sendImg = [[SendImageViewController alloc] 
										 initWithNibName:@"SendImageViewController" bundle:[NSBundle mainBundle]];
//									 initWithFrame:CGRectMake(0, 0, 320, 460-44-tabSpace)];
	// sendImg.frame = CGRectMake(0.0f, 0.0f, 320.0f, 460.0f);
	// sendImg.view.frame = CGRectMake(0, 0, 200, 200);
	[sendImg setParent:self];
	[self.view addSubview:sendImg.view];
	[sendImg release];
}


-(void) touchesEnded: (NSSet *) touches withEvent: (UIEvent *) event 
{	
	if (imgCont != nil) {
		[imgCont touchesEnded:touches withEvent:event];
		UITouch *theTouch = [touches anyObject];
		//CGPoint currentTouchPosition = [theTouch locationInView:self.view];
		NSDictionary *touchLoc = [NSDictionary dictionaryWithObject:
								  [NSValue valueWithCGPoint:[theTouch locationInView:self.view]] forKey:@"location"];
		
		// if (theTouch.tapCount == 1) {
		//	[self performSelector:@selector(handleSingleTap:) withObject:touchLoc afterDelay:0.3];
		//} 
		if (theTouch.tapCount == 2) {
			// [self performSelector:@selector(handleDoubleTap:) withObject:touchLoc afterDelay:0.01];
			[imgCont handleDoubleTap:touchLoc];
		}	
	}
	if (showImage) return;
	for (UITouch *touch in touches)
	{
		for (int i = 1; i <= [self.view subviews].count; i++)
		{
			if(CGRectContainsPoint([[self.view viewWithTag:i]frame], [touch locationInView:self.view]) )
			{
				if (i >= [imagesArray count]) i = [imagesArray count];
				// NSLog(@"tit: %@", [titlesArray objectAtIndex:i]);
					/*
				DetailView *any = [[DetailView alloc] initWithNibName:@"DetailView" bundle:nil];
				any.xImage = [xArray objectAtIndex:i-1];
				[self.navigationController pushViewController:any animated:YES];
				[any release];
				 */
				showImage = TRUE;
				NSLog(@"c: %i - i: %i", [imagesArray count], i-1);
				//NSLog(@"name: %@ %@", 
				//	  [titlesArray objectAtIndex:i-1],
				//	  [dataArray objectAtIndex:i-1]);
				imageInfo * thumb = [imagesArray objectAtIndex:i-1];
				if (imgCont != nil) [imgCont release];
				Config *cnf = [[Config alloc] init];
				NSString * tabbar = [cnf loadValue:@"useTabBar"];
				int tabSpace = 0;
				if ([tabbar isEqualToString:@"1"])
					tabSpace = 0; //44;
				NSLog(@"tab: %i", tabSpace);

				// [Config updateValue:@"selectedListItem" value:[NSString stringWithFormat:@"%i", i-1]];
				[cnf updateValue:@"selectedListItem" value:[NSString stringWithFormat:@"%i", i-1]];

				imgCont = [[ImageViewController alloc] 
												 initWithThumb:thumb
												 withTitle:[titlesArray objectAtIndex:i-1] // [aTitles objectAtIndex:i]
												 withFrame:CGRectMake(0, 0, 320, 460-tabSpace)];
				textTitle = [titlesArray objectAtIndex:i-1];
				textUrl =  [[dataArray objectAtIndex:i-1] objectAtIndex:0];
				[imgCont setPageIndex:i];
				imgCont.view.userInteractionEnabled = NO; //
				// [self.navigationController pushViewController:imgCont animated:YES];
				[self.view addSubview:imgCont.view];
				[self initStatusBar:self.view withType:2];
				// [imgCont changeZoomMode: YES];
				// [imgCont.view setUserInteractionEnabled:YES];
				// [self.view setUserInteractionEnabled:NO];
				
				[cnf release];
				
			}
		}
	}

}

- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event 
{
	UITouch *aTouch = [touches anyObject];
    if (aTouch.tapCount == 2) {
		[NSObject cancelPreviousPerformRequestsWithTarget:self];
	}	
	// if(zoomMode == YES) {
	//	ImageViewController * imagecont = [self getCurrentController];
	if (imgCont != nil)
	[imgCont touchesBegan:touches withEvent:event];
	// }
}

- (void) touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event 
{
	if (imgCont != nil)
		[imgCont touchesMoved:touches withEvent:event];
}

- (void) touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event 
{
	if (imgCont != nil)
		[imgCont touchesCancelled:touches withEvent:event];
}

- (imageInfo*) getCurrentImage
{
	return [imagesArray objectAtIndex:pageIndex];
}

- (void) addImageFromName:(NSString*)imagename
			   withFolder:(NSString *)foldername
{
	imageInfo * thumb = [[imageInfo alloc] initWithName:imagename withFolder:foldername withParentFrame:self.view.frame]; 
	[imagesArray addObject:thumb];
	[thumb release];
}

- (void) initStatusBar:(UIView *)actualView withType:(int)type {
	NSLog(@"status...");
	Config *cnf = [[Config alloc] init];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	int tabSpace = 0;
	if ([tabbar isEqualToString:@"1"] && type != 2)
		tabSpace = 48;

	// NSString *title =@"Video";
	// UIToolbar *
	toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	[toolbar setFrame:CGRectMake(0, 420-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];

	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	toolbar.alpha = 0.7;
	
	[actualView addSubview:toolbar];
	
	if (type == 1) {

		// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
		[button addTarget:self action:@selector(goSubmit:) forControlEvents:UIControlEventTouchUpInside];
	
		NSString *url = @"http://72.3.226.28/clients/development/mcgrawhill/construction/construction_app_events/buttons/tab_bar_icon_photos.png";
		NSURL *imgURL     = [NSURL URLWithString:url];
		NSData * imgData = [NSData dataWithContentsOfURL:imgURL];

		// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
		UIImage * btnImage = [UIImage imageWithData:imgData] ; 
	button.frame = CGRectMake(280, 7, 30, 30);
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	// btnImage = [UIImage imageNamed:@"tabbutton_share.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];

		toolbar = (	UIToolbar *)[self.view viewWithTag:10001];
	
	[toolbar addSubview:button];
	
	// [button release];
	
	/*
	 UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	 [button setFrame:CGRectMake(260,10,50,26)];
	 [button setTitle:@"View" forState:UIControlStateNormal];
	 [button addTarget:self action:@selector(goView:) forControlEvents:UIControlEventTouchUpInside];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 [toolbar addSubview:button];
	 // [button release];
	 */
	} else if (type == 2) {

		[self hidetabbar];

		UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
		[button addTarget:self action:@selector(goShare:) forControlEvents:UIControlEventTouchUpInside];
		button.frame = CGRectMake(2, 2, 30, 30);
		UIImage * btnImage = [UIImage imageNamed:@"tabbutton_share.png"];
		button.backgroundColor = [UIColor clearColor];
		[button setImage:btnImage forState:UIControlStateNormal];
		[toolbar addSubview:button];

		
		UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[backButton setFrame:CGRectMake(260,7,50,26)];
	[backButton setTitle:@"Back" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(goBack) forControlEvents:UIControlEventTouchUpInside];
	backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[toolbar addSubview:backButton];
	// [backButton release];
	}
	
	[cnf release];
}

- (void) hidetabbar {
	
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.5];
	
	for(UIView *view in self.tabBarController.view.subviews)
	{
		// NSLog(@"%@", view);
		
		if([view isKindOfClass:[UITabBar class]])
		{
			
			if (hiddenTabBar) {
				[view setFrame:CGRectMake(view.frame.origin.x, 411, view.frame.size.width, view.frame.size.height)];
			} else {
				[view setFrame:CGRectMake(view.frame.origin.x, 480, view.frame.size.width, view.frame.size.height)];
			}
		} else {
			if (hiddenTabBar) {
				[view setFrame:CGRectMake(view.frame.origin.x, view.frame.origin.y, view.frame.size.width, 411)];
			} else {
				[view setFrame:CGRectMake(view.frame.origin.x, view.frame.origin.y, view.frame.size.width, 480)];
			}
			
		}
	}
	
	[UIView commitAnimations];
	
	hiddenTabBar = !hiddenTabBar;
}

-(IBAction)goShare:(id) sender {
	
	Config *cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * twitter = @""; // [[NSString alloc] init];
	NSString * email = @""; // [[NSString alloc] init];
	NSString * twitterId = @""; // [[NSString alloc] init];
	NSString * emailId = @""; // [[NSString alloc] init];
	
	NSString * facebook = @""; // [[NSString alloc] init];
	NSString * facebookId = @""; // [[NSString alloc] init];
	NSString * facebookLink = @""; // [[NSString alloc] init];
	NSString * facebookTitle = @""; // [[NSString alloc] init];
	NSString * facebookComment = @""; // [[NSString alloc] init];
	
	NSString * twitterLink = @""; // [[NSString alloc] init];
	NSString * twitterTitle = @""; // [[NSString alloc] init];
	NSString * twitterComment = @""; // [[NSString alloc] init];
	
	NSString * emailSubject = @""; // [[NSString alloc] init];
	NSString * emailSubjectTitle = @""; // [[NSString alloc] init];
	NSString * emailBodyText = @""; // [[NSString alloc] init];
	NSString * emailBodyTitle = @""; // [[NSString alloc] init];
	NSString * emailBodyLink = @""; // [[NSString alloc] init];
	
	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"idItem: %@ : %@ ", displayId, idItem);
				if ([displayId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		NSLog(@"f? %i", f);
		
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"twitter"]) {
									twitter = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"facebook"]) {
									facebook = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"email"]) {
									email = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// facebook
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:facebookId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"facebook_subject_entity"]) {
									facebookTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookTitle = [facebookTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"facebook_link"]) {
									facebookLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookLink = [facebookLink urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"facebook_comment"]) {
									facebookComment = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookComment = [facebookComment urlUnescapedString];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// twitter
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:twitterId]) {
						NSLog(@"twot..");
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"twitter_title"]) {
									twitterTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterTitle = [twitterTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"twitter_link"]) {
									twitterLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterLink = [twitterLink urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"twitter_twitt"]) {
									twitterComment = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterComment = [twitterComment urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// e-mail
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:emailId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"email_subject"]) {
									emailSubject = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailSubject = [emailSubject urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_subject_entity"]) {
									emailSubjectTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailSubjectTitle = [emailSubjectTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_body"]) {
									emailBodyText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyText = [emailBodyText urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_body_entity"]) {
									emailBodyTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyTitle = [emailBodyTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_link"]) {
									emailBodyLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyLink = [emailBodyLink urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					
					
					
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
			// cnf = [[Config alloc] init];
			NSString * selectedListItem = [cnf loadValue:@"selectedListItem"];
			// cnf = [[Config alloc] initWithName:@"feedSource"];
			NSString * feedSource = [cnf loadValue:@"feedSource"];
			// NSURL *u = [NSURL URLWithString:feedSource];
			NSLog(@"fil: %@", feedSource); 
			
			NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			NSString *documentsDir = [documentPaths objectAtIndex:0];
			NSString *fileName = [documentsDir stringByAppendingPathComponent:feedSource];
			NSLog(@"fil: %@", fileName); 
			NSData *myXMLData = [NSData dataWithContentsOfFile:fileName];
			NSString *unescaped = [[[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding] autorelease];
			unescaped = [unescaped htmlUnescapedString];
			
			TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
			
			TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
            [tbxml release];
			if (rootXMLElement) {
				childXMLElement = rootXMLElement->firstChild;
				do {
					NSLog(@"tt: %@", [TBXML elementName:childXMLElement]);
					if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
						TBXMLElement * dataXMLElement = childXMLElement->firstChild;
						// NSInteger total = 1;
						int counter = 0;
						do {
							NSLog(@"dd: %@ - %@", [TBXML elementName:dataXMLElement], selectedListItem);
							if ([selectedListItem isEqualToString:[NSString stringWithFormat:@"%i", counter]]) {
								TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
								do {
									NSLog(@"tt: %@", [TBXML elementName:itemXMLElement]);
									if ([[TBXML elementName:itemXMLElement] isEqualToString:facebookTitle]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										facebookTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:facebookLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										facebookLink = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:twitterTitle]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										twitterTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:twitterLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										twitterLink = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailSubjectTitle]) {
										NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailSubjectTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailBodyTitle]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailBodyTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailBodyLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailBodyLink = titleText;
									}
								} while ((itemXMLElement = itemXMLElement->nextSibling));
								// CGRect descriptionLabelFrame = CGRectMake(10, titleTextSize.height+imgHeight+60, 300, descriptionTextSize.height);
								// descriptionLabel.frame = descriptionLabelFrame;
								// total++;
								// self.view.frame = CGRectMake(0, 0, 320,titleTextSize.height+imgHeight+descriptionTextSize.height);
							}
							counter++;
						} while ((dataXMLElement = dataXMLElement->nextSibling));
					}
				} while ((childXMLElement = childXMLElement->nextSibling));
			}
			
		}
		
	}
	
	NSLog(@"tw: %@", twitter);
	
	
	[shareView.view removeFromSuperview];
	shareView = [ShareViewController sharedManager];
	
	[shareView setMailSubject:[NSString stringWithFormat:@"%@ : %@", emailSubject, emailSubjectTitle]];
	NSString * message = [NSString stringWithFormat:@"<p>%@\n"
						  "<br /><br /> \n"
						  "<a href=\"%@\">%@</a> \n"
						  "<br />%@<br /><br /> \n"
						  "</p>\n",
						  emailBodyText, emailBodyLink, emailBodyTitle, emailBodyLink];
	
	[shareView setMailText:message];
	
	[shareView setTextTitle:textTitle];
	[shareView setTextDescription:textUrl];
	[shareView setTextUrl:textUrl];
	
	[shareView setUseMail:email];
	[shareView setUseFacebook:facebook];
	[shareView setUseTwitter:twitter];
	
	[shareView setFacebookTitle:facebookTitle];
	[shareView setFacebookDescription:facebookComment];
	[shareView setFacebookLink:facebookLink];
	
	[shareView setTwitterTitle:twitterTitle];
	[shareView setTwitterDescription:twitterComment];
	[shareView setTwitterLink:twitterLink];
	
	[self.view addSubview:shareView.view];
	// popupView.view.frame = CGRectMake(0, self.view.frame.size.height,320,100);
	shareView.view.frame = CGRectMake(0,460,320,460);
    // [popupView setFrame:CGRectOffset([popupView frame], 0, popupView.frame.size.height)]; // Move it up top and off screen
	[UIView beginAnimations:@"animateImageOn" context:NULL]; // Begin animation
	[shareView.view setFrame:CGRectOffset([shareView.view frame], 0, -shareView.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
	
	[cnf release];
}

-(void)hideShare {
    [NSObject cancelPreviousPerformRequestsWithTarget: self];
	[UIView beginAnimations:@"animateImageOff" context:NULL]; // Begin animation
	// [shareView.view setFrame:CGRectOffset([shareView.view frame], 0, shareView.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
}

@end
