//
//  TwitterViewController.h
//  app_builder
//
//  Created by ivan bejarano on 6/22/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "SA_OAuthTwitterController.h"
#import "ListSelectionDelegate.h"
#import "TwitterSplitViewController.h"

@interface TwitterViewController : // UITableViewController
UIViewController <UITableViewDelegate, UITableViewDataSource, SA_OAuthTwitterControllerDelegate> 
{
	// UITableView * tableView;
    NSDictionary * infoData;
	UIActivityIndicatorView *waitView;
	UILabel *waitLabel;
	NSString * twtUrl;
	NSString * twtStyleTitle;
	NSString * twtStyleDate;
	NSMutableArray * twts;
	SA_OAuthTwitterEngine *_engine;
	UIView *twitterView;
	UITextView * twitterMessageText;
	NSString * twitterTitle;
	NSString * twitterDescription;
	NSString * twitterLink;
	NSString * useTwitter;
	NSString* kAppId;
	NSString* kOAuthConsumerKey;
	NSString* kOAuthConsumerSecret;
	BOOL hiddenTabBar;
    id<ListSelectionDelegate> _delegate;
    TwitterSplitViewController * parentView;
}

// @property (nonatomic,retain) IBOutlet UITableView * tableView;
@property (nonatomic,retain) IBOutlet UILabel *waitLabel;
@property (nonatomic,retain) IBOutlet NSString * twtUrl;
@property (nonatomic,retain) IBOutlet NSString * twtStyleTitle;
@property (nonatomic,retain) IBOutlet NSString * twtStyleDate;
@property (nonatomic, retain) NSMutableArray * twts;
@property (nonatomic, retain) NSString* kAppId;
@property (nonatomic, retain) NSString* kOAuthConsumerKey;
@property (nonatomic, retain) NSString* kOAuthConsumerSecret;
@property (nonatomic, retain) NSString * twitterTitle;
@property (nonatomic, retain) NSString * twitterDescription;
@property (nonatomic, retain) NSString * twitterLink;
@property (nonatomic, assign) IBOutlet id<ListSelectionDelegate> delegate;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
- (void) goDownload;
- (void) processXml:(NSMutableData *)myXMLData;
- (void)showXML;
- (void) initStatusBar:(UIView *)actualView withType:(int)type;

-(IBAction) goTwt: (id) sender;
-(void) createTwitterView;
-(IBAction) sendTwitter: (id) sender;
- (void) goDetail;
- (void) hidetabbar;
- (void) loadDetail: (int) row;
- (void)setParent: (UIViewController *)viewController;

@end
