//
//  app_builderAppDelegate.h
//  app_builder
//
//  Created by IVAN BEJARANO on 10/14/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <sqlite3.h> // Import the SQLite database framework
#import "TBXML.h"
#import "Config.h"

@class app_builderViewController;

// @interface app_builderAppDelegate : NSObject <UIApplicationDelegate> {
@interface app_builderAppDelegate : WTAppDelegate <UIApplicationDelegate> {
    UIWindow *window;
    app_builderViewController *viewController;
	NSString * appPath;
	BOOL isInternetConnected;
}

@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) IBOutlet app_builderViewController *viewController;
@property (nonatomic, retain) NSString * appPath;
// @property (nonatomic, retain) NSString * xml_url;

-(void) checkAndCreateFile:(NSString *)file;
-(void) loadFirstConfig;
-(void) checkUpdate;
-(void) doUpdate;
-(void) displayView:(NSString *)sNewView;
- (BOOL) connectedToNetwork;
- (BOOL) isOnLine;
- (void) updateConfig;
- (void) updateWebtrends;
- (void) createResources;

@end

