// ===
// Functions test
// ===

#import <sqlite3.h>
#import "TBXml.h"
#import "FontItem.h"

@interface Functions : NSObject {
		NSString *databaseName;
		NSString *databasePath;
}

+ (UIColor *) colorForHex:(NSString *)hexColor;
+ (TBXMLElement *)readConfigXmlFile;
+(UIImage *)resizeImage:(UIImage *)img width:(CGFloat)targetWidth height:(CGFloat)targetHeight;
// - (BOOL) connectedToNetwork;
+ (NSString *)fontName:(NSString *)font fontStyle:style;
//+ (void)updateConfig:(NSString *)name withValue:(NSString *)newValue;
//+ (NSString *)loadConfig:(NSString *)name;
+ (void) initToolBar:(UIView *)actualView withTitle:(NSString *)title; // withView:(BOOL)viewButton;
+ (void) addToolBar:(UIView *)actualView withTitle:(NSString*) title
		   actualId: (NSString *)actualId;
+ (void)goMenu:(id) sender;
+ (NSString *) loadFromTabBar:(NSString *)actualTitle;
+ (FontItem *) loadFont:(NSString *)idFont;
+ (void) sendWebtrends:(NSString *)currPath eventDescr:(NSString *)eventDescr 
			 eventType:(NSString *)eventType 
		  contentGroup:(NSString *)contentGroup 
			 mediaName:(NSString *)mediaName 
			 mediaType:(NSString *)mediaType 
			mediaEvent:(NSString *)mediaEvent;
+ (void) useAd:(NSString *)moduleId;
+ (BOOL) connectedToNetwork;
+ (void) deleteAllFilesInPath: (NSString *)path;
+ (void) initWaitView:(UIView *)actualView;
+ (void) showAnimated:(UIView *)actualView;
+ (void) stopAnimated:(UIView *)actualView;
+ (BOOL) hidetabbar:(BOOL)hiddenTabBar withViewController:(UIViewController *)viewController;
+ (NSString *) headerStyle;
+ (void) addStatusBar:(UIView *)actualView withTabBar:(BOOL)useTabBarSpace;
+ (BOOL) hidetabbar:(BOOL)hiddenTabBar withViewController:(UIViewController *)viewController;

@end