//
//  StylePageControl.m
//  app_builder
//
//  Created by IVAN BEJARANO on 10/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "StylePageControl.h"

@implementation StylePageControl

- (void) setCurrentPage:(NSInteger)page {
	[super setCurrentPage:page];
	
	NSString* imgActive = [[NSBundle mainBundle] pathForResource:@"page_control-6x6-active.png" ofType:nil];
	NSString* imgInactive = [[NSBundle mainBundle] pathForResource:@"page_control-6x6.png" ofType:nil];
	for (NSUInteger subviewIndex = 0; subviewIndex < [self.subviews count]; subviewIndex++) 
	{
		UIImageView* subview = [self.subviews objectAtIndex:subviewIndex];
		if (subviewIndex == page) 
			[subview setImage:[UIImage imageWithContentsOfFile:imgActive]];
		else 
			[subview setImage:[UIImage imageWithContentsOfFile:imgInactive]];
	}
}

- (void) setNumberOfPages:(NSInteger)pages 
{
	[super setNumberOfPages:pages];
	
	NSString* img = [[NSBundle mainBundle] pathForResource:@"page_control-6x6.png" ofType:nil];
	for (NSUInteger subviewIndex = 0; subviewIndex < [self.subviews count]; subviewIndex++) 
	{
		UIImageView* subview = [self.subviews objectAtIndex:subviewIndex];
		[subview setImage:[UIImage imageWithContentsOfFile:img]];
	}
}

@end
