//
//  imageInfo.h
//  app_builder
//
//  Created by IVAN BEJARANO on 11/19/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface imageInfo : UIImageView 
{
	CGRect		originalRect;
	CGRect		parentFrame;
	CGFloat		ratio;
}

// - (id) initWithName:(NSString*)imagename parentFrame:(CGRect)frame;
- (id) initWithName:(NSString*)imagename withFolder:(NSString*)foldername withParentFrame:(CGRect)frame;

- (void)		scaleToFitRect:(CGRect)rect;
- (void)		scaleToOriginalRect;
- (float)		getRatio;
- (void)		centerImage;
- (void)		setOffset:(float)xoff:(float)yoff;
- (void)		addOffset:(float)xoff:(float)yoff;
- (void)		boundOffset;
- (void) setParentFrame: (CGRect) frame;

@end
